<?php
 namespace App\Backup; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\FindChmodCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\WriteFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\RcloneCopyCommand; use App\System\Command\RcloneLsJsonCommand; use App\System\Command\RclonePurgeCommand; class Rclone { private const FREQUENCY_DAILY = "\x64\141\x69\x6c\x79"; private const CONFIG_DIRECTORY = "\x2f\162\x6f\157\164\x2f\x2e\143\x6f\x6e\146\x69\x67\x2f\x72\x63\154\157\156\x65\x2f"; private const CLP_USER_CONFIG_DIRECTORY = "\57\x68\157\x6d\145\57\143\x6c\160\57\x2e\x63\157\x6e\x66\x69\x67\57"; private const CLP_USER = "\x63\x6c\x70"; public const CREDENTIALS_DIRECTORY = "\57\x68\x6f\155\x65\x2f\x63\x6c\160\x2f\x2e\143\x6f\156\x66\x69\x67\x2f\162\143\x6c\157\156\145\x2f\x63\162\x65\x64\x65\156\164\151\x61\154\x73\57"; private const CONFIG_FILE = "\57\162\157\157\164\x2f\56\x63\157\156\146\x69\x67\57\x72\x63\x6c\x6f\x6e\x65\x2f\162\143\154\x6f\x6e\x65\x2e\143\x6f\x6e\x66"; private const CRON_JOB_FILE = "\57\x65\x74\143\x2f\143\162\157\156\x2e\x64\x2f\143\154\160\x2d\x72\143\x6c\157\156\x65"; private CommandExecutor $commandExecutor; private ?string $configFile = null; private array $flags = []; public function __construct() { $this->commandExecutor = new CommandExecutor(); } public function setConfigFile(string $configFile) : void { $this->configFile = $configFile; } public function getConfigFile() : ?string { goto Ff220; Cc0b2: $this->configFile = self::CONFIG_FILE; goto Cc448; a6355: return $this->configFile; goto f53a6; Cc448: Bac3e: goto a6355; Ff220: if (!(true === is_null($this->configFile))) { goto Bac3e; } goto Cc0b2; f53a6: } public function addFlag(string $flag, string $value) { $this->flags[] = ["\x66\x6c\x61\147" => $flag, "\x76\x61\x6c\165\145" => $value]; } public function getFlags() : array { return $this->flags; } public function copy(string $source, string $destination) : void { goto c1591; F8d44: $this->addFlagsToCommand($flags, $rcloneCopyCommand); goto c9f82; db64f: $rcloneCopyCommand->setDestination($destination); goto F8d44; c9f82: $this->commandExecutor->execute($rcloneCopyCommand, 21600); goto f4db6; Adfdc: $configFile = $this->getConfigFile(); goto b415d; b415d: $rcloneCopyCommand = new RcloneCopyCommand(); goto Fd4d0; Fd4d0: $rcloneCopyCommand->setConfigFile($configFile); goto c1549; c1591: $flags = $this->getFlags(); goto Adfdc; c1549: $rcloneCopyCommand->setSource($source); goto db64f; f4db6: } public function lsJson(?string $remotePath = null, $directoriesOnly = false) : array { goto Cab49; c00b6: Bccc8: goto bf5f5; be253: $rcloneLsJsonCommand = new RcloneLsJsonCommand(); goto B4c0a; E7951: $files = $rcloneLsJsonCommand->getFiles(); goto F4c7a; Eb31e: $configFile = $this->getConfigFile(); goto be253; d45dd: $this->commandExecutor->execute($rcloneLsJsonCommand, 20); goto E7951; Cab49: $flags = $this->getFlags(); goto Eb31e; bf5f5: $this->addFlagsToCommand($flags, $rcloneLsJsonCommand); goto d45dd; De615: if (!(true === $directoriesOnly)) { goto Bccc8; } goto c4a6f; Bb870: $rcloneLsJsonCommand->setRemotePath($remotePath); goto De615; B4c0a: $rcloneLsJsonCommand->setConfigFile($configFile); goto Bb870; F4c7a: return $files; goto B5530; c4a6f: $rcloneLsJsonCommand->setDirectoriesOnly(true); goto c00b6; B5530: } public function purge(string $remotePath) { goto de45c; cf7c8: $this->commandExecutor->execute($rclonePurgeCommand, 21600); goto b61cb; fd4df: $rclonePurgeCommand = new RclonePurgeCommand(); goto ca165; de45c: $flags = $this->getFlags(); goto fd4df; A0f29: $this->addFlagsToCommand($flags, $rclonePurgeCommand); goto cf7c8; ca165: $rclonePurgeCommand->setRemotePath($remotePath); goto A0f29; b61cb: } public function writeConfig(string $config) : void { goto Db9bb; Acd6e: $writeConfigFileCommand->setContent($config); goto c790d; C4e55: $writeConfigFileCommand = new WriteFileCommand(); goto A2662; Db9bb: $configFile = $this->getConfigFile(); goto Eb057; Eb057: $createConfigDirectoryCommand = new CreateDirectoryCommand(); goto a3c3a; c790d: $this->commandExecutor->execute($createConfigDirectoryCommand); goto Ee8c7; A2662: $writeConfigFileCommand->setFile($configFile); goto Acd6e; Ee8c7: $this->commandExecutor->execute($writeConfigFileCommand); goto e777e; a3c3a: $createConfigDirectoryCommand->setDirectory(self::CONFIG_DIRECTORY); goto C4e55; e777e: } public function writeCredentialsFile(string $file, string $content) : void { goto Fbc6a; B42cd: $chownConfigDirectoryCommand->setFile(self::CLP_USER_CONFIG_DIRECTORY); goto ac7b7; ac7b7: $chownConfigDirectoryCommand->setRecursive(true); goto dc251; B8108: $chmodConfigDirectoryCommand->setDirectoryChmod(770); goto D4dc2; feccf: $chmodConfigDirectoryCommand->setFile(self::CLP_USER_CONFIG_DIRECTORY); goto B8108; D4dc2: $chmodConfigDirectoryCommand->setFileChmod(770); goto Dc20f; B2d13: $chownConfigDirectoryCommand = new ChownCommand(); goto B42cd; C6b29: file_put_contents($file, $content); goto e578f; f41d3: $credentialsDirectoryCommand->setDirectory(self::CREDENTIALS_DIRECTORY); goto B2d13; Fbc6a: $credentialsDirectoryCommand = new CreateDirectoryCommand(); goto f41d3; Cb92d: $this->commandExecutor->execute($chownConfigDirectoryCommand); goto B7f6a; dc251: $chownConfigDirectoryCommand->setUser(self::CLP_USER); goto cce79; cce79: $chownConfigDirectoryCommand->setGroup(self::CLP_USER); goto fcd54; Dc20f: $this->commandExecutor->execute($credentialsDirectoryCommand); goto Cb92d; fcd54: $chmodConfigDirectoryCommand = new FindChmodCommand(); goto feccf; B7f6a: $this->commandExecutor->execute($chmodConfigDirectoryCommand); goto C6b29; e578f: } public function createCronJob(string $frequency, string $executionTime = null) : void { goto ce3da; Fa8d8: $this->commandExecutor->execute($writeCronJobFileCommand); goto b634d; Bbb25: $writeCronJobFileCommand = new WriteFileCommand(); goto d1ae5; Fe1aa: d21ba: goto Bbb25; d45dc: $cronJobContent .= sprintf("\60\40\45\x73\x20\52\40\52\x20\52\x20\x63\x6c\x70\40\57\165\x73\x72\57\x62\151\x6e\57\x62\x61\163\x68\40\55\143\x20\x22\x2f\165\x73\x72\57\x62\x69\156\x2f\143\154\x70\x63\164\154\40\162\x65\x6d\157\x74\x65\x2d\142\141\x63\x6b\165\x70\72\143\x72\x65\141\x74\x65\x20\55\x2d\x64\145\154\x61\x79\75\x74\162\x75\x65\x22\x20\46\x3e\40\57\144\x65\166\x2f\156\165\154\154", $executionTime); goto Fe1aa; d1ae5: $writeCronJobFileCommand->setFile(self::CRON_JOB_FILE); goto ba523; ba523: $writeCronJobFileCommand->setContent($cronJobContent); goto Fa8d8; a52f5: goto d21ba; goto A590b; ffdcd: if (self::FREQUENCY_DAILY == $frequency) { goto Fd13e; } goto F430b; ce3da: $cronJobContent = sprintf("\115\101\111\114\x54\x4f\75\x22\x22\45\163", PHP_EOL); goto ffdcd; F430b: $cronJobContent .= sprintf("\x30\x20\52\x2f\45\163\40\x2a\40\52\40\52\40\x63\154\x70\x20\x2f\x75\x73\x72\x2f\x62\x69\156\57\142\141\163\150\x20\55\143\x20\42\x2f\x75\x73\162\57\142\151\156\57\x63\154\160\x63\x74\x6c\40\162\145\155\x6f\164\x65\x2d\142\141\143\153\165\x70\72\143\162\x65\141\x74\x65\40\x2d\x2d\144\x65\x6c\141\x79\75\x74\x72\165\145\42\40\46\x3e\40\x2f\x64\145\x76\x2f\156\x75\x6c\154", $frequency); goto a52f5; A590b: Fd13e: goto d45dc; b634d: } private function addFlagsToCommand(array $flags, $command) : void { goto B6a4b; E4364: c3df5: goto a5ba1; Dbe14: foreach ($flags as $flagData) { $command->addFlag($flagData["\x66\x6c\x61\x67"], $flagData["\x76\141\x6c\165\145"]); de6e4: } goto a5cf7; B6a4b: if (!(false === empty($flags))) { goto c3df5; } goto Dbe14; a5cf7: B7946: goto E4364; a5ba1: } public function deleteCronJob() : void { goto bcfde; Cb787: $this->commandExecutor->execute($deleteCronJobFileCommand); goto Ae0b2; F8ec5: $deleteCronJobFileCommand->setFile(self::CRON_JOB_FILE); goto Cb787; bcfde: $deleteCronJobFileCommand = new DeleteFileCommand(); goto F8ec5; Ae0b2: } public function deleteCredentials() : void { goto cb09f; Bb61c: $deleteCredentialsDirectoryCommand->setDirectory(self::CREDENTIALS_DIRECTORY); goto cd2d8; cb09f: $deleteCredentialsDirectoryCommand = new DeleteDirectoryCommand(); goto Bb61c; cd2d8: $this->commandExecutor->execute($deleteCredentialsDirectoryCommand); goto cf775; cf775: } }
