<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\DatabaseUser as DatabaseUserEntity; use App\Database\Manager as DatabaseManager; use App\Service\Crypto; class DatabaseAddCommand extends BaseCommand { private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private ValidatorInterface $validator; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto D81ad; E64e6: $this->databaseEntityManager = $databaseEntityManager; goto f3358; D81ad: $this->siteEntityManager = $siteEntityManager; goto E64e6; b34a0: $this->validator = $validator; goto c3622; f3358: $this->databaseUserEntityManager = $databaseUserEntityManager; goto B2e08; c3622: parent::__construct(); goto C61db; B2e08: $this->databaseServerEntityManager = $databaseServerEntityManager; goto b34a0; C61db: } protected function configure() : void { goto Ec437; f67e9: $this->addOption("\x64\141\x74\141\x62\x61\163\x65\x55\163\145\x72\x50\141\x73\x73\x77\x6f\x72\x64", null, InputOption::VALUE_REQUIRED); goto d4e33; Db04c: $this->addOption("\x64\157\x6d\x61\151\156\x4e\141\x6d\x65", null, InputOption::VALUE_REQUIRED); goto C7cd0; ca225: $this->setDescription("\143\154\160\x63\x74\154\40\144\x62\72\141\144\144\40\55\55\144\157\155\141\x69\x6e\x4e\x61\155\x65\x3d\167\x77\167\56\144\x6f\x6d\141\x69\156\56\143\x6f\155\40\55\55\144\141\164\141\x62\x61\163\x65\x4e\x61\155\x65\75\155\x79\x2d\x64\141\x74\x61\x62\141\163\x65\40\x2d\x2d\x64\x61\x74\x61\142\x61\163\145\125\163\145\x72\116\x61\x6d\x65\75\152\157\150\156\x20\x2d\55\144\x61\164\141\x62\141\163\x65\125\x73\145\x72\x50\141\x73\x73\167\x6f\162\144\75\47\41\163\x65\x63\162\145\164\x50\x61\x73\163\x77\157\x72\x64\x21\x27"); goto Db04c; e2a92: $this->addOption("\x64\x61\164\x61\142\141\163\x65\x55\163\x65\x72\116\x61\x6d\x65", null, InputOption::VALUE_REQUIRED); goto f67e9; C7cd0: $this->addOption("\144\141\x74\141\x62\141\163\145\116\141\155\145", null, InputOption::VALUE_REQUIRED); goto e2a92; Ec437: $this->setName("\144\x62\x3a\x61\x64\144"); goto ca225; d4e33: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto b8cce; d5609: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto C718c; df6f9: if (!(true === is_null($siteEntity))) { goto abde9; } goto c9731; A639d: $constraints = new ConstraintViolationList(); goto a8b4e; b6e82: $databaseEntity->setName($databaseName); goto f2952; aea98: $databaseEntity->addUser($databaseUserEntity); goto b4272; f2efc: $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); goto df6f9; c9731: throw new \Exception(sprintf("\x44\x6f\x6d\141\x69\x6e\116\141\155\x65\x20\x22\45\163\x22\40\144\x6f\x65\163\x20\156\157\x74\x20\x65\x78\151\163\x74\x2e", $domainName)); goto A0e0f; C7753: $databaseName = trim($input->getOption("\144\x61\164\141\x62\141\x73\x65\x4e\141\x6d\145")); goto A9e85; b8cce: $this->validateInput($input); goto A771b; A0e0f: abde9: goto d5609; f14ec: return BaseCommand::FAILURE; goto f3e73; c5ce5: $databaseManager->createUser($databaseUserEntity); goto efa62; efa62: $this->siteEntityManager->updateEntity($siteEntity); goto f7962; B794a: $databaseUserEntity->setPassword(Crypto::encrypt($databaseUserPassword)); goto cc99a; C7f6b: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto A36a1; df3eb: $databaseUserEntity->setDatabase($databaseEntity); goto aea98; d30d8: $databaseUserEntity->setUserName($databaseUserName); goto B794a; f2952: $databaseEntity->setSite($siteEntity); goto Ae863; Af14b: if (0 == count($databaseConstraints) && 0 == count($databaseUserConstraints)) { goto e969f; } goto A639d; A36a1: $databaseManager->createDatabase($databaseEntity); goto c5ce5; a8b4e: $constraints->addAll($databaseConstraints); goto Ecc4d; F2d8c: $databaseUserPassword = trim($input->getOption("\144\141\x74\x61\x62\141\163\x65\125\163\145\162\x50\x61\x73\x73\x77\x6f\162\144")); goto f2efc; cc99a: $databaseUserEntity->setPermissions(DatabaseUserEntity::PERMISSIONS_READ_WRITE); goto df3eb; bbc6f: C3257: goto f14ec; D8153: $databaseUserConstraints = $this->validator->validate($databaseUserEntity); goto Af14b; f75a3: ee600: goto bbc6f; Fc7f6: $databaseConstraints = $this->validator->validate($databaseEntity); goto D8153; c9d97: return $this->renderConstraints($constraints, $output); goto A2def; C718c: if (!(false === is_null($activeDatabaseServerEntity))) { goto C3257; } goto e5247; Ecc4d: $constraints->addAll($databaseUserConstraints); goto c9d97; A771b: $domainName = trim($input->getOption("\x64\x6f\155\141\x69\156\x4e\141\x6d\145")); goto C7753; A2def: goto ee600; goto eba7d; A9e85: $databaseUserName = trim($input->getOption("\x64\141\x74\141\142\141\x73\x65\x55\x73\145\162\x4e\141\x6d\145")); goto F2d8c; f7962: $output->writeln(sprintf("\x3c\151\x6e\x66\157\x3e\x44\x61\x74\x61\x62\141\x73\145\74\57\151\156\146\157\x3e\x20\74\143\157\x6d\155\145\156\x74\76\x25\163\x3c\x2f\143\x6f\x6d\x6d\145\x6e\x74\76\x20\x3c\151\156\x66\157\76\150\141\163\x20\x62\145\x65\156\40\x61\144\144\145\144\56\74\57\151\156\x66\x6f\76", $databaseName)); goto Eca1f; b4272: $siteEntity->addDatabase($databaseEntity); goto Fc7f6; c49af: $databaseEntity->setDatabaseServer($activeDatabaseServerEntity); goto b6e82; e5247: $databaseEntity = $this->databaseEntityManager->createEntity(); goto c49af; eba7d: e969f: goto C7f6b; Ae863: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto d30d8; Eca1f: return BaseCommand::SUCCESS; goto f75a3; f3e73: } catch (\Exception $e) { goto D39b7; D03a4: $output->writeln(sprintf("\74\145\x72\162\157\162\76\45\x73\74\x2f\145\x72\x72\x6f\x72\76", $errorMessage)); goto D6699; D39b7: $errorMessage = $e->getMessage(); goto D03a4; D6699: return BaseCommand::FAILURE; goto Caaca; Caaca: } } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\156\141\x6d\145", "\x64\x61\x74\x61\x62\141\x73\x65\116\x61\x6d\145", $constraints); $this->changePropertyPath("\x75\x73\x65\x72\116\x61\155\x65", "\144\x61\164\x61\x62\x61\x73\145\x55\163\x65\162\x4e\141\x6d\145", $constraints); } }
