<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\Entity\Database as DatabaseEntity; use App\System\CommandExecutor; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\System\Command\DeleteOldFilesRecursiveCommand; use App\System\Command\FindChmodCommand; use App\System\Command\ChownCommand; use App\Database\Exporter as DatabaseExporter; class DatabaseBackupCommand extends BaseCommand { private const RETENTION_PERIOD = 7; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private int $retentionPeriod = 0; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto ac575; ac575: $this->siteEntityManager = $siteEntityManager; goto eeaec; De809: $this->databaseServerEntityManager = $databaseServerEntityManager; goto aa0e5; Faf63: $this->validator = $validator; goto d5aba; aa0e5: $this->commandExecutor = new CommandExecutor(); goto Faf63; eeaec: $this->databaseEntityManager = $databaseEntityManager; goto De809; d5aba: parent::__construct(); goto F82f1; F82f1: } protected function configure() : void { goto dfcf8; F59dc: $this->setDescription("\x63\x6c\160\143\164\154\x20\144\x62\72\x62\x61\x63\x6b\165\x70\40\55\55\x69\x67\x6e\157\162\x65\104\141\164\141\142\141\163\x65\163\x3d\x27\x64\x62\61\x2c\x64\142\x32\x27\x20\x2d\55\162\145\x74\145\x6e\x74\151\x6f\156\x50\x65\162\x69\x6f\144\x3d\x37"); goto Befb4; C85d6: $this->addOption("\x72\145\164\145\156\x74\151\x6f\x6e\x50\145\x72\x69\x6f\144", null, InputOption::VALUE_OPTIONAL, '', self::RETENTION_PERIOD); goto Fc764; Befb4: $this->addOption("\x69\147\156\x6f\162\x65\104\141\164\141\142\x61\x73\x65\x73", null, InputOption::VALUE_OPTIONAL); goto C85d6; dfcf8: $this->setName("\144\142\72\142\x61\143\x6b\165\x70"); goto F59dc; Fc764: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto D15c6; eff5e: F4a7a: goto C036f; D4c82: $this->retentionPeriod = (int) $input->getOption("\162\x65\x74\145\156\x74\x69\x6f\156\x50\x65\162\151\x6f\144"); goto b18ce; B7b4b: return BaseCommand::SUCCESS; goto Ef828; C036f: fc28b: goto B7b4b; E4f96: if (!count($siteEntities)) { goto fc28b; } goto d76e6; b18ce: $siteEntities = $this->siteEntityManager->findAll(); goto E4f96; Ac89e: $ignoredDatabases = explode("\54", $input->getOption("\151\x67\156\157\x72\145\104\x61\x74\x61\142\141\163\x65\163")); goto D4c82; D15c6: $this->validateInput($input); goto Ac89e; d76e6: foreach ($siteEntities as $siteEntity) { goto d10c1; ad86f: foreach ($databaseEntities as $databaseEntity) { goto d3666; ba6be: Da239: goto db40d; aa85a: if (!(false === in_array($databaseName, $ignoredDatabases))) { goto e2f29; } goto cca2c; d3666: $databaseName = $databaseEntity->getName(); goto aa85a; cca2c: $this->createDatabaseDump($databaseEntity); goto Bdaeb; Bdaeb: e2f29: goto ba6be; db40d: } goto f5998; D96bf: if (!count($databaseEntities)) { goto E4c85; } goto ad86f; f7377: E4c85: goto c843d; c843d: C3836: goto C5349; d10c1: $databaseEntities = $siteEntity->getDatabases(); goto D96bf; f5998: eb9ac: goto f7377; C5349: } goto eff5e; Ef828: } catch (\Exception $e) { goto b12f3; d9d86: return BaseCommand::FAILURE; goto D2aae; Ec0c4: $output->writeln(sprintf("\x3c\145\162\x72\x6f\x72\x3e\45\x73\x3c\57\145\162\162\x6f\162\x3e", $errorMessage)); goto d9d86; b12f3: $errorMessage = $e->getMessage(); goto Ec0c4; D2aae: } } private function createDatabaseDump(DatabaseEntity $databaseEntity) : void { try { goto A1073; A481e: $this->resetPermissions($databaseEntity); goto d7785; b1534: $outputDirectory = sprintf("\x25\163\57\45\163\57\45\x73\57", rtrim($backupDirectory, "\57"), $databaseName, $dateTime->format("\x59\55\155\55\x64")); goto D1379; d7785: $this->cleanUpBackups($databaseEntity); goto d7056; A1dec: $backupDirectory = sprintf("\x2f\x68\157\155\x65\x2f\45\163\57\142\141\x63\153\165\x70\x73\57\x64\141\164\141\x62\x61\x73\x65\163\x2f", $siteUser); goto b1534; D1379: $outputFile = sprintf("\45\163\x2f\x25\163", rtrim($outputDirectory, "\x2f"), sprintf("\45\163\137\45\x73\x2e\x73\161\154\x2e\x67\x7a", $databaseName, $dateTime->getTimestamp())); goto F3f8d; A1073: $dateTime = new \DateTime("\156\157\167", new \DateTimeZone("\x55\124\103")); goto ebe3d; A45f1: $databaseName = $databaseEntity->getName(); goto A1dec; F3f8d: $databaseExporter = new DatabaseExporter($databaseEntity); goto F04df; ebe3d: $siteEntity = $databaseEntity->getSite(); goto acaf2; F04df: $databaseExporter->setFile($outputFile); goto C54d4; acaf2: $siteUser = $siteEntity->getUser(); goto A45f1; Ddc66: $databaseExporter->export(); goto A481e; C54d4: $databaseExporter->createOutputDirectory(); goto Ddc66; d7056: } catch (\Exception $e) { $logger = $this->getLogger(); $logger->exception($e); } } private function resetPermissions(DatabaseEntity $databaseEntity) { goto C4c42; Ae6f3: $this->commandExecutor->execute($backupDirectoryChownCommand); goto d5b34; Bcc34: $backupDirectoryChmodCommand->setDirectoryChmod(750); goto C389f; d1711: $backupDirectoryChownCommand->setUser($siteUser); goto Adab9; C4c42: $siteEntity = $databaseEntity->getSite(); goto cc3ec; C389f: $backupDirectoryChmodCommand->setFileChmod(760); goto Ae6f3; cc3ec: $siteUser = $siteEntity->getUser(); goto e197a; C2946: $backupDirectoryChownCommand->setRecursive(true); goto d1711; e197a: $backupDirectory = sprintf("\x2f\x68\157\155\145\57\45\x73\57\x62\141\x63\153\x75\x70\163\x2f\x64\141\x74\141\x62\141\x73\x65\x73\57", $siteUser); goto C2fc9; d5b34: $this->commandExecutor->execute($backupDirectoryChmodCommand); goto Ba40f; Adab9: $backupDirectoryChownCommand->setGroup($siteUser); goto C73df; e6731: $backupDirectoryChmodCommand->setFile($backupDirectory); goto Bcc34; E0ae2: $backupDirectoryChownCommand->setFile($backupDirectory); goto C2946; C73df: $backupDirectoryChmodCommand = new FindChmodCommand(); goto e6731; C2fc9: $backupDirectoryChownCommand = new ChownCommand(); goto E0ae2; Ba40f: } private function cleanUpBackups(DatabaseEntity $databaseEntity) { goto e8552; A3a62: $siteUser = $siteEntity->getUser(); goto f4429; D1f94: $this->commandExecutor->execute($deleteOldBackupsCommand, 360); goto a98ba; f4429: $databaseBackupDirectory = sprintf("\x2f\150\x6f\x6d\x65\x2f\45\x73\57\x62\x61\143\153\x75\160\x73\57\x64\x61\164\141\x62\141\163\145\163\57", $siteUser); goto baa68; c72c4: $deleteOldBackupsCommand->setDirectory($databaseBackupDirectory); goto Cfb66; baa68: $deleteOldBackupsCommand = new DeleteOldFilesRecursiveCommand(); goto c72c4; e8552: $siteEntity = $databaseEntity->getSite(); goto A3a62; Cfb66: $deleteOldBackupsCommand->setRetentionPeriod($this->retentionPeriod); goto D1f94; a98ba: } }
