<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Database\Importer as DatabaseImporter; use App\System\Command\CheckIfFileExistsCommand; use App\System\CommandExecutor; class DatabaseImportCommand extends BaseCommand { const SYSTEM_USER_ROOT = "\x72\x6f\157\x74"; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private SshUserEntityManager $sshUserEntityManager; private CommandExecutor $commandExecutor; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, SshUserEntityManager $sshUserEntityManager) { goto cd0c4; A10eb: parent::__construct(); goto A505e; cd0c4: $this->siteEntityManager = $siteEntityManager; goto d6309; Cb242: $this->commandExecutor = new CommandExecutor(); goto A10eb; Bc806: $this->databaseServerEntityManager = $databaseServerEntityManager; goto cfa05; cfa05: $this->sshUserEntityManager = $sshUserEntityManager; goto Cb242; d6309: $this->databaseEntityManager = $databaseEntityManager; goto Bc806; A505e: } protected function configure() : void { goto f1d18; D9a19: $this->addOption("\144\x61\x74\x61\x62\x61\x73\x65\x4e\x61\x6d\x65", null, InputOption::VALUE_REQUIRED); goto Daf9a; adaa3: $this->setDescription("\x63\x6c\160\143\x74\154\x20\x64\x62\72\x69\155\x70\157\x72\164\x20\55\x2d\144\x61\x74\141\x62\x61\x73\x65\x4e\141\155\145\75\x6d\x79\x2d\x64\x61\164\141\142\x61\x73\x65\40\x2d\x2d\x66\x69\154\x65\75\144\x75\x6d\160\56\163\161\x6c\56\x67\x7a"); goto D9a19; Daf9a: $this->addOption("\146\151\x6c\145", null, InputOption::VALUE_REQUIRED); goto D2215; f1d18: $this->setName("\x64\142\72\x69\x6d\x70\x6f\162\x74"); goto adaa3; D2215: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto ca1e0; C84e5: $importFile = $input->getOption("\146\x69\x6c\145"); goto b9cda; cb31e: $siteUser = $siteEntity->getUser(); goto bc9a6; F1666: f2f5d: goto cb31e; C755e: $siteEntity = $this->siteEntityManager->findOneByUser($systemUserName); goto A5049; Ffa86: $userBelongsToSite = false === is_null($siteEntity) && $siteUser === $databaseEntity->getSite()->getUser(); goto Aef8a; A8779: goto a4201; goto F1666; Bc3c0: $output->writeln(sprintf("\74\x69\x6e\x66\x6f\x3e\x49\155\160\157\x72\164\40\x69\x6e\164\x6f\x20\144\141\164\x61\x62\141\163\145\74\57\x69\156\146\157\76\x20\74\x63\157\x6d\x6d\x65\x6e\x74\76\45\163\74\57\x63\157\155\155\145\156\164\76\x20\x3c\x69\156\x66\157\76\x77\x61\x73\x20\163\165\x63\x63\x65\x73\x73\x66\165\154\56\74\57\x69\x6e\146\x6f\76", $databaseName)); goto a3020; fbe40: if (!(false === str_contains($importFile, "\57"))) { goto F2335; } goto d7c64; Aef8a: $isSuperUser = false; goto a3627; Bc4de: C29b0: goto C61e2; bc9a6: a4201: goto Ffa86; ca077: throw new \Exception(sprintf("\x44\x61\164\x61\142\141\x73\x65\x20\42\x25\163\42\x20\144\157\x65\x73\x20\x6e\x6f\164\x20\145\170\x69\163\164\56", $databaseName)); goto fa0c4; F5615: $isSuperUser = true; goto A236a; be9d8: if (false === is_null($databaseEntity)) { goto e9845; } goto ca077; c77ce: D73bb: goto fbe40; fa52e: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto be9d8; a8402: if (!(false === is_null($sshUserEntity))) { goto F6f4b; } goto B9b1a; c863a: Bdc65: goto Ba769; b2a0e: e9845: goto C755e; A236a: $siteUser = self::SYSTEM_USER_ROOT; goto Bc4de; Ba769: B8a53: goto E92b3; Aec41: $systemUserName = self::SYSTEM_USER_ROOT; goto c77ce; B9b1a: $siteEntity = $sshUserEntity->getSite(); goto c9466; C61e2: $userIsAllowedToImport = true === $isSuperUser || true === $userBelongsToSite; goto b8776; B5df5: $this->checkIfFileExists($importFile); goto fa52e; a3627: if (!(self::SYSTEM_USER_ROOT == $systemUserName)) { goto C29b0; } goto F5615; d08f5: $databaseImporter->import($importFile); goto Bc3c0; E92b3: return BaseCommand::FAILURE; goto c9794; E4508: if (!("\144\x65\x76" == $_ENV["\101\x50\120\x5f\x45\x4e\x56"])) { goto D73bb; } goto Aec41; A9bba: F2335: goto B5df5; fa0c4: goto B8a53; goto b2a0e; A5049: $siteUser = null; goto Dec79; Deff6: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($systemUserName); goto a8402; Dec79: if (false === is_null($siteEntity)) { goto f2f5d; } goto Deff6; ca1e0: $this->validateInput($input); goto e587d; a128b: F6f4b: goto A8779; c9466: $siteUser = $siteEntity->getUser(); goto a128b; d7c64: $importFile = sprintf("\45\x73\x2f\45\163", rtrim(getcwd(), "\x2f"), $importFile); goto A9bba; e587d: $databaseName = $input->getOption("\x64\141\x74\141\x62\x61\163\145\x4e\141\155\x65"); goto C84e5; b9cda: $systemUserName = $_SERVER["\x53\125\x44\x4f\x5f\x55\123\105\122"] ?? ''; goto E4508; b8776: if (!(true === $userIsAllowedToImport && false === is_null($siteUser))) { goto Bdc65; } goto Ae820; Ae820: $databaseImporter = new DatabaseImporter($databaseEntity); goto d08f5; a3020: return BaseCommand::SUCCESS; goto c863a; c9794: } catch (\Exception $e) { goto Fd3e3; Fd3e3: $errorMessage = $this->maskString($e->getMessage()); goto E75e7; f8148: return BaseCommand::FAILURE; goto e7cac; E75e7: $output->writeln(sprintf("\74\x65\162\162\157\x72\x3e\45\163\x3c\57\145\x72\x72\x6f\x72\x3e", $errorMessage)); goto f8148; e7cac: } } private function checkIfFileExists(string $importFile) { try { goto f8887; B119d: $this->commandExecutor->execute($checkIfFileExistsCommand); goto f6b1a; f8887: $checkIfFileExistsCommand = new CheckIfFileExistsCommand(); goto Ff3cd; Ff3cd: $checkIfFileExistsCommand->setFile($importFile); goto B119d; f6b1a: } catch (\Exception $e) { throw new \Exception(sprintf("\x46\151\154\x65\x20\42\45\163\42\40\144\157\x65\163\40\156\157\x74\40\x65\x78\151\x73\x74\x2e", $importFile)); } } }
