<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\System\CommandExecutor; use App\System\Command\WriteFileCommand; use App\System\Command\DeleteFileCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Site as SiteEntity; use App\Entity\Notification; use App\Notification\NotificationQueue; use App\Backup\Rclone; use App\Backup\Dropbox\Client as DropboxClient; use App\Backup\Rclone\DropboxConfigTemplate; use App\Backup\Rclone\ConfigBuilder as RcloneConfigBuilder; use App\Backup\StorageProvider; use App\Backup\TarCreator; use App\Service\Logger; class RemoteBackupCreateCommand extends BaseCommand { private SiteEntityManager $siteEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private ?\DateTime $serverDateTime = null; private array $excludes = []; private ?string $storageProvider = null; public function __construct(SiteEntityManager $siteEntityManager, Logger $logger, ValidatorInterface $validator) { goto b72b1; Aff11: $this->validator = $validator; goto c5c60; F7767: $this->logger = $logger; goto Aff11; cc090: $this->commandExecutor = new CommandExecutor(); goto F7767; b72b1: $this->siteEntityManager = $siteEntityManager; goto cc090; c5c60: parent::__construct(); goto bde33; bde33: } protected function configure() : void { goto a521e; a521e: $this->setName("\x72\x65\155\x6f\164\x65\x2d\142\x61\x63\153\165\160\x3a\143\162\x65\141\164\x65"); goto d6d86; d6d86: $this->setDescription("\x63\x6c\160\143\x74\x6c\40\x72\x65\x6d\x6f\164\x65\x2d\142\x61\143\x6b\165\160\x3a\x63\162\x65\x61\164\145"); goto Cd5d7; Cd5d7: $this->addOption("\x64\x65\154\x61\171", null, InputOption::VALUE_OPTIONAL, false); goto e09b9; e09b9: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto B2f8a; B2f8a: $this->validateInput($input); goto ef809; F5999: foreach ($siteEntities as $siteEntity) { $this->backupSite($siteEntity); e4930: } goto B1ac9; E142d: if (!(true === $isEnabled && false === empty($this->storageProvider))) { goto d0da5; } goto d98d3; c5da4: $this->refreshDropboxAccessToken($delay); goto dc41e; C098d: $this->storageProvider = $this->getConfigValue("\x72\145\x6d\157\x74\x65\137\x62\x61\143\x6b\x75\160\x5f\163\164\157\162\x61\x67\x65\x5f\160\162\x6f\166\x69\x64\x65\162"); goto E142d; d98d3: $siteEntities = $this->siteEntityManager->findAll(); goto E9616; df4a3: $this->backupDatabases(clone $input, clone $output); goto e5116; ef809: $isEnabled = (bool) $this->getConfigValue("\x72\x65\x6d\x6f\164\145\x5f\x62\x61\x63\153\x75\x70\x5f\x65\x6e\141\x62\x6c\145\144"); goto C098d; B1ac9: D8e04: goto A3883; A3883: e3704: goto d10a6; f7614: d0da5: goto dfa00; dfa00: return BaseCommand::SUCCESS; goto D7cf5; e5116: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto bf51f; } goto Dee60; d10a6: $this->cleanBackups(); goto f7614; dc41e: bf51f: goto F5999; E9616: if (!count($siteEntities)) { goto e3704; } goto df4a3; Dee60: $delay = (bool) $input->getOption("\144\145\154\141\x79"); goto c5da4; D7cf5: } catch (\Exception $e) { goto b402f; Cbc63: $output->writeln(sprintf("\x3c\145\162\x72\157\162\x3e\45\x73\74\x2f\x65\162\162\x6f\162\x3e", $errorMessage)); goto D6c39; D6c39: return BaseCommand::FAILURE; goto b6470; b402f: $errorMessage = $e->getMessage(); goto Cbc63; b6470: } } private function backupDatabases(InputInterface $input, OutputInterface $output) : void { try { goto C3cf6; b69f2: $exitCode = $command->run($input, $output); goto C46e6; b3c65: $command = $application->find("\144\x62\72\x62\x61\143\x6b\x75\x70"); goto b69f2; C3cf6: $application = $this->getApplication(); goto b3c65; C46e6: } catch (\Exception $e) { $this->logger->exception($e); } } private function backupSite(SiteEntity $siteEntity) { goto D3410; Ad16b: if (!(false === $isSiteExcluded)) { goto d3429; } goto C5512; D3410: $isSiteExcluded = $this->isSiteExcluded($siteEntity); goto Ad16b; Fd5c7: d3429: goto C7d5c; C5512: try { try { goto A67ca; b744b: $rclone->copy($destinationFile, $destination); goto Eafcb; c7798: if (!(false === empty($siteExcludes))) { goto f6368; } goto da581; Aa747: $siteUser = $siteEntity->getUser(); goto Acc8e; da581: $excludes = array_merge($excludes, $siteExcludes); goto C0d3a; Deb80: $tarCreator->create($sources, $destinationFile, $excludes); goto B7962; B7962: $destination = $this->getDestination($siteEntity); goto D1333; C9895: $sources = [$homeDirectory, $vhostFile]; goto E8ec6; fc304: switch ($this->storageProvider) { case StorageProvider::GOOGLE_DRIVE: goto e7e23; e7e23: $email = $this->getConfigValue("\x72\145\155\157\164\x65\x5f\142\x61\143\153\x75\x70\137\145\155\141\151\x6c"); goto fae0e; fae0e: $rclone->addFlag("\55\x2d\x64\162\151\166\x65\55\151\155\160\145\162\163\x6f\156\141\x74\145", $email); goto F0ae2; F0ae2: goto cc450; goto Afb28; Afb28: } goto F9086; C3c78: $siteVhostFile = sprintf("\x2f\x68\x6f\155\145\x2f\x25\x73\x2f\x73\151\x74\x65\x2d\x76\x68\157\163\164", $siteUser); goto B51a8; E8ec6: $tarCreator = new TarCreator(); goto Deb80; c56bf: $homeDirectory = sprintf("\x2f\x68\157\155\x65\x2f\45\163\x2f", $siteUser); goto Ac476; Dfe00: cc450: goto b744b; B51a8: $this->createSiteSettingsFile($siteSettingsFile, $siteEntity); goto a4722; d7dd3: $destinationFile = sprintf("\57\x68\x6f\x6d\145\57\45\x73\57\164\155\x70\57\142\141\143\153\x75\160\56\x74\x61\162", $siteUser); goto E5096; Acc8e: $domainName = $siteEntity->getDomainName(); goto c56bf; C0d3a: f6368: goto Aa747; F9086: f1b4c: goto Dfe00; f9575: $siteExcludes = $this->getSiteExcludes($siteEntity); goto c7798; A67ca: $excludes = ["\56\x73\x73\x68", "\x74\x6d\x70", "\x6c\157\147\163"]; goto f9575; E5096: $siteSettingsFile = sprintf("\57\x68\x6f\x6d\145\57\45\x73\x2f\x73\151\164\145\x2d\163\145\164\164\151\156\x67\163\56\152\163\x6f\156", $siteUser); goto C3c78; a4722: $this->createSiteVhostFile($siteVhostFile, $siteEntity); goto C9895; D1333: $rclone = new Rclone(); goto fc304; Ac476: $vhostFile = sprintf("\x2f\x65\164\143\x2f\x6e\147\x69\156\170\x2f\163\x69\x74\x65\x73\55\x65\156\141\x62\x6c\145\144\x2f\45\x73\56\143\157\x6e\146", $domainName); goto d7dd3; Eafcb: } catch (\Exception $e) { throw $e; } finally { $files = [$destinationFile, $siteSettingsFile, $siteVhostFile]; foreach ($files as $file) { goto daf15; daf15: $deleteFileCommand = new DeleteFileCommand(); goto b7bcb; b7bcb: $deleteFileCommand->setFile($file); goto b2158; b2158: $this->commandExecutor->execute($deleteFileCommand, 60); goto f2353; f2353: Badd8: goto e7450; e7450: } Af31c: } } catch (\Exception $e) { goto d4f5d; d4f5d: $errorMessage = $e->getMessage(); goto Aed64; Aed64: $subject = sprintf("\122\x65\x6d\x6f\x74\x65\x20\x42\141\143\x6b\x75\x70\40\x66\141\151\x6c\145\x64\72\40\45\163", $domainName); goto b6815; b6815: $this->addNotification($subject, $errorMessage); goto B0111; B0111: } goto Fd5c7; C7d5c: } private function createSiteSettingsFile(string $siteSettingsFile, SiteEntity $siteEntity) : void { goto e285d; e285d: $siteType = $siteEntity->getType(); goto D2fb7; Ef55d: ce32d: goto f47f5; ed1fb: $fileContent = json_encode($settings, JSON_PRETTY_PRINT); goto b6465; a38cd: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto D77a2; bfebc: goto bc4c4; goto B0b2e; A1a6f: $settings["\156\157\x64\145\x6a\163\123\145\164\x74\x69\x6e\147\x73"] = $nodejsSettings; goto bfebc; B630e: $nodejsSettings = ["\166\145\x72\163\151\x6f\156" => $nodejsSettingsEntity->getNodejsVersion(), "\160\157\162\x74" => $nodejsSettingsEntity->getPort()]; goto A1a6f; D77a2: $nodejsSettingsEntity = $siteEntity->getNodejsSettings(); goto B630e; B0b2e: case SiteEntity::TYPE_PHP: goto A98c0; C60ec: goto bc4c4; goto Fc9f2; A98c0: $phpSettingsEntity = $siteEntity->getPhpSettings(); goto Af9c9; C8783: $settings["\160\150\160\x53\x65\x74\x74\x69\156\147\x73"] = $phpSettings; goto C60ec; Af9c9: $phpSettings = ["\166\145\x72\163\x69\157\x6e" => $phpSettingsEntity->getPhpVersion(), "\x6d\x65\155\x6f\162\x79\114\151\155\x69\164" => $phpSettingsEntity->getMemoryLimit(), "\155\141\x78\105\x78\x65\143\x75\x74\151\x6f\x6e\124\x69\x6d\145" => $phpSettingsEntity->getMaxExecutionTime(), "\x6d\x61\170\x49\x6e\x70\x75\x74\124\151\x6d\x65" => $phpSettingsEntity->getMaxInputTime(), "\x6d\x61\x78\111\x6e\160\165\x74\126\141\x72\x73" => $phpSettingsEntity->getMaxInputVars(), "\x70\157\163\x74\115\x61\x78\x53\x69\172\145" => $phpSettingsEntity->getPostMaxSize(), "\x75\160\154\x6f\x61\x64\x4d\x61\170\x46\151\154\145\x53\151\x7a\145" => $phpSettingsEntity->getUploadMaxFileSize(), "\141\x64\144\x69\164\151\x6f\x6e\x61\154\x43\x6f\156\x66\151\x67\x75\x72\141\164\151\x6f\x6e" => $phpSettingsEntity->getAdditionalConfiguration()]; goto C8783; Fc9f2: case SiteEntity::TYPE_PYTHON: goto D513d; aee2c: $settings["\160\171\164\150\x6f\x6e\123\145\x74\164\151\x6e\147\163"] = $pythonSettings; goto d8578; d7251: $pythonSettings = ["\166\145\162\163\151\x6f\156" => $pythonSettingsEntity->getPythonVersion(), "\x70\x6f\162\x74" => $pythonSettingsEntity->getPort()]; goto aee2c; D513d: $pythonSettingsEntity = $siteEntity->getPythonSettings(); goto d7251; d8578: goto bc4c4; goto fbb63; fbb63: case SiteEntity::TYPE_REVERSE_PROXY: goto d82d4; d82d4: $reverseProxySettings = ["\x75\162\x6c" => $siteEntity->getReverseProxyUrl()]; goto e82db; a09fe: goto bc4c4; goto fa5a5; e82db: $settings["\162\x65\166\x65\162\x73\x65\120\x72\x6f\x78\x79\123\x65\x74\x74\151\x6e\x67\x73"] = $reverseProxySettings; goto a09fe; fa5a5: } goto Ef55d; b6465: $writeFileCommand = new WriteFileCommand(); goto eeae1; c0af0: $writeFileCommand->setContent($fileContent); goto b20d6; eeae1: $writeFileCommand->setFile($siteSettingsFile); goto c0af0; D2fb7: $settings = ["\164\171\x70\145" => $siteType, "\x64\157\155\x61\151\x6e\x4e\141\x6d\x65" => $siteEntity->getDomainName(), "\162\157\157\164\x44\151\x72\145\x63\x74\x6f\162\171" => $siteEntity->getRootDirectory(), "\x73\x69\164\145\x55\163\145\162" => $siteEntity->getUser(), "\160\141\147\x65\x53\x70\145\145\x64" => $siteEntity->getPageSpeedSettings()]; goto a38cd; f47f5: bc4c4: goto ed1fb; b20d6: $this->commandExecutor->execute($writeFileCommand, 15); goto e3b21; e3b21: } private function createSiteVhostFile(string $siteVhostFile, SiteEntity $siteEntity) : void { goto e1fda; d4d66: $this->commandExecutor->execute($writeFileCommand, 15); goto D3b56; e1fda: $vhost = $siteEntity->getVhostTemplate(); goto A8162; A8162: $writeFileCommand = new WriteFileCommand(); goto a4d31; a4d31: $writeFileCommand->setFile($siteVhostFile); goto e73df; e73df: $writeFileCommand->setContent($vhost); goto d4d66; D3b56: } private function isSiteExcluded(SiteEntity $siteEntity) : bool { goto c3e5a; c3e5a: $isSiteExcluded = false; goto fb68b; cb6f0: D1211: goto Edd51; Dc8e6: $homeDirectory = sprintf("\57\150\x6f\x6d\x65\57\45\x73", $siteUser); goto F81ac; fb68b: $excludes = $this->getExcludes(); goto c161f; Edd51: Be48d: goto Ea6f3; d6e65: $siteUser = $siteEntity->getUser(); goto Dc8e6; c161f: if (!(false === empty($excludes))) { goto Be48d; } goto d6e65; Ea6f3: return $isSiteExcluded; goto Abaec; F81ac: foreach ($excludes as $exclude) { goto b2cf3; Ef41c: goto D1211; goto E25a0; aa3da: faf9c: goto C9b0b; b2cf3: $exclude = rtrim($exclude, "\57"); goto dcb4a; E876f: $isSiteExcluded = true; goto Ef41c; dcb4a: if (!($homeDirectory == $exclude)) { goto adf90; } goto E876f; E25a0: adf90: goto aa3da; C9b0b: } goto cb6f0; Abaec: } private function getExcludes() : array { goto c2667; C304a: return $this->excludes; goto Ade90; da1ff: $this->excludes = json_decode($excludes); goto Efea5; a0f11: c9467: goto C304a; ef75e: if (!(false === empty($excludes))) { goto Ed116; } goto da1ff; E5fcb: $excludes = $this->getConfigValue("\x72\x65\155\157\164\145\137\142\141\x63\x6b\x75\x70\137\x65\170\x63\154\x75\x64\x65\163"); goto ef75e; Efea5: Ed116: goto a0f11; c2667: if (!(true === empty($this->excludes))) { goto c9467; } goto E5fcb; Ade90: } private function getSiteExcludes(SiteEntity $siteEntity) : array { goto d18f6; e7a50: ec069: goto e72bd; e72bd: return $siteExcludes; goto e20cb; d18f6: $siteExcludes = []; goto Af3ce; Af3ce: $excludes = $this->getExcludes(); goto bb099; c3003: $siteUser = $siteEntity->getUser(); goto Bb835; A1fc4: foreach ($excludes as $exclude) { goto C4973; E85a1: $siteExcludes[] = rtrim(ltrim($exclude, "\x2f"), "\x2f"); goto A6c2c; ea17a: F241d: goto Fa503; C4973: if (!($homeDirectory == substr($exclude, 0, strlen($homeDirectory)))) { goto F241d; } goto F3a59; A6c2c: d83a2: goto ea17a; Cb6a6: if (!(false === empty($exclude))) { goto d83a2; } goto E85a1; Fa503: df523: goto Ad8ba; F3a59: $exclude = substr($exclude, strlen($homeDirectory) - 1); goto Cb6a6; Ad8ba: } goto D428a; bb099: if (!(false === empty($excludes))) { goto ec069; } goto c3003; Bb835: $homeDirectory = sprintf("\x2f\150\157\155\x65\x2f\45\163\x2f", $siteUser); goto A1fc4; D428a: C975a: goto e7a50; e20cb: } private function getServerDateTime() : \DateTime { goto C1355; Dcf0f: B0a74: goto b71d8; acde4: e6030: goto Dcf0f; C8bff: $timezone = $this->getConfigValue("\164\151\x6d\x65\x7a\157\156\x65"); goto f5136; Cad20: $this->serverDateTime->setTimezone(new \DateTimeZone("\125\124\x43")); goto D2f22; D2f22: if (!(false === empty($timezone))) { goto e6030; } goto B5427; f5136: $this->serverDateTime = new \DateTime("\156\x6f\x77"); goto Cad20; B5427: $this->serverDateTime->setTimezone(new \DateTimeZone($timezone)); goto acde4; C1355: if (!(true === is_null($this->serverDateTime))) { goto B0a74; } goto C8bff; b71d8: return $this->serverDateTime; goto B8a80; B8a80: } private function getDestination(SiteEntity $siteEntity) : string { goto c4672; Afefd: $storageDirectory = $this->getConfigValue("\162\x65\155\x6f\x74\145\x5f\x62\x61\143\x6b\x75\x70\137\x73\x74\x6f\x72\x61\147\145\x5f\144\x69\x72\145\143\164\x6f\162\x79"); goto d0f3d; Cb771: E0ef9: goto E5eab; e1410: Aa7eb: goto Cb771; d6fbc: switch ($this->storageProvider) { case StorageProvider::AMAZON_S3: case StorageProvider::WASABI: $destination = $this->getConfigValue("\162\145\x6d\x6f\164\x65\137\x62\141\143\153\x75\160\137\x62\x75\143\153\145\x74"); goto E0ef9; case StorageProvider::DIGITAL_OCEAN_SPACES: $destination = $this->getConfigValue("\x72\145\155\157\164\145\137\x62\141\x63\x6b\165\160\137\163\160\x61\x63\x65"); goto E0ef9; } goto e1410; E6ac5: return $destination; goto f1460; d0f3d: $serverDateTime = $this->getServerDateTime(); goto c09a0; df418: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto bf57b; } goto Cbe59; c09a0: $destination = sprintf("\x25\163\57\45\x73\57\x25\163\57\x25\163\57\150\157\x6d\x65\57\x25\x73\57", $destination, rtrim(ltrim($storageDirectory, "\57"), "\57"), $serverDateTime->format("\x59\55\x6d\x2d\144"), $serverDateTime->format("\110\56\151"), $siteUser); goto df418; Cbe59: $destination = ltrim($destination, "\57"); goto ae912; c4672: $destination = ''; goto d6fbc; E5eab: $siteUser = $siteEntity->getUser(); goto Afefd; ae912: bf57b: goto E6ac5; f1460: } private function cleanBackups() : void { goto F06c8; fcb0f: Ead85: goto f817a; F5aa7: try { goto Deeac; a67f6: de5aa: goto e275f; Deeac: $dateTime = new \DateTime(); goto B2cf0; c5303: $deleteDateTime->modify(sprintf("\x2d\x25\163\x20\144\141\x79\163", $retentionPeriod)); goto A8654; Ed2e2: $remotePath = ltrim($remotePath, "\x2f"); goto A8766; A8766: e9afb: goto b2b0f; Ef224: foreach ($directories as $directory) { goto Ef7b7; E0bc0: if (!(StorageProvider::SFTP == $this->storageProvider)) { goto E1159; } goto Cba7b; d6a97: d2b37: goto A63ca; fad1f: $purgeRemotePath = ltrim($purgeRemotePath, "\x2f"); goto ed8bf; bf917: $purgeRemotePath = sprintf("\x25\163\57\45\x73\57", rtrim(ltrim($remotePath, "\57"), "\x2f"), $directoryName); goto fed2d; Dd4a8: if (!(true === isset($directoryDate) && $directoryDate <= $deleteDateTime)) { goto d2b37; } goto bf917; fab8b: $rclone->purge($purgeRemotePath); goto d6a97; B5310: try { $isValidDate = true; $directoryDate = new \DateTime($directoryName); } catch (\Exception $e) { $isValidDate = false; } goto befac; ed8bf: A6077: goto E0bc0; d6904: f9def: goto Fd8a0; c316c: E1159: goto fab8b; Cba7b: $purgeRemotePath = sprintf("\57\x25\163", ltrim($purgeRemotePath, "\x2f")); goto c316c; cde2f: if (!(false === is_null($directoryName))) { goto f9def; } goto B5310; A63ca: fc011: goto d6904; Fd8a0: d5e7b: goto E81a5; fed2d: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto A6077; } goto fad1f; Ef7b7: $directoryName = $directory["\x4e\141\155\145"] ?? null; goto cde2f; befac: if (!(true === $isValidDate)) { goto fc011; } goto Dd4a8; E81a5: } goto Db1b7; b09b1: Ac506: goto C35a2; D3bf3: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto e9afb; } goto Ed2e2; C4b95: if (!(false === empty($directories))) { goto Ac506; } goto Ef224; b2b0f: $directories = (array) $rclone->lsJson($remotePath, true); goto C4b95; Fe8c6: $remotePath = sprintf("\45\x73\57\x25\x73\57", $remotePath, rtrim(ltrim($storageDirectory, "\x2f"), "\x2f")); goto D3bf3; A8654: $deleteDateTime->setTimezone(new \DateTimeZone("\125\x54\103")); goto B6b72; Db1b7: a1611: goto b09b1; B6b72: $deleteDateTime->setTime(0, 0, 0, 0); goto A915a; df060: $rclone = new Rclone(); goto b3f3a; e275f: De686: goto Fe8c6; A915a: $remotePath = ''; goto df060; B2cf0: $deleteDateTime = clone $dateTime; goto c5303; b3f3a: switch ($this->storageProvider) { case StorageProvider::AMAZON_S3: case StorageProvider::WASABI: $remotePath = $this->getConfigValue("\162\x65\x6d\x6f\x74\145\137\x62\141\x63\153\165\160\x5f\x62\x75\143\x6b\145\164"); goto De686; case StorageProvider::DIGITAL_OCEAN_SPACES: $remotePath = $this->getConfigValue("\162\145\x6d\157\x74\x65\137\x62\141\x63\153\165\160\x5f\x73\160\141\143\x65"); goto De686; case StorageProvider::GOOGLE_DRIVE: goto f73c0; f41fd: $rclone->addFlag("\55\x2d\144\x72\151\166\145\55\x69\155\x70\x65\x72\163\157\x6e\141\164\145", $email); goto b6d56; f73c0: $email = $this->getConfigValue("\x72\x65\x6d\x6f\x74\145\137\142\141\x63\153\x75\x70\137\x65\x6d\141\x69\x6c"); goto f41fd; b6d56: goto De686; goto dbeb1; dbeb1: } goto a67f6; C35a2: } catch (\Exception $e) { goto b4ad3; b4ad3: $errorMessage = $e->getMessage(); goto Cb0b5; fe830: $this->addNotification($subject, $errorMessage); goto e181e; Cb0b5: $subject = sprintf("\122\x65\x6d\x6f\164\x65\40\102\x61\x63\153\x75\160\40\143\154\145\141\156\x75\x70\x20\x66\x61\151\154\145\x64\56"); goto fe830; e181e: } goto fcb0f; F06c8: $retentionPeriod = (int) $this->getConfigValue("\162\x65\x6d\157\x74\x65\x5f\x62\141\x63\x6b\x75\x70\x5f\162\x65\164\145\156\164\151\157\x6e\137\x70\145\x72\x69\157\144"); goto a6db5; a6db5: $storageDirectory = $this->getConfigValue("\x72\x65\155\157\164\x65\137\142\x61\x63\153\165\160\137\x73\164\157\162\141\147\x65\x5f\x64\151\x72\145\x63\x74\157\x72\x79"); goto B28d5; B28d5: if (!($retentionPeriod && false === empty($storageDirectory))) { goto Ead85; } goto F5aa7; f817a: } private function refreshDropboxAccessToken(bool $delay) { try { goto Db2e5; d307f: B1a60: goto af3ef; ab575: if (false === empty($token)) { goto Faa55; } goto F789a; Bdd55: $rclone = new Rclone(); goto Bea68; F789a: throw new \Exception("\101\x63\143\145\163\163\x20\x54\157\x6b\145\x6e\40\x63\141\156\x6e\157\164\40\x62\x65\40\x65\x6d\160\x74\x79\x2e"); goto C3f61; af3ef: $refreshToken = $this->getConfigValue("\x72\145\x6d\x6f\164\145\137\x62\141\143\x6b\x75\x70\x5f\x72\x65\x66\162\x65\163\150\137\x74\x6f\x6b\145\x6e"); goto d38ef; d32be: E5eb7: goto c4cbe; c85b6: $rcloneConfigTemplate->setToken($token); goto d1f0b; Cae7b: $token = $dropboxClient->getAccessToken($refreshToken); goto ab575; c6f17: $rcloneConfigTemplate = new DropboxConfigTemplate(); goto c85b6; D823e: sleep(rand(5, 60)); goto d307f; c0d49: $rcloneConfig = $rcloneConfigBuilder->build(); goto Bdd55; B1166: Faa55: goto c6f17; C3f61: goto E5eb7; goto B1166; d1f0b: $rcloneConfigBuilder = new RcloneConfigBuilder($rcloneConfigTemplate); goto c0d49; d38ef: $dropboxClient = new DropboxClient(); goto Cae7b; Bea68: $rclone->writeConfig($rcloneConfig); goto d32be; Db2e5: if (!(true === $delay)) { goto B1a60; } goto D823e; c4cbe: } catch (\Exception $e) { $errorMessage = $e->getMessage(); $this->addNotification("\x52\145\x66\162\145\163\x68\151\x6e\147\40\x44\x72\157\x70\x62\157\170\x20\x41\x63\143\145\x73\163\40\124\157\153\145\156\x20\x46\141\x69\x6c\x65\144", $errorMessage); } } private function addNotification(string $subject, string $errorMessage) : void { goto f759c; f759c: $notification = new Notification(); goto Db697; b1416: $notification->setMessage($errorMessage); goto D499e; Db697: $notification->setSubject($subject); goto b1416; D499e: $notification->setSeverity(Notification::SEVERITY_CRITICAL); goto Bf302; Bf302: NotificationQueue::addNotification($notification); goto e2e22; e2e22: } }
