<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\NodejsSettings as NodejsSettingsEntity; use App\Site\NodejsSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\NodejsTemplate as NodejsVhostTemplate; use App\Site\Creator\NodejsSite as NodejsSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddNodejsCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x4e\157\x64\145\152\163"; protected function configure() : void { goto D945b; b6a90: $this->addOption("\x73\151\164\145\x55\x73\x65\162", null, InputOption::VALUE_REQUIRED); goto Db88b; Cdcf2: $this->setComment("\101\144\144\x69\x6e\x67\x20\141\x20\116\157\144\x65\x2e\152\x73\x20\x53\x69\x74\145"); goto Bc0b5; f7598: $this->addOption("\x61\x70\160\x50\157\162\x74", null, InputOption::VALUE_REQUIRED); goto b6a90; Db88b: $this->addOption("\x73\x69\x74\x65\125\x73\145\162\120\x61\x73\x73\167\x6f\x72\x64", null, InputOption::VALUE_REQUIRED); goto ac4c0; Baf99: $this->addOption("\156\x6f\144\145\152\163\126\145\162\163\151\x6f\156", null, InputOption::VALUE_REQUIRED); goto f7598; D70d0: $this->setDescription("\143\x6c\160\x63\164\154\40\x73\151\164\145\x3a\x61\x64\x64\x3a\156\x6f\x64\x65\152\163\x20\x2d\55\x64\157\x6d\x61\x69\156\116\x61\x6d\145\x3d\167\x77\x77\x2e\144\157\155\x61\151\156\x2e\x63\x6f\155\40\x2d\55\x6e\x6f\x64\145\152\x73\x56\x65\162\x73\x69\x6f\156\75\62\x32\x20\x2d\x2d\141\160\x70\120\x6f\x72\164\x3d\x33\x30\60\x30\x20\x2d\55\x73\x69\164\145\x55\163\x65\162\x3d\152\x6f\150\156\x20\55\55\x73\151\164\x65\x55\163\145\162\120\141\x73\163\x77\x6f\162\144\75\47\41\x73\x65\x63\162\x65\x74\x50\x61\163\x73\x77\157\x72\144\41\x27"); goto Cdcf2; Bc0b5: $this->addOption("\x64\157\155\141\151\156\x4e\141\155\145", null, InputOption::VALUE_REQUIRED); goto Baf99; D945b: $this->setName("\163\151\164\145\x3a\x61\x64\x64\72\x6e\x6f\x64\x65\152\x73"); goto D70d0; ac4c0: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto Ea340; eac15: $nodejsSite->setCertificate($certificateEntity); goto C45af; dd4ae: $nodejsSite->setUser($siteEntity->getUser()); goto fa4d5; cf06c: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto df07e; b6c9b: if (0 == count($siteConstraints) && 0 == count($nodejsSettingsConstraints)) { goto e85c4; } goto ff7b8; Ca58e: return SiteCommand::SUCCESS; goto F1a37; F3feb: $subdomain = $resolvedDomainName->subDomain()->toString(); goto D8938; Fc5af: $siteEntity->setUser($siteUser); goto e2f54; Edadf: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\56\56\57\56\56\x2f\162\x65\x73\x6f\x75\x72\x63\145\163\x2f\156\x67\151\x6e\x78\57\x76\150\157\163\x74\x5f\x74\145\x6d\x70\154\141\x74\x65\x2f\x72\145\x64\x69\x72\145\143\x74"); goto ebd2f; acd30: $subjectAlternativeNames = []; goto feee5; bd34b: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto b3bb5; b36c0: $siteEntity->setDomainName($domainName); goto Ce0b3; dd8d4: $nodejsSiteCreator->createLogrotateFile(); goto a08f3; E0370: if (false === is_null($vhostTemplateEntity)) { goto caaea; } goto a8267; C5306: $nodejsSettingsConstraints = $this->validator->validate($nodejsSettingsEntity); goto b6c9b; Dbf70: if (!(false === is_null($subdomain) && "\x77\x77\x77" == $subdomain)) { goto fe330; } goto Dcdb8; a412e: $nodejsSite->setDomainName($domainName); goto E1df1; Dcdb8: $subjectAlternativeNames[] = $registrableDomain; goto e640a; E3252: $nodejsSiteCreator->installNodejs(); goto A6ef2; E137c: $siteConstraints = $this->validator->validate($siteEntity); goto C5306; Fba53: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto d128e; ecab9: $nodejsSite->setNodejsSettings($nodejsSettingsEntity); goto eac15; a76da: $siteEntity->setCertificate($certificateEntity); goto eebab; Ac7d1: $domainName = mb_strtolower(trim($input->getOption("\144\x6f\155\141\151\156\116\141\155\x65"))); goto F2249; d128e: $vhostTemplate->resetProcessors(); goto bd34b; a9a40: $nodejsSettingsEntity = new NodejsSettingsEntity(); goto a20b6; edd9d: $nodejsSite->setSubdomain($subdomain); goto B43cf; F6d6b: a6000: goto Bfd57; Ce0b3: $siteEntity->setRootDirectory($rootDirectory); goto Fc5af; c87cc: Fa8de: goto B7bce; ea908: $certificateEntity->setDefaultCertificate(true); goto Da412; ebda9: $certificateEntity->setCsr($csr); goto aa39f; e2f54: $siteEntity->setUserPassword($siteUserPassword); goto E62fe; F2249: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto A42cd; Ddfb2: $siteEntity->setType(SiteEntity::TYPE_NODEJS); goto b36c0; dccf5: $appPort = (int) $input->getOption("\x61\160\160\120\x6f\x72\x74"); goto Bf93a; a08f3: $nodejsSiteCreator->createNvmDirectory(); goto E3252; C1133: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto ea908; Bdba6: B3d2c: goto a64be; Ea340: $this->validateInput($input); goto Ac7d1; Fea1b: $output->writeln(sprintf("\74\151\156\146\x6f\76\x53\x69\x74\x65\74\x2f\x69\156\146\x6f\76\40\74\143\x6f\155\x6d\x65\156\x74\76\x25\163\x3c\x2f\143\157\x6d\x6d\x65\156\164\x3e\40\74\151\156\x66\x6f\x3e\150\141\x73\40\142\145\x65\156\40\x61\144\144\x65\144\x2e\x3c\x2f\151\156\x66\x6f\x3e", $domainName)); goto Ca58e; d59b5: goto a77b9; goto a1b02; b3208: $subjectAlternativeNames[] = sprintf("\x77\x77\167\x2e\45\x73", $domainName); goto A5560; a55b2: if (true === isset($_ENV["\101\x50\x50\x5f\x48\x54\x54\x50\x33"]) && "\164\x72\165\x65" === $_ENV["\101\x50\120\137\110\x54\124\120\x33"]) { goto B3d2c; } goto Edadf; e8688: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto f63de; edfe3: $nodejsSiteCreator->resetPermissions(); goto Dfbe7; b0ce8: a77b9: goto e3d98; ff7b8: $constraints = new ConstraintViolationList(); goto f752e; feee5: if (!(true === is_null($subdomain))) { goto D4f77; } goto b3208; d66a5: $certificateEntity->setSite($siteEntity); goto d27cb; B6a48: $vhostTemplate = sprintf("\x25\163\x25\x73", $redirectionVhostTemplate, $vhostTemplate); goto c9236; f63de: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto b19e8; b02c1: $siteEntity = $this->siteEntityManager->createEntity(); goto Ddfb2; A42cd: $rootDirectory = $domainName; goto cb90d; Ca06c: $this->siteEntityManager->updateEntity($siteEntity); goto Fea1b; Da412: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto ebda9; d0138: $nodejsSettingsEntity->setSite($siteEntity); goto E137c; ed5df: $certificateEntity->setCertificate($selfSignedCertificate); goto a76da; e640a: fe330: goto e8688; ebd2f: goto Fa8de; goto Bdba6; A6ef2: $nodejsSiteCreator->createPrivateKeyAndCertificate(); goto af34d; a88fa: if (!(false === empty($redirectionVhostTemplate))) { goto b7299; } goto B6a48; c9236: b7299: goto F6d6b; B7bce: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto a88fa; af6c9: $nodejsSiteCreator->createRootDirectory(); goto dd8d4; d27cb: $rsaKeyGenerator = new RsaKeyGenerator(); goto Cbd60; c8d37: e85c4: goto Eb122; Bf93a: $siteUser = trim($input->getOption("\163\x69\x74\x65\x55\163\145\162")); goto f791f; af34d: $nodejsSiteCreator->createNginxVhost(); goto F67f1; a7e53: goto d84af; goto c8d37; Ac7e6: $nodejsSiteCreator->createUser(); goto af6c9; C45af: $nodejsSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto af94a; aa8ca: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto b02c1; F67f1: $nodejsSiteCreator->reloadNginxService(); goto edfe3; cb90d: $nodejsVersion = (int) $input->getOption("\x6e\x6f\144\145\152\x73\126\x65\x72\x73\151\x6f\x6e"); goto dccf5; D85f8: $nodejsSettingsEntity->setNodejsVersion($nodejsVersion); goto d936d; B43cf: $nodejsSite->setRootDirectory($siteEntity->getRootDirectory()); goto ecab9; b3bb5: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto d14fd; a20b6: $siteEntity->setNodejsSettings($nodejsSettingsEntity); goto D85f8; aa39f: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto ed5df; E1df1: $nodejsSite->setRegistrableDomain($registrableDomain); goto edd9d; a64be: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\56\x2e\57\56\x2e\x2f\x72\x65\x73\x6f\165\x72\143\145\x73\x2f\x6e\147\151\x6e\x78\57\166\150\x6f\x73\164\x5f\x74\145\155\x70\x6c\141\x74\145\57\162\145\x64\x69\x72\145\x63\x74\x2d\x68\x74\x74\160\x33"); goto c87cc; df07e: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto F3feb; d14fd: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto ad68c; fcfb1: return $this->renderConstraints($constraints, $output); goto a7e53; f752e: $constraints->addAll($siteConstraints); goto f83ab; E54bd: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto E0370; A5560: D4f77: goto Dbf70; d936d: $nodejsSettingsEntity->setPort($appPort); goto d0138; fa4d5: $nodejsSite->setUserPassword($siteEntity->getUserPassword()); goto a412e; af94a: $nodejsSiteCreator = new NodejsSiteCreator($nodejsSite); goto Ac7e6; F1a37: d84af: goto b0ce8; ad68c: $vhostTemplate->build(); goto A6720; D8938: $subdomain = false === empty($subdomain) ? $subdomain : null; goto E54bd; E62fe: if (!(true === is_null($subdomain) || "\167\x77\167" == $subdomain)) { goto a6000; } goto a55b2; Bfd57: $siteEntity->setVhostTemplate($vhostTemplate); goto a9a40; C6529: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto Ca06c; Eb122: $certificateEntity = $this->certificateEntityManager->createEntity(); goto d66a5; f791f: $siteUserPassword = trim($input->getOption("\163\151\164\145\125\163\145\162\x50\141\x73\163\167\x6f\162\144")); goto cf06c; a1b02: caaea: goto aa8ca; f83ab: $constraints->addAll($nodejsSettingsConstraints); goto fcfb1; Dfbe7: $vhostTemplate = new NodejsVhostTemplate($nodejsSite); goto Fba53; b19e8: $csr = $csrGenerator->generate(); goto C1133; a8267: throw new \Exception(sprintf("\x56\150\157\x73\x74\40\x54\145\155\160\154\x61\x74\145\40\x22\45\x73\42\40\144\157\x65\163\40\156\157\164\x20\145\170\151\x73\x74\56", $vhostTemplate)); goto d59b5; eebab: $nodejsSite = new NodejsSite(); goto dd4ae; Cbd60: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto acd30; A6720: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto C6529; e3d98: } catch (\Exception $e) { goto cf43b; a6105: return SiteCommand::FAILURE; goto aaaf0; D8fa7: $output->writeln(sprintf("\x3c\145\162\162\x6f\162\x3e\45\x73\x3c\57\x65\162\x72\157\162\x3e", $errorMessage)); goto a6105; cf43b: $errorMessage = $e->getMessage(); goto D8fa7; aaaf0: } } }
