<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Site\StaticSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\StaticTemplate as StaticVhostTemplate; use App\Site\Creator\StaticSite as StaticSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddStaticCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x53\164\141\164\151\x63"; protected function configure() : void { goto c60b8; fa61d: $this->addOption("\163\x69\x74\145\125\x73\145\162\120\141\163\x73\167\157\162\144", null, InputOption::VALUE_REQUIRED); goto A7d3d; c60b8: $this->setName("\163\151\x74\x65\x3a\x61\x64\x64\72\x73\x74\x61\x74\151\x63"); goto b1004; A5d06: $this->addOption("\x73\151\164\145\125\x73\145\162", null, InputOption::VALUE_REQUIRED); goto fa61d; b1004: $this->setDescription("\143\x6c\160\x63\x74\x6c\x20\x73\151\164\x65\72\141\x64\144\72\x73\x74\x61\164\151\x63\x20\55\x2d\x64\157\155\141\151\156\x4e\x61\x6d\x65\x3d\167\167\x77\x2e\x64\x6f\155\141\151\156\x2e\143\x6f\155\x20\x2d\x2d\163\151\164\145\x55\163\145\x72\x3d\152\157\x68\x6e\40\x2d\55\x73\151\164\x65\125\x73\x65\x72\x50\141\163\x73\x77\157\x72\144\75\47\x21\163\145\x63\162\x65\x74\120\x61\x73\163\167\x6f\162\x64\41\x27"); goto A4859; A4859: $this->setComment("\101\x64\x64\x69\x6e\x67\x20\141\40\123\164\x61\164\151\143\40\110\124\115\x4c\40\123\x69\164\x65"); goto Cbaa4; Cbaa4: $this->addOption("\144\157\x6d\x61\151\156\116\x61\x6d\x65", null, InputOption::VALUE_REQUIRED); goto A5d06; A7d3d: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto b6a03; D2dab: Cc761: goto db675; Fafdb: $staticSiteCreator->createLogrotateFile(); goto b2112; c39e3: $staticSite = new StaticSite(); goto D881e; Dd76a: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto Aa7a5; Ac1c3: $certificateEntity->setSite($siteEntity); goto D1b34; e40f1: $staticSiteCreator = new StaticSiteCreator($staticSite); goto Dfae5; e4e05: $siteUser = trim($input->getOption("\163\151\x74\x65\125\163\145\x72")); goto e0ac9; Eca9b: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto a9ca5; a6d05: return $this->renderConstraints($constraints, $output); goto A2f28; b4423: $staticSite->setUserPassword($siteEntity->getUserPassword()); goto Df430; F4d4e: return SiteCommand::SUCCESS; goto d10c9; C0c9e: if (false === is_null($vhostTemplateEntity)) { goto B7aa9; } goto F44c2; F8997: $staticSiteCreator->createNginxVhost(); goto B6804; C49e6: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto C0c9e; ecf5b: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto c061a; c061a: $siteEntity = $this->siteEntityManager->createEntity(); goto E872e; Df1d5: $domainName = mb_strtolower(trim($input->getOption("\x64\x6f\x6d\x61\x69\156\x4e\141\155\x65"))); goto C9ddf; Aa7a5: $vhostTemplate->resetProcessors(); goto f3f0d; cfa30: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto dd8a0; Ffd33: $csr = $csrGenerator->generate(); goto e55b2; f2b08: $staticSite->setRegistrableDomain($registrableDomain); goto D900f; E15f7: if (!(false === empty($redirectionVhostTemplate))) { goto bb6c3; } goto f0117; ca1b5: $staticSiteCreator->createRootDirectory(); goto Fafdb; E5fee: $constraints = new ConstraintViolationList(); goto Dbda0; Df430: $staticSite->setDomainName($domainName); goto f2b08; Ebc84: goto E95c0; goto b9b16; D76cc: if (!(true === is_null($subdomain))) { goto E4cab; } goto C8d90; e555c: Cb2aa: goto a1f7d; d10c9: eef54: goto ce014; B3023: if (true === isset($_ENV["\x41\x50\x50\137\110\124\124\x50\63"]) && "\x74\x72\165\x65" === $_ENV["\101\x50\x50\x5f\110\x54\x54\x50\x33"]) { goto Cb2aa; } goto E9b93; F151e: Fb0a6: goto b30cd; D1788: $staticSite->setRootDirectory($siteEntity->getRootDirectory()); goto ce965; b30b1: $siteEntity->setRootDirectory($rootDirectory); goto b3d30; D900f: $staticSite->setSubdomain($subdomain); goto D1788; A8546: $siteEntity->setCertificate($certificateEntity); goto c39e3; f3309: $certificateEntity->setCsr($csr); goto e2154; D881e: $staticSite->setUser($siteEntity->getUser()); goto b4423; a8259: $vhostTemplate = new StaticVhostTemplate($staticSite); goto Dd76a; d13d9: $subjectAlternativeNames = []; goto D76cc; E4dd1: goto Fb0a6; goto e555c; c05c8: $certificateEntity->setDefaultCertificate(true); goto d7acc; e0ac9: $siteUserPassword = trim($input->getOption("\163\151\164\x65\x55\x73\145\162\x50\141\163\163\x77\157\162\x64")); goto a3ffe; b76bc: $subjectAlternativeNames[] = $registrableDomain; goto c6c4d; ce965: $staticSite->setCertificate($certificateEntity); goto Dcb3f; C9ddf: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto d4f30; a073a: $vhostTemplate->build(); goto Eca9b; C31f2: $certificateEntity = $this->certificateEntityManager->createEntity(); goto Ac1c3; c6c4d: cc4f8: goto f2691; cbd2c: $this->siteEntityManager->updateEntity($siteEntity); goto bd18f; B1b11: bb6c3: goto D2dab; e3db5: $subdomain = false === empty($subdomain) ? $subdomain : null; goto C49e6; B6804: $staticSiteCreator->reloadNginxService(); goto E5c75; E5f49: $subdomain = $resolvedDomainName->subDomain()->toString(); goto e3db5; E872e: $siteEntity->setType(SiteEntity::TYPE_STATIC); goto f7268; D6354: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto d13d9; E9056: if (!(true === is_null($subdomain) || "\x77\167\x77" == $subdomain)) { goto Cc761; } goto B3023; E9b93: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\x2e\56\x2f\56\56\57\162\145\x73\157\165\x72\143\x65\x73\57\x6e\x67\x69\x6e\x78\x2f\x76\150\157\163\x74\137\x74\x65\155\x70\154\x61\164\x65\57\162\145\144\151\x72\145\143\164"); goto E4dd1; E823a: if (0 == count($siteConstraints)) { goto eb8ae; } goto E5fee; b9b16: B7aa9: goto ecf5b; b6a03: $this->validateInput($input); goto Df1d5; a3ffe: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto Bda6b; f7268: $siteEntity->setDomainName($domainName); goto b30b1; f3f0d: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto cfa30; F44c2: throw new \Exception(sprintf("\x56\150\x6f\163\x74\40\124\145\155\160\x6c\x61\164\x65\x20\x22\x25\x73\42\40\x64\157\145\163\40\156\x6f\x74\40\x65\170\151\x73\164\56", $vhostTemplate)); goto Ebc84; Dee8e: E4cab: goto E8102; d4f30: $rootDirectory = $domainName; goto e4e05; b2112: $staticSiteCreator->createIndexHtml(); goto Ad2a9; d7acc: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto f3309; e55b2: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto c05c8; f2691: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto F9c39; D1b34: $rsaKeyGenerator = new RsaKeyGenerator(); goto D6354; ce014: E95c0: goto ac822; C8d90: $subjectAlternativeNames[] = sprintf("\x77\167\167\56\45\x73", $domainName); goto Dee8e; b048c: $siteConstraints = $this->validator->validate($siteEntity); goto E823a; b30cd: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto E15f7; B91d9: $siteEntity->setUserPassword($siteUserPassword); goto E9056; E5c75: $staticSiteCreator->resetPermissions(); goto a8259; bd18f: $output->writeln(sprintf("\x3c\x69\x6e\146\157\x3e\123\x69\164\145\x3c\57\151\x6e\x66\157\x3e\x20\74\x63\x6f\155\x6d\145\x6e\164\x3e\45\163\74\57\143\157\155\x6d\145\x6e\164\x3e\40\74\151\156\146\157\x3e\150\x61\163\x20\142\x65\x65\x6e\x20\141\x64\144\x65\x64\56\x3c\x2f\x69\156\x66\x6f\76", $domainName)); goto F4d4e; a1f7d: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\x2e\56\x2f\x2e\56\x2f\x72\145\163\157\165\x72\x63\x65\163\57\156\147\151\156\x78\x2f\166\150\157\163\164\137\x74\145\155\160\x6c\x61\x74\145\57\162\145\x64\151\162\x65\x63\x74\x2d\x68\x74\164\160\63"); goto F151e; Ad2a9: $staticSiteCreator->createPrivateKeyAndCertificate(); goto F8997; b3d30: $siteEntity->setUser($siteUser); goto B91d9; db675: $siteEntity->setVhostTemplate($vhostTemplate); goto b048c; Dcb3f: $staticSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto e40f1; e2154: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto A68f4; F9c39: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto Ffd33; Bda6b: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto E5f49; dd8a0: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto a073a; E8102: if (!(false === is_null($subdomain) && "\x77\167\x77" == $subdomain)) { goto cc4f8; } goto b76bc; A68f4: $certificateEntity->setCertificate($selfSignedCertificate); goto A8546; f0117: $vhostTemplate = sprintf("\x25\163\x25\x73", $redirectionVhostTemplate, $vhostTemplate); goto B1b11; Dfae5: $staticSiteCreator->createUser(); goto ca1b5; A2f28: goto eef54; goto a8d69; a9ca5: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto cbd2c; a8d69: eb8ae: goto C31f2; Dbda0: $constraints->addAll($siteConstraints); goto a6d05; ac822: } catch (\Exception $e) { goto eae9e; be05a: $output->writeln(sprintf("\x3c\145\162\162\x6f\162\x3e\x25\163\74\57\145\x72\x72\157\x72\76", $errorMessage)); goto ed561; ed561: return SiteCommand::FAILURE; goto fe9c3; eae9e: $errorMessage = $e->getMessage(); goto be05a; fe9c3: } } }
