<?php
 namespace App\Command; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use Doctrine\Common\Collections\ArrayCollection; use App\Command\Command as BaseCommand; use App\Entity\Site as SiteEntity; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\ReverseProxySite; use App\Site\Deleter as SiteDeleter; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Updater\ReverseProxySite as ReverseProxySiteUpdater; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Deleter\ReverseProxySite as ReverseProxySiteDeleter; use App\Site\Parser\DomainName as DomainNameParser; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\VhostTemplateManager as VhostTemplateEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; class SiteCommand extends BaseCommand { protected DomainNameParser $domainNameParser; protected SiteEntityManager $siteEntityManager; protected CertificateEntityManager $certificateEntityManager; protected DatabaseServerEntityManager $databaseServerEntityManager; protected VhostTemplateEntityManager $vhostTemplateEntityManager; protected ValidatorInterface $validator; public function __construct(DomainNameParser $domainNameParser, SiteEntityManager $siteEntityManager, CertificateEntityManager $certificateEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, VhostTemplateEntityManager $vhostTemplateEntityManager, ValidatorInterface $validator) { goto D8617; E712e: $this->validator = $validator; goto f3e26; D8617: $this->domainNameParser = $domainNameParser; goto d80b1; d80b1: $this->siteEntityManager = $siteEntityManager; goto E6c87; f3e26: parent::__construct(); goto D51cf; E6c87: $this->certificateEntityManager = $certificateEntityManager; goto b5f14; dd69c: $this->vhostTemplateEntityManager = $vhostTemplateEntityManager; goto E712e; b5f14: $this->databaseServerEntityManager = $databaseServerEntityManager; goto dd69c; D51cf: } protected function configure() : void { $this->setName("\163\x69\164\145\72\x74\155\x70"); } protected function getSite(string $domainName) : ?Site { goto c5c7c; c8c1e: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto d91d1; A2b94: goto F14bb; goto A3367; d6116: $site->setFtpUsers($siteEntity->getFtpUsers()); goto a20d6; f41ae: $site->setBasicAuth($siteEntity->getBasicAuth()); goto d3418; da09d: $site->setRegistrableDomain($registrableDomain); goto E8952; c5c7c: $site = null; goto Caf74; Fd17a: $site->setCertificates($siteEntity->getCertificates()); goto Ab4be; Ab4be: $site->setCronJobs($siteEntity->getCronJobs()); goto d6116; a53fb: $site->setDomainName($siteEntity->getDomainName()); goto da09d; f72c8: $site->setCertificate($siteEntity->getCertificate()); goto Fd17a; fd327: $siteDatabases = $this->getSiteDatabases($siteEntity); goto a6bdf; Cddb0: $site->setBlockedIps($siteEntity->getBlockedIps()); goto f72c8; B307c: d2100: goto A2537; C7e78: e8604: goto D9833; d3418: $site->setBlockedBots($siteEntity->getBlockedBots()); goto Cddb0; C0b43: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto c8c1e; f494a: $site->setRootDirectory($siteEntity->getRootDirectory()); goto Cacc9; aa53e: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto Ba2e4; e2fde: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto De20a; De20a: $site = new NodejsSite(); goto Eac72; c206a: goto e8604; goto Bec33; Eac72: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto c206a; Bec33: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto e8604; case SiteEntity::TYPE_PHP: goto Ada49; Ada49: $site = new PhpSite(); goto B24bc; B24bc: $site->setPhpSettings($siteEntity->getPhpSettings()); goto b4166; b4166: $site->setVarnishCache($siteEntity->getVarnishCache()); goto Da2e1; Da2e1: goto e8604; goto F6e3f; F6e3f: case SiteEntity::TYPE_PYTHON: goto A1d18; E0dc2: $site->setPythonSettings($siteEntity->getPythonSettings()); goto a54a8; A1d18: $site = new PythonSite(); goto E0dc2; a54a8: goto e8604; goto Ca617; Ca617: case SiteEntity::TYPE_REVERSE_PROXY: goto e954a; Df435: goto e8604; goto d78b5; e954a: $site = new ReverseProxySite(); goto Da1c8; Da1c8: $site->setReverseProxyUrl($siteEntity->getReverseProxyUrl()); goto Df435; d78b5: } goto fc7fa; Ba2e4: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto Eab50; A3367: c6ebc: goto Fcaea; Cacc9: $site->setDatabases($siteDatabases); goto f41ae; E5d4b: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto B307c; a20d6: $site->setSshUsers($siteEntity->getSshUsers()); goto C0b43; A2537: F14bb: goto Ca4cc; Bac5c: if (false === is_null($siteEntity)) { goto c6ebc; } goto a0262; Fcaea: $siteType = $siteEntity->getType(); goto e2fde; d91d1: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto E5d4b; D9833: if (!(false === is_null($site))) { goto d2100; } goto aa53e; a0262: throw new \Exception(sprintf("\123\151\164\x65\40\42\45\x73\42\40\x64\157\145\x73\x20\x6e\x6f\x74\x20\x65\170\151\163\x74\56", $domainName)); goto A2b94; Caf74: $siteEntity = $this->getSiteEntity($domainName); goto Bac5c; Eab50: $subdomain = $resolvedDomainName->subDomain()->toString(); goto D88b8; E8952: $site->setSubdomain($subdomain); goto f494a; D88b8: $subdomain = false === empty($subdomain) ? $subdomain : null; goto fd327; fc7fa: D2fe4: goto C7e78; Ca4cc: return $site; goto e4ca2; a6bdf: $site->setUser($siteEntity->getUser()); goto a53fb; e4ca2: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto a0e51; e90d3: foreach ($databaseEntities as $databaseEntity) { goto Ece68; feb4e: E0662: goto d2da6; D9313: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto B3e04; } goto Fd393; Fd393: $siteDatabases->add($databaseEntity); goto b1cee; Ece68: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto D9313; b1cee: B3e04: goto feb4e; d2da6: } goto e106f; a0e51: $siteDatabases = new ArrayCollection(); goto e27e8; C5856: $databaseEntities = $siteEntity->getDatabases(); goto e90d3; e106f: Ccf83: goto c7f45; e27e8: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto C5856; c7f45: return $siteDatabases; goto dee9a; dee9a: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto bbcfa; c478e: return $siteDeleter; goto E5b1d; cee25: c9c9b: goto fb146; Ded7c: $siteType = $site->getType(); goto e0fe0; bbcfa: $siteDeleter = null; goto Ded7c; fb146: c3a68: goto c478e; e0fe0: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto c3a68; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto c3a68; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto c3a68; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto c3a68; case SiteEntity::TYPE_REVERSE_PROXY: $siteDeleter = new ReverseProxySiteDeleter($site); goto c3a68; } goto cee25; E5b1d: } protected function getSiteUpdater(Site $site) : ?SiteUpdater { goto Dc51f; Ee376: return $siteUpdater; goto f20c0; C2f70: $siteType = $site->getType(); goto D7fb1; e6332: b1ce9: goto Ee376; D7fb1: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto b1ce9; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto b1ce9; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto b1ce9; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto b1ce9; case SiteEntity::TYPE_REVERSE_PROXY: $siteUpdater = new ReverseProxySiteUpdater($site); goto b1ce9; } goto C2d48; Dc51f: $siteUpdater = null; goto C2f70; C2d48: d11a3: goto e6332; f20c0: } protected function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } protected function getSiteEntityBySiteUser(string $siteUser) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByUser($siteUser); return $siteEntity; } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\x75\x73\145\162", "\x73\151\164\145\x55\163\x65\162", $constraints); $this->changePropertyPath("\165\163\145\162\x50\141\x73\163\167\157\x72\x64", "\x73\x69\164\145\x55\x73\x65\x72\120\x61\163\163\x77\x6f\162\144", $constraints); } }
