<?php
 namespace App\Controller\Admin; use Symfony\Component\Form\FormError; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Contracts\Translation\TranslatorInterface; use Symfony\Component\Form\Form; use App\Controller\Controller; use App\Event\EventQueue; use App\Service\Crypto; use App\Service\Logger; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Database\Connection as DatabaseConnection; use App\Entity\Manager\ConfigManager; use App\Entity\Certificate as CertificateEntity; use App\Entity\DatabaseServer as DatabaseServerEntity; use App\Security\Admin\CustomDomain as AdminCustomDomain; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\Certificate; use App\Site\Ssl\LetsEncryptClient; use App\Site\Ssl\Util\Openssl; class SettingsController extends Controller { private ConfigManager $configManager; private DatabaseServerEntityManager $databaseServerEntityManager; public function __construct(ConfigManager $configManager, DatabaseServerEntityManager $databaseServerEntityManager, TranslatorInterface $translator, Logger $logger) { goto D8d91; f2c85: parent::__construct($translator, $logger); goto a77e6; D8d91: $this->configManager = $configManager; goto c39ea; c39ea: $this->databaseServerEntityManager = $databaseServerEntityManager; goto f2c85; a77e6: } public function settings(Request $request) : Response { goto d182d; C7571: if (!(true === $request->isMethod("\x50\x4f\123\x54"))) { goto c3d1e; } goto b49c7; a01bc: $customDomainForm = $this->createCustomDomainForm($customDomainData); goto C7571; d182d: $customDomainName = $this->configManager->get("\143\165\163\x74\x6f\155\137\x64\x6f\155\x61\x69\x6e"); goto Dda9d; Dcf1a: $response = $this->handleCustomDomainForm($request, $customDomainForm); goto b485f; Ac90d: a2b1b: goto bd053; d932f: $response = $this->render("\x41\x64\155\x69\x6e\x2f\123\x65\164\x74\x69\x6e\x67\163\x2f\151\156\x64\145\x78\56\x68\x74\155\154\x2e\x74\167\x69\147", ["\143\x75\163\164\157\155\104\157\x6d\141\151\156\106\157\162\155" => $customDomainForm->createView(), "\146\157\x72\x6d\x45\162\x72\x6f\162\x73" => $this->formErrors]); goto F6a23; Dda9d: $customDomainData = ["\x64\157\155\141\x69\x6e\x4e\x61\155\145" => false === is_null($customDomainName) ? $customDomainName : '']; goto a01bc; f9ad2: return $response; goto Ac90d; F8a58: if (!(true === $customDomainForm->isSubmitted())) { goto C5a9b; } goto Dcf1a; c4adb: c3d1e: goto d932f; b49c7: $customDomainForm->handleRequest($request); goto F8a58; F6a23: return $response; goto Db037; bd053: C5a9b: goto c4adb; b485f: if (!(false === is_null($response))) { goto a2b1b; } goto f9ad2; Db037: } private function createCustomDomainForm(array $data) : Form { goto Cf76a; Cf76a: $form = $this->createForm("\101\x70\x70\134\x46\x6f\x72\x6d\x5c\101\x64\155\x69\x6e\103\165\163\x74\157\x6d\104\x6f\x6d\x61\151\156\123\145\164\164\151\156\147\x73\x54\171\x70\x65", $data, ["\141\143\164\x69\157\156" => $this->generateUrl("\143\x6c\160\137\x61\x64\x6d\x69\156\x5f\163\145\164\164\151\156\147\163"), "\155\145\x74\x68\157\144" => "\x50\117\x53\x54", "\141\x74\x74\x72" => []]); goto ed610; E125f: return $form; goto fa17e; ed610: $form->add("\x73\x75\142\155\x69\x74", SubmitType::class, ["\x61\164\164\x72" => ["\x63\x6c\x61\163\163" => "\x62\x74\156\x20\142\x74\x6e\x2d\x62\x6c\165\145\40\142\164\156\55\x6c\147"], "\x6c\x61\x62\x65\154" => "\x53\141\166\x65"]); goto E125f; fa17e: } private function handleCustomDomainForm(Request $request, Form $form) { goto cc372; ece64: bebeb: goto d1d8c; bca9a: Afe26: goto a6d4d; df5b8: goto Afe26; goto ece64; cc372: if (true === $form->isValid()) { goto bebeb; } goto af327; d1d8c: try { goto E37a4; Ec2d7: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto Ff628; e4353: return $response; goto B21ae; e937b: cc43b: goto D2f57; cef64: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto b8bc3; ddc06: $distinguishedNameDomains = $domains; goto b4630; F88cc: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto fb039; Aad83: return $response; goto e937b; C580e: $session->getFlashBag()->set("\163\165\x63\143\x65\x73\x73", $this->translator->trans("\x43\154\x6f\x75\144\x50\x61\156\145\154\x20\x43\x75\163\x74\x6f\155\x20\x44\x6f\x6d\141\151\156\40\x68\x61\163\x20\x62\145\145\x6e\40\163\x61\x76\145\x64\56")); goto D41e7; b4630: $commonName = array_shift($distinguishedNameDomains); goto F3619; b4757: $letsEncryptPrivateKey = $this->configManager->get("\154\x65\x5f\x70\162\x69\166\141\x74\x65\x5f\153\x65\x79"); goto cef64; Cfbab: $domainName = $form->get("\x64\x6f\x6d\x61\x69\x6e\x4e\141\155\x65")->getData(); goto Bc54f; B565c: $adminCustomDomain->delete(); goto a4568; Bd7cb: $adminCustomDomain->reloadNginx(); goto Fece4; A4c52: $certificate->setCertificate($selfSignedCertificate); goto a677a; b8bc3: $letsEncryptClient = new LetsEncryptClient($privateKey); goto ac022; a677a: $adminCustomDomain->deleteLetsEncryptChallengeFiles(); goto Fe604; d2a53: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto E1051; dc9bc: $adminCustomDomain->writePrivateKeyAndCertificate($certificate); goto ef235; Fece4: $this->configManager->set("\x63\165\163\x74\x6f\x6d\137\144\157\x6d\141\151\x6e", $domainName); goto bac98; b88f3: $certificate->setPrivateKey($privateKey->getPEM()); goto A4c52; f2a4f: e237f: goto E7d27; a258e: $adminCustomDomain->writeMotdFile($domainName); goto Bd7cb; D0bb8: $vhostTemplate = file_get_contents($vhostTemplateFile); goto ddc06; E37a4: $user = $this->getUser(); goto f0cab; ac022: $letsEncryptClient->registerAccount(); goto Ec2d7; E64ec: $this->formErrors = $this->getErrorMessages($form); goto F5919; A3462: $adminCustomDomain = new AdminCustomDomain(); goto B565c; D41e7: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\x61\x64\155\151\156\137\x73\x65\x74\x74\x69\x6e\x67\163")); goto Aad83; E570d: $rsaKeyGenerator = new RsaKeyGenerator(); goto fd835; F728e: foreach ($validationErrors as $domain => $validationErrorMessage) { $form->addError(new FormError(sprintf("\x25\163\72\x20\x25\163", $domain, $validationErrorMessage))); F69d4: } goto f711c; D2f57: c5b0a: goto ab5a9; ebad5: $session->getFlashBag()->set("\x73\x75\143\x63\x65\163\163", $this->translator->trans("\x43\x6c\157\x75\144\x50\x61\x6e\145\x6c\40\103\165\x73\164\x6f\x6d\x20\x44\x6f\155\141\151\156\x20\150\141\x73\40\142\145\145\156\40\163\141\166\x65\x64\x2e")); goto a761f; F68fe: A732c: goto a449e; B21ae: goto c5b0a; goto F68fe; a1971: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto a1726; F3619: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto E570d; F5919: goto cc43b; goto f2a4f; b5627: $adminCustomDomain->delete(); goto F728e; a761f: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x61\144\x6d\x69\156\x5f\163\x65\164\x74\151\x6e\147\x73")); goto e4353; E1051: $csr = $csrGenerator->generate(); goto F88cc; d1169: EventQueue::addEvent(EventQueue::EVENT_ADMIN_CUSTOM_DOMAIN_DISABLE, $user, [], $request); goto ebad5; B1552: $adminCustomDomain->writeVhostFile($domainName, $vhostTemplate); goto a258e; bac98: $eventData = ["\144\157\x6d\x61\151\x6e\116\141\x6d\x65" => $domainName]; goto d00ff; Aa622: $adminCustomDomain = new AdminCustomDomain(); goto b5627; a1726: if (true === empty($validationErrors)) { goto e237f; } goto Aa622; a449e: $domains = [$domainName]; goto b4757; B3dbc: $adminCustomDomain->reloadNginx(); goto a1971; E7d27: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto aa7ca; Cba07: if (false === empty($domainName)) { goto A732c; } goto A3462; a4568: $this->configManager->delete("\x63\x75\163\164\x6f\155\x5f\x64\x6f\155\x61\151\156"); goto d1169; Ff628: $vhostTemplateFile = realpath(dirname(__FILE__) . "\57\56\56\57\56\x2e\x2f\x2e\56\x2f\x72\x65\x73\x6f\165\x72\143\145\x73\57\x6e\x67\151\x6e\170\x2f\166\x68\x6f\163\164\x5f\164\x65\x6d\160\x6c\x61\x74\145\57\x63\165\x73\x74\157\x6d\55\x64\x6f\155\x61\151\156"); goto D0bb8; Bc54f: $adminCustomDomain = new AdminCustomDomain(); goto Cba07; aa7ca: $adminCustomDomain->writePrivateKeyAndCertificate($certificate); goto B1552; f711c: b2caa: goto E64ec; fb039: $certificate = new Certificate(); goto b88f3; Fe604: $adminCustomDomain->createLetsEncryptChallengeFiles($certificateOrder); goto dc9bc; fd835: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto d2a53; f0cab: $session = $request->getSession(); goto Cfbab; d00ff: EventQueue::addEvent(EventQueue::EVENT_ADMIN_CUSTOM_DOMAIN_ENABLE, $user, $eventData, $request); goto C580e; ef235: $adminCustomDomain->writeVhostFile($domainName, $vhostTemplate); goto B3dbc; ab5a9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\162", $this->translator->trans("\x41\x6e\x20\x65\162\x72\x6f\162\40\150\x61\x73\40\x6f\x63\143\x75\162\x72\x65\x64\x2c\x20\145\162\x72\x6f\162\x20\x6d\145\163\x73\141\147\145\72\40\45\x65\x72\x72\157\162\x4d\145\x73\x73\x61\147\145\45", ["\x25\145\x72\162\x6f\x72\115\145\x73\x73\x61\147\145\x25" => $e->getMessage()])); } finally { if (!(true === isset($adminCustomDomain))) { goto Bc3e6; } $adminCustomDomain->deleteLetsEncryptChallengeFiles(); Bc3e6: } goto bca9a; af327: $this->formErrors = $this->getErrorMessages($form); goto df5b8; a6d4d: } public function databaseServers(Request $request) : Response { goto E6740; e4c1f: $response = $this->render("\x41\144\x6d\x69\156\x2f\123\145\x74\164\151\x6e\x67\x73\57\104\141\164\x61\x62\x61\x73\x65\55\x53\145\x72\166\x65\162\163\57\x69\156\144\145\170\x2e\150\164\155\154\x2e\x74\167\151\x67", ["\x64\x61\164\x61\142\141\163\x65\123\x65\x72\x76\x65\x72\x73" => $databaseServers]); goto Ba93e; Ba93e: return $response; goto D095d; E6740: $databaseServers = $this->databaseServerEntityManager->findAll([], ["\x68\157\x73\164" => "\x41\x53\x43"]); goto e4c1f; D095d: } public function addDatabaseServer(Request $request) : Response { goto B5a4c; D1688: return $response; goto e307c; c874a: if (!(true === $form->isSubmitted())) { goto ebf59; } goto Dff0e; B5a4c: $databaseServerEntity = $this->databaseServerEntityManager->createEntity(); goto F2ea1; e307c: Bbe8b: goto A8236; f7cde: $response = $this->render("\x41\144\x6d\x69\x6e\57\x53\x65\164\x74\x69\x6e\147\x73\57\104\x61\164\141\x62\x61\163\x65\x2d\123\x65\x72\166\x65\162\x73\57\x61\144\x64\56\x68\164\155\x6c\x2e\164\167\151\147", ["\x66\x6f\x72\155" => $form->createView(), "\146\x6f\x72\155\105\x72\x72\x6f\x72\x73" => $this->formErrors]); goto d389b; A6662: Ea4bd: goto f7cde; Dff0e: $response = $this->handleDatabaseServerForm($request, $form); goto b01f1; Ae6e8: if (!(true === $request->isMethod("\120\117\123\x54"))) { goto Ea4bd; } goto ed59e; A8236: ebf59: goto A6662; F2ea1: $form = $this->createDatabaseServerForm($databaseServerEntity); goto Ae6e8; d389b: return $response; goto Ceeff; ed59e: $form->handleRequest($request); goto c874a; b01f1: if (!(false === is_null($response))) { goto Bbe8b; } goto D1688; Ceeff: } private function createDatabaseServerForm(DatabaseServerEntity $databaseServerEntity) : Form { goto d02ec; D653a: $form->add("\163\165\142\155\151\x74", SubmitType::class, ["\x61\164\164\x72" => ["\143\x6c\141\x73\163" => "\142\164\156\x20\142\x74\156\55\x62\154\x75\x65\40\x62\164\156\55\x6c\147"], "\x6c\141\142\145\154" => "\x41\144\x64\x20\x44\x61\x74\x61\x62\x61\163\x65\x20\x53\x65\162\x76\x65\162"]); goto B021f; d02ec: $form = $this->createForm("\x41\x70\160\x5c\x46\x6f\162\155\134\x41\144\155\x69\x6e\104\141\164\141\x62\141\163\x65\x53\x65\162\166\145\162\124\171\x70\x65", $databaseServerEntity, ["\141\143\164\151\x6f\156" => $this->generateUrl("\143\x6c\x70\x5f\x61\x64\155\151\156\137\x64\x61\164\141\x62\x61\x73\x65\137\x73\x65\162\x76\145\x72\x5f\x61\144\x64"), "\155\145\164\x68\157\x64" => "\120\x4f\123\124", "\141\164\x74\162" => []]); goto D653a; B021f: return $form; goto E9d50; E9d50: } private function handleDatabaseServerForm(Request $request, Form $form) { goto Ecc96; b8058: $this->formErrors = $this->getErrorMessages($form); goto e0771; B3151: e4b00: goto ec96e; ec96e: try { goto E2494; E2494: $user = $this->getUser(); goto c7e32; E68d7: $eventData = ["\150\157\x73\164" => $databaseServerEntity->getHost(), "\165\163\x65\x72\116\141\155\x65" => $databaseServerEntity->getUserName(), "\x70\x6f\x72\164" => $databaseServerEntity->getPort(), "\145\x6e\147\151\x6e\145" => $engine, "\x76\x65\162\x73\151\157\x6e" => $version]; goto a25b8; E46d0: $engine = $databaseConnection->getEngine(); goto bc4b2; Cf0e3: return $response; goto d326d; d64c1: $databaseServerEntity = $form->getData(); goto af1b7; B8b68: $databaseServerEntity->setEngine($engine); goto Aabee; d5d5c: $session->getFlashBag()->set("\x73\165\143\x63\145\163\163", $this->translator->trans("\x44\141\164\x61\x62\141\x73\145\x20\123\x65\162\x76\x65\x72\x20\150\x61\163\x20\142\x65\145\x6e\x20\141\x64\144\x65\x64\x2e")); goto d2a24; b34fe: $databaseServerEntity->setPassword($encryptedPassword); goto e2bbe; e2bbe: $databaseConnection = new DatabaseConnection($databaseServerEntity); goto E46d0; a6c0e: $databaseServerEntity->setIsDefault(false); goto E68d7; bc4b2: $version = $databaseConnection->getVersion(); goto B8b68; Aabee: $databaseServerEntity->setVersion($version); goto a6c0e; c7e32: $session = $request->getSession(); goto d64c1; Cacec: $this->databaseServerEntityManager->updateEntity($databaseServerEntity); goto d5d5c; d2a24: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\141\x64\155\151\156\137\x64\x61\164\141\x62\x61\x73\145\137\x73\x65\162\x76\x65\162\x73")); goto Cf0e3; af1b7: $password = $databaseServerEntity->getPassword(); goto D1b22; a25b8: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_ADD, $user, $eventData, $request); goto Cacec; D1b22: $encryptedPassword = Crypto::encrypt($password); goto b34fe; d326d: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\x72", $this->translator->trans("\x41\156\40\x65\x72\162\x6f\x72\40\x68\141\x73\x20\157\143\x63\165\x72\x72\145\x64\x2c\x20\145\162\162\157\162\x20\x6d\145\x73\x73\141\147\145\x3a\40\45\145\x72\162\x6f\162\115\145\163\163\x61\x67\145\x25", ["\45\x65\x72\162\x6f\x72\x4d\145\163\x73\141\147\x65\x25" => $e->getMessage()])); } goto aee7a; e0771: goto Fa376; goto B3151; aee7a: Fa376: goto B1284; Ecc96: if (true === $form->isValid()) { goto e4b00; } goto b8058; B1284: } public function editDatabaseServer(Request $request) : Response { goto d71c0; Fe58c: Bced8: goto ec405; Bdc39: if (!(true === $request->isMethod("\x50\117\123\124"))) { goto C2aec; } goto F46e2; b02ad: b1cfd: goto B7099; ec405: C2aec: goto D6723; D6723: $response = $this->render("\x41\x64\155\151\x6e\57\x53\145\164\x74\151\156\x67\x73\x2f\104\x61\164\141\x62\x61\163\x65\x2d\x53\x65\x72\166\145\162\x73\57\x65\x64\x69\x74\56\150\164\155\x6c\x2e\x74\x77\x69\x67", ["\144\141\x74\141\142\x61\x73\145\x53\x65\162\x76\145\162" => $databaseServerEntity, "\146\157\162\x6d" => $form->createView(), "\x66\157\x72\x6d\105\x72\x72\157\162\163" => $this->formErrors]); goto E92f9; A16e9: $databaseServerEntity = $this->databaseServerEntityManager->findOneById($id); goto ef92e; ef92e: if (true === is_null($databaseServerEntity)) { goto E21f4; } goto c8d64; B02ab: goto b1cfd; goto a9d4a; d2e83: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x61\x64\x6d\x69\156\137\x64\x61\164\x61\142\141\163\145\x5f\x73\x65\162\166\145\x72\163")); goto A9518; D7e26: $form = $this->createDatabaseServerEditForm($databaseServerEntity); goto Bdc39; Bfb25: if (!(false === is_null($response))) { goto Bd361; } goto Fa42d; E92f9: return $response; goto B02ab; b3de6: $response = $this->handleDatabaseServerEditForm($request, $form); goto Bfb25; Fa42d: return $response; goto Ddb9f; C83cb: if (!(true === $form->isSubmitted())) { goto Bced8; } goto b3de6; c8d64: $databaseServerEntity->setPassword(''); goto D7e26; d71c0: $id = (int) $request->get("\x69\144"); goto A16e9; a9d4a: E21f4: goto d2e83; A9518: return $response; goto b02ad; F46e2: $form->handleRequest($request); goto C83cb; Ddb9f: Bd361: goto Fe58c; B7099: } private function createDatabaseServerEditForm(DatabaseServerEntity $databaseServerEntity) : Form { goto c6efb; c6efb: $form = $this->createForm("\x41\160\x70\x5c\x46\157\162\155\134\101\144\155\151\156\x44\141\x74\141\142\141\163\x65\x53\145\x72\x76\x65\162\105\144\151\x74\124\x79\x70\x65", $databaseServerEntity, ["\x61\143\164\151\x6f\x6e" => $this->generateUrl("\143\x6c\160\137\x61\144\155\x69\x6e\137\x64\141\x74\141\142\x61\163\x65\x5f\x73\145\x72\166\x65\x72\137\145\x64\x69\164", ["\151\144" => $databaseServerEntity->getId()]), "\155\x65\164\x68\x6f\x64" => "\x50\x4f\123\x54", "\141\x74\164\x72" => []]); goto C3826; C3826: $form->add("\x73\165\142\x6d\151\x74", SubmitType::class, ["\141\164\x74\162" => ["\x63\x6c\141\x73\x73" => "\142\x74\156\x20\x62\x74\156\55\x62\x6c\x75\x65\40\x62\x74\x6e\55\x6c\147"], "\x6c\x61\142\145\x6c" => "\123\x61\x76\x65"]); goto ce55a; ce55a: return $form; goto E025d; E025d: } private function handleDatabaseServerEditForm(Request $request, Form $form) { goto Fc2b3; cf31e: $this->formErrors = $this->getErrorMessages($form); goto f4378; b6af4: try { goto Be622; A1f0c: $databaseServerEntity->setPassword($encryptedPassword); goto Df84c; bab78: $databaseServerEntity = $form->getData(); goto Caa84; Df84c: $databaseConnection = new DatabaseConnection($databaseServerEntity); goto F0eed; c820e: $databaseServerEntity->setIsDefault(false); goto ee26d; Be622: $user = $this->getUser(); goto eddfc; E87ef: $session->getFlashBag()->set("\x73\165\x63\x63\x65\x73\163", $this->translator->trans("\x44\141\164\141\142\141\163\x65\40\x53\x65\162\x76\145\162\x20\150\141\163\40\x62\x65\x65\156\40\165\x70\x64\141\x74\x65\144\x2e")); goto B88ee; Caa84: $password = $databaseServerEntity->getPassword(); goto F3f90; Ec0fe: $version = $databaseConnection->getVersion(); goto cf6ce; eddfc: $session = $request->getSession(); goto bab78; B88ee: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x61\144\155\x69\x6e\137\x64\141\164\x61\142\x61\163\145\137\163\x65\x72\166\145\x72\163")); goto B386c; f52ca: $databaseServerEntity->setVersion($version); goto c820e; A1eb9: $this->databaseServerEntityManager->updateEntity($databaseServerEntity); goto E87ef; Fab3e: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_EDIT, $user, $eventData, $request); goto A1eb9; cf6ce: $databaseServerEntity->setEngine($engine); goto f52ca; F3f90: $encryptedPassword = Crypto::encrypt($password); goto A1f0c; F0eed: $engine = $databaseConnection->getEngine(); goto Ec0fe; ee26d: $eventData = ["\x68\x6f\x73\x74" => $databaseServerEntity->getHost(), "\165\163\x65\162\116\x61\x6d\x65" => $databaseServerEntity->getUserName(), "\x70\x6f\x72\x74" => $databaseServerEntity->getPort(), "\145\156\147\151\156\145" => $engine, "\166\x65\162\x73\151\x6f\156" => $version]; goto Fab3e; B386c: return $response; goto c4bbb; c4bbb: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\x65\x72", $this->translator->trans("\x41\156\x20\145\162\162\x6f\162\x20\x68\141\x73\x20\157\x63\143\165\162\162\145\144\54\40\x65\x72\162\x6f\x72\x20\x6d\x65\x73\163\x61\x67\x65\x3a\x20\x25\x65\x72\162\x6f\162\x4d\x65\163\163\x61\147\145\x25", ["\x25\x65\x72\x72\157\162\x4d\145\163\163\x61\147\145\45" => $e->getMessage()])); } goto d2d33; f4378: goto bd4c6; goto Cb8fc; Cb8fc: b35d3: goto b6af4; d2d33: bd4c6: goto E3a0d; Fc2b3: if (true === $form->isValid()) { goto b35d3; } goto cf31e; E3a0d: } public function setDatabaseServerActive(Request $request) : Response { goto a027d; Ba2f0: return $response; goto D5e7a; Cb649: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto d28b5; ceeae: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\141\144\155\x69\156\137\144\141\x74\x61\142\141\163\x65\137\163\145\x72\x76\x65\x72\163")); goto Ba2f0; Bd040: $databaseServerEntity = $this->databaseServerEntityManager->findOneById($id); goto B4a97; a027d: $id = (int) $request->get("\151\x64"); goto Bd040; fbacb: try { goto ba242; E2b5d: $eventData = ["\x6f\x6c\144\x48\157\x73\164" => $activeDatabaseServerEntity->getHost(), "\157\x6c\144\x55\x73\145\x72\116\x61\155\x65" => $activeDatabaseServerEntity->getUserName(), "\156\145\167\110\x6f\163\164" => $databaseServerEntity->getHost(), "\x6e\x65\x77\125\x73\145\162\x4e\x61\155\x65" => $databaseServerEntity->getUserName()]; goto c71f1; ba242: $user = $this->getUser(); goto F7f3d; D45b8: $this->databaseServerEntityManager->updateEntity($databaseServerEntity); goto aabc9; F7f3d: $session = $request->getSession(); goto B0fa8; B0fa8: $databaseServerEntity->setIsActive(true); goto C24b1; c71f1: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_CHANGE, $user, $eventData, $request); goto a4cbc; aabc9: $this->databaseServerEntityManager->updateEntity($activeDatabaseServerEntity); goto E2b5d; a4cbc: $session->getFlashBag()->set("\x73\x75\x63\x63\145\163\163", $this->translator->trans("\x44\141\164\141\x62\x61\x73\145\x20\123\x65\162\x76\x65\x72\x20\150\141\163\x20\142\x65\x65\156\40\143\x68\x61\156\147\145\144\x2e")); goto f1e1e; C24b1: $activeDatabaseServerEntity->setIsActive(false); goto D45b8; f1e1e: } catch (\Exception $e) { $session->getFlashBag()->set("\144\x61\156\147\145\x72", $this->translator->trans("\104\141\164\141\142\x61\x73\145\40\x53\x65\162\166\x65\x72\x20\143\x72\145\x64\x65\x6e\164\x69\141\154\163\x20\141\x72\x65\x20\156\x6f\x74\x20\x76\141\x6c\x69\x64\56")); } goto Ca142; D2651: D62a7: goto ceeae; d28b5: if (!($databaseServerEntity->getId() != $activeDatabaseServerEntity->getId())) { goto E8274; } goto fbacb; B4a97: if (!(false === is_null($databaseServerEntity))) { goto D62a7; } goto Cb649; Ca142: E8274: goto D2651; D5e7a: } public function deleteDatabaseServer(Request $request) : Response { goto Bc9db; ebc06: if (!(false === is_null($databaseServerEntity) && false === $databaseServerEntity->isDefault() && false === $databaseServerEntity->isActive())) { goto a4015; } goto aaf74; ca3d7: a4015: goto B2430; Eb037: $databaseServerEntity = $this->databaseServerEntityManager->findOneById($id); goto ebc06; dc7e7: return $response; goto E97da; B2430: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\141\x64\155\x69\x6e\x5f\x64\141\164\141\142\141\163\145\x5f\x73\x65\162\166\145\162\163")); goto dc7e7; aaf74: try { goto f6689; F7c9a: $session->getFlashBag()->set("\x73\165\143\x63\x65\x73\163", $this->translator->trans("\x44\x61\x74\141\x62\x61\x73\145\40\123\145\x72\x76\x65\x72\x20\150\141\x73\40\142\x65\x65\156\40\x64\145\x6c\145\x74\145\x64\56")); goto B89ca; A187b: $eventData = ["\150\x6f\x73\x74" => $databaseServerEntity->getHost(), "\x75\163\145\x72\116\141\x6d\145" => $databaseServerEntity->getUserName()]; goto b43b0; bae3c: $this->databaseServerEntityManager->deleteEntity($databaseServerEntity); goto A187b; f6689: $user = $this->getUser(); goto e1ee9; b43b0: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_DELETE, $user, $eventData, $request); goto F7c9a; e1ee9: $session = $request->getSession(); goto bae3c; B89ca: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\x65\x72", $this->translator->trans("\x41\x6e\40\x65\162\x72\x6f\x72\40\150\141\163\40\x6f\x63\x63\x75\162\162\145\144\54\x20\145\162\x72\x6f\162\40\155\x65\x73\x73\141\147\x65\72\x20\x25\x65\162\162\157\162\x4d\145\163\x73\x61\147\x65\45", ["\45\x65\162\x72\x6f\162\x4d\x65\x73\163\141\x67\145\45" => $e->getMessage()])); } goto ca3d7; Bc9db: $id = (int) $request->get("\x69\144"); goto Eb037; E97da: } }
