<?php
 namespace App\Controller\Frontend; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Contracts\Translation\TranslatorInterface; use App\Controller\Controller; use App\Entity\Manager\InstanceCpuManager as InstanceCpuEntityManager; use App\Entity\Manager\InstanceMemoryManager as InstanceMemoryEntityManager; use App\Entity\Manager\InstanceDiskUsageManager as InstanceDiskUsageEntityManager; use App\Entity\Manager\InstanceLoadAverageManager as InstanceLoadAverageEntityManager; use App\System\CommandExecutor; use App\System\Command\MemoryInformationCommand; use App\System\Command\ProcessorCoresCommand; use App\Entity\InstanceDiskUsage as InstanceDiskUsageEntity; use App\Entity\InstanceLoadAverage as InstanceLoadAverageEntity; use App\Monitoring\Chart; use App\Monitoring\LoadAverageChart; use App\Util\HumanFileSize as HumanFileSizeUtil; use App\Util\Time as TimeUtil; use App\Service\Logger; use App\Entity\User; class DashboardController extends Controller { public const TIME_RANGE_LAST_THIRTY_MINUTES = 1; public const TIME_RANGE_LAST_HOUR = 2; public const TIME_RANGE_LAST_THREE_HOURS = 3; public const TIME_RANGE_LAST_SIX_HOURS = 4; public const TIME_RANGE_LAST_TWELVE_HOURS = 5; private static array $timeRanges = [self::TIME_RANGE_LAST_THIRTY_MINUTES, self::TIME_RANGE_LAST_HOUR, self::TIME_RANGE_LAST_THREE_HOURS, self::TIME_RANGE_LAST_SIX_HOURS, self::TIME_RANGE_LAST_TWELVE_HOURS]; private InstanceCpuEntityManager $instanceCpuEntityManager; private InstanceMemoryEntityManager $instanceMemoryEntityManager; private InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager; private InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager; public function __construct(InstanceCpuEntityManager $instanceCpuEntityManager, InstanceMemoryEntityManager $instanceMemoryEntityManager, InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager, InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager, TranslatorInterface $translator, Logger $logger) { goto de27b; e43ba: $this->instanceLoadAverageEntityManager = $instanceLoadAverageEntityManager; goto Db6ea; de27b: $this->instanceCpuEntityManager = $instanceCpuEntityManager; goto c2870; c2870: $this->instanceMemoryEntityManager = $instanceMemoryEntityManager; goto bea90; Db6ea: parent::__construct($translator, $logger); goto e29b3; bea90: $this->instanceDiskUsageEntityManager = $instanceDiskUsageEntityManager; goto e43ba; e29b3: } public function index(Request $request) : Response { goto f7d0b; aa55d: $homeDiskSize = HumanFileSizeUtil::convert($homeDiskSizeInBytes, "\107\x42", 0); goto Edf09; efebf: $memoryData = $this->getMemoryDataForTimeRange($startTime, $endTime, $minuteInterval); goto A21d4; bb821: $memoryChart->setData($memoryData); goto F53af; Abc27: $diskChart->setData($diskData); goto ef509; ae078: $timeRange = true === is_null($timeRange) ? self::TIME_RANGE_LAST_THIRTY_MINUTES : (true === in_array($timeRange, self::$timeRanges) ? $timeRange : self::TIME_RANGE_LAST_THIRTY_MINUTES); goto d0bbb; A21d4: $diskData = $this->getDiskDataForTimeRange($startTime, $endTime, $minuteInterval); goto Aa608; f7d0b: $user = $this->getUser(); goto c83c2; ef2b8: $cloud = $environment->getCloudProvider(); goto a8e71; Eb946: $cpuChart = new Chart("\103\x50\125\x20\x55\x73\x61\147\x65"); goto c8d0a; aec47: $loadAverageChart->setInformation($loadAverageChartInformation); goto A7e99; E7aa3: $loadAverageChart->setCategories($categories); goto D88e8; ef552: $rootDiskSize = HumanFileSizeUtil::convert($rootDiskSizeInBytes, "\x47\102", 0); goto C95ec; B5306: switch ($timeRange) { case self::TIME_RANGE_LAST_THIRTY_MINUTES: goto E03bd; e8143: $startTime = (clone $endTime)->modify("\55\x33\60\x20\x6d\151\x6e\165\164\145\163"); goto d0818; d0818: goto c1072; goto C2360; E03bd: $minuteInterval = 5; goto e8143; C2360: case self::TIME_RANGE_LAST_HOUR: goto D98af; D4741: $startTime = (clone $endTime)->modify("\x2d\61\x20\x68\157\165\x72"); goto A7c9f; D98af: $minuteInterval = 10; goto D4741; A7c9f: goto c1072; goto b032c; b032c: case self::TIME_RANGE_LAST_THREE_HOURS: goto D345f; d11ec: $startTime = (clone $dateTime)->modify("\x2d\63\40\150\157\165\162\x73"); goto A684f; A684f: goto c1072; goto A6d9a; D345f: $minuteInterval = 30; goto d11ec; A6d9a: case self::TIME_RANGE_LAST_SIX_HOURS: goto E53ba; E53ba: $minuteInterval = 60; goto B8d2d; ff43a: goto c1072; goto E5485; B8d2d: $startTime = (clone $dateTime)->modify("\55\66\40\x68\157\165\162\163"); goto ff43a; E5485: case self::TIME_RANGE_LAST_TWELVE_HOURS: goto Eb102; ed733: goto c1072; goto a77f1; Eb102: $minuteInterval = 120; goto F75bb; F75bb: $startTime = (clone $dateTime)->modify("\55\61\x32\40\150\x6f\x75\x72\163"); goto ed733; a77f1: } goto Fa292; c8d0a: $cpuChart->setInformation($cpuInformation); goto a0b97; e7154: goto f6684; goto da8c6; c83c2: $instance = $request->attributes->get("\x69\x6e\x73\164\x61\x6e\x63\145"); goto a8850; a8850: $environment = $instance->getEnvironment(); goto ef2b8; cf5f8: $loadAverageData = [["\x6e\141\155\145" => $this->translator->trans("\x31\x20\115\151\x6e\165\x74\145"), "\143\x6f\154\157\x72" => "\x23\67\67\64\141\141\64", "\x64\141\x74\141" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_ONE_MINUTE] ?? []], ["\156\x61\x6d\145" => $this->translator->trans("\65\x20\115\x69\156\x75\x74\145\163"), "\x63\x6f\x6c\x6f\x72" => "\x23\145\142\x35\x38\66\143", "\144\x61\164\x61" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES] ?? []], ["\x6e\141\155\145" => $this->translator->trans("\x31\x35\x20\115\151\x6e\x75\x74\145\x73"), "\143\157\154\x6f\162" => "\43\x30\x30\x37\x38\144\64", "\x64\x61\x74\141" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] ?? []]]; goto b273a; ef509: $diskChart->setCategories($categories); goto B86dc; a0b97: $cpuChart->setData($cpuData); goto b202d; Cfc87: $cpuData = $this->getCpuDataForTimeRange($startTime, $endTime, $minuteInterval); goto efebf; C0038: $memoryChart = new Chart("\x4d\145\x6d\157\162\x79\40\x55\x73\141\147\145"); goto ae454; ae454: $memoryChart->setInformation($totalMemory); goto bb821; B77bd: $loadAverageChart = new LoadAverageChart("\x4c\x6f\141\144\40\x41\x76\145\162\x61\147\x65"); goto aec47; b02de: $endTime = TimeUtil::roundToNearestMinuteInterval($dateTime, 5); goto B5306; D88e8: $response = $this->render("\106\162\x6f\156\x74\x65\156\144\57\104\141\x73\150\x62\157\x61\162\x64\x2f\151\156\144\x65\170\56\x68\164\x6d\x6c\56\x74\167\x69\147", ["\143\x6c\x6f\x75\x64" => $cloud, "\151\156\x73\164\141\x6e\x63\x65" => $instance, "\x75\x73\x65\162" => $user, "\x74\151\x6d\145\x52\x61\156\x67\145" => $timeRange, "\x63\x70\165\103\150\x61\x72\164" => $cpuChart, "\155\145\x6d\157\162\x79\x43\150\x61\162\164" => $memoryChart, "\144\x69\x73\x6b\x43\x68\x61\x72\164" => $diskChart, "\x6c\157\141\144\x41\x76\145\162\141\x67\145\103\x68\141\x72\164" => $loadAverageChart]); goto e3189; b202d: $cpuChart->setCategories($categories); goto C0038; A572a: $numberOfProcessorCores = 0; goto F1ff3; d0bbb: $totalMemory = ''; goto A572a; F53af: $memoryChart->setCategories($categories); goto Ac901; b273a: $cpuInformation = sprintf("\45\x73\40\x25\x73", $numberOfProcessorCores, $this->translator->trans("\x43\x50\125")); goto Eb946; Fa292: F995f: goto c2867; A7e99: $loadAverageChart->setData($loadAverageData); goto E7aa3; Dd091: $diskData = [["\x6e\x61\x6d\145" => sprintf("\x2f\40\50\45\x73\51", $rootDiskSize), "\143\157\154\x6f\162" => "\43\67\x33\142\x66\64\143", "\144\x61\x74\x61" => $diskData["\162\x6f\157\164"] ?: []], ["\x6e\x61\x6d\x65" => sprintf("\x2f\x68\157\x6d\x65\40\50\45\x73\x29", $homeDiskSize), "\143\x6f\154\x6f\x72" => "\x23\x66\x33\142\x66\x30\x30", "\144\x61\164\141" => $diskData["\150\x6f\x6d\x65"] ?: []]]; goto e0f3f; e3189: return $response; goto Ce6f4; Aa608: if ($homeDiskSize != $rootDiskSize) { goto C6e01; } goto F87f7; F87f7: $diskData = [["\156\141\155\145" => sprintf("\x2f\x20\50\x25\x73\51", $rootDiskSize), "\x63\157\x6c\x6f\162" => "\43\x37\x33\x62\x66\64\143", "\x64\x61\164\x61" => $diskData["\x72\157\x6f\x74"] ?: []]]; goto e7154; Edf09: $dateTime = new \DateTime(); goto b02de; Ac901: $diskChart = new Chart("\x44\151\x73\x6b\40\x55\x73\x61\x67\x65"); goto Abc27; B86dc: $loadAverageChartInformation = sprintf("\x25\163\x20\x25\163", $numberOfProcessorCores, $this->translator->trans("\x43\x50\125")); goto B77bd; c2867: c1072: goto a9bd7; C95ec: $homeDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_HOME); goto aa55d; a9bd7: $categories = $this->getCategoriesForTimeRange($user, $startTime, $endTime, $minuteInterval); goto Cfc87; F6d9b: $loadAverageRawData = $this->getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval); goto cf5f8; a8e71: $timeRange = $request->get("\164\151\155\x65\x52\x61\156\x67\145"); goto ae078; da8c6: C6e01: goto Dd091; F1ff3: try { goto d1c23; C7aab: $totalMemoryInBytes = $memoryInformationCommand->getTotalMemoryInBytes(); goto E5d28; A9e14: $commandExecutor->execute($memoryInformationCommand); goto C7aab; E5d28: $totalMemory = HumanFileSizeUtil::convert($totalMemoryInBytes, "\x47\x42", 0); goto E0c0c; E0c0c: $processorCoresCommand = new ProcessorCoresCommand(); goto e3282; e3282: $commandExecutor->execute($processorCoresCommand); goto f36df; Cc37c: $memoryInformationCommand = new MemoryInformationCommand(); goto A9e14; f36df: $numberOfProcessorCores = $processorCoresCommand->getNumberOfProcessorCores(); goto aceb2; d1c23: $commandExecutor = new CommandExecutor(); goto Cc37c; aceb2: } catch (\Exception $e) { $this->logger->exception($e); } goto a051d; a051d: $rootDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_ROOT); goto ef552; e0f3f: f6684: goto F6d9b; Ce6f4: } private function getCategoriesForTimeRange(User $user, \DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto e5b6a; cb05f: $endDataDate->modify(sprintf("\53\45\60\65\144\x20\155\x69\156\x75\x74\x65\163", $minuteInterval)); goto E54d6; baa78: if (!($endDataDate <= $endTime)) { goto a0133; } goto Cdaff; Ca436: return $categories; goto c138e; fbeae: a0133: goto Ca436; D7637: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\60\65\144\x20\155\151\x6e\x75\x74\145\x73", $minuteInterval)); goto df3be; Ba14e: $categories[] = $categoryDateTime->format("\110\x3a\151"); goto E6964; e5b6a: $categories = []; goto D7637; E54d6: goto C67c7; goto fbeae; E6964: $startDataDate->modify(sprintf("\x2b\45\x30\x35\144\40\155\x69\156\165\164\x65\x73", $minuteInterval)); goto cb05f; F32a5: C67c7: goto baa78; Cdaff: $categoryDateTime = clone $endDataDate; goto c1673; c1673: $categoryDateTime->setTimezone(new \DateTimeZone($user->getTimezone())); goto Ba14e; df3be: $endDataDate = clone $startTime; goto F32a5; c138e: } private function getCpuDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto Bcacc; aca16: $startDataDate->modify(sprintf("\x2b\45\x30\x35\x64\x20\x6d\x69\156\x75\x74\x65\x73", $minuteInterval)); goto b500d; d949c: c1239: goto d6b81; F6c33: if (!($endDataDate <= $endTime)) { goto c1239; } goto acfd4; ddd16: $endDataDate = clone $startTime; goto bf10b; Bcacc: $cpuData = []; goto A02fa; acfd4: $averageCpuValue = $this->instanceCpuEntityManager->getAverageCpuValue($startDataDate, $endDataDate); goto bbbb8; A02fa: $startDataDate = (clone $startTime)->modify(sprintf("\55\x25\60\65\144\40\x6d\x69\x6e\165\164\145\163", $minuteInterval)); goto ddd16; Ab5b8: goto Ce17f; goto d949c; d6b81: return $cpuData; goto D73cd; bbbb8: $cpuData[] = $averageCpuValue; goto aca16; bf10b: Ce17f: goto F6c33; b500d: $endDataDate->modify(sprintf("\x2b\45\60\x35\x64\x20\155\151\x6e\x75\x74\x65\163", $minuteInterval)); goto Ab5b8; D73cd: } private function getMemoryDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto C0e7a; A92ae: e337c: goto c9a08; B17f6: $startDataDate = (clone $startTime)->modify(sprintf("\55\x25\60\65\144\40\155\x69\x6e\165\164\x65\x73", $minuteInterval)); goto C721d; c9a08: if (!($endDataDate <= $endTime)) { goto E0f0a; } goto acfc6; acfc6: $averageMemoryValue = $this->instanceMemoryEntityManager->getAverageMemoryValue($startDataDate, $endDataDate); goto E11ca; c8586: E0f0a: goto Cdbe3; C721d: $endDataDate = clone $startTime; goto A92ae; f9751: goto e337c; goto c8586; Cdbe3: return $memoryData; goto B7265; E11ca: $memoryData[] = (int) $averageMemoryValue; goto F04ee; C0e7a: $memoryData = []; goto B17f6; C5dfc: $endDataDate->modify(sprintf("\x2b\x25\x30\65\144\40\x6d\151\x6e\x75\x74\x65\163", $minuteInterval)); goto f9751; F04ee: $startDataDate->modify(sprintf("\x2b\x25\60\x35\x64\x20\155\x69\x6e\x75\x74\145\163", $minuteInterval)); goto C5dfc; B7265: } private function getDiskDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto Bf35d; b10b9: $endDataDate->modify(sprintf("\x2b\x25\60\65\x64\x20\x6d\x69\x6e\165\164\145\163", $minuteInterval)); goto D65ed; B9452: foreach (["\x2f", "\x2f\x68\x6f\x6d\145"] as $disk) { goto D24f2; f31fa: goto F3979; goto f24ec; b6a81: $diskData["\x72\157\x6f\x74"][] = (int) $averageDiskSizeValue; goto Fd6bd; f24ec: E1f18: goto b6a81; d26d2: c54d9: goto ffe2c; D94df: $diskData["\x68\157\x6d\145"][] = (int) $averageDiskSizeValue; goto f31fa; Fd6bd: F3979: goto d26d2; D24f2: $averageDiskSizeValue = (int) $this->instanceDiskUsageEntityManager->getAverageDiskSizeValue($disk, $startDataDate, $endDataDate); goto a16c2; a16c2: if ("\x2f" == $disk) { goto E1f18; } goto D94df; ffe2c: } goto d65d0; c4b33: Ac64a: goto A9512; A9512: return $diskData; goto e08d9; Ea8ef: if (!($endDataDate <= $endTime)) { goto Ac64a; } goto B9452; d65d0: Fba24: goto dbd55; ee99b: e73eb: goto Ea8ef; D65ed: goto e73eb; goto c4b33; f73d8: $startDataDate = (clone $startTime)->modify(sprintf("\55\45\60\x35\144\x20\x6d\x69\x6e\x75\164\145\163", $minuteInterval)); goto cb172; Bf35d: $diskData = []; goto f73d8; dbd55: $startDataDate->modify(sprintf("\x2b\45\x30\65\x64\x20\x6d\151\x6e\x75\164\x65\163", $minuteInterval)); goto b10b9; cb172: $endDataDate = clone $startTime; goto ee99b; e08d9: } private function getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto Cbe54; e2aef: goto de988; goto A2bc2; f6656: foreach ([InstanceLoadAverageEntity::PERIOD_ONE_MINUTE, InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES, InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] as $period) { goto C4242; B8de0: A87af: goto d1f1a; e9181: $loadAverageData[$period][] = round($loadAverageValue, 2); goto B8de0; C4242: $loadAverageValue = $this->instanceLoadAverageEntityManager->getLoadAverageValue($period, $startDataDate, $endDataDate); goto e9181; d1f1a: } goto c98f0; f503a: $startDataDate->modify(sprintf("\x2b\45\60\x35\x64\40\155\151\x6e\x75\x74\145\x73", $minuteInterval)); goto a90b6; c98f0: c2f4e: goto f503a; ae13c: de988: goto C00e0; a90b6: $endDataDate->modify(sprintf("\x2b\x25\60\65\x64\40\155\x69\x6e\165\x74\145\x73", $minuteInterval)); goto e2aef; C00e0: if (!($endDataDate <= $endTime)) { goto F1f46; } goto f6656; Cbffa: return $loadAverageData; goto ba39e; e1409: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\x25\x30\65\144\x20\x6d\151\156\165\x74\145\x73", $minuteInterval)); goto d2600; A2bc2: F1f46: goto Cbffa; d2600: $endDataDate = clone $startTime; goto ae13c; Cbe54: $loadAverageData = []; goto e1409; ba39e: } }
