<?php
 namespace App\Controller\Frontend; use Symfony\Component\Form\FormError; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\HttpFoundation\RedirectResponse; use Symfony\Component\Form\Extension\Core\Type\ButtonType; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Component\Security\Core\Exception\InvalidCsrfTokenException; use Symfony\Contracts\Translation\TranslatorInterface; use Symfony\Component\HttpFoundation\Cookie; use Symfony\Component\Form\Form; use Twig\Environment as Twig; use Doctrine\Common\Collections\ArrayCollection; use App\Controller\Controller; use App\Event\EventQueue; use App\Service\Crypto; use App\Service\Logger; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\ReverseProxySite; use App\Entity\Site as SiteEntity; use App\Entity\NodejsSettings; use App\Entity\PhpSettings; use App\Entity\PythonSettings; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\BlockedBot as BlockedBotEntity; use App\Entity\BlockedIp as BlockedIpEntity; use App\Entity\Database as DatabaseEntity; use App\Entity\DatabaseUser as DatabaseUserEntity; use App\Entity\User as UserEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\CronJob as CronJobEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Updater\ReverseProxySite as ReverseProxySiteUpdater; use App\Site\Deleter as SiteDeleter; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Deleter\ReverseProxySite as ReverseProxySiteDeleter; use App\Database\Manager as DatabaseManager; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\BasicAuthManager as BasicAuthEntityManager; use App\Entity\Manager\BlockedIpManager as BlockedIpEntityManager; use App\Entity\Manager\BlockedBotManager as BlockedBotEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\CronJobManager as CronJobEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\NodejsSettingsManager as NodejsSettingsEntityManager; use App\Entity\Manager\FtpUserManager as FtpUserEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Log\LogfileReader; use App\Log\LogsFinder; use App\Log\Parser\NginxAccessLogParser; use App\Log\Parser\NginxErrorLogParser; use App\Log\Parser\PhpFpmErrorLogParser; use App\Site\Parser\DomainName as DomainNameParser; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\LetsEncryptClient; use App\Site\VarnishCache\Client as VarnishCacheClient; class SitesController extends Controller { private const FILE_MANAGER_COOKIE_EXPIRATION = 3; private ConfigManager $configManager; private SiteEntityManager $siteEntityManager; private BasicAuthEntityManager $basicAuthEntityManager; private BlockedIpEntityManager $blockedIpEntityManager; private BlockedBotEntityManager $blockedBotEntityManager; private CertificateEntityManager $certificateEntityManager; private CronJobEntityManager $cronJobEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private NodejsSettingsEntityManager $nodejsSettingsEntityManager; private FtpUserEntityManager $ftpUserEntityManager; private SshUserEntityManager $sshUserEntityManager; private DomainNameParser $domainNameParser; public function __construct(ConfigManager $configManager, SiteEntityManager $siteEntityManager, BasicAuthEntityManager $basicAuthEntityManager, BlockedIpEntityManager $blockedIpEntityManager, BlockedBotEntityManager $blockedBotEntityManager, CertificateEntityManager $certificateEntityManager, CronJobEntityManager $cronJobEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, NodejsSettingsEntityManager $nodejsSettingsEntityManager, FtpUserEntityManager $ftpUserEntityManager, SshUserEntityManager $sshUserEntityManager, DomainNameParser $domainNameParser, TranslatorInterface $translator, Logger $logger) { goto A19a1; Cc5d4: $this->basicAuthEntityManager = $basicAuthEntityManager; goto afe1b; A9966: $this->sshUserEntityManager = $sshUserEntityManager; goto D6fa0; C552c: $this->cronJobEntityManager = $cronJobEntityManager; goto B6e81; C4f9e: $this->nodejsSettingsEntityManager = $nodejsSettingsEntityManager; goto c9cca; D5608: $this->siteEntityManager = $siteEntityManager; goto Cc5d4; c9cca: $this->ftpUserEntityManager = $ftpUserEntityManager; goto A9966; d76a3: $this->databaseUserEntityManager = $databaseUserEntityManager; goto C415d; C415d: $this->databaseServerEntityManager = $databaseServerEntityManager; goto C4f9e; Eb80d: parent::__construct($translator, $logger); goto a4984; Ffd35: $this->blockedBotEntityManager = $blockedBotEntityManager; goto Bb9f4; Bb9f4: $this->certificateEntityManager = $certificateEntityManager; goto C552c; D6fa0: $this->domainNameParser = $domainNameParser; goto Eb80d; afe1b: $this->blockedIpEntityManager = $blockedIpEntityManager; goto Ffd35; B6e81: $this->databaseEntityManager = $databaseEntityManager; goto d76a3; A19a1: $this->configManager = $configManager; goto D5608; a4984: } public function index(Request $request) : Response { goto aa600; bb294: $sites = $this->siteEntityManager->getUserSites($user, ["\144\157\x6d\x61\x69\156\116\x61\x6d\x65" => "\141\x73\x63"]); goto ffd28; b71d9: return $response; goto c4530; ffd28: $response = $this->render("\106\x72\x6f\156\x74\x65\156\x64\57\x53\151\x74\x65\57\151\x6e\x64\x65\x78\56\150\164\155\154\56\x74\167\x69\147", ["\165\163\x65\x72" => $user, "\x73\151\x74\145\163" => $sites]); goto b71d9; aa600: $user = $this->getUser(); goto bb294; c4530: } public function fileManager(Request $request) : Response { goto e0602; D4ec0: return $response; goto Fef2b; bc4a7: $cookieExpirationDate->modify(sprintf("\x2b\x25\163\x20\150\157\x75\x72\163", self::FILE_MANAGER_COOKIE_EXPIRATION)); goto c2d28; e0602: $site = $this->getSite($request); goto D128a; a6bfb: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\164\x65\163")); goto C8600; F7618: df7a6: goto bf79b; Dde22: $response = $this->render("\106\162\157\156\x74\x65\156\144\57\x53\151\164\145\x2f\x66\x69\x6c\x65\x2d\x6d\x61\156\141\147\x65\162\x2e\x68\x74\x6d\154\56\x74\x77\151\147", ["\x73\151\x74\145" => $site, "\146\x69\154\145\115\141\x6e\x61\x67\145\162\x55\x72\154" => $fileManagerUrl, "\x66\x6f\x72\x6d\x45\x72\x72\x6f\x72\x73" => $this->formErrors]); goto A4599; C8600: goto Ac134; goto F7618; A4599: Ac134: goto D4ec0; D128a: if (false === is_null($site)) { goto df7a6; } goto a6bfb; bf79b: $siteUser = $site->getUser(); goto f0cc1; D91e7: $fileManagerUrl = sprintf("\45\163\57\x66\151\x6c\145\x2d\x6d\141\156\x61\x67\x65\x72\57", rtrim($request->getSchemeAndHttpHost(), "\57")); goto Dde22; f0cc1: $session = $request->getSession(); goto fbc87; fbc87: $locale = $request->getLocale(); goto f2ae6; c2d28: $data = ["\x75\163\x65\162" => $siteUser, "\x6c\157\x63\141\154\x65" => $locale]; goto Bbbb4; Bbbb4: $session->set("\143\x6c\160\55\146\x69\x6c\145\x2d\155\141\156\141\147\145\x72", $data); goto D91e7; f2ae6: $cookieExpirationDate = new \DateTime("\156\157\x77"); goto bc4a7; Fef2b: } public function view(Request $request) : Response { goto Eb2dc; B52e4: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\x69\164\x65\137\x73\x65\164\164\x69\156\x67\x73", ["\144\x6f\155\x61\151\x6e\116\141\x6d\x65" => $domainName])); goto De042; De042: return $response; goto A3683; Eb2dc: $domainName = $request->get("\144\157\155\141\151\x6e\x4e\141\x6d\145"); goto B52e4; A3683: } public function logs(Request $request) : Response { goto Add66; E2584: return $response; goto B2858; Add66: $site = $this->getSite($request); goto E3ed3; f9110: b137d: goto a734d; ea669: $form = $this->createLogsForm($siteEntity); goto b6c52; a734d: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ea669; e15b6: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\x69\x74\x65\x73")); goto Ca042; b6c52: $response = $this->render("\x46\162\157\156\164\145\x6e\144\x2f\x53\x69\x74\x65\57\154\157\147\x73\x2e\x68\164\x6d\x6c\x2e\164\167\151\147", ["\x73\151\164\145" => $site, "\x66\157\162\x6d\x45\162\162\x6f\x72\x73" => $this->formErrors, "\x66\157\162\x6d" => $form->createView()]); goto a750e; Ca042: goto ae006; goto f9110; E3ed3: if (false === is_null($site)) { goto b137d; } goto e15b6; a750e: ae006: goto E2584; B2858: } private function createLogsForm(SiteEntity $siteEntity) : Form { goto B3bda; b88fd: return $form; goto E588d; B3bda: $form = $this->createForm("\x41\160\x70\x5c\x46\x6f\162\x6d\134\x53\151\x74\x65\114\x6f\x67\163\x54\171\x70\145", [], ["\x61\x63\164\x69\x6f\x6e" => $this->generateUrl("\x63\x6c\x70\x5f\x73\x69\x74\145\x5f\154\157\x67\163", ["\144\x6f\x6d\141\x69\156\116\141\x6d\145" => $siteEntity->getDomainName()]), "\x6d\x65\164\x68\x6f\x64" => "\120\x4f\123\124", "\141\x74\x74\x72" => []]); goto af9d6; af9d6: $form->add("\x75\x70\144\141\x74\145", ButtonType::class, ["\141\x74\164\x72" => ["\x63\154\x61\x73\x73" => "\142\x74\x6e\40\142\x74\156\x2d\154\147\x20\142\164\156\55\142\x6c\165\x65\40\142\164\156\55\x75\160\144\141\164\145"], "\x6c\141\x62\x65\154" => "\x55\x70\144\141\164\x65"]); goto b88fd; E588d: } public function logFileContent(Request $request, Twig $twig) : Response { goto B7008; Df7af: if (!(false === is_null($site))) { goto C7c6e; } goto e5cbb; bb056: $numberOfLines = (int) $request->get("\156\x75\155\142\145\162\117\x66\x4c\x69\x6e\x65\x73"); goto Eeeae; B7008: $data = []; goto b889a; b889a: $site = $this->getSite($request); goto Df7af; Eeeae: if (!(false === empty($service) && false === empty($logfileName))) { goto f6840; } goto f6ce1; a6031: return $response; goto d99dd; f6ce1: try { goto Ce901; Cf9e4: if ("\141\x63\x63\x65\163\163\56\x6c\157\147" == substr($logfileName, 0, 10)) { goto b260d; } goto d51ea; D7b9b: $logfile = sprintf("\57\x68\x6f\155\145\57\x25\x73\57\154\x6f\x67\x73\57\x25\163\57\x25\x73", $site->getUser(), $service, $logfileName); goto Bfe2d; C5d93: $nginxAccessLogParser = new NginxAccessLogParser($logLines); goto C630e; F6b5b: Dd3e6: goto a2bdf; d51ea: $nginxErrorLogParser = new NginxErrorLogParser($logLines); goto D5c4d; C630e: $nginxAccessLogParser->setTimezone($userTimezone->getName()); goto Fdb4b; D5c4d: $logMessages = $nginxErrorLogParser->parse(); goto ca21f; d1aae: da9f1: goto f7d4d; F4ad2: goto da9f1; goto de137; C6444: $userTimezone = $user->getTimezone(); goto Cf9e4; D35b2: if (!("\160\150\160" == $service)) { goto Dd3e6; } goto Bdb15; f7d4d: d0158: goto D35b2; a307c: $logMessagesHtml = $twig->render("\106\x72\157\156\164\x65\156\x64\57\123\x69\164\x65\x2f\114\x6f\x67\163\x2f\160\x68\160\x2d\x66\x70\155\55\145\x72\x72\157\x72\x2d\x6c\157\x67\x2d\x6d\145\x73\x73\141\147\x65\163\56\150\164\155\x6c\x2e\x74\167\151\147", ["\154\157\x67\115\145\163\x73\141\147\x65\x73" => $logMessages]); goto F6b5b; cafd2: $logLines = $logfileReader->getLines($numberOfLines); goto e2004; Bfe2d: $logfileReader = new LogfileReader($logfile); goto cafd2; F224a: $logMessagesHtml = $twig->render("\106\x72\157\156\x74\145\156\144\x2f\x53\151\164\x65\x2f\114\157\x67\x73\x2f\156\x67\151\156\170\x2d\141\143\x63\145\x73\163\55\154\x6f\147\x2d\155\145\163\163\141\x67\145\x73\56\150\164\x6d\x6c\56\164\x77\x69\x67", ["\x6c\157\147\115\145\163\163\141\x67\145\x73" => $logMessages]); goto d1aae; f8c40: $user = $this->getUser(); goto dd91a; cd2a0: $logMessages = $phpFpmErrorLogParser->parse(); goto a307c; ca21f: $logMessagesHtml = $twig->render("\106\x72\157\x6e\164\x65\x6e\x64\x2f\123\151\164\x65\x2f\x4c\x6f\x67\163\57\x6e\147\151\x6e\170\55\145\162\x72\157\162\55\x6c\157\x67\x2d\x6d\145\163\163\x61\147\x65\x73\x2e\150\164\x6d\x6c\56\x74\167\151\147", ["\154\x6f\x67\115\145\x73\163\141\x67\145\163" => $logMessages]); goto F4ad2; dd91a: if (!("\156\147\151\x6e\x78" == $service)) { goto d0158; } goto C6444; Fdb4b: $logMessages = $nginxAccessLogParser->parse(); goto F224a; e2004: $logMessagesHtml = ''; goto f8c40; Bdb15: $phpFpmErrorLogParser = new PhpFpmErrorLogParser($logLines); goto cd2a0; a2bdf: $data["\154\x6f\147\115\x65\163\163\x61\x67\x65\163\x48\164\155\154"] = $logMessagesHtml; goto B91d7; de137: b260d: goto C5d93; Ce901: $service = basename($service); goto D7b9b; B91d7: } catch (\Exception $e) { $this->logger->exception($e); } goto A2b88; e5cbb: $service = trim($request->get("\x73\145\162\x76\x69\x63\145")); goto ff599; C4c26: C7c6e: goto e55fc; e55fc: $response = $this->json($data); goto a6031; A2b88: f6840: goto C4c26; ff599: $logfileName = trim($request->get("\x6c\x6f\x67\x46\151\154\145")); goto bb056; d99dd: } public function loadLogfilesForService(Request $request) : Response { goto add39; fb910: $site = $this->getSite($request); goto a78bb; D8c38: return $response; goto Da190; add39: $data = []; goto fb910; c9d86: $service = trim($request->get("\163\145\x72\x76\151\x63\145")); goto D2e03; a78bb: if (!(false === is_null($site))) { goto Af661; } goto c9d86; A7f13: Af661: goto a07bd; a07bd: $response = $this->json($data); goto D8c38; E9dcf: A89a6: goto A7f13; f6ef0: try { goto d3173; d3173: $service = basename($service); goto D96b3; B93df: $logfiles = $logsFinder->getLogfiles(); goto Aab1b; D96b3: $logfilesDirectory = sprintf("\x2f\x68\157\155\145\57\45\x73\57\154\157\x67\x73\57\45\x73\x2f", $site->getUser(), $service); goto ed583; f91d6: b4278: goto da490; ed583: $logsFinder = new LogsFinder($logfilesDirectory); goto B93df; Aab1b: if (!(false === empty($logfiles))) { goto b4278; } goto B05d6; B05d6: $data["\x6c\x6f\x67\146\x69\154\x65\x73"] = $logfiles; goto f91d6; da490: } catch (\Exception $e) { $this->logger->exception($e); } goto E9dcf; D2e03: if (!(false === empty($service))) { goto A89a6; } goto f6ef0; Da190: } public function cronJobs(Request $request) : Response { goto D10ba; a04df: d7a7e: goto Fa149; C3e44: $response = $this->render("\x46\x72\157\156\x74\145\x6e\x64\57\x53\151\x74\145\57\143\x72\x6f\x6e\55\152\157\x62\163\56\150\164\x6d\x6c\x2e\x74\167\151\147", ["\x73\151\164\x65" => $site, "\146\x6f\162\155\x45\x72\x72\x6f\x72\163" => $this->formErrors]); goto a04df; F9db0: if (false === is_null($site)) { goto df301; } goto Fba23; Fba23: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\x69\x74\x65\x73")); goto Fe765; D10ba: $site = $this->getSite($request); goto F9db0; Fe765: goto d7a7e; goto E141a; Fa149: return $response; goto cffc9; E141a: df301: goto C3e44; cffc9: } public function newCronJob(Request $request) : Response { goto e8ab6; F88ad: $response = $this->handleCronJobForm($request, $form, $site); goto De617; a73d1: $response = $this->render("\106\162\157\x6e\164\145\x6e\x64\x2f\123\151\164\x65\x2f\x6e\145\167\55\143\x72\157\x6e\55\152\157\142\x2e\x68\164\x6d\154\56\x74\x77\151\x67", ["\163\151\x74\x65" => $site, "\x66\x6f\x72\x6d" => $form->createView(), "\x66\157\162\155\x45\x72\x72\x6f\x72\163" => $this->formErrors]); goto Ca72b; aac3d: $form->handleRequest($request); goto E0766; e6f02: $cronJobEntity = $this->cronJobEntityManager->createEntity(); goto efb3b; df1da: cb9eb: goto a73d1; B3b2e: $form = $this->createCronJobForm($cronJobEntity); goto beef3; e9c22: return $response; goto ab3f2; B9e27: A29ca: goto c05b9; Ca72b: b22f5: goto Dfc2e; ab3f2: C5fc7: goto c2b2f; Dfc2e: return $response; goto De81c; c2b2f: E1b07: goto df1da; D4465: goto b22f5; goto B9e27; e8ab6: $site = $this->getSite($request); goto Cca85; beef3: if (!(true === $request->isMethod("\x50\x4f\123\x54"))) { goto cb9eb; } goto aac3d; Cca85: if (false === is_null($site)) { goto A29ca; } goto Adf8a; Adf8a: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\151\x74\x65\x73")); goto D4465; De617: if (!(false === is_null($response))) { goto C5fc7; } goto e9c22; c05b9: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto e6f02; efb3b: $cronJobEntity->setSite($siteEntity); goto B3b2e; E0766: if (!(true === $form->isSubmitted())) { goto E1b07; } goto F88ad; De81c: } private function createCronJobForm(CronJobEntity $cronJobEntity) : Form { goto c4658; b00a6: $form->add("\163\165\x62\155\x69\164", SubmitType::class, ["\x61\x74\164\x72" => ["\143\x6c\141\163\x73" => "\x62\164\x6e\x20\x62\x74\156\x2d\x62\154\x75\145\40\x62\164\x6e\x2d\x6c\x67"], "\x6c\x61\142\145\x6c" => "\x41\144\x64\x20\103\x72\x6f\x6e\40\112\x6f\x62"]); goto B6472; c0bd0: $form = $this->createForm("\101\160\160\x5c\106\x6f\162\x6d\x5c\123\x69\164\145\x43\x72\x6f\x6e\112\157\142\124\171\160\145", $cronJobEntity, ["\x61\x63\x74\151\x6f\156" => $this->generateUrl("\143\x6c\160\x5f\x73\x69\x74\145\x5f\143\162\x6f\156\x5f\x6a\x6f\x62\x5f\156\x65\x77", ["\144\157\155\x61\151\156\116\141\x6d\145" => $siteEntity->getDomainName()]), "\155\145\164\x68\157\144" => "\x50\x4f\123\124", "\x61\x74\164\162" => []]); goto b00a6; B6472: return $form; goto Abe72; c4658: $siteEntity = $cronJobEntity->getSite(); goto c0bd0; Abe72: } private function handleCronJobForm(Request $request, Form $form, Site $site) { goto Fd83e; Fd83e: if (true === $form->isValid()) { goto d106b; } goto e9788; Dadcb: goto ca43c; goto F02df; B84cf: try { goto Bdec2; aedf7: $this->siteEntityManager->updateEntity($siteEntity); goto E781f; Cde23: c613d: goto b859f; Bdec2: $session = $request->getSession(); goto D78c0; F96bb: return $response; goto d2149; a1570: $cronJobEntity = $form->getData(); goto bfed0; df122: Affc8: goto F96bb; Ec0b5: $session->getFlashBag()->set("\x73\165\x63\143\x65\163\x73", $this->translator->trans("\103\162\x6f\x6e\40\112\x6f\142\40\150\141\x73\40\142\145\145\156\x20\x61\x64\144\x65\x64\56")); goto Aa5be; Aff97: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_ADD, $user, $eventData, $request); goto Ec0b5; e6d4f: $siteEntity = $this->getSiteEntity($domainName); goto dc44d; Aa5be: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\151\x74\145\x5f\143\162\157\156\137\152\x6f\x62\163", ["\144\157\x6d\x61\151\156\x4e\x61\155\x65" => $site->getDomainName()])); goto df122; D78c0: $domainName = $site->getDomainName(); goto e6d4f; cd88b: $siteUpdater->updateUserCrontab(); goto E4677; dc44d: if (false === is_null($siteEntity)) { goto c613d; } goto b7e8d; b7e8d: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\151\164\145\163")); goto e24cc; E781f: $siteUpdater = $this->getSiteUpdater($site); goto cd88b; E4677: $eventData = ["\163\x69\164\145" => $domainName, "\143\x72\157\x6e\x74\x61\142\105\x78\160\x72\x65\x73\163\151\157\156" => $cronJobEntity->getCrontabExpression()]; goto Aff97; e24cc: goto Affc8; goto Cde23; a08ca: $site->setCronJobs($siteEntity->getCronJobs()); goto aedf7; b859f: $user = $this->getUser(); goto a1570; bfed0: $siteEntity->addCronJob($cronJobEntity); goto a08ca; d2149: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\162", $this->translator->trans("\101\156\40\145\x72\x72\157\x72\x20\150\141\x73\x20\x6f\x63\143\165\162\x72\x65\144\54\40\x65\162\x72\x6f\x72\40\x6d\x65\163\x73\x61\x67\145\72\x20\45\x65\x72\x72\157\x72\115\145\x73\163\141\x67\145\45", ["\45\145\x72\162\x6f\162\x4d\145\163\x73\141\147\x65\x25" => $e->getMessage()])); } goto ed786; F02df: d106b: goto B84cf; e9788: $this->formErrors = $this->getErrorMessages($form); goto Dadcb; ed786: ca43c: goto aa752; aa752: } public function deleteCronJob(Request $request) : Response { goto bd331; ab47e: try { goto C6e2f; Dff9f: $this->siteEntityManager->updateEntity($siteEntity); goto Bde96; A4340: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_DELETE, $user, $evenData, $request); goto b7b44; Eaca5: $siteEntity = $this->getSiteEntity($domainName); goto f4eb2; Ae230: if (!(false === is_null($siteEntity) && false === is_null($cronJobEntity))) { goto Abab5; } goto d1b00; E3b69: $user = $this->getUser(); goto e44eb; c905d: $domainName = $site->getDomainName(); goto Eaca5; be363: if (!($siteEntity->getDomainName() == $cronJobSiteEntity->getDomainName())) { goto Db1a5; } goto E3b69; C91da: $evenData = ["\163\x69\x74\145" => $domainName, "\143\157\x6d\155\141\156\x64" => $cronJobEntity->getCommand()]; goto A4340; f4eb2: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto Ae230; d9ec6: $siteUpdater->updateUserCrontab(); goto C91da; ec199: Db1a5: goto c28ce; C6e2f: $session = $request->getSession(); goto E8b60; Bde96: $siteUpdater = $this->getSiteUpdater($site); goto d9ec6; E8b60: $id = (int) $request->get("\x69\144"); goto c905d; ef2af: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\164\145\137\143\x72\157\x6e\x5f\152\157\x62\163", ["\x64\157\155\x61\x69\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto A1b2c; db9ba: $site->setCronJobs($siteEntity->getCronJobs()); goto Dff9f; d1b00: $cronJobSiteEntity = $cronJobEntity->getSite(); goto be363; e44eb: $siteEntity->removeCronJob($cronJobEntity); goto db9ba; A1b2c: return $response; goto ec199; b7b44: $session->getFlashBag()->set("\163\165\143\143\x65\163\163", $this->translator->trans("\103\x72\157\x6e\40\112\157\x62\40\x68\x61\x73\x20\x62\145\145\156\x20\144\145\154\145\164\x65\x64\x2e")); goto ef2af; c28ce: Abab5: goto E81f5; E81f5: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\x65\x72", $this->translator->trans("\101\x6e\x20\x65\x72\x72\x6f\x72\40\x68\x61\163\x20\157\143\143\x75\162\x72\x65\144\54\x20\x65\x72\162\x6f\162\x20\155\145\x73\163\x61\147\145\x3a\x20\45\145\x72\162\x6f\x72\115\145\163\163\x61\x67\145\x25", ["\45\145\x72\x72\157\x72\x4d\145\x73\163\141\147\x65\45" => $e->getMessage()])); } goto d7d13; ad589: return $response; goto b51cb; d7d13: Eaa32: goto E15cf; bd331: $site = $this->getSite($request); goto E5b41; E5b41: $this->checkCsrfToken($request, "\x63\162\157\156\152\157\142\55\144\145\x6c\145\164\145"); goto Ed525; E15cf: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\x69\x74\x65\163")); goto ad589; Ed525: if (!(false === is_null($site))) { goto Eaa32; } goto ab47e; b51cb: } public function editCronJob(Request $request) : Response { goto c9f67; C3ed9: goto dc528; goto F074a; A6ed9: Bc8f8: goto A72bf; Da02f: dc528: goto C7f10; Dbc42: if (false === is_null($cronJobEntity) && false === is_null($site) && $cronJobEntity->getSite()->getDomainName() == $site->getDomainName()) { goto D44a5; } goto C0ec7; C0ec7: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\151\x74\x65\163")); goto C3ed9; A35a6: C1b71: goto d8b27; f5316: if (!(true === $request->isMethod("\x50\x4f\123\x54"))) { goto C1b71; } goto ea5c1; cbff9: return $response; goto A6ed9; f0c2e: $form = $this->createCronJobEditForm($cronJobEntity); goto f5316; aa1a3: if (!(true === $form->isSubmitted())) { goto a0d3a; } goto a66d0; ceaf4: $site = $this->getSite($request); goto Fc10e; Fc10e: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto Dbc42; d8b27: $response = $this->render("\x46\x72\157\x6e\164\x65\156\144\57\x53\x69\x74\145\x2f\x65\x64\x69\164\55\x63\162\x6f\x6e\x2d\x6a\x6f\x62\56\150\164\x6d\154\56\x74\x77\x69\x67", ["\x73\151\164\145" => $site, "\146\157\162\155" => $form->createView(), "\146\157\162\155\x45\162\162\x6f\x72\163" => $this->formErrors]); goto Da02f; c9f67: $id = (int) $request->get("\151\144"); goto ceaf4; cbf9f: if (!(false === is_null($response))) { goto Bc8f8; } goto cbff9; C7f10: return $response; goto abe64; F074a: D44a5: goto f0c2e; a66d0: $response = $this->handleCronJobEditForm($request, $form, $site); goto cbf9f; A72bf: a0d3a: goto A35a6; ea5c1: $form->handleRequest($request); goto aa1a3; abe64: } private function createCronJobEditForm(CronJobEntity $cronJobEntity) : Form { goto a9e7c; f388c: $form = $this->createForm("\101\x70\x70\134\x46\x6f\x72\155\x5c\x53\151\x74\145\x43\x72\157\156\112\157\142\x45\x64\x69\x74\124\x79\x70\145", $cronJobEntity, ["\x61\x63\x74\151\x6f\x6e" => $this->generateUrl("\x63\154\160\137\x73\151\164\x65\x5f\x63\162\x6f\156\x5f\x6a\157\x62\137\x65\144\151\164", ["\x64\x6f\155\141\x69\156\x4e\141\x6d\145" => $siteEntity->getDomainName(), "\x69\144" => $cronJobEntity->getId()]), "\155\x65\164\150\157\144" => "\x50\117\123\x54", "\141\164\164\162" => []]); goto B5991; a9e7c: $siteEntity = $cronJobEntity->getSite(); goto f388c; B5991: $form->add("\163\x75\x62\155\151\x74", SubmitType::class, ["\141\164\164\162" => ["\x63\154\x61\x73\x73" => "\x62\164\x6e\x20\x62\x74\x6e\x2d\142\x6c\165\x65\x20\142\164\x6e\x2d\x6c\x67"], "\x6c\x61\x62\x65\x6c" => "\x53\x61\166\145"]); goto D50cb; D50cb: return $form; goto fc118; fc118: } private function handleCronJobEditForm(Request $request, Form $form, Site $site) { goto Eff6a; f1c16: A7515: goto add08; Dbceb: C59cd: goto aa8be; Eff6a: if (true === $form->isValid()) { goto C59cd; } goto c6338; aa8be: try { goto b8efb; d8450: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\164\x65\163")); goto E97c1; F16c5: $cronJobEntity = $form->getData(); goto E0293; Deeaf: $user = $this->getUser(); goto F16c5; e29de: F2bca: goto Deeaf; A0f5f: $siteUpdater->updateUserCrontab(); goto f6adb; E97c1: goto F5dc0; goto e29de; B4c77: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_EDIT, $user, $eventData, $request); goto Ffe85; E0293: $siteEntity->addCronJob($cronJobEntity); goto cb92c; F1b47: if (false === is_null($siteEntity)) { goto F2bca; } goto d8450; cb92c: $site->setCronJobs($siteEntity->getCronJobs()); goto ac0cd; C223d: $siteUpdater = $this->getSiteUpdater($site); goto A0f5f; ac0cd: $this->siteEntityManager->updateEntity($siteEntity); goto C223d; b8efb: $session = $request->getSession(); goto d0354; B4a1d: return $response; goto d15c9; c2fb8: $siteEntity = $this->getSiteEntity($domainName); goto F1b47; d0354: $domainName = $site->getDomainName(); goto c2fb8; f6adb: $eventData = ["\163\x69\164\145" => $domainName, "\143\162\157\156\164\x61\x62\105\170\160\x72\145\163\163\x69\157\x6e" => $cronJobEntity->getCrontabExpression()]; goto B4c77; Ffe85: $session->getFlashBag()->set("\x73\165\x63\143\145\163\x73", $this->translator->trans("\x43\x72\157\x6e\x20\x4a\x6f\x62\x20\x68\x61\x73\40\x62\145\145\x6e\x20\163\141\x76\145\144\56")); goto dcbdf; dcbdf: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\164\145\x5f\143\x72\157\x6e\x5f\152\157\x62\163", ["\x64\157\x6d\x61\151\x6e\x4e\x61\155\145" => $site->getDomainName()])); goto cb17e; cb17e: F5dc0: goto B4a1d; d15c9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\x65\162", $this->translator->trans("\101\156\40\145\162\x72\157\162\40\x68\x61\163\x20\157\x63\x63\x75\x72\x72\145\144\x2c\x20\x65\x72\x72\x6f\x72\40\x6d\x65\163\163\141\x67\x65\72\40\45\x65\x72\x72\157\x72\115\x65\x73\x73\141\147\x65\45", ["\x25\x65\x72\162\157\162\x4d\145\163\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto f1c16; C27d8: goto A7515; goto Dbceb; c6338: $this->formErrors = $this->getErrorMessages($form); goto C27d8; add08: } public function users(Request $request) : Response { goto c0115; db06d: $response = $this->render("\106\x72\157\156\x74\x65\x6e\144\57\x53\x69\164\145\x2f\165\163\x65\162\163\56\150\164\x6d\154\56\x74\167\x69\147", ["\163\151\x74\145" => $site, "\146\157\162\x6d\105\162\162\157\x72\163" => $this->formErrors]); goto Ce49a; af03f: return $response; goto f2b64; c0115: $site = $this->getSite($request); goto F35c1; b2903: goto E7c34; goto Ac984; Ac984: C57a3: goto db06d; Df9a6: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\x69\164\x65\163")); goto b2903; F35c1: if (false === is_null($site)) { goto C57a3; } goto Df9a6; Ce49a: E7c34: goto af03f; f2b64: } public function newFtpUser(Request $request) : Response { goto Ea794; cb732: if (!(false === is_null($response))) { goto Eac1c; } goto eeae3; A8cbb: a1a11: goto cb523; cb523: Fc0d0: goto e8d63; e8d63: $response = $this->render("\106\x72\x6f\156\164\x65\156\x64\x2f\x53\x69\x74\x65\x2f\x6e\145\167\55\x66\164\160\55\x75\x73\x65\x72\56\x68\x74\155\154\56\x74\x77\151\147", ["\x73\x69\164\x65" => $site, "\x66\157\162\x6d" => $form->createView(), "\x66\157\162\x6d\105\x72\x72\157\x72\163" => $this->formErrors]); goto Fe40b; Fde05: $form = $this->createFtpUserForm($ftpUserEntity); goto C27d0; ec72d: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ddfb2; f916c: goto C390a; goto f230b; eeae3: return $response; goto eac5d; f230b: fa26b: goto ec72d; eac5d: Eac1c: goto A8cbb; bd6c4: $response = $this->handleFtpUserForm($request, $form, $site); goto cb732; ddfb2: $ftpUserEntity = $this->ftpUserEntityManager->createEntity(); goto D7f4f; dfa97: return $response; goto E9f90; Fa55e: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\x69\x74\x65\163")); goto f916c; E76c5: if (!(true === $form->isSubmitted())) { goto a1a11; } goto bd6c4; Fe40b: C390a: goto dfa97; C27d0: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto Fc0d0; } goto ec2f6; Ea794: $site = $this->getSite($request); goto D95e0; D95e0: if (false === is_null($site)) { goto fa26b; } goto Fa55e; D7f4f: $ftpUserEntity->setSite($siteEntity); goto Fde05; ec2f6: $form->handleRequest($request); goto E76c5; E9f90: } private function createFtpUserForm(FtpUserEntity $ftpUserEntity) : Form { goto bb00e; bae5f: $form = $this->createForm("\101\x70\x70\x5c\106\x6f\162\155\x5c\x53\151\164\145\x46\164\x70\125\x73\x65\162\x54\171\x70\145", $ftpUserEntity, ["\x61\143\164\151\x6f\156" => $this->generateUrl("\143\x6c\160\137\x73\151\x74\145\137\x66\164\x70\x5f\165\x73\x65\162\x5f\x6e\145\167", ["\x64\157\x6d\x61\x69\x6e\x4e\x61\155\x65" => $siteEntity->getDomainName()]), "\155\x65\164\x68\157\144" => "\120\x4f\123\x54", "\x61\164\x74\162" => []]); goto fbba5; fbba5: $form->add("\163\165\142\x6d\x69\164", SubmitType::class, ["\141\x74\x74\162" => ["\x63\154\141\163\x73" => "\x62\x74\156\40\x62\x74\156\x2d\142\154\165\x65\40\142\164\x6e\55\154\x67"], "\154\x61\142\145\x6c" => "\101\x64\x64\40\x55\163\x65\x72"]); goto fc9a6; bb00e: $siteEntity = $ftpUserEntity->getSite(); goto bae5f; fc9a6: return $form; goto F09c4; F09c4: } private function handleFtpUserForm(Request $request, Form $form, Site $site) { goto C4f0a; b1cab: Be792: goto C06af; Be51a: $this->formErrors = $this->getErrorMessages($form); goto F4828; F4828: goto Be792; goto c7a98; C4f0a: if (true === $form->isValid()) { goto d423a; } goto Be51a; bae66: try { goto b9151; D695d: $ftpUserPassword = $form->get("\x70\141\x73\x73\x77\x6f\162\144")->getData(); goto C8a6e; A699a: $user = $this->getUser(); goto fae97; b9725: $ftpUserName = $ftpUserEntity->getUserName(); goto D695d; eb76f: Af506: goto A699a; b2d2d: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_ADD, $user, $eventData, $request); goto f8c2a; f8c2a: $session->getFlashBag()->set("\163\165\x63\143\145\x73\163", $this->translator->trans("\125\x73\x65\x72\40\150\141\x73\x20\x62\x65\145\x6e\x20\x61\x64\x64\145\144\56")); goto d0f61; d0f61: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\151\164\x65\137\x75\x73\145\162\163", ["\x64\x6f\x6d\x61\151\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto c7a8b; A6e24: if (false === is_null($siteEntity)) { goto Af506; } goto Def1d; b9151: $session = $request->getSession(); goto F83b7; B4aa5: return $response; goto C5c24; Def1d: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\x74\145\x73")); goto Ed3d4; D7738: $siteEntity = $this->getSiteEntity($domainName); goto A6e24; F83b7: $domainName = $site->getDomainName(); goto D7738; fae97: $ftpUserEntity = $form->getData(); goto b9725; c7a8b: C4944: goto B4aa5; c9efe: $this->siteEntityManager->updateEntity($siteEntity); goto ebc60; Cfc66: $eventData = ["\x73\151\x74\145" => $domainName, "\165\x73\x65\162\x4e\141\155\145" => $ftpUserName, "\x68\157\155\145\x44\x69\162\x65\143\x74\157\162\171" => $ftpUserEntity->getHomeDirectory()]; goto b2d2d; a5b6a: $siteEntity->addFtpUser($ftpUserEntity); goto c9efe; Ed3d4: goto C4944; goto eb76f; ebc60: $siteUpdater = $this->getSiteUpdater($site); goto F02e2; F02e2: $siteUpdater->createFtpUser($ftpUserEntity); goto Cfc66; C8a6e: $ftpUserEntity->setPassword($ftpUserPassword); goto a5b6a; C5c24: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\162", $this->translator->trans("\101\156\x20\145\162\162\x6f\x72\40\x68\x61\163\40\x6f\x63\x63\165\162\162\145\x64\54\x20\145\162\x72\x6f\162\40\155\x65\x73\163\141\147\145\x3a\x20\45\145\162\162\157\x72\x4d\x65\163\x73\141\147\145\x25", ["\x25\x65\x72\162\x6f\x72\x4d\145\163\x73\x61\147\x65\x25" => $e->getMessage()])); } goto b1cab; c7a98: d423a: goto bae66; C06af: } public function editFtpUser(Request $request) : Response { goto cbdd4; Ee244: B6b78: goto a88d9; Fccdb: $form->handleRequest($request); goto aaf75; af38f: goto B6b78; goto E2974; B98a2: Fbe94: goto D2fae; d10c0: if (!(false === is_null($response))) { goto Fbe94; } goto E5200; C5fbd: $response = $this->handleFtpUserEditForm($request, $form, $site); goto d10c0; cf874: $site = $this->getSite($request); goto Cf643; D2fae: c208d: goto D1aba; f8f3c: $form = $this->createFtpUserEditForm($ftpUserEntity); goto b6417; E2974: fc3c2: goto f8f3c; E99d3: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\x73\x69\x74\145\163")); goto af38f; aaf75: if (!(true === $form->isSubmitted())) { goto c208d; } goto C5fbd; Cf643: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto b5464; a88d9: return $response; goto E0ffc; b6417: if (!(true === $request->isMethod("\x50\117\123\124"))) { goto b44fc; } goto Fccdb; bffc5: $response = $this->render("\x46\162\x6f\x6e\x74\x65\x6e\144\57\123\151\164\x65\57\x65\144\x69\164\x2d\146\x74\x70\55\165\163\145\162\x2e\150\164\155\154\56\x74\x77\x69\147", ["\x73\151\164\145" => $site, "\146\157\162\155" => $form->createView(), "\x66\x6f\162\155\x45\x72\x72\157\162\x73" => $this->formErrors]); goto Ee244; cbdd4: $userName = $request->get("\165\163\x65\162\x4e\141\155\x65"); goto cf874; E5200: return $response; goto B98a2; D1aba: b44fc: goto bffc5; b5464: if (false === is_null($ftpUserEntity) && false === is_null($site) && $ftpUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto fc3c2; } goto E99d3; E0ffc: } private function createFtpUserEditForm(FtpUserEntity $ftpUserEntity) : Form { goto A3262; A3262: $siteEntity = $ftpUserEntity->getSite(); goto f09d2; F8a73: return $form; goto da7ff; f09d2: $form = $this->createForm("\101\x70\x70\x5c\106\157\162\x6d\134\123\x69\x74\145\x46\164\x70\125\163\x65\x72\105\x64\151\x74\124\171\x70\145", $ftpUserEntity, ["\141\x63\164\151\x6f\156" => $this->generateUrl("\x63\x6c\160\x5f\x73\151\164\145\137\x66\x74\x70\137\165\163\145\x72\137\x65\x64\151\x74", ["\144\x6f\155\141\x69\x6e\x4e\x61\155\x65" => $siteEntity->getDomainName(), "\x75\163\145\162\x4e\x61\x6d\x65" => $ftpUserEntity->getUserName()]), "\155\145\164\x68\x6f\144" => "\120\117\123\x54", "\141\x74\164\x72" => []]); goto D3a5b; D3a5b: $form->add("\x73\165\x62\155\x69\x74", SubmitType::class, ["\x61\164\164\x72" => ["\143\154\141\x73\x73" => "\x62\x74\x6e\x20\142\164\x6e\55\142\x6c\165\145\40\142\164\156\55\x6c\147"], "\154\x61\142\145\154" => "\123\141\166\x65"]); goto F8a73; da7ff: } private function handleFtpUserEditForm(Request $request, Form $form, Site $site) { goto e257a; cf39d: e9551: goto b9a17; f3a40: goto e9551; goto f1a06; e257a: if (true === $form->isValid()) { goto Ad3d2; } goto F1b28; F1b28: $this->formErrors = $this->getErrorMessages($form); goto f3a40; f1a06: Ad3d2: goto C5282; C5282: try { goto Bbbc5; ea40c: cf62c: goto C1277; aed23: $siteEntity = $this->getSiteEntity($domainName); goto f98b3; C1277: $eventData = ["\163\151\164\145" => $domainName, "\x75\163\x65\162\116\141\x6d\145" => $ftpUserName, "\150\157\x6d\x65\x44\151\162\145\x63\x74\x6f\162\171" => $ftpUserHomeDirectory]; goto Fca8e; ce6a9: $ftpUserHomeDirectory = $ftpUserEntity->getHomeDirectory(); goto db7bb; db7bb: $this->siteEntityManager->updateEntity($siteEntity); goto F6627; F6627: $siteUpdater = $this->getSiteUpdater($site); goto cb0d4; D7b21: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\164\x65\163")); goto Dd6a0; Fca8e: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_EDIT, $user, $eventData, $request); goto Ca244; f98b3: if (false === is_null($siteEntity)) { goto c10e9; } goto D7b21; Fa6e0: $user = $this->getUser(); goto Aa94b; C51c7: $domainName = $site->getDomainName(); goto aed23; Aa94b: $ftpUserEntity = $form->getData(); goto f3834; Bbbc5: $session = $request->getSession(); goto C51c7; D537f: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\x69\x74\x65\x5f\165\163\145\162\163", ["\x64\x6f\x6d\x61\151\156\116\141\x6d\145" => $site->getDomainName()])); goto C6cf3; Ca2cd: $siteUpdater->changeUserPassword($ftpUserName, $ftpUserPassword); goto ea40c; f3834: $ftpUserName = $ftpUserEntity->getUserName(); goto C4bb1; Dd6a0: goto eb113; goto A7950; C6cf3: eb113: goto bbaed; bbaed: return $response; goto Cb32f; C4bb1: $ftpUserPassword = $form->get("\x70\141\163\163\x77\157\162\x64")->getData(); goto ce6a9; A7950: c10e9: goto Fa6e0; cb0d4: $siteUpdater->changeUserHomeDirectory($ftpUserName, $ftpUserHomeDirectory); goto Bf8a0; Ca244: $session->getFlashBag()->set("\x73\x75\x63\143\x65\x73\163", $this->translator->trans("\125\163\x65\162\40\x68\x61\x73\x20\142\x65\145\x6e\x20\163\141\x76\145\144\56")); goto D537f; Bf8a0: if (!(false === empty($ftpUserPassword))) { goto cf62c; } goto Ca2cd; Cb32f: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\162", $this->translator->trans("\101\156\x20\145\x72\162\157\x72\x20\150\x61\163\x20\x6f\143\x63\x75\x72\162\x65\144\x2c\40\x65\x72\162\x6f\162\x20\155\145\163\x73\141\x67\x65\x3a\x20\45\145\x72\x72\157\x72\x4d\x65\163\163\141\147\145\45", ["\45\x65\x72\162\x6f\x72\115\x65\x73\x73\141\147\145\x25" => $e->getMessage()])); } goto cf39d; b9a17: } public function deleteFtpUser(Request $request) : Response { goto edaad; d477b: E4c52: goto e9192; e9192: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\164\145\x73")); goto d62af; e1434: try { goto F805c; D030b: $siteUpdater->deleteUser($userName, false); goto Edff6; d29f8: $siteUpdater = $this->getSiteUpdater($site); goto D030b; e91cb: F6336: goto E0171; E256c: fec8e: goto e91cb; D8537: $siteEntity = $this->getSiteEntity($domainName); goto D7f60; a1dd3: $session->getFlashBag()->set("\163\x75\143\143\145\163\x73", $this->translator->trans("\x55\x73\x65\x72\40\150\x61\163\40\x62\x65\x65\x6e\x20\x64\x65\x6c\145\x74\145\144\x2e")); goto d642a; d642a: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\151\164\145\x5f\165\x73\145\x72\x73", ["\144\x6f\155\x61\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto ca340; Cb6d8: $user = $this->getUser(); goto D9a32; F805c: $session = $request->getSession(); goto F8709; c53cc: $siteEntity->removeFtpUser($ftpUserEntity); goto Ee258; D9a32: $userName = $ftpUserEntity->getUserName(); goto c53cc; D7f60: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto af879; Ac5bd: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_DELETE, $user, $evenData, $request); goto a1dd3; Edff6: $evenData = ["\163\151\164\145" => $domainName, "\x75\x73\x65\x72\x4e\x61\x6d\x65" => $userName]; goto Ac5bd; af879: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($ftpUserEntity))) { goto F6336; } goto Da813; Ee258: $this->siteEntityManager->updateEntity($siteEntity); goto d29f8; A7f4c: if (!($siteEntity->getDomainName() == $ftpUserSiteEntity->getDomainName())) { goto fec8e; } goto Cb6d8; ca340: return $response; goto E256c; ad3c7: $domainName = $site->getDomainName(); goto D8537; Da813: $ftpUserSiteEntity = $ftpUserEntity->getSite(); goto A7f4c; F8709: $userName = $request->get("\x75\163\x65\x72\x4e\x61\155\145"); goto ad3c7; E0171: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\145\162", $this->translator->trans("\101\156\x20\145\162\162\157\162\x20\150\141\163\x20\157\143\143\165\x72\162\x65\144\54\40\x65\x72\162\157\x72\x20\x6d\x65\x73\163\141\147\x65\x3a\40\x25\145\x72\x72\157\x72\115\145\163\x73\x61\x67\145\x25", ["\x25\145\x72\x72\157\162\x4d\145\163\163\141\x67\145\45" => $e->getMessage()])); } goto d477b; edaad: $site = $this->getSite($request); goto F25ac; Ea9be: if (!(false === is_null($site))) { goto E4c52; } goto e1434; F25ac: $this->checkCsrfToken($request, "\x75\x73\x65\162\55\x64\x65\x6c\x65\x74\145"); goto Ea9be; d62af: return $response; goto E8b5e; E8b5e: } public function newSshUser(Request $request) : Response { goto C242e; F3abc: $sshUserEntity->setSite($siteEntity); goto ec5f2; ec5f2: $form = $this->createSshUserForm($sshUserEntity); goto c7146; d557f: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\x74\145\x73")); goto Ff8c2; e7fb0: if (!(true === $form->isSubmitted())) { goto c5e0c; } goto Ea17b; F3019: b41dd: goto cc678; C242e: $site = $this->getSite($request); goto b6b74; Ea17b: $response = $this->handleSshUserForm($request, $form, $site); goto E0b51; E0b51: if (!(false === is_null($response))) { goto b41dd; } goto Eb947; c6eae: Efb7e: goto Ab856; Bdbe8: return $response; goto F7dcf; C9958: Dba88: goto ddcea; Ab856: $response = $this->render("\106\162\x6f\156\164\x65\156\x64\x2f\x53\151\x74\145\57\156\x65\167\x2d\x73\x73\150\55\x75\x73\145\x72\x2e\x68\x74\x6d\154\x2e\164\x77\x69\147", ["\x73\151\164\145" => $site, "\x66\157\162\155" => $form->createView(), "\146\x6f\x72\155\105\162\162\x6f\x72\163" => $this->formErrors]); goto B9b39; B9b39: Eb934: goto Bdbe8; Ff8c2: goto Eb934; goto C9958; b6b74: if (false === is_null($site)) { goto Dba88; } goto d557f; c7146: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto Efb7e; } goto Ed781; Be02a: $sshUserEntity = $this->sshUserEntityManager->createEntity(); goto F3abc; Eb947: return $response; goto F3019; cc678: c5e0c: goto c6eae; Ed781: $form->handleRequest($request); goto e7fb0; ddcea: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto Be02a; F7dcf: } private function createSshUserForm(SshUserEntity $sshUserEntity) : Form { goto b9152; C87d6: $form->add("\x73\165\142\x6d\x69\x74", SubmitType::class, ["\141\164\164\162" => ["\143\x6c\141\163\163" => "\x62\164\156\x20\142\x74\x6e\x2d\x62\154\x75\x65\40\142\x74\156\x2d\x6c\147"], "\154\141\142\x65\154" => "\x41\144\144\40\x55\163\x65\162"]); goto C5c85; Eab4d: $form = $this->createForm("\x41\160\160\134\x46\x6f\162\x6d\x5c\x53\151\164\145\x53\163\150\125\163\145\162\124\x79\x70\x65", $sshUserEntity, ["\141\x63\164\151\x6f\156" => $this->generateUrl("\x63\x6c\x70\137\163\x69\x74\145\x5f\x73\163\x68\x5f\165\163\x65\x72\137\156\145\x77", ["\144\157\x6d\x61\x69\x6e\x4e\141\x6d\x65" => $siteEntity->getDomainName()]), "\155\145\x74\x68\x6f\x64" => "\x50\117\x53\x54", "\141\164\164\x72" => []]); goto C87d6; C5c85: return $form; goto B1802; b9152: $siteEntity = $sshUserEntity->getSite(); goto Eab4d; B1802: } private function handleSshUserForm(Request $request, Form $form, Site $site) { goto Df5c5; F7da1: goto ff310; goto c43e2; Df5c5: if (true === $form->isValid()) { goto A86ea; } goto c83bb; c43e2: A86ea: goto ce5af; eb768: ff310: goto aa37d; ce5af: try { goto eec6e; F375c: $sshUserEntity->setPassword($sshUserPassword); goto C4985; D8002: b2152: goto cc31c; cdfea: $siteUpdater = $this->getSiteUpdater($site); goto e6ea4; d6a5f: if (!(false === empty($sshKeys))) { goto b2152; } goto a13f4; d5d2e: $sshUserEntity = $form->getData(); goto E5cf2; a2356: ae0da: goto d3280; e5cd8: $this->siteEntityManager->updateEntity($siteEntity); goto cdfea; d3280: $user = $this->getUser(); goto d5d2e; dee63: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_ADD, $user, $eventData, $request); goto C61f8; af149: d51b7: goto fe4a9; fe4a9: return $response; goto ca68d; efbb9: $domainName = $site->getDomainName(); goto f22c7; F5bed: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\164\145\163")); goto d7306; Dc4dc: if (false === is_null($siteEntity)) { goto ae0da; } goto F5bed; E5cf2: $sshUserName = $sshUserEntity->getUserName(); goto E00c3; d7306: goto d51b7; goto a2356; B1ec4: $siteEntity->addSshUser($sshUserEntity); goto e5cd8; E00c3: $sshUserPassword = $form->get("\x70\x61\x73\163\x77\157\x72\144")->getData(); goto F375c; eec6e: $session = $request->getSession(); goto efbb9; cc31c: $eventData = ["\x73\x69\164\x65" => $domainName, "\x75\163\x65\162\116\x61\x6d\145" => $sshUserName, "\163\163\x68\x4b\145\x79\163" => $sshKeys]; goto dee63; d3ef7: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\151\164\x65\137\x75\163\x65\x72\x73", ["\144\x6f\x6d\141\151\x6e\x4e\141\155\145" => $site->getDomainName()])); goto af149; C61f8: $session->getFlashBag()->set("\x73\165\x63\x63\145\163\163", $this->translator->trans("\125\x73\x65\x72\x20\150\x61\x73\40\x62\145\145\x6e\40\x61\x64\x64\145\144\x2e")); goto d3ef7; e6ea4: $siteUpdater->createSshUser($sshUserEntity); goto d6a5f; a13f4: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto D8002; f22c7: $siteEntity = $this->getSiteEntity($domainName); goto Dc4dc; C4985: $sshKeys = $sshUserEntity->getSshKeys(); goto B1ec4; ca68d: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\147\x65\162", $this->translator->trans("\101\x6e\x20\145\162\x72\157\x72\x20\150\x61\x73\40\157\143\x63\x75\162\162\145\144\x2c\40\x65\x72\162\157\x72\40\155\x65\x73\163\141\147\x65\x3a\x20\45\x65\x72\162\157\162\x4d\145\x73\163\141\147\145\x25", ["\x25\x65\x72\162\x6f\162\x4d\145\x73\163\x61\x67\145\45" => $e->getMessage()])); } goto eb768; c83bb: $this->formErrors = $this->getErrorMessages($form); goto F7da1; aa37d: } public function editSshUser(Request $request) : Response { goto a7b4c; Dab9a: $form->handleRequest($request); goto Ffe3d; ec1c1: if (false === is_null($sshUserEntity) && false === is_null($site) && $sshUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto d9b5f; } goto F050f; F6caa: dacef: goto C25c2; A6d00: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto fdbde; } goto Dab9a; A3d17: if (!(false === is_null($response))) { goto dacef; } goto Cbd50; ba9ce: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto ec1c1; d4d88: goto F98ff; goto Dafd8; C25c2: f0c18: goto F8b4d; C9284: F98ff: goto b46d1; F050f: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\x69\164\x65\x73")); goto d4d88; aa68a: $site = $this->getSite($request); goto ba9ce; F8b4d: fdbde: goto D5158; Ac53e: $form = $this->createSshUserEditForm($sshUserEntity); goto A6d00; fa037: $response = $this->handleSshUserEditForm($request, $form, $site); goto A3d17; b46d1: return $response; goto ba22f; Ffe3d: if (!(true === $form->isSubmitted())) { goto f0c18; } goto fa037; D5158: $response = $this->render("\106\x72\x6f\x6e\x74\x65\156\x64\x2f\x53\151\164\145\57\145\x64\x69\164\x2d\x73\163\x68\x2d\165\163\x65\162\56\150\x74\155\154\56\164\x77\151\147", ["\x73\x69\164\145" => $site, "\146\157\x72\155" => $form->createView(), "\146\x6f\162\155\x45\162\162\x6f\x72\163" => $this->formErrors]); goto C9284; Cbd50: return $response; goto F6caa; Dafd8: d9b5f: goto Ac53e; a7b4c: $userName = $request->get("\165\163\145\162\x4e\141\155\145"); goto aa68a; ba22f: } private function createSshUserEditForm(SshUserEntity $sshUserEntity) : Form { goto b0def; b0def: $siteEntity = $sshUserEntity->getSite(); goto F294f; fd77d: $form->add("\163\x75\x62\x6d\151\x74", SubmitType::class, ["\141\x74\164\162" => ["\x63\x6c\x61\163\163" => "\x62\164\156\40\x62\164\156\x2d\x62\154\x75\145\40\x62\164\156\x2d\x6c\x67"], "\154\x61\x62\x65\x6c" => "\x53\141\x76\145"]); goto c23dc; F294f: $form = $this->createForm("\x41\160\x70\x5c\106\x6f\x72\155\x5c\123\x69\164\145\x53\163\150\x55\x73\145\x72\x45\x64\151\164\124\171\160\x65", $sshUserEntity, ["\x61\143\164\151\x6f\156" => $this->generateUrl("\x63\x6c\160\137\163\151\x74\145\x5f\x73\x73\150\137\x75\163\x65\162\137\145\144\x69\164", ["\x64\157\155\141\x69\156\x4e\141\x6d\x65" => $siteEntity->getDomainName(), "\x75\163\x65\x72\116\141\x6d\x65" => $sshUserEntity->getUserName()]), "\155\x65\x74\x68\157\144" => "\x50\117\123\124", "\x61\x74\164\x72" => []]); goto fd77d; c23dc: return $form; goto ef022; ef022: } private function handleSshUserEditForm(Request $request, Form $form, Site $site) { goto Cce16; e8642: aa799: goto f92ce; ff2c0: B8164: goto Ab384; efe57: goto aa799; goto ff2c0; Ab384: try { goto E4705; Fc669: $this->siteEntityManager->updateEntity($siteEntity); goto A4795; A83c3: $sshUserName = $sshUserEntity->getUserName(); goto Cfa64; D7582: f8dfd: goto C1fae; c604d: $sshKeys = false === is_null($sshUserEntity->getSshKeys()) ? $sshUserEntity->getSshKeys() : ''; goto Fc669; E4705: $session = $request->getSession(); goto Bb9b9; f085c: $user = $this->getUser(); goto db260; f57e6: $eventData = ["\163\x69\x74\145" => $domainName, "\165\163\145\x72\116\141\x6d\145" => $sshUserName, "\x73\x73\x68\x4b\x65\171\163" => $sshKeys]; goto b5e73; e8266: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\x69\164\145\x73")); goto b3982; B0bb3: $session->getFlashBag()->set("\x73\165\143\x63\x65\163\x73", $this->translator->trans("\125\163\145\x72\x20\x68\x61\163\x20\x62\x65\x65\156\40\x73\141\166\x65\144\x2e")); goto Eb020; b5e73: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_EDIT, $user, $eventData, $request); goto B0bb3; Eb020: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\151\164\145\137\165\x73\x65\162\163", ["\x64\157\x6d\x61\x69\x6e\x4e\141\x6d\x65" => $site->getDomainName()])); goto ef63a; C1fae: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto f57e6; Cfa64: $sshUserPassword = $form->get("\160\141\x73\x73\x77\157\162\144")->getData(); goto c604d; F076e: $siteUpdater->changeUserPassword($sshUserName, $sshUserPassword); goto D7582; b3982: goto f1515; goto Acfec; ef63a: f1515: goto dff63; db260: $sshUserEntity = $form->getData(); goto A83c3; Bb9b9: $domainName = $site->getDomainName(); goto e5be8; dff63: return $response; goto D3c31; e5be8: $siteEntity = $this->getSiteEntity($domainName); goto D4818; Acfec: C8321: goto f085c; D4818: if (false === is_null($siteEntity)) { goto C8321; } goto e8266; b944e: if (!(false === empty($sshUserPassword))) { goto f8dfd; } goto F076e; A4795: $siteUpdater = $this->getSiteUpdater($site); goto b944e; D3c31: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\162", $this->translator->trans("\x41\x6e\x20\145\162\162\x6f\x72\x20\x68\141\163\x20\157\143\x63\x75\162\x72\145\144\54\40\x65\x72\x72\157\162\x20\x6d\x65\x73\x73\141\147\x65\x3a\x20\x25\145\x72\162\x6f\x72\x4d\145\163\x73\141\x67\145\45", ["\45\145\x72\x72\x6f\x72\115\x65\x73\x73\141\x67\x65\x25" => $e->getMessage()])); } goto e8642; b9c92: $this->formErrors = $this->getErrorMessages($form); goto efe57; Cce16: if (true === $form->isValid()) { goto B8164; } goto b9c92; f92ce: } public function deleteSshUser(Request $request) : Response { goto f19db; abf2e: return $response; goto B0a04; c232d: if (!(false === is_null($site))) { goto f86cb; } goto Ae0e0; Ae0e0: try { goto Dc677; F87b9: $userName = $sshUserEntity->getUserName(); goto cdadb; C78db: $siteUpdater = $this->getSiteUpdater($site); goto acd70; Fe0dd: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\x74\145\137\165\163\x65\162\163", ["\144\157\x6d\x61\151\x6e\116\x61\x6d\145" => $site->getDomainName()])); goto Befd6; C4258: A6212: goto C7d7a; Eaf2a: $evenData = ["\163\x69\x74\145" => $domainName, "\x75\163\x65\x72\x4e\x61\155\145" => $userName]; goto E5e9f; be124: $userName = $request->get("\165\163\x65\x72\116\141\x6d\x65"); goto F36fe; E5e9f: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_DELETE, $user, $evenData, $request); goto Efce2; Dc677: $session = $request->getSession(); goto be124; D4d9e: $user = $this->getUser(); goto F87b9; cdadb: $siteEntity->removeSshUser($sshUserEntity); goto Adc91; B0dce: f9f8f: goto C4258; F36fe: $domainName = $site->getDomainName(); goto d6db5; Dcfe8: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($sshUserEntity))) { goto A6212; } goto B6a28; d6db5: $siteEntity = $this->getSiteEntity($domainName); goto d9f5b; B6a28: $sshUserSiteEntity = $sshUserEntity->getSite(); goto A80a4; Befd6: return $response; goto B0dce; d9f5b: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto Dcfe8; acd70: $siteUpdater->deleteUser($userName, true); goto Eaf2a; Adc91: $this->siteEntityManager->updateEntity($siteEntity); goto C78db; Efce2: $session->getFlashBag()->set("\x73\x75\x63\143\x65\163\x73", $this->translator->trans("\x55\x73\x65\x72\40\150\x61\x73\x20\x62\145\x65\x6e\40\x64\x65\154\145\164\x65\144\56")); goto Fe0dd; A80a4: if (!($siteEntity->getDomainName() == $sshUserSiteEntity->getDomainName())) { goto f9f8f; } goto D4d9e; C7d7a: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\x65\162", $this->translator->trans("\x41\156\x20\145\x72\x72\157\162\x20\150\x61\163\x20\157\143\x63\x75\x72\x72\x65\144\54\40\x65\162\162\157\162\x20\x6d\x65\x73\163\141\x67\x65\72\40\45\x65\162\162\157\x72\x4d\x65\163\x73\141\x67\145\45", ["\45\145\162\162\x6f\162\x4d\x65\163\x73\141\147\x65\x25" => $e->getMessage()])); } goto e7130; f19db: $site = $this->getSite($request); goto de424; B5078: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\x65\163")); goto abf2e; de424: $this->checkCsrfToken($request, "\165\x73\x65\162\x2d\x64\145\154\145\x74\x65"); goto c232d; e7130: f86cb: goto B5078; B0a04: } public function security(Request $request) : Response { goto dd68c; c9557: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto f8da0; Ecd21: B53cf: goto b0aff; B6c9a: if (!(true === $cloudflareForm->isSubmitted())) { goto Df326; } goto ce28f; f8da0: $cloudflareData = ["\x61\x6c\x6c\157\x77\124\162\141\146\x66\x69\143\x46\x72\157\x6d\x43\x6c\x6f\165\144\x66\154\x61\x72\145\x4f\156\154\171" => $siteEntity->allowTrafficFromCloudflareOnly()]; goto B373d; D2c76: if (false === is_null($site)) { goto d998c; } goto Dbe82; Dbe82: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\164\x65\x73")); goto f22f5; b37d1: $cloudflareForm = $this->createCloudflareForm($siteEntity, $cloudflareData); goto B468f; d4548: D5035: goto D3fe8; F2786: $cloudflareForm->handleRequest($request); goto Fb78b; a4f66: eff05: goto D3fce; f22f5: goto B53cf; goto ae3f9; B006f: $basicAuthEntity = $site->getBasicAuth(); goto fb5c1; eff22: f6e12: goto e5b2a; ab9f1: return $response; goto eff22; f1192: if (!(false === is_null($response))) { goto f6e12; } goto ab9f1; fe12d: Afb24: goto Cf96b; ae3f9: d998c: goto c9557; B373d: $blockedBots = $site->getBlockedBots(); goto Fc2b5; ce28f: $response = $this->handleCloudflareForm($request, $cloudflareForm, $site); goto f1192; c232e: $basicAuthForm = $this->createBasicAuthForm($basicAuthEntity); goto b37d1; dd68c: $site = $this->getSite($request); goto D2c76; F955d: $basicAuthForm->handleRequest($request); goto F2786; A3cc7: if (!(false === is_null($response))) { goto Afb24; } goto A8158; fb5c1: if (!(true === is_null($basicAuthEntity))) { goto eff05; } goto db07f; D3fe8: $response = $this->render("\106\x72\x6f\156\164\x65\156\144\x2f\x53\151\164\x65\57\163\145\x63\165\x72\151\164\x79\x2e\150\x74\155\x6c\56\x74\x77\x69\147", ["\163\151\x74\145" => $site, "\142\154\157\x63\x6b\x65\x64\x49\x70\163" => $blockedIps, "\x62\x6c\x6f\x63\x6b\145\x64\x42\157\164\x73" => $blockedBots, "\142\141\x73\x69\x63\x41\x75\164\x68\106\157\162\x6d" => $basicAuthForm->createView(), "\x63\154\157\x75\144\146\154\x61\x72\145\x46\x6f\162\x6d" => $cloudflareForm->createView(), "\146\157\x72\x6d\105\x72\162\x6f\162\x73" => $this->formErrors]); goto Ecd21; D3fce: $basicAuthEntity->setSite($siteEntity); goto c232e; b0aff: return $response; goto a6fff; Fa980: $response = $this->handleBasicAuthForm($request, $basicAuthForm, $site); goto A3cc7; Fb78b: if (!(true === $basicAuthForm->isSubmitted())) { goto cd616; } goto Fa980; e5b2a: Df326: goto d4548; B468f: if (!(true === $request->isMethod("\x50\x4f\123\124"))) { goto D5035; } goto F955d; A8158: return $response; goto fe12d; Cf96b: cd616: goto B6c9a; db07f: $basicAuthEntity = $this->basicAuthEntityManager->createEntity(); goto a4f66; Fc2b5: $blockedIps = $site->getBlockedIps(); goto B006f; a6fff: } private function createCloudflareForm(SiteEntity $siteEntity, array $data) : Form { goto Fe248; ff845: return $form; goto C3015; B14f7: $form->add("\163\165\x62\x6d\151\164", SubmitType::class, ["\x61\164\164\x72" => ["\x63\x6c\x61\x73\x73" => "\142\164\156\40\x62\164\x6e\x2d\x62\154\165\x65\x20\142\164\x6e\55\154\147"], "\x6c\141\x62\x65\x6c" => "\123\x61\x76\x65"]); goto ff845; Fe248: $form = $this->createForm("\101\x70\x70\x5c\106\157\x72\x6d\134\123\151\x74\145\x43\x6c\157\x75\x64\146\154\x61\x72\x65\124\171\x70\x65", $data, ["\x61\x63\x74\x69\x6f\x6e" => $this->generateUrl("\x63\154\160\x5f\163\151\164\145\x5f\163\x65\x63\165\162\x69\164\x79", ["\x64\x6f\155\x61\x69\x6e\116\x61\x6d\145" => $siteEntity->getDomainName()]), "\x6d\145\x74\x68\157\x64" => "\120\x4f\123\124", "\x61\164\x74\162" => []]); goto B14f7; C3015: } private function createBasicAuthForm(BasicAuthEntity $basicAuthEntity) : Form { goto Cc646; E28bd: $form->add("\163\x75\142\x6d\151\x74", SubmitType::class, ["\141\x74\164\x72" => ["\x63\154\x61\x73\x73" => "\x62\164\156\40\142\164\156\55\142\154\165\145\40\142\x74\156\x2d\x6c\147"], "\x6c\x61\x62\145\154" => "\123\141\x76\x65"]); goto Bb706; Db8c2: $form = $this->createForm("\101\160\x70\134\x46\157\162\155\x5c\x53\151\x74\145\102\141\163\x69\x63\101\x75\x74\x68\x54\x79\160\145", $basicAuthEntity, ["\x61\x63\x74\151\x6f\156" => $this->generateUrl("\143\x6c\160\137\x73\x69\x74\145\137\x73\145\x63\165\x72\151\x74\171", ["\x64\157\155\x61\151\x6e\116\x61\x6d\x65" => $siteEntity->getDomainName()]), "\x6d\x65\x74\x68\157\144" => "\120\x4f\x53\124", "\x61\x74\x74\162" => []]); goto E28bd; Bb706: return $form; goto a77b0; Cc646: $siteEntity = $basicAuthEntity->getSite(); goto Db8c2; a77b0: } private function handleBasicAuthForm(Request $request, Form $form, Site $site) { goto E77c9; F3ae9: fb91d: goto b6583; Bf61d: Df959: goto F9f66; fbd17: goto Df959; goto F3ae9; b6583: try { goto D8a70; fa980: $this->siteEntityManager->updateEntity($siteEntity); goto fb2a7; D4401: EventQueue::addEvent(EventQueue::EVENT_SITE_BASIC_AUTHENTIFICATION_SETTINGS, $user, $eventData, $request); goto D7f50; F1cc4: $basicAuthEntity = $form->getData(); goto fd37f; a77d6: cec19: goto D5320; bdabd: $siteUpdater->reloadNginxService(); goto C5290; A2aa0: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\x74\145\137\163\145\143\165\162\x69\164\x79", ["\x64\x6f\x6d\x61\x69\156\116\141\x6d\145" => $site->getDomainName()])); goto a77d6; fb2a7: $siteUpdater = $this->getSiteUpdater($site); goto A6418; d641a: e8eaf: goto b967c; D5320: return $response; goto f63cc; aa25e: $siteEntity = $this->getSiteEntity($domainName); goto E2c61; E2c61: if (false === is_null($siteEntity)) { goto e8eaf; } goto B6029; A6418: $siteUpdater->createBasicAuthFile($basicAuthEntity); goto d9f43; d9f43: $siteUpdater->updateNginxVhost(); goto bdabd; fd37f: $siteEntity->setBasicAuth($basicAuthEntity); goto e15b3; e991b: $domainName = $site->getDomainName(); goto aa25e; B6029: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\x74\145\x73")); goto bedbf; C5290: $eventData = ["\163\151\164\x65" => $domainName, "\x61\143\x74\x69\166\145" => true === $basicAuthEntity->getIsActive() ? "\61" : "\60", "\165\163\145\162\x4e\141\x6d\145" => $basicAuthEntity->getUserName(), "\167\150\x69\164\x65\154\151\163\x74\145\x64\x49\160\x73" => $basicAuthEntity->getWhitelistedIps()]; goto D4401; e15b3: $site->setBasicAuth($basicAuthEntity); goto fa980; bedbf: goto cec19; goto d641a; D8a70: $session = $request->getSession(); goto e991b; D7f50: $session->getFlashBag()->set("\163\165\143\143\x65\163\163", $this->translator->trans("\102\x61\x73\151\143\40\101\x75\x74\x68\x65\156\x74\151\143\x61\164\x69\x6f\156\x20\163\x65\164\x74\x69\156\x67\x73\40\150\141\x76\145\40\x62\x65\145\156\40\x73\141\166\x65\x64\56")); goto A2aa0; b967c: $user = $this->getUser(); goto F1cc4; f63cc: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\162", $this->translator->trans("\101\156\40\x65\162\162\157\x72\40\x68\141\x73\x20\x6f\x63\143\165\x72\162\145\144\x2c\x20\145\162\162\157\x72\40\155\x65\x73\163\x61\x67\x65\x3a\40\x25\x65\162\x72\x6f\x72\x4d\x65\163\x73\x61\147\145\x25", ["\x25\145\x72\162\x6f\x72\115\x65\x73\163\141\147\145\45" => $e->getMessage()])); } goto Bf61d; B8b3f: $this->formErrors = $this->getErrorMessages($form); goto fbd17; E77c9: if (true === $form->isValid()) { goto fb91d; } goto B8b3f; F9f66: } private function handleCloudflareForm(Request $request, Form $form, Site $site) { goto A9389; f06d0: goto b68ab; goto Af7f0; F2f30: $this->formErrors = $this->getErrorMessages($form); goto f06d0; A9389: if (true === $form->isValid()) { goto bcd53; } goto F2f30; fba98: b68ab: goto ceb09; Af7f0: bcd53: goto d2c4e; d2c4e: try { goto e63f4; f7ce2: $siteEntity = $this->getSiteEntity($domainName); goto Fa12a; Fa12a: if (false === is_null($siteEntity)) { goto Ac4dc; } goto B060d; d5ae9: $user = $this->getUser(); goto f8f5a; A06a5: $site->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto e4558; a8c87: goto d48da; goto ef9f0; ef9f0: Ac4dc: goto d5ae9; B060d: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\145\163")); goto a8c87; bf55f: $siteUpdater = $this->getSiteUpdater($site); goto D1634; D686b: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\x69\164\145\137\163\145\x63\x75\162\x69\164\171", ["\144\157\155\141\151\156\x4e\x61\155\145" => $site->getDomainName()])); goto d86fa; A660e: $domainName = $site->getDomainName(); goto f7ce2; f3460: $eventData = ["\x73\x69\x74\145" => $domainName, "\141\154\x6c\157\167\x54\162\x61\x66\146\151\x63\x46\x72\157\155\x43\154\157\x75\x64\x66\x6c\x61\x72\145\x4f\156\154\171" => true === $allowTrafficFromCloudflareOnly ? "\61" : "\x30"]; goto E4283; B6ddb: return $response; goto F370f; e63f4: $session = $request->getSession(); goto A660e; e4558: $this->siteEntityManager->updateEntity($siteEntity); goto bf55f; Bf75c: $siteEntity->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto A06a5; D1634: $siteUpdater->updateNginxVhost(); goto Dfca2; d3a9e: $session->getFlashBag()->set("\163\x75\x63\143\x65\x73\x73", $this->translator->trans("\103\154\157\x75\x64\x66\154\141\x72\x65\x20\163\x65\164\164\x69\156\147\163\x20\150\x61\x76\145\x20\x62\145\x65\x6e\x20\163\141\166\x65\x64\x2e")); goto D686b; E4283: EventQueue::addEvent(EventQueue::EVENT_SITE_CLOUDFLARE_SETTINGS, $user, $eventData, $request); goto d3a9e; d86fa: d48da: goto B6ddb; Dfca2: $siteUpdater->reloadNginxService(); goto f3460; f8f5a: $allowTrafficFromCloudflareOnly = $form->get("\141\154\154\x6f\x77\x54\x72\141\146\x66\x69\143\106\162\157\155\x43\154\x6f\x75\x64\146\x6c\141\162\x65\117\x6e\154\x79")->getData(); goto Bf75c; F370f: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\145\x72", $this->translator->trans("\101\x6e\x20\x65\x72\x72\x6f\x72\x20\150\x61\163\40\157\x63\143\x75\162\162\145\144\54\x20\x65\162\x72\x6f\x72\40\155\145\163\x73\141\x67\145\72\40\45\145\x72\x72\157\x72\115\145\x73\x73\x61\x67\x65\45", ["\45\145\162\162\x6f\x72\115\x65\x73\163\x61\147\x65\x25" => $e->getMessage()])); } goto fba98; ceb09: } public function newBlockedIp(Request $request) : Response { goto f66a8; B6e7d: Dc15c: goto Fae23; fd6f9: if (!(false === is_null($response))) { goto b528d; } goto f0a2c; Dab1d: return $response; goto f1a79; B30c3: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto Dc15c; } goto B8aae; Fa95d: edc49: goto B6e7d; bcab0: $form = $this->createBlockedIpForm($blockedIpEntity); goto B30c3; dc8b0: if (false === is_null($site)) { goto b226d; } goto B34b6; a73a9: goto Ad9ee; goto Bb461; B8aae: $form->handleRequest($request); goto e6a31; b441c: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ac274; ac274: $blockedIpEntity = $this->blockedIpEntityManager->createEntity(); goto D8244; f0a2c: return $response; goto Db9dd; B34b6: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\x69\164\x65\163")); goto a73a9; D8244: $blockedIpEntity->setSite($siteEntity); goto bcab0; f66a8: $site = $this->getSite($request); goto dc8b0; f38be: $response = $this->handleBlockedIpForm($request, $form, $site); goto fd6f9; Fae23: $response = $this->render("\106\162\157\156\x74\x65\156\144\x2f\123\151\x74\x65\x2f\x6e\145\167\x2d\x62\154\x6f\x63\x6b\145\x64\55\x69\160\x2e\150\164\x6d\x6c\56\x74\167\x69\147", ["\x73\x69\x74\145" => $site, "\146\x6f\162\x6d" => $form->createView(), "\x66\157\x72\x6d\x45\x72\x72\157\x72\x73" => $this->formErrors]); goto dbdee; Db9dd: b528d: goto Fa95d; dbdee: Ad9ee: goto Dab1d; Bb461: b226d: goto b441c; e6a31: if (!(true === $form->isSubmitted())) { goto edc49; } goto f38be; f1a79: } private function createBlockedIpForm(BlockedIpEntity $blockedIpEntity) : Form { goto F6f13; A97fc: $form->add("\163\x75\142\x6d\151\x74", SubmitType::class, ["\x61\164\x74\162" => ["\143\x6c\141\163\163" => "\142\164\156\x20\142\x74\x6e\55\142\x6c\165\x65\x20\142\x74\x6e\x2d\x6c\147"], "\x6c\141\x62\x65\154" => "\101\144\x64\x20\111\x50"]); goto d2edf; d2edf: return $form; goto Ec71d; Dcec1: $form = $this->createForm("\x41\160\160\134\106\x6f\x72\155\x5c\x53\x69\164\x65\x42\x6c\x6f\143\x6b\145\x64\x49\x50\124\x79\x70\145", $blockedIpEntity, ["\141\143\x74\x69\157\156" => $this->generateUrl("\143\154\160\137\163\x69\164\x65\x5f\163\x65\x63\x75\162\151\164\171\137\142\x6c\157\143\153\145\x64\137\151\x70\137\156\x65\167", ["\x64\x6f\155\141\x69\x6e\116\x61\155\145" => $siteEntity->getDomainName()]), "\155\145\x74\150\157\144" => "\x50\x4f\x53\124", "\x61\164\x74\x72" => []]); goto A97fc; F6f13: $siteEntity = $blockedIpEntity->getSite(); goto Dcec1; Ec71d: } private function handleBlockedIpForm(Request $request, Form $form, Site $site) { goto A653c; e47c4: $this->formErrors = $this->getErrorMessages($form); goto B4c4a; A7449: try { goto f6505; D554b: $siteEntity = $this->getSiteEntity($domainName); goto D5904; eaf5c: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\163", $this->translator->trans("\111\120\x20\x68\141\163\40\x62\x65\145\x6e\40\141\x64\x64\x65\144\56")); goto C3773; d7009: cc621: goto B7d53; F3e4d: E14d7: goto E5c4c; B7d53: return $response; goto F4c29; adb2e: $siteUpdater = $this->getSiteUpdater($site); goto ea183; c8217: $blockedIp = $form->getData(); goto d814d; D5904: if (false === is_null($siteEntity)) { goto E14d7; } goto b8904; Cb73a: goto cc621; goto F3e4d; fd06e: $siteUpdater->reloadNginxService(); goto dca9d; d814d: $siteEntity->addBlockedIp($blockedIp); goto F98dd; F98dd: $this->siteEntityManager->updateEntity($siteEntity); goto adb2e; b3a1c: $domainName = $site->getDomainName(); goto D554b; dca9d: $eventData = ["\163\x69\x74\145" => $domainName, "\151\160" => $blockedIp->getIp()]; goto B4554; ea183: $siteUpdater->updateNginxVhost(); goto fd06e; C3773: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\151\x74\145\137\163\x65\x63\165\162\x69\164\171", ["\x64\157\x6d\x61\151\x6e\116\x61\x6d\145" => $site->getDomainName()])); goto d7009; b8904: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\151\x74\145\163")); goto Cb73a; f6505: $session = $request->getSession(); goto b3a1c; B4554: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_ADD, $user, $eventData, $request); goto eaf5c; E5c4c: $user = $this->getUser(); goto c8217; F4c29: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\162", $this->translator->trans("\x41\x6e\x20\x65\162\162\157\162\x20\150\141\163\40\157\143\143\165\162\162\145\144\54\40\145\x72\x72\x6f\x72\x20\x6d\x65\x73\163\x61\x67\145\x3a\x20\x25\x65\162\162\x6f\162\x4d\145\x73\x73\x61\147\145\45", ["\x25\145\x72\162\x6f\162\x4d\145\163\x73\141\x67\145\x25" => $e->getMessage()])); } goto a394c; A653c: if (true === $form->isValid()) { goto A3457; } goto e47c4; B4c4a: goto ac79f; goto d27b4; a394c: ac79f: goto b9897; d27b4: A3457: goto A7449; b9897: } public function deleteBlockedIp(Request $request) : Response { goto a04c0; Efc67: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\164\x65\x73")); goto F364b; f54d6: $this->checkCsrfToken($request, "\x69\160\55\144\145\x6c\145\x74\x65"); goto ff663; A3a16: try { goto d9126; ab88a: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedIpEntity) && $siteEntity == $blockedIpEntity->getSite())) { goto e5c56; } goto Ff878; d9126: $session = $request->getSession(); goto Fc144; b57bc: $siteEntity = $this->getSiteEntity($domainName); goto C1005; E9c36: e5c56: goto C3d99; A6d66: $domainName = $site->getDomainName(); goto b57bc; Ab73d: $siteUpdater->reloadNginxService(); goto E35be; ddb0d: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\164\x65\137\x73\145\143\165\x72\151\x74\171", ["\144\157\x6d\141\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto F6e08; E2a14: $session->getFlashBag()->set("\x73\165\x63\x63\x65\163\163", $this->translator->trans("\x49\x50\x20\x68\141\x73\40\142\145\x65\x6e\x20\144\x65\154\x65\x74\145\x64\56")); goto ddb0d; Df7ff: $this->siteEntityManager->updateEntity($siteEntity); goto b03d3; E35be: $eventData = ["\163\x69\164\145" => $domainName, "\x69\x70" => $blockedIpEntity->getIp()]; goto e6625; cbdfc: $siteUpdater->updateNginxVhost(); goto Ab73d; Ff878: $user = $this->getUser(); goto c9391; b03d3: $siteUpdater = $this->getSiteUpdater($site); goto cbdfc; Fc144: $id = (int) $request->get("\151\144"); goto A6d66; c9391: $siteEntity->removeBlockedIp($blockedIpEntity); goto Df7ff; e6625: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_DELETE, $user, $eventData, $request); goto E2a14; C1005: $blockedIpEntity = $this->blockedIpEntityManager->findOneById($id); goto ab88a; F6e08: return $response; goto E9c36; C3d99: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\x72", $this->translator->trans("\x41\x6e\x20\145\x72\162\157\x72\x20\150\141\x73\x20\157\143\x63\165\x72\162\x65\144\54\40\145\x72\x72\157\x72\x20\155\x65\x73\x73\141\x67\145\x3a\40\x25\145\162\x72\157\162\115\145\x73\163\x61\x67\x65\45", ["\45\x65\162\162\x6f\162\115\x65\163\x73\x61\x67\x65\45" => $e->getMessage()])); } goto Add9e; a04c0: $site = $this->getSite($request); goto f54d6; ff663: if (!(false === is_null($site))) { goto Cec8a; } goto A3a16; F364b: return $response; goto b7419; Add9e: Cec8a: goto Efc67; b7419: } public function newBlockedBot(Request $request) : Response { goto f652a; ba609: $form->handleRequest($request); goto A9d26; Cab8f: D1d4c: goto B750b; B2921: $response = $this->handleBlockedBotForm($request, $form, $site); goto faec2; Fd285: $form = $this->createBlockedBotForm($blockedBotEntity); goto ae3e4; d754c: goto fb4f3; goto D49ee; A04b6: return $response; goto f5f58; ff9e1: $blockedBotEntity = $this->blockedBotEntityManager->createEntity(); goto e7b46; de31c: if (false === is_null($site)) { goto ceef9; } goto E0624; B5a44: E4711: goto Cab8f; A9d26: if (!(true === $form->isSubmitted())) { goto D1d4c; } goto B2921; ae3e4: if (!(true === $request->isMethod("\x50\x4f\123\124"))) { goto d48d9; } goto ba609; d0de1: fb4f3: goto A04b6; e7b46: $blockedBotEntity->setSite($siteEntity); goto Fd285; d6c9f: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ff9e1; E0624: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\164\x65\163")); goto d754c; B750b: d48d9: goto D4b8f; f652a: $site = $this->getSite($request); goto de31c; D4b8f: $response = $this->render("\x46\162\x6f\x6e\x74\x65\x6e\144\57\123\x69\164\145\57\x6e\x65\x77\55\x62\154\157\x63\x6b\x65\x64\x2d\142\x6f\x74\56\x68\164\155\x6c\x2e\164\x77\151\147", ["\163\x69\164\x65" => $site, "\146\x6f\162\x6d" => $form->createView(), "\146\157\x72\155\105\x72\162\157\x72\163" => $this->formErrors]); goto d0de1; D49ee: ceef9: goto d6c9f; faec2: if (!(false === is_null($response))) { goto E4711; } goto E4fff; E4fff: return $response; goto B5a44; f5f58: } private function createBlockedBotForm(BlockedBotEntity $blockedBotEntity) : Form { goto ac88c; e5c21: $form->add("\163\165\x62\x6d\151\164", SubmitType::class, ["\141\164\x74\162" => ["\x63\x6c\141\163\x73" => "\142\164\156\40\142\164\x6e\x2d\x62\154\x75\x65\x20\x62\x74\x6e\55\x6c\x67"], "\x6c\x61\x62\145\x6c" => "\101\x64\144\40\x42\157\x74"]); goto Af9a7; ac88c: $siteEntity = $blockedBotEntity->getSite(); goto E5a18; Af9a7: return $form; goto F1d0b; E5a18: $form = $this->createForm("\101\160\160\134\x46\157\x72\x6d\x5c\123\x69\164\145\102\x6c\x6f\143\153\145\x64\102\x6f\164\124\x79\x70\145", $blockedBotEntity, ["\x61\143\x74\151\157\x6e" => $this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\x65\x5f\x73\145\143\165\162\151\164\171\x5f\142\x6c\157\x63\x6b\145\x64\137\142\x6f\x74\x5f\156\x65\167", ["\144\x6f\155\141\151\x6e\x4e\x61\155\145" => $siteEntity->getDomainName()]), "\x6d\x65\x74\150\157\144" => "\x50\x4f\123\124", "\x61\x74\x74\x72" => []]); goto e5c21; F1d0b: } private function handleBlockedBotForm(Request $request, Form $form, Site $site) { goto E4ff2; Df4aa: try { goto Ef511; F51c2: if (false === is_null($siteEntity)) { goto B855b; } goto f97f5; E6a23: $siteUpdater->reloadNginxService(); goto D63c2; af641: $siteEntity = $this->getSiteEntity($domainName); goto F51c2; D2212: $domainName = $site->getDomainName(); goto af641; ef8e2: $siteUpdater = $this->getSiteUpdater($site); goto cc28f; Ab6ec: fea91: goto Ba9bb; cbc29: $this->siteEntityManager->updateEntity($siteEntity); goto ef8e2; F54f7: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\x74\145\137\x73\145\143\165\162\151\164\171", ["\x64\157\155\141\x69\156\x4e\x61\x6d\x65" => $site->getDomainName()])); goto Ab6ec; B7dd4: $session->getFlashBag()->set("\163\165\143\143\145\x73\x73", $this->translator->trans("\x42\157\x74\x20\x68\141\x73\x20\142\x65\x65\156\x20\141\144\144\x65\x64\56")); goto F54f7; ef8eb: goto fea91; goto ab1a0; B00c6: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_ADD, $user, $eventData, $request); goto B7dd4; f72e0: $user = $this->getUser(); goto a58d3; Accb4: $siteEntity->addBlockedBot($blockedBot); goto cbc29; Ef511: $session = $request->getSession(); goto D2212; D63c2: $eventData = ["\x73\151\x74\x65" => $domainName, "\156\x61\x6d\145" => $blockedBot->getName()]; goto B00c6; a58d3: $blockedBot = $form->getData(); goto Accb4; Ba9bb: return $response; goto b853f; f97f5: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\164\145\x73")); goto ef8eb; ab1a0: B855b: goto f72e0; cc28f: $siteUpdater->updateNginxVhost(); goto E6a23; b853f: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\101\156\x20\145\x72\x72\x6f\162\40\150\141\x73\x20\x6f\143\x63\x75\x72\x72\x65\x64\x2c\x20\145\162\162\x6f\162\x20\x6d\145\x73\x73\141\x67\145\x3a\40\45\x65\162\x72\157\x72\115\145\163\x73\x61\147\x65\45", ["\45\145\x72\x72\x6f\x72\x4d\x65\x73\x73\141\147\145\45" => $e->getMessage()])); } goto E5d13; E4ff2: if (true === $form->isValid()) { goto abedd; } goto F4efe; F4efe: $this->formErrors = $this->getErrorMessages($form); goto F56c5; defe3: abedd: goto Df4aa; E5d13: D9fa6: goto A8fd8; F56c5: goto D9fa6; goto defe3; A8fd8: } public function deleteBlockedBot(Request $request) : Response { goto e55aa; De856: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\164\x65\x73")); goto Ec86a; a538b: if (!(false === is_null($site))) { goto b17b3; } goto Ad4d2; Ad4d2: try { goto cab55; F5141: d9eaa: goto d0ab8; A83a5: $siteUpdater->updateNginxVhost(); goto B0b4b; adea5: $siteEntity->removeBlockedBot($blockedBotEntity); goto e7288; E181f: $id = (int) $request->get("\151\144"); goto F7179; F30c8: $siteUpdater = $this->getSiteUpdater($site); goto A83a5; B0b4b: $siteUpdater->reloadNginxService(); goto E8741; cab55: $session = $request->getSession(); goto E181f; aaec7: $user = $this->getUser(); goto adea5; fd4f8: $blockedBotEntity = $this->blockedBotEntityManager->findOneById($id); goto cd0c0; bf121: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\164\145\137\163\145\143\165\162\151\x74\x79", ["\144\x6f\x6d\x61\x69\156\x4e\141\x6d\145" => $site->getDomainName()])); goto bbae4; F7179: $domainName = $site->getDomainName(); goto D0155; F2c1b: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_DELETE, $user, $eventData, $request); goto d45be; bbae4: return $response; goto F5141; E8741: $eventData = ["\163\151\164\x65" => $domainName, "\156\141\x6d\145" => $blockedBotEntity->getName()]; goto F2c1b; cd0c0: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedBotEntity) && $siteEntity == $blockedBotEntity->getSite())) { goto d9eaa; } goto aaec7; d45be: $session->getFlashBag()->set("\163\x75\x63\143\145\163\163", $this->translator->trans("\102\157\x74\x20\150\x61\163\40\142\145\145\x6e\40\x64\x65\x6c\x65\x74\x65\144\56")); goto bf121; D0155: $siteEntity = $this->getSiteEntity($domainName); goto fd4f8; e7288: $this->siteEntityManager->updateEntity($siteEntity); goto F30c8; d0ab8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\145\x72", $this->translator->trans("\x41\156\40\145\162\162\x6f\162\40\x68\x61\163\x20\x6f\143\x63\x75\162\x72\x65\144\x2c\40\x65\162\x72\157\x72\x20\x6d\x65\163\x73\141\x67\145\x3a\40\x25\145\162\162\x6f\162\x4d\x65\163\163\x61\x67\145\x25", ["\x25\145\x72\x72\x6f\162\x4d\x65\x73\163\141\147\145\x25" => $e->getMessage()])); } goto C26a6; e55aa: $site = $this->getSite($request); goto Aff6c; C26a6: b17b3: goto De856; Aff6c: $this->checkCsrfToken($request, "\x62\157\x74\x2d\144\145\154\x65\164\x65"); goto a538b; Ec86a: return $response; goto d636f; d636f: } public function certificates(Request $request) : Response { goto C42ba; b3dc3: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\151\x74\145\x73")); goto F6eef; C42ba: $site = $this->getSite($request); goto F92ae; e75cb: $certificates = $site->getCertificates(); goto d2737; ea0d7: Bd82e: goto acf5c; d2737: $response = $this->render("\106\x72\157\x6e\164\x65\x6e\144\57\x53\151\164\x65\57\x63\x65\x72\x74\x69\146\x69\143\x61\x74\x65\x73\x2e\150\x74\x6d\154\x2e\x74\x77\x69\x67", ["\x73\151\x74\145" => $site, "\x69\156\x73\x74\141\x6c\154\x65\x64\103\145\162\x74\x69\x66\x69\x63\x61\164\x65" => $installedCertificate, "\143\145\162\x74\151\x66\x69\143\x61\164\x65\x73" => $certificates]); goto ea0d7; F6eef: goto Bd82e; goto e39e1; acf5c: return $response; goto c3f88; ecbdb: $installedCertificate = $site->getCertificate(); goto e75cb; e39e1: F352d: goto ecbdb; F92ae: if (false === is_null($site)) { goto F352d; } goto b3dc3; c3f88: } public function importCertificate(Request $request) : Response { goto B3e28; F26ad: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto e45f4; d3dd2: dff69: goto D410f; Bcf88: $form = $this->createImportCertificateForm($certificateEntity); goto D65c8; dba66: $form->handleRequest($request); goto f5f6b; A4b2d: goto fa900; goto Ebd4c; f5f6b: if (!(true === $form->isSubmitted())) { goto c1854; } goto A3c10; A3c10: $response = $this->handleImportCertificateForm($request, $form, $site); goto E5a57; e45f4: $certificateEntity = $this->certificateEntityManager->createEntity(); goto f431e; D65c8: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto dff69; } goto dba66; C9e4d: c1854: goto d3dd2; ade6b: $certificateEntity->setSite($siteEntity); goto Bcf88; Ebd4c: C1af5: goto F26ad; B3e28: $site = $this->getSite($request); goto Ead18; E8b30: fa900: goto aa5f2; A92fd: return $response; goto bb79e; D410f: $response = $this->render("\106\162\x6f\156\164\145\156\144\57\x53\151\164\x65\x2f\151\x6d\160\x6f\162\x74\55\x63\x65\x72\164\151\x66\151\x63\x61\x74\x65\56\150\x74\x6d\x6c\x2e\164\x77\x69\x67", ["\163\x69\x74\x65" => $site, "\146\x6f\x72\155" => $form->createView(), "\146\x6f\162\155\x45\162\162\x6f\162\x73" => $this->formErrors]); goto E8b30; Ead18: if (false === is_null($site)) { goto C1af5; } goto de5a3; bb79e: B9b0f: goto C9e4d; f431e: $certificateEntity->setType(CertificateEntity::TYPE_IMPORTED); goto ade6b; aa5f2: return $response; goto Ce065; de5a3: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\x74\x65\163")); goto A4b2d; E5a57: if (!(false === is_null($response))) { goto B9b0f; } goto A92fd; Ce065: } private function createImportCertificateForm(CertificateEntity $certificateEntity) : Form { goto d8628; ae441: return $form; goto B5bbe; E91bb: $form->add("\163\x75\x62\155\151\x74", SubmitType::class, ["\141\x74\x74\x72" => ["\x63\154\x61\163\163" => "\x62\164\x6e\40\x62\x74\x6e\x2d\142\x6c\x75\145\x20\142\x74\156\55\x6c\147"], "\x6c\x61\x62\x65\154" => "\111\155\160\157\162\x74\x20\x61\156\x64\40\x49\x6e\163\164\x61\154\154"]); goto ae441; C1ee0: $form = $this->createForm("\101\160\x70\x5c\106\157\162\155\x5c\x53\x69\x74\145\111\x6d\160\x6f\x72\x74\103\x65\x72\x74\x69\x66\x69\143\x61\164\x65\x54\x79\160\145", $certificateEntity, ["\141\143\x74\x69\157\156" => $this->generateUrl("\x63\154\x70\x5f\163\151\x74\145\x5f\x63\x65\162\164\x69\146\x69\x63\x61\164\145\137\151\155\x70\157\162\x74", ["\x64\157\155\x61\x69\x6e\x4e\141\155\x65" => $siteEntity->getDomainName()]), "\x6d\x65\x74\150\157\x64" => "\120\x4f\x53\124", "\141\164\164\x72" => []]); goto E91bb; d8628: $siteEntity = $certificateEntity->getSite(); goto C1ee0; B5bbe: } private function handleImportCertificateForm(Request $request, Form $form, Site $site) { goto E69f4; Acb5f: d3a69: goto E4dca; b0631: goto c30bb; goto Acb5f; E4dca: try { goto Bcc07; d6db8: $siteEntity = $this->getSiteEntity($domainName); goto F51e0; cefe8: $siteUpdater = $this->getSiteUpdater($site); goto F9ad3; bf0c1: $this->siteEntityManager->updateEntity($siteEntity); goto C3b70; F9ad3: $siteUpdater->installCertificate($certificateEntity); goto F8fe3; Fd35a: $siteEntity->addCertificate($certificateEntity); goto bf0c1; b96ab: $domainName = $site->getDomainName(); goto d6db8; Ef432: goto D1716; goto E2c0f; C3b70: $evenData = ["\x73\x69\164\x65" => $domainName]; goto bddc2; c7d1d: $certificateEntity = $form->getData(); goto cefe8; A7a28: $session->getFlashBag()->set("\163\x75\x63\x63\x65\163\x73", $this->translator->trans("\x43\145\x72\164\x69\146\151\x63\x61\164\145\x20\150\x61\x73\40\142\145\145\156\40\x69\156\163\164\141\x6c\x6c\x65\144\56")); goto d9e2d; bddc2: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto A7a28; E2c0f: C3a21: goto f6b05; Bcc07: $session = $request->getSession(); goto b96ab; d9e2d: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\x74\145\137\143\x65\162\164\x69\146\x69\143\x61\x74\145\x73", ["\144\x6f\155\x61\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto aaf0d; F8fe3: $siteEntity->setCertificate($certificateEntity); goto Fd35a; D3ec1: return $response; goto A471d; F51e0: if (false === is_null($siteEntity)) { goto C3a21; } goto Fcd66; Fcd66: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\164\145\x73")); goto Ef432; f6b05: $user = $this->getUser(); goto c7d1d; aaf0d: D1716: goto D3ec1; A471d: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\145\162", $this->translator->trans("\x41\156\40\x65\x72\162\x6f\x72\x20\150\x61\163\x20\x6f\x63\143\x75\162\162\x65\144\54\x20\145\162\x72\x6f\162\40\x6d\x65\x73\163\x61\147\x65\72\40\45\x65\162\x72\x6f\162\115\x65\163\163\x61\147\x65\45", ["\45\145\x72\162\x6f\x72\115\x65\x73\163\141\x67\x65\45" => $e->getMessage()])); } goto Dd588; Dd588: c30bb: goto B4ac8; E69f4: if (true === $form->isValid()) { goto d3a69; } goto bee7a; bee7a: $this->formErrors = $this->getErrorMessages($form); goto b0631; B4ac8: } public function newLetsEncryptCertificate(Request $request) : Response { goto Ff6ab; a2dc6: $subdomain = $resolvedDomainName->subDomain()->toString(); goto Caefc; f652e: $domains = [$domainName]; goto E8243; f19a9: Dc1be: goto c2c42; f4b82: if (!(true === $form->isSubmitted())) { goto ab70d; } goto B0293; F62e2: $domains = [$registrableDomain, sprintf("\167\167\x77\56\45\163", $registrableDomain)]; goto f19a9; d8868: $form->handleRequest($request); goto f4b82; Ff6ab: $site = $this->getSite($request); goto E1974; A91ca: ab70d: goto Ea5ea; Fc9f0: goto A1287; goto ced1c; Fd051: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto a2dc6; ab946: $domains = array_filter($domains, function ($value) { return false === empty(trim($value)); }); goto c29c7; ced1c: dba7a: goto d481a; D39d0: return $response; goto A6e2f; f34f5: $domains = array_unique($domains); goto Ee4dd; E1974: if (false === is_null($site)) { goto dba7a; } goto D1b51; d23c1: $domains = []; goto E5dae; Fd354: D0160: goto F62e2; B0293: $domains = (array) $request->get("\144\157\155\141\151\x6e\163"); goto ab946; Ea5ea: b8fc5: goto E43ab; Ee4dd: $response = $this->handleLetsEncryptCertificateForm($request, $form, $site, $domains); goto bea6c; E17e7: Cef62: goto d8868; E5dae: if (true === $request->isMethod("\120\117\123\x54")) { goto Cef62; } goto Ce8bb; Caefc: $subdomain = false === empty($subdomain) ? $subdomain : null; goto C4241; E8243: goto Dc1be; goto Fd354; D1b51: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\x69\x74\145\163")); goto Fc9f0; C4241: if (true === is_null($subdomain) || "\x77\x77\167" == $subdomain) { goto D0160; } goto f652e; A7ffb: $form = $this->createLetsEncryptCertificateForm($domainName); goto d23c1; c29c7: $domains = array_map("\164\162\151\155", $domains); goto f34f5; E43ab: $response = $this->render("\106\162\157\156\164\x65\156\x64\x2f\x53\x69\x74\x65\x2f\156\x65\x77\x2d\154\145\164\x73\x2d\145\x6e\143\162\171\x70\164\55\143\145\162\164\151\146\151\x63\141\164\x65\x2e\x68\164\155\154\x2e\164\167\x69\x67", ["\163\x69\164\x65" => $site, "\144\x6f\155\x61\x69\x6e\163" => $domains, "\146\x6f\162\155" => $form->createView(), "\146\x6f\162\155\105\162\x72\157\x72\x73" => $this->formErrors]); goto E4feb; d481a: $domainName = $site->getDomainName(); goto A7ffb; c2c42: goto b8fc5; goto E17e7; e108c: return $response; goto F1188; F1188: B189a: goto A91ca; bea6c: if (!(false === is_null($response))) { goto B189a; } goto e108c; E4feb: A1287: goto D39d0; Ce8bb: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto Fd051; A6e2f: } private function createLetsEncryptCertificateForm(string $domainName) : Form { goto F7aec; Cfa20: $form->add("\163\x75\x62\155\151\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\x61\x73\x73" => "\142\x74\x6e\x20\142\x74\156\55\142\154\x75\x65\40\142\164\156\55\154\x67"], "\154\141\x62\x65\x6c" => "\x43\162\145\x61\164\145\40\141\156\144\40\x49\x6e\163\x74\x61\154\154"]); goto Aecc6; Aecc6: return $form; goto C79db; F7aec: $form = $this->createForm("\x41\160\160\x5c\x46\157\x72\155\x5c\x53\x69\x74\x65\114\145\x74\163\x45\156\143\162\171\x70\x74\103\x65\x72\x74\151\x66\x69\x63\x61\164\x65\x54\171\160\x65", [], ["\141\143\x74\x69\157\156" => $this->generateUrl("\x63\x6c\x70\x5f\163\151\164\x65\x5f\x6c\145\x74\x73\x5f\145\156\143\162\x79\x70\164\x5f\x63\145\162\164\x69\146\x69\143\x61\x74\x65\137\156\x65\167", ["\x64\157\x6d\141\151\156\116\141\x6d\145" => $domainName]), "\x6d\x65\x74\150\x6f\144" => "\120\x4f\123\x54", "\x61\164\x74\x72" => ["\151\144" => "\x63\x72\145\141\x74\x65\x2d\154\x65\164\x73\55\145\x6e\143\x72\171\160\x74\x2d\143\x65\162\x74\x69\146\x69\x63\141\x74\x65\55\146\157\162\155"]]); goto Cfa20; C79db: } private function handleLetsEncryptCertificateForm(Request $request, Form $form, Site $site, array $domains) { goto b155c; b155c: if (!(true === $form->isValid())) { goto bbdd2; } goto Ecf61; e0d6f: $this->formErrors = $this->getErrorMessages($form); goto C5767; Ecf61: try { goto d6c9d; d6c9d: $session = $request->getSession(); goto caf69; B433d: $certificateEntity->setCertificate($certificate->getCertificate()); goto Fca6b; ce0c9: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto b7952; aa4f7: $distinguishedNameDomains = $domains; goto c6908; c4a8a: $certificateEntity->setCsr($certificate->getCsr()); goto dc0df; A9a1a: $csr = $csrGenerator->generate(); goto ee154; E813a: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto ca957; e2204: $letsEncryptClient = new LetsEncryptClient($privateKey); goto Cbbac; Cd0fe: $evenData = ["\163\151\164\145" => $domainName]; goto ce0c9; Bb2f4: $rsaKeyGenerator = new RsaKeyGenerator(); goto cbba2; D5d4c: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto c14b0; ca957: dac79: goto Cc67d; fede4: return $response; goto Ce10c; a1852: $letsEncryptClient = new LetsEncryptClient($privateKey); goto e276d; E2301: $this->siteEntityManager->updateEntity($siteEntity); goto Cd0fe; c14b0: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto Cf199; Cbbac: $letsEncryptClient->setDryRun(true); goto D789b; F8daf: $siteEntity->setCertificate($certificateEntity); goto A30ea; D455f: goto D2ece; goto fb04e; E154b: $siteUpdater = $this->getSiteUpdater($site); goto D5d4c; Ddc80: $certificateEntity = $this->certificateEntityManager->createEntity(); goto d79b7; C07d9: $siteEntity = $this->getSiteEntity($domainName); goto c6ede; c6ede: if (false === is_null($siteEntity)) { goto A2c9b; } goto A19d6; cb0a3: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto e2204; Cc67d: if (true === empty($validationErrors)) { goto Eaba5; } goto Bea70; Fca6b: $certificateEntity->setCertificateChain($certificate->getCertificateChain()); goto a247e; ceffd: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto E154b; Db5e1: $siteUpdater->installCertificate($certificateEntity); goto F8daf; E4de2: $siteUpdater = $this->getSiteUpdater($site); goto C73a7; A1e69: return $response; goto D455f; Bea70: foreach ($validationErrors as $domain => $validationErrorMessage) { $form->addError(new FormError(sprintf("\45\163\72\x20\45\x73", $domain, $validationErrorMessage))); C9a20: } goto Ec671; D789b: $letsEncryptClient->registerAccount(); goto ceffd; Ec671: e31c1: goto a7fa6; a7fa6: goto Bbfeb; goto e4bb1; Ce10c: Bbfeb: goto Ca138; a247e: $siteUpdater = $this->getSiteUpdater($site); goto Db5e1; ee154: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto Ddc80; A19d6: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\151\164\145\x73")); goto A1e69; caacc: $certificateEntity->setSite($siteEntity); goto c4a8a; Cba72: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto E4de2; Acccc: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto A9a1a; d79b7: $certificateEntity->setType(CertificateEntity::TYPE_LETS_ENCRYPT); goto caacc; e4bb1: Eaba5: goto aa4f7; Ca138: D2ece: goto b7d41; dc0df: $certificateEntity->setPrivateKey($certificate->getPrivateKey()); goto B433d; caf69: $domainName = $site->getDomainName(); goto C07d9; b7952: $session->getFlashBag()->set("\x73\x75\x63\143\145\163\163", $this->translator->trans("\x43\145\162\x74\151\146\151\143\141\164\x65\x20\x68\141\x73\x20\x62\x65\x65\x6e\40\151\x6e\163\x74\141\x6c\154\145\144\x2e")); goto b54fd; e276d: $letsEncryptClient->registerAccount(); goto Cba72; C73a7: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto A27e3; A27e3: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto E813a; b4e08: $letsEncryptPrivateKey = $this->configManager->get("\154\x65\137\160\162\151\x76\x61\164\145\137\153\145\171"); goto cb0a3; b54fd: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\151\164\x65\x5f\x63\145\162\x74\x69\x66\x69\143\x61\164\145\x73", ["\144\157\x6d\141\151\156\x4e\x61\x6d\145" => $site->getDomainName()])); goto fede4; A30ea: $siteEntity->addCertificate($certificateEntity); goto E2301; b665f: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto Bb2f4; Cf199: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto db178; fb04e: A2c9b: goto Feec0; c6908: $commonName = array_shift($distinguishedNameDomains); goto b665f; cbba2: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto Acccc; Feec0: $user = $this->getUser(); goto b4e08; db178: if (!(true === empty($validationErrors))) { goto dac79; } goto a1852; b7d41: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\145\x72", $this->translator->trans("\x41\156\x20\x65\162\x72\157\162\40\x68\x61\163\40\157\143\143\165\162\x72\145\144\x2c\x20\x65\162\x72\157\162\x20\x6d\x65\163\163\141\147\145\x3a\40\x25\x65\162\162\157\x72\x4d\145\163\163\141\147\x65\45", ["\x25\145\x72\x72\x6f\162\115\x65\163\x73\141\x67\145\x25" => $e->getMessage()])); } finally { if (!(true === isset($siteUpdater))) { goto Ff875; } $siteUpdater->deleteLetsEncryptChallengeDirectory(); Ff875: } goto Fd9f6; Fd9f6: bbdd2: goto e0d6f; C5767: } public function installCertificate(Request $request) : Response { goto e5a09; De8cf: return $response; goto Deabb; e5a09: $site = $this->getSite($request); goto Efe36; D8323: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\x69\x74\x65\163")); goto De8cf; f502b: try { goto ec485; f8560: b900c: goto c71dd; c0299: $user = $this->getUser(); goto dda73; E9aa3: $siteUpdater->installCertificate($certificateEntity); goto E6038; fcf27: df30c: goto f8560; F4c74: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto cc1c3; e0bd4: $uid = $request->get("\165\151\144"); goto Fea1a; cc1c3: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity))) { goto b900c; } goto D1871; E6038: $siteEntity->setCertificate($certificateEntity); goto ea256; dda73: $siteUpdater = $this->getSiteUpdater($site); goto E9aa3; Fea1a: $domainName = $site->getDomainName(); goto aea4a; ea256: $this->siteEntityManager->updateEntity($siteEntity); goto ac3a3; ac3a3: $evenData = ["\163\x69\x74\145" => $domainName]; goto a8991; D1871: $certificateSiteEntity = $certificateEntity->getSite(); goto E791b; E791b: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto df30c; } goto c0299; f9870: return $response; goto fcf27; cabb0: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\164\145\137\143\145\162\164\151\146\151\143\x61\164\145\163", ["\144\x6f\155\x61\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto f9870; ec485: $session = $request->getSession(); goto e0bd4; a8991: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto Cf03e; aea4a: $siteEntity = $this->getSiteEntity($domainName); goto F4c74; Cf03e: $session->getFlashBag()->set("\163\x75\x63\x63\145\x73\163", $this->translator->trans("\103\145\x72\x74\x69\x66\x69\143\x61\x74\x65\x20\150\141\163\x20\142\x65\145\156\x20\x69\156\x73\x74\x61\x6c\x6c\x65\x64\x2e")); goto cabb0; c71dd: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\x72", $this->translator->trans("\101\156\40\145\x72\x72\x6f\x72\x20\150\x61\x73\40\157\x63\x63\x75\162\162\145\144\54\x20\145\162\162\157\162\40\x6d\x65\x73\x73\x61\147\145\x3a\40\45\145\162\162\x6f\162\115\x65\163\163\141\147\x65\45", ["\x25\x65\162\162\157\162\x4d\145\x73\163\x61\x67\x65\x25" => $e->getMessage()])); } goto c007b; Efe36: if (!(false === is_null($site))) { goto D82be; } goto f502b; c007b: D82be: goto D8323; Deabb: } public function deleteCertificate(Request $request) : Response { goto Ef019; B82e6: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\164\145\163")); goto d9a0c; d3002: e50f7: goto B82e6; ecb35: $this->checkCsrfToken($request, "\143\x65\x72\x74\x69\146\x69\x63\x61\164\145\x2d\144\x65\x6c\145\164\x65"); goto eab67; eab67: if (!(false === is_null($site))) { goto e50f7; } goto A5d50; Ef019: $site = $this->getSite($request); goto ecb35; d9a0c: return $response; goto E4c75; A5d50: try { goto c7ca5; cbe48: $domainName = $site->getDomainName(); goto Be119; Cf173: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity) && false === $certificateEntity->getDefaultCertificate())) { goto E2646; } goto Eba43; C91a0: return $response; goto f7665; f4482: $siteEntity->removeCertificate($certificateEntity); goto B8106; B8106: $this->siteEntityManager->updateEntity($siteEntity); goto B07dc; B9d22: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\x69\164\x65\x5f\x63\145\x72\164\151\146\x69\x63\x61\164\x65\x73", ["\x64\157\x6d\x61\151\x6e\x4e\141\155\145" => $site->getDomainName()])); goto C91a0; B07dc: $evenData = ["\x73\x69\x74\x65" => $domainName]; goto dc8cd; Abd60: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto Cf173; Be119: $siteEntity = $this->getSiteEntity($domainName); goto Abd60; B7152: $uid = $request->get("\x75\151\144"); goto cbe48; c7ca5: $session = $request->getSession(); goto B7152; f7665: A7b3d: goto a4d78; A0fdf: $session->getFlashBag()->set("\x73\x75\143\143\x65\163\163", $this->translator->trans("\103\x65\x72\164\x69\146\x69\x63\x61\x74\x65\40\x68\141\163\40\x62\145\145\156\40\144\x65\x6c\x65\x74\145\144\x2e")); goto B9d22; Eba43: $certificateSiteEntity = $certificateEntity->getSite(); goto a55f0; dc8cd: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_DELETE, $user, $evenData, $request); goto A0fdf; a55f0: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto A7b3d; } goto ca586; ca586: $user = $this->getUser(); goto f4482; a4d78: E2646: goto Bca56; Bca56: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\x65\162", $this->translator->trans("\101\x6e\40\x65\162\162\x6f\162\x20\150\141\x73\x20\x6f\143\143\x75\x72\162\x65\144\54\x20\x65\162\x72\x6f\x72\40\x6d\x65\163\x73\141\147\145\x3a\x20\45\145\x72\x72\157\162\x4d\145\163\163\141\x67\x65\x25", ["\45\x65\162\x72\x6f\162\115\145\163\163\x61\x67\145\45" => $e->getMessage()])); } goto d3002; E4c75: } public function databases(Request $request) : Response { goto bb2e7; e1d72: $databaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Ab7fe; A9788: goto Cb012; goto A38eb; Bfe5b: return $response; goto E250a; d5b5c: if (false === is_null($site)) { goto b5629; } goto ee12d; e0b7f: f41ec: goto e9a68; b9559: Cb012: goto Bfe5b; f3ce1: $databases = $site->getDatabases(); goto e1d72; ee12d: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\164\x65\x73")); goto A9788; bb2e7: $site = $this->getSite($request); goto d5b5c; A38eb: b5629: goto f3ce1; Ab7fe: $numberOfDatabaseUsers = 0; goto ade3e; e9a68: $response = $this->render("\x46\x72\157\x6e\x74\145\156\144\57\x53\x69\164\x65\57\x64\141\x74\x61\142\x61\x73\x65\163\56\x68\x74\x6d\x6c\56\x74\x77\151\x67", ["\x73\151\164\x65" => $site, "\x64\141\164\141\x62\141\163\x65\x73" => $databases, "\x6e\x75\155\x62\145\162\117\x66\104\x61\x74\x61\142\141\x73\x65\125\163\x65\x72\x73" => $numberOfDatabaseUsers, "\x64\x61\164\141\142\x61\x73\x65\x53\x65\162\x76\x65\162" => $databaseServerEntity]); goto b9559; ade3e: foreach ($databases as $database) { $numberOfDatabaseUsers += count($database->getUsers()); d7448: } goto e0b7f; E250a: } public function newDatabase(Request $request) : Response { goto F86a9; c72b4: if (!(true === $form->isSubmitted())) { goto f33d3; } goto b7a44; D19af: $form->handleRequest($request); goto c72b4; Cc040: $databaseEntity = $this->databaseEntityManager->createEntity(); goto Dd7ac; F86a9: $site = $this->getSite($request); goto c3708; b5252: return $response; goto a8fed; f8bb2: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto Cc040; f84f1: C9e24: goto aa13a; Bb858: if (!(false === is_null($response))) { goto D9c9e; } goto fbbaa; d0aa1: D9c9e: goto b8328; Dd7ac: $databaseEntity->setSite($siteEntity); goto f19d5; d3a1d: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\151\x74\x65\163")); goto B073f; aa13a: $response = $this->render("\x46\x72\x6f\x6e\164\x65\156\144\x2f\123\x69\164\x65\57\x6e\145\x77\x2d\144\x61\x74\141\142\x61\x73\x65\x2e\150\164\155\x6c\x2e\x74\167\x69\x67", ["\x73\151\x74\145" => $site, "\146\157\162\155" => $form->createView(), "\x66\x6f\162\x6d\x45\x72\162\x6f\x72\x73" => $this->formErrors]); goto B3455; B3455: dfc57: goto b5252; d7010: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto C9e24; } goto D19af; b8328: f33d3: goto f84f1; c3708: if (false === is_null($site)) { goto Be80a; } goto d3a1d; Aa1a8: Be80a: goto f8bb2; fbbaa: return $response; goto d0aa1; f19d5: $form = $this->createDatabaseForm($site, $databaseEntity); goto d7010; B073f: goto dfc57; goto Aa1a8; b7a44: $response = $this->handleDatabaseForm($request, $form, $site); goto Bb858; a8fed: } private function createDatabaseForm(Site $site, DatabaseEntity $databaseEntity) : Form { goto E5f60; aae4e: $form->add("\163\x75\142\155\151\164", SubmitType::class, ["\141\164\164\162" => ["\x63\x6c\x61\x73\x73" => "\x62\x74\x6e\40\x62\x74\x6e\x2d\x62\154\x75\x65\x20\142\x74\156\x2d\x6c\147"], "\154\141\142\x65\154" => "\x41\x64\x64\40\104\141\x74\141\142\141\x73\x65"]); goto Fb0db; Fb0db: return $form; goto C92e2; E5f60: $form = $this->createForm("\x41\160\x70\134\x46\157\x72\x6d\134\123\151\164\x65\x44\141\x74\x61\x62\x61\x73\145\124\x79\x70\145", $databaseEntity, ["\141\x63\164\x69\x6f\156" => $this->generateUrl("\x63\154\160\x5f\163\151\x74\x65\137\x64\x61\164\141\x62\x61\163\x65\137\156\145\x77", ["\144\x6f\x6d\141\x69\x6e\116\141\155\x65" => $site->getDomainName()]), "\155\x65\x74\x68\x6f\144" => "\120\x4f\123\x54", "\x61\x74\164\162" => []]); goto aae4e; C92e2: } private function handleDatabaseForm(Request $request, Form $form, Site $site) { goto E8d24; E8d24: if (true === $form->isValid()) { goto baea1; } goto A4e5d; B60ed: Cf2ce: goto Dbfac; fb5d5: try { goto Ef490; B5938: $databaseManager->createUser($databaseUserEntity); goto C1a82; E18bc: goto D644b; goto Da56b; A7b01: $databaseUserPassword = $form->get("\165\163\x65\162\x50\x61\163\163\167\x6f\162\x64")->getData(); goto Fd866; a5fce: $databaseEntity = $form->getData(); goto a866c; C1a82: $this->siteEntityManager->updateEntity($siteEntity); goto c263f; ecf44: $domainName = $site->getDomainName(); goto Af087; B7b76: return $response; goto e437e; f352f: $session = $request->getSession(); goto ecf44; a8a88: $databaseManager->createDatabase($databaseEntity); goto B5938; f58a1: D644b: goto B7b76; Ba84d: $databaseUserEntity->setDatabase($databaseEntity); goto d505d; b80d0: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\x74\x65\x5f\144\141\164\x61\x62\141\x73\x65\x73", ["\x64\157\155\x61\x69\x6e\x4e\x61\x6d\x65" => $site->getDomainName()])); goto f58a1; c263f: $eventData = ["\x73\x69\164\145" => $domainName, "\144\x61\164\x61\x62\x61\163\x65" => $databaseEntity->getName(), "\144\x61\x74\141\x62\x61\x73\145\x55\163\145\x72\x4e\x61\155\145" => $databaseUserEntity->getUserName()]; goto F9220; Bcb16: $databaseEntity->setDatabaseServer($activeDatabaseServerEntity); goto F32c7; Da56b: e5f50: goto a5fce; fd61f: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\x74\145\x5f\144\x61\x74\141\x62\x61\163\145\137\156\145\x77", ["\144\x6f\155\x61\x69\156\116\141\155\x65" => $site->getDomainName()])); goto E18bc; Af087: $siteEntity = $this->getSiteEntity($domainName); goto b23cd; F32c7: $databaseEntity->setSite($siteEntity); goto ebb34; ec27f: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto Bcb16; E57e5: $databaseUserEntity->setPermissions(DatabaseUserEntity::PERMISSIONS_READ_WRITE); goto Ba84d; Aac07: $session->getFlashBag()->set("\163\165\143\x63\145\x73\163", $this->translator->trans("\x44\141\x74\x61\x62\x61\x73\x65\40\x68\x61\163\40\142\145\145\x6e\40\141\x64\x64\145\x64\x2e")); goto b80d0; c1e39: $databaseUserEntity->setPassword(Crypto::encrypt($databaseUserPassword)); goto E57e5; ebb34: $databaseUserName = $form->get("\165\x73\145\162\x4e\141\155\x65")->getData(); goto A7b01; Fd866: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto b8dad; b23cd: if (false === is_null($siteEntity)) { goto e5f50; } goto fd61f; F9220: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_ADD, $user, $eventData, $request); goto Aac07; a4ed2: $siteEntity->addDatabase($databaseEntity); goto a8a88; d505d: $databaseEntity->addUser($databaseUserEntity); goto a4ed2; a866c: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ec27f; b8dad: $databaseUserEntity->setUserName($databaseUserName); goto c1e39; Ef490: $user = $this->getUser(); goto f352f; e437e: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\x67\x65\162", $this->translator->trans("\101\156\40\x65\x72\162\157\162\x20\x68\141\163\x20\157\x63\x63\x75\x72\162\x65\144\54\x20\145\162\x72\157\x72\x20\155\x65\163\163\x61\147\x65\x3a\x20\x25\145\x72\x72\x6f\x72\x4d\x65\163\163\141\147\145\x25", ["\45\x65\x72\x72\x6f\162\x4d\145\x73\x73\141\147\x65\45" => $e->getMessage()])); } goto B60ed; A4e5d: $this->formErrors = $this->getErrorMessages($form); goto ce6b9; dd04b: baea1: goto fb5d5; ce6b9: goto Cf2ce; goto dd04b; Dbfac: } public function deleteDatabase(Request $request) : Response { goto Fca03; bdea7: $this->checkCsrfToken($request, "\144\x61\x74\141\x62\141\x73\145\55\x64\145\154\145\164\x65"); goto b8462; E4da6: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName() && false === is_null($siteEntity))) { goto Eee08; } goto B8552; Fca03: $site = $this->getSite($request); goto bdea7; B8552: try { goto eaa1e; Fc116: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_DELETE, $user, $eventData, $request); goto c15d8; b9c8d: $siteEntity->removeDatabase($databaseEntity); goto fc5a0; b370d: $session = $request->getSession(); goto A6b88; b99c5: $eventData = ["\163\151\164\145" => $domainName, "\x64\x61\x74\x61\142\141\163\x65" => $databaseEntity->getName()]; goto Fc116; e82f8: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto ab2d3; De047: $databaseManager->deleteDatabase($databaseEntity, true); goto b9c8d; ab2d3: $databaseManager = new DatabaseManager($databaseServerEntity); goto De047; fc5a0: $this->siteEntityManager->updateEntity($siteEntity); goto b99c5; A6b88: $domainName = $site->getDomainName(); goto e82f8; eaa1e: $user = $this->getUser(); goto b370d; c15d8: $session->getFlashBag()->set("\163\x75\x63\x63\145\163\163", $this->translator->trans("\x44\141\164\x61\x62\141\x73\x65\x20\150\x61\163\40\x62\145\145\x6e\40\x64\145\x6c\x65\164\x65\x64\x2e")); goto C9e31; C9e31: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\x65\x72", $this->translator->trans("\101\156\40\145\162\162\x6f\162\x20\150\141\163\x20\157\143\143\x75\x72\162\145\x64\x2c\40\x65\162\x72\x6f\x72\x20\155\x65\x73\x73\x61\x67\145\x3a\40\45\145\x72\x72\x6f\162\115\145\163\163\141\147\x65\45", ["\45\145\x72\x72\x6f\162\115\x65\163\x73\x61\x67\145\x25" => $e->getMessage()])); } goto F9f75; C68d5: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto E4da6; C923c: return $response; goto B0b99; d28d3: Eee08: goto b75b9; b8462: if (!(false === is_null($site))) { goto bc325; } goto Bddb0; Bddb0: $databaseName = $request->get("\144\141\x74\x61\142\141\163\x65\x4e\x61\x6d\145"); goto fd1ba; E02a4: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\151\164\145\163")); goto C923c; Cb0c6: return $response; goto d28d3; F9f75: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\164\145\x5f\x64\141\x74\x61\142\141\163\x65\x73", ["\x64\x6f\x6d\x61\151\x6e\116\141\x6d\145" => $site->getDomainName()])); goto Cb0c6; fd1ba: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto C68d5; b75b9: bc325: goto E02a4; B0b99: } public function phpMyAdmin(Request $request) : Response { goto b1bcb; c220c: ce960: goto c78f4; e68f6: $session = $request->getSession(); goto ae048; d8e75: $site = $this->getSite($request); goto Ba398; E0f30: return $response; goto A007e; E7e07: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto Ae7a7; Df9c5: return $response; goto ddade; Ba398: if (!(false === is_null($site))) { goto e4afa; } goto ec515; Becdc: $phpMyAdminUrl = sprintf("\x68\x74\x74\x70\163\x3a\57\x2f\x25\x73\x3a\x25\x73\x2f\x70\150\160\x6d\171\x61\x64\x6d\151\x6e\x2f\x6c\x6f\x67\151\156\56\x70\x68\160", $request->getHost(), $request->getPort()); goto cd98f; a3a82: $phpMyAdminUrl = sprintf("\x68\x74\164\x70\x73\x3a\57\57\x25\x73\72\45\163\x2f\160\x68\160\155\x79\141\x64\155\151\156\57\x6c\157\x67\151\x6e\56\160\x68\x70", $request->getHost(), $request->getPort()); goto Cfa65; ae048: if (false === is_null($domainName)) { goto C2a76; } goto Ddfae; B1a1c: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto e19a0; } goto a3a82; b6f45: if (!(false === is_null($activeDatabaseServerEntity))) { goto ce960; } goto Becdc; C29a9: $response = new RedirectResponse($phpMyAdminUrl); goto E0f30; d4b45: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\x74\x65\x73")); goto Df9c5; C882d: D3815: goto d4b45; B9bc7: $response->headers->clearCookie("\x70\x6d\141\101\x75\164\x68\x2d\x31\137\150\164\164\x70\x73"); goto B4dc6; C38ee: $response = new RedirectResponse($phpMyAdminUrl); goto B1bd4; Ddfae: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto b6f45; c78f4: goto D3815; goto B2d80; e3ffe: return $response; goto c220c; Ae7a7: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto A7f43; B4dc6: $response->headers->clearCookie("\x53\x69\x67\156\157\156\x53\x65\163\163\x69\157\156"); goto e3ffe; cd98f: $data = ["\x68\x6f\x73\x74" => $activeDatabaseServerEntity->getHost(), "\160\x6f\x72\164" => $activeDatabaseServerEntity->getPort()]; goto A3058; A007e: e19a0: goto c527a; b1bcb: $domainName = $request->get("\x64\157\155\141\x69\x6e\x4e\x61\155\x65"); goto e68f6; B1bd4: $response->headers->clearCookie("\x63\x6c\x70\55\x70\x6d\141"); goto d1a0b; d1a0b: $response->headers->clearCookie("\x70\150\x70\115\x79\x41\x64\155\x69\x6e\137\x68\164\x74\160\x73"); goto B9bc7; Cfa65: $data = ["\150\x6f\163\164" => $activeDatabaseServerEntity->getHost(), "\x75\x73\145\x72\x4e\x61\x6d\x65" => $databaseUserEntity->getUserName(), "\160\x61\163\x73\x77\157\162\x64" => $databaseUserEntity->getDecryptedPassword(), "\160\x6f\162\164" => $activeDatabaseServerEntity->getPort()]; goto C597d; B2d80: C2a76: goto d8e75; A3058: $session->set("\143\x6c\x70\x2d\160\155\x61", $data); goto C38ee; C597d: $session->set("\143\x6c\x70\55\160\155\141", $data); goto C29a9; A7f43: if (!(false === is_null($activeDatabaseServerEntity) && false === is_null($activeDatabaseServerEntity))) { goto b4b88; } goto Fdd0a; Fdd0a: $databaseEntity = $databaseUserEntity->getDatabase(); goto B1a1c; ec515: $databaseUserName = $request->get("\144\x61\164\141\142\141\163\145\125\163\145\x72\116\141\155\x65"); goto E7e07; Cc515: e4afa: goto C882d; c527a: b4b88: goto Cc515; ddade: } public function phpMyAdminLogout(Request $request) { goto Bd4ea; Bd4ea: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\x74\145\163")); goto df45b; D8b1a: $response->headers->clearCookie("\x70\155\141\101\165\x74\x68\55\61\x5f\x68\x74\x74\x70\x73"); goto D05b0; df45b: $response->headers->clearCookie("\143\154\x70\x2d\x70\x6d\141"); goto aa5df; D05b0: $response->headers->clearCookie("\x53\151\x67\156\157\156\123\x65\163\x73\151\157\x6e"); goto f695f; aa5df: $response->headers->clearCookie("\160\150\x70\x4d\x79\x41\x64\x6d\x69\156\x5f\x68\x74\x74\x70\163"); goto D8b1a; f695f: return $response; goto Ddd79; Ddd79: } public function newDatabaseUser(Request $request) : Response { goto e9cd4; A19a5: if (false === is_null($site)) { goto c3ec5; } goto f8bda; F6173: return $response; goto a09ad; a2b92: $response = $this->render("\106\162\x6f\156\x74\x65\156\x64\x2f\x53\x69\164\x65\57\156\x65\167\x2d\144\141\164\141\142\x61\x73\x65\55\165\163\145\162\x2e\x68\164\x6d\x6c\56\x74\x77\151\147", ["\163\151\164\x65" => $site, "\x64\141\x74\141\x62\141\x73\x65\x55\163\x65\x72" => $databaseUserEntity, "\x64\x61\164\141\x62\141\163\145\163" => $databases, "\x66\x6f\x72\155" => $form->createView(), "\x66\157\162\155\x45\162\162\x6f\162\163" => $this->formErrors]); goto a980c; B8046: c3ec5: goto Aa823; ab711: $siteEntity = $this->getSiteEntity($domainName); goto e76cd; cb8c5: return $response; goto A733f; e21d3: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\x74\145\137\x64\x61\164\x61\142\141\163\145\x73", ["\x64\157\x6d\141\151\x6e\116\141\155\145" => $site->getDomainName()])); goto Aacec; d209d: goto E860b; goto B8046; e76cd: if (count($databases) && false === is_null($siteEntity)) { goto D8228; } goto cca58; e9cd4: $site = $this->getSite($request); goto A19a5; fe4ec: $session->getFlashBag()->set("\144\141\156\147\x65\x72", $this->translator->trans("\116\x6f\x20\x64\141\164\141\x62\141\163\x65\x20\x66\157\165\156\x64\73\x20\143\162\145\141\x74\x65\40\141\x20\144\141\x74\x61\x62\141\163\x65\40\146\151\x72\x73\164\56")); goto e21d3; fb00f: D8228: goto Bdabc; ff694: $form->handleRequest($request); goto E8c05; E8c05: if (!(true === $form->isSubmitted())) { goto C657b; } goto e37e6; F700c: C657b: goto F487a; Ea26a: E860b: goto cb8c5; Aacec: goto Ac512; goto fb00f; d9078: $databaseUserEntity->setSite($siteEntity); goto D1774; F487a: baf58: goto a2b92; Aa823: $databases = $site->getDatabases(); goto C592e; Bdabc: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto d9078; f8bda: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\164\145\x73")); goto d209d; C592e: $domainName = $site->getDomainName(); goto ab711; A3752: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto baf58; } goto ff694; c6b77: if (!(false === is_null($response))) { goto ee505; } goto F6173; a980c: Ac512: goto Ea26a; D1774: $form = $this->createDatabaseUserForm($site, $databaseUserEntity); goto A3752; a09ad: ee505: goto F700c; e37e6: $response = $this->handleDatabaseUserForm($request, $form, $site); goto c6b77; cca58: $session = $request->getSession(); goto fe4ec; A733f: } private function createDatabaseUserForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto Bbda4; e88a3: return $form; goto F1182; Bbda4: $form = $this->createForm("\101\x70\x70\x5c\106\x6f\x72\155\x5c\123\x69\164\145\104\x61\164\141\x62\141\163\145\125\163\x65\162\x54\x79\x70\x65", $databaseUserEntity, ["\x61\x63\x74\151\157\x6e" => $this->generateUrl("\x63\154\x70\x5f\163\x69\164\x65\x5f\144\x61\x74\141\142\141\163\x65\x5f\165\163\145\x72\137\156\x65\x77", ["\x64\x6f\x6d\x61\x69\x6e\116\141\x6d\145" => $site->getDomainName()]), "\155\x65\x74\150\x6f\x64" => "\120\x4f\x53\x54", "\x61\164\164\162" => []]); goto c7632; c7632: $form->add("\163\x75\x62\x6d\x69\x74", SubmitType::class, ["\141\x74\x74\162" => ["\143\154\x61\x73\x73" => "\142\x74\x6e\x20\x62\164\156\x2d\142\x6c\165\x65\40\142\x74\x6e\55\x6c\147"], "\154\141\142\x65\x6c" => "\x41\144\144\x20\104\x61\x74\141\x62\141\163\145\40\x55\163\145\x72"]); goto e88a3; F1182: } private function handleDatabaseUserForm(Request $request, Form $form, Site $site) { goto e8224; c608b: goto e69ca; goto e5f60; e8224: if (true === $form->isValid()) { goto B7813; } goto a2d65; e5f60: B7813: goto De1af; D1b83: e69ca: goto D02f6; a2d65: $this->formErrors = $this->getErrorMessages($form); goto c608b; De1af: try { goto C2d63; a6140: $session = $request->getSession(); goto c0989; f11eb: $siteEntity = $this->getSiteEntity($domainName); goto ee5ea; e14bc: $databaseName = $databaseEntity->getName(); goto e5c53; cccde: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto e7206; e7206: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto b17da; C2d63: $user = $this->getUser(); goto a6140; Aef62: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto D5051; ee5ea: if (false === is_null($siteEntity)) { goto C436d; } goto E0ae7; E0ae7: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\x69\x74\145\x5f\x64\x61\164\x61\x62\141\163\x65\137\x75\x73\145\x72\x5f\x6e\145\167", ["\x64\x6f\x6d\x61\151\156\x4e\x61\155\x65" => $site->getDomainName()])); goto af958; c0989: $domainName = $site->getDomainName(); goto f11eb; B3da1: $databaseUserEntity = $form->getData(); goto Aef62; D32ea: $databaseEntity = $databaseUserEntity->getDatabase(); goto e14bc; D5051: $databaseUserEntity->setPassword($encryptedPassword); goto cccde; C8306: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\x69\164\145\137\144\x61\164\x61\142\x61\163\x65\163", ["\144\157\x6d\x61\x69\156\116\141\x6d\145" => $site->getDomainName()])); goto Fb345; Fb345: Da35a: goto A667f; E60a5: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_ADD, $user, $eventData, $request); goto e7f3a; af958: goto Da35a; goto B5655; B5655: C436d: goto B3da1; A667f: return $response; goto C173a; b17da: $databaseManager->createUser($databaseUserEntity); goto Bcf00; Bcf00: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto D32ea; e5c53: $eventData = ["\x73\151\x74\145" => $domainName, "\144\141\x74\141\142\141\163\145\x55\x73\145\162\116\141\155\x65" => $databaseUserEntity->getUserName(), "\x70\145\x72\x6d\151\163\163\x69\x6f\156\163" => $databaseUserEntity->getPermissions(), "\144\141\x74\x61\x62\141\163\x65" => $databaseName]; goto E60a5; e7f3a: $session->getFlashBag()->set("\163\165\x63\x63\x65\163\163", $this->translator->trans("\x44\141\164\141\x62\141\163\145\x20\x55\x73\145\162\x20\x68\x61\163\x20\x62\x65\x65\x6e\x20\x61\x64\144\x65\x64\56")); goto C8306; C173a: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\145\162", $this->translator->trans("\101\x6e\40\145\162\162\x6f\162\40\150\141\x73\40\157\x63\143\165\x72\x72\x65\x64\54\x20\x65\162\x72\x6f\x72\40\155\145\x73\163\x61\x67\145\72\x20\x25\145\x72\x72\157\x72\115\145\x73\163\x61\x67\145\45", ["\45\145\x72\162\x6f\x72\115\x65\163\x73\x61\147\x65\x25" => $e->getMessage()])); } goto D1b83; D02f6: } public function editDatabaseUser(Request $request) : Response { goto ebc2d; B7280: $session = $request->getSession(); goto A5c86; C3af8: $response = $this->handleDatabaseUserEditForm($request, $form, $site); goto F200c; e0a72: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto c23c9; } goto ea02f; f29fd: goto c75c6; goto C9ec9; Ba1a1: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\164\x65\137\x64\x61\x74\141\142\141\163\x65\x73", ["\x64\x6f\155\x61\x69\x6e\x4e\x61\155\x65" => $site->getDomainName()])); goto f29fd; ef174: $siteEntity = $this->getSiteEntity($domainName); goto Fff85; de9e3: b9c1f: goto D2eb7; ea02f: $form->handleRequest($request); goto aba1b; b6edc: c75c6: goto b46a1; B7a56: C0b4c: goto b6edc; D2eb7: $databases = $site->getDatabases(); goto a6422; e20a3: return $response; goto Eccc1; b6865: e32fc: goto E3d9e; A4959: return $response; goto b5b96; A5c86: $session->getFlashBag()->set("\144\x61\156\147\145\162", $this->translator->trans("\x4e\x6f\40\144\x61\x74\141\x62\141\163\145\40\146\x6f\165\156\144\x3b\40\143\162\x65\141\164\145\40\141\x20\144\x61\x74\x61\x62\x61\x73\145\x20\x66\x69\162\163\164\x2e")); goto Ba1a1; b5b96: ae04b: goto b6865; Ce635: $response = $this->render("\106\x72\x6f\x6e\164\x65\x6e\144\x2f\x53\151\x74\x65\x2f\x65\x64\151\x74\55\x64\141\x74\x61\142\x61\x73\145\x2d\165\x73\145\x72\56\x68\x74\155\154\56\x74\167\151\x67", ["\x73\x69\x74\145" => $site, "\x64\x61\x74\x61\x62\141\163\145\125\163\145\x72" => $databaseUserEntity, "\146\157\162\155" => $form->createView(), "\x66\157\x72\155\x45\162\x72\x6f\x72\163" => $this->formErrors]); goto B7a56; Dfb36: $databaseUserEntity->setPassword(''); goto C27f5; a6422: $domainName = $site->getDomainName(); goto ef174; b46a1: d96f9: goto e20a3; C27f5: $form = $this->createDatabaseUserEditForm($site, $databaseUserEntity); goto e0a72; ebc2d: $site = $this->getSite($request); goto Ccc62; b59d6: if (!(false === is_null($databaseUserEntity))) { goto C0b4c; } goto Dfb36; aba1b: if (!(true === $form->isSubmitted())) { goto e32fc; } goto C3af8; E3d9e: c23c9: goto Ce635; F3f96: goto d96f9; goto de9e3; C9ec9: Cca72: goto a870c; B0dc7: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\x69\x74\x65\163")); goto F3f96; Ccc62: if (false === is_null($site)) { goto b9c1f; } goto B0dc7; Fff85: if (count($databases) && false === is_null($siteEntity)) { goto Cca72; } goto B7280; F200c: if (!(false === is_null($response))) { goto ae04b; } goto A4959; A5ffc: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto b59d6; a870c: $databaseUserName = $request->get("\144\141\164\141\142\x61\x73\145\125\163\x65\162\x4e\x61\x6d\145"); goto A5ffc; Eccc1: } private function createDatabaseUserEditForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto C390e; Bb7fd: return $form; goto cb78e; C390e: $form = $this->createForm("\x41\x70\x70\x5c\106\157\x72\x6d\134\x53\151\x74\145\104\141\164\x61\x62\x61\163\x65\125\163\x65\x72\105\144\x69\164\x54\171\x70\145", $databaseUserEntity, ["\x61\143\164\x69\x6f\156" => $this->generateUrl("\143\x6c\160\137\163\151\164\145\137\x64\x61\164\141\142\x61\163\x65\137\165\163\145\x72\137\145\x64\151\164", ["\x64\157\x6d\141\151\x6e\x4e\141\155\145" => $site->getDomainName(), "\x64\141\164\141\x62\x61\163\145\x55\x73\x65\162\116\x61\x6d\x65" => $databaseUserEntity->getUserName()]), "\x6d\x65\x74\x68\x6f\x64" => "\x50\117\123\124", "\141\164\x74\x72" => []]); goto a83ff; a83ff: $form->add("\163\x75\x62\155\x69\164", SubmitType::class, ["\x61\x74\164\x72" => ["\x63\x6c\x61\x73\163" => "\142\164\x6e\40\142\164\156\x2d\x62\154\165\x65\40\142\164\x6e\x2d\x6c\147"], "\x6c\141\x62\145\x6c" => "\x53\141\166\145"]); goto Bb7fd; cb78e: } private function handleDatabaseUserEditForm(Request $request, Form $form, Site $site) { goto Ac8e0; bc1ef: try { goto a0738; cc28d: $databaseUserEntity->setPassword($encryptedPassword); goto e00e6; be2ea: $domainName = $site->getDomainName(); goto cbdcd; bb638: B18d5: goto ef262; e00e6: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ba7da; B519e: $eventData = ["\163\151\x74\x65" => $domainName, "\x64\141\x74\x61\x62\141\163\145\x55\163\x65\162\x4e\141\x6d\x65" => $databaseUserEntity->getUserName(), "\160\145\x72\x6d\151\163\x73\151\x6f\x6e\163" => $databaseUserEntity->getPermissions(), "\144\141\x74\141\x62\141\x73\145" => $databaseName]; goto ff762; Bfa47: $databaseManager->createUser($databaseUserEntity); goto de0cf; cbdcd: $siteEntity = $this->getSiteEntity($domainName); goto b7661; ff762: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_EDIT, $user, $eventData, $request); goto f8eba; b7661: if (false === is_null($siteEntity)) { goto c15c1; } goto Da975; ba7da: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto Bfa47; de0cf: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto E6f0a; ea076: $databaseName = $databaseEntity->getName(); goto B519e; a0738: $user = $this->getUser(); goto F2637; c3f5b: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto cc28d; e1cfa: $databaseUserEntity = $form->getData(); goto c3f5b; E6f0a: $databaseEntity = $databaseUserEntity->getDatabase(); goto ea076; ef262: return $response; goto c0202; Ca6be: c15c1: goto e1cfa; Da975: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\x74\145\x5f\144\141\164\x61\142\141\x73\145\x5f\165\x73\x65\x72\137\x6e\x65\x77", ["\x64\x6f\155\141\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto c4d15; cec1c: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\151\164\145\x5f\x64\141\164\x61\142\x61\163\145\x73", ["\x64\157\155\141\x69\156\x4e\x61\155\x65" => $site->getDomainName()])); goto bb638; c4d15: goto B18d5; goto Ca6be; f8eba: $session->getFlashBag()->set("\163\165\143\x63\145\163\163", $this->translator->trans("\104\x61\x74\x61\142\x61\163\x65\40\x55\163\145\x72\x20\x68\x61\163\40\142\145\145\156\40\x75\160\144\141\x74\145\144\x2e")); goto cec1c; F2637: $session = $request->getSession(); goto be2ea; c0202: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\162", $this->translator->trans("\x41\156\x20\x65\162\x72\x6f\162\40\150\141\163\40\x6f\x63\x63\165\x72\162\x65\144\x2c\40\x65\x72\162\x6f\x72\x20\x6d\145\x73\163\141\x67\145\x3a\x20\45\145\x72\162\157\162\115\145\163\163\x61\x67\145\45", ["\x25\145\x72\x72\157\x72\x4d\145\x73\x73\x61\147\x65\45" => $e->getMessage()])); } goto a178f; Ac8e0: if (true === $form->isValid()) { goto dbda2; } goto af269; f0f32: goto f3719; goto b073a; a178f: f3719: goto E131c; b073a: dbda2: goto bc1ef; af269: $this->formErrors = $this->getErrorMessages($form); goto f0f32; E131c: } public function deleteDatabaseUser(Request $request) : Response { goto d6f07; Ae9c1: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto e6d9c; d6f07: $site = $this->getSite($request); goto e1928; B8059: $databaseUserName = $request->get("\x64\141\x74\x61\x62\x61\163\145\125\x73\x65\162\x4e\141\155\x65"); goto Ae9c1; Cc586: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\164\145\137\144\141\x74\141\x62\141\163\145\163", ["\x64\157\155\x61\151\156\116\x61\155\x65" => $site->getDomainName()])); goto D57d9; f6734: ea05c: goto F3a15; e1928: $this->checkCsrfToken($request, "\144\x61\x74\141\x62\x61\x73\145\x2d\165\163\x65\162\55\144\145\154\145\x74\x65"); goto af8c7; D57d9: return $response; goto ce8e9; Be929: try { goto Aa2c4; Baed7: $domainName = $site->getDomainName(); goto cec35; d2eee: $user = $this->getUser(); goto Baed7; cec35: $session = $request->getSession(); goto e96e0; b4697: c59f0: goto d85a2; Aa2c4: $databaseEntity = $databaseUserEntity->getDatabase(); goto A0be2; ee068: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto a47cc; da53c: $eventData = ["\x73\x69\x74\145" => $domainName, "\x64\141\x74\x61\x62\x61\x73\145\x55\x73\145\162\116\x61\x6d\x65" => $databaseUserName]; goto C6cc4; A0be2: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto c59f0; } goto d2eee; C0149: $this->databaseUserEntityManager->deleteEntity($databaseUserEntity); goto B40d1; B40d1: $session->getFlashBag()->set("\x73\165\143\143\x65\x73\163", $this->translator->trans("\104\141\164\141\x62\x61\163\x65\x20\x55\163\x65\162\x20\x68\141\163\40\x62\145\145\x6e\x20\144\x65\x6c\x65\x74\x65\144\56")); goto da53c; a47cc: $databaseManager->deleteUser($databaseUserEntity); goto C0149; e96e0: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ee068; C6cc4: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_DELETE, $user, $eventData, $request); goto b4697; d85a2: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\101\x6e\40\x65\x72\x72\x6f\162\40\150\x61\x73\40\157\x63\143\x75\162\162\x65\x64\x2c\x20\x65\162\162\157\162\x20\155\x65\163\x73\x61\147\x65\x3a\x20\x25\145\x72\x72\x6f\x72\115\145\163\163\x61\147\145\x25", ["\45\x65\x72\162\x6f\162\115\x65\163\163\141\x67\x65\x25" => $e->getMessage()])); } goto Cc586; ce8e9: f0262: goto f6734; B5a48: return $response; goto b9ff1; F3a15: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\163\x69\164\x65\x73")); goto B5a48; e6d9c: if (!(false === is_null($databaseUserEntity))) { goto f0262; } goto Be929; af8c7: if (!(false === is_null($site))) { goto ea05c; } goto B8059; b9ff1: } public function varnishCache(Request $request) : Response { goto bb0e3; f254f: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto C53fd; } goto Da6fb; E09c7: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\x65\163")); goto E902c; f04e2: $purgeCacheForm->handleRequest($request); goto b7e85; bdf4e: $varnishCacheSettingsData = ["\151\x73\105\156\141\142\x6c\x65\x64" => true === isset($varnishCacheSettings["\x65\156\141\x62\x6c\145\144"]) && true === $varnishCacheSettings["\x65\x6e\x61\x62\x6c\145\x64"] ? true : false, "\x73\145\162\166\x65\x72" => true === isset($varnishCacheSettings["\163\145\162\166\x65\x72"]) ? $varnishCacheSettings["\163\145\x72\x76\145\x72"] : "\x31\62\x37\56\x30\x2e\x30\56\x31\x3a\x36\x30\70\61", "\143\141\143\150\145\124\x61\147\x50\x72\x65\x66\151\x78" => true === isset($varnishCacheSettings["\x63\141\x63\x68\x65\x54\141\147\120\x72\145\x66\151\170"]) ? $varnishCacheSettings["\x63\x61\x63\x68\x65\x54\x61\147\x50\x72\x65\x66\151\170"] : substr(md5(time()), 0, 4), "\x63\141\x63\150\x65\x4c\x69\x66\145\x74\151\155\145" => true === isset($varnishCacheSettings["\143\141\143\150\145\x4c\151\x66\145\x74\x69\x6d\x65"]) ? $varnishCacheSettings["\x63\141\143\150\x65\x4c\x69\146\x65\x74\x69\155\145"] : "\66\60\x34\x38\60\60", "\x65\170\x63\x6c\x75\144\145\x64\x50\141\162\x61\x6d\163" => true === isset($varnishCacheSettings["\x65\x78\143\x6c\x75\x64\x65\x64\120\141\x72\141\x6d\x73"]) ? implode("\x2c", $varnishCacheSettings["\145\x78\143\154\x75\x64\145\144\120\141\162\141\x6d\x73"]) : "\137\137\123\111\104\x2c\156\x6f\x43\x61\143\150\145\54", "\145\x78\143\154\165\x64\145\163" => true === isset($varnishCacheSettings["\x65\x78\x63\x6c\165\144\x65\163"]) ? implode(PHP_EOL, $varnishCacheSettings["\x65\170\x63\x6c\165\x64\145\x73"]) : '']; goto Fc417; e38a0: D1eea: goto cf8a2; Da6fb: $settingsForm->handleRequest($request); goto f04e2; Af215: return $response; goto d5bcd; A0478: c66dd: goto Af215; E823b: if (!(false === is_null($response))) { goto D1eea; } goto A40f6; bb0e3: $site = $this->getSite($request); goto Eef9f; ab70f: if (!(false === is_null($response))) { goto B536d; } goto de0f9; dc4d5: $response = $this->render("\106\162\157\156\164\x65\x6e\x64\x2f\123\x69\164\145\x2f\166\x61\162\x6e\x69\163\150\x2d\143\x61\143\x68\145\56\150\x74\x6d\154\x2e\164\167\x69\x67", ["\x73\x69\x74\x65" => $site, "\x73\145\164\x74\x69\156\x67\163\106\x6f\x72\x6d" => $settingsForm->createView(), "\x70\x75\x72\x67\145\x43\x61\x63\x68\x65\x46\157\x72\x6d" => $purgeCacheForm->createView(), "\x66\157\x72\x6d\x45\162\162\157\x72\163" => $this->formErrors]); goto A0478; e00a0: B7481: goto Cf6c8; A40f6: return $response; goto e38a0; dc6d3: C53fd: goto dc4d5; e646c: if (!(true === $purgeCacheForm->isSubmitted())) { goto D8924; } goto F7d7a; Ff413: Bbe49: goto e646c; cf8a2: D8924: goto dc6d3; F7d7a: $response = $this->handleVarnishCachePurgeCacheForm($request, $purgeCacheForm, $site); goto E823b; Eef9f: if (false === is_null($site) && true === $site->getVarnishCache()) { goto B7481; } goto E09c7; E9d10: $purgeCacheForm = $this->createVarnishCachePurgeCacheForm($site); goto f254f; de0f9: return $response; goto bcf03; Fc417: $settingsForm = $this->createVarnishCacheSettingsForm($site, $varnishCacheSettingsData); goto E9d10; bcf03: B536d: goto Ff413; b7e85: if (!(true === $settingsForm->isSubmitted())) { goto Bbe49; } goto d975d; d975d: $response = $this->handleVarnishCacheSettingsForm($request, $settingsForm, $site); goto ab70f; Cf6c8: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto bdf4e; E902c: goto c66dd; goto e00a0; d5bcd: } private function createVarnishCacheSettingsForm(Site $site, array $data) : Form { goto ea6da; cdcbc: return $form; goto De19d; E0552: $form->add("\163\x75\x62\155\x69\164", SubmitType::class, ["\x61\164\164\x72" => ["\143\x6c\x61\x73\x73" => "\142\164\156\40\142\x74\156\55\142\x6c\x75\145\40\142\164\156\55\x6c\x67"], "\x6c\x61\142\x65\154" => "\x53\141\166\145"]); goto cdcbc; ea6da: $form = $this->createForm("\101\x70\x70\134\x46\157\162\x6d\x5c\123\151\x74\145\x56\x61\162\x6e\151\x73\x68\x43\x61\x63\150\145\123\145\164\164\x69\156\147\163\x54\171\160\x65", $data, ["\141\x63\164\151\157\x6e" => $this->generateUrl("\x63\154\x70\137\x73\x69\164\145\x5f\166\x61\162\x6e\151\x73\x68\x5f\143\x61\x63\x68\145", ["\x64\x6f\155\141\151\x6e\x4e\141\x6d\145" => $site->getDomainName()]), "\155\145\164\x68\157\x64" => "\x50\117\x53\x54", "\x61\164\x74\x72" => []]); goto E0552; De19d: } private function createVarnishCachePurgeCacheForm(Site $site) : Form { goto F3918; a251b: return $form; goto e7954; Eeac4: $form->add("\x73\x75\x62\155\x69\164", SubmitType::class, ["\x61\164\164\162" => ["\x63\154\141\x73\x73" => "\x62\x74\x6e\40\x62\x74\156\55\x62\x6c\x75\x65\40\142\x74\156\x2d\154\147"], "\x6c\141\142\x65\154" => "\x50\x75\162\147\145\40\103\141\x63\x68\145"]); goto a251b; F3918: $form = $this->createForm("\101\x70\160\134\106\157\162\x6d\134\123\x69\x74\x65\126\x61\162\156\x69\x73\150\103\141\x63\150\x65\x50\165\162\147\x65\x43\x61\143\150\x65\124\171\x70\x65", ["\x73\x69\x74\x65" => $site], ["\x61\x63\x74\x69\157\156" => $this->generateUrl("\x63\154\160\x5f\163\x69\164\145\x5f\x76\141\162\x6e\x69\x73\150\137\x63\x61\143\150\x65", ["\144\157\x6d\141\151\x6e\116\x61\x6d\x65" => $site->getDomainName()]), "\x6d\x65\164\150\157\144" => "\x50\x4f\123\124", "\x61\x74\x74\162" => []]); goto Eeac4; e7954: } private function handleVarnishCacheSettingsForm(Request $request, Form $form, Site $site) { goto Ccf80; ee737: goto bb4cb; goto c5f1d; Cfc3d: $this->formErrors = $this->getErrorMessages($form); goto ee737; Ccf80: if (true === $form->isValid()) { goto C118c; } goto Cfc3d; C4964: try { goto Df2c8; dcd3f: $varnishCacheSettings = ["\x65\156\141\x62\x6c\x65\x64" => $isEnabled, "\x73\145\162\166\145\x72" => $server, "\x63\x61\143\150\x65\124\141\x67\120\162\145\x66\151\170" => $cacheTagPrefix, "\x63\x61\143\x68\145\114\151\x66\145\164\151\155\145" => $cacheLifetime, "\145\170\x63\x6c\x75\x64\145\x73" => $excludes, "\x65\170\x63\154\x75\144\145\x64\x50\x61\x72\x61\155\x73" => $excludedParams]; goto b6862; fbe54: $siteUpdater->phpSettings(); goto abdc9; F5bdd: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\164\x65\163")); goto cac2c; a2925: $cacheTagPrefix = $form->get("\x63\x61\143\150\145\124\x61\147\x50\162\x65\x66\x69\170")->getData(); goto f155e; F1653: $excludes = array_map("\164\162\151\x6d", array_filter(explode(PHP_EOL, trim($form->get("\145\x78\x63\x6c\x75\144\145\x73")->getData())))); goto dcd3f; b6862: $site->setVarnishCacheSettings($varnishCacheSettings); goto D9d56; ac785: $siteEntity = $this->getSiteEntity($domainName); goto C528c; abdc9: $eventData = ["\x73\x69\164\145" => $domainName, "\166\141\x72\156\x69\163\150\x43\x61\143\x68\145\105\x6e\141\x62\154\145\144" => $isEnabled, "\163\145\x72\x76\x65\162" => $server, "\x63\x61\x63\150\x65\x54\141\x67\x50\x72\145\146\x69\x78" => $cacheTagPrefix, "\143\x61\x63\x68\x65\x4c\151\x66\145\164\151\155\145" => $cacheLifetime, "\x65\170\143\154\165\x64\x65\163" => $excludes, "\145\x78\143\x6c\165\144\145\x64\120\141\x72\141\x6d\x73" => $excludedParams]; goto D11d2; cac2c: goto fcd88; goto c22e5; Df2c8: $session = $request->getSession(); goto D1862; D1862: $domainName = $site->getDomainName(); goto ac785; A179c: $siteUpdater->writeVarnishCacheSettingsFile($varnishCacheSettings); goto fbe54; D11be: $user = $this->getUser(); goto b99aa; Cb0a5: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\164\x65\137\166\x61\162\156\151\163\150\x5f\143\141\143\150\145", ["\144\157\155\141\151\156\116\141\155\145" => $site->getDomainName()])); goto A3601; E8a5f: $cacheLifetime = $form->get("\143\x61\x63\x68\145\114\x69\146\x65\164\151\155\145")->getData(); goto a2925; C528c: if (false === is_null($siteEntity)) { goto D6295; } goto F5bdd; c22e5: D6295: goto D11be; f155e: $excludedParams = array_map("\164\162\x69\x6d", array_filter(explode("\x2c", trim($form->get("\145\170\143\x6c\x75\144\x65\144\120\x61\x72\141\x6d\163")->getData())))); goto F1653; D11d2: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_SETTINGS_UPDATE, $user, $eventData, $request); goto Ee36a; fa56e: $server = $form->get("\163\x65\162\166\x65\162")->getData(); goto E8a5f; Ee36a: $session->getFlashBag()->set("\163\165\x63\x63\145\x73\x73", $this->translator->trans("\126\141\x72\x6e\x69\163\x68\x20\x43\x61\x63\150\x65\40\123\145\164\164\151\x6e\x67\163\40\x68\x61\x76\145\x20\142\x65\145\156\x20\163\x61\166\145\144\x2e")); goto Cb0a5; A3601: fcd88: goto E9239; b99aa: $isEnabled = $form->get("\x69\163\105\x6e\141\x62\x6c\x65\144")->getData(); goto fa56e; D9d56: $siteUpdater = $this->getSiteUpdater($site); goto A179c; E9239: return $response; goto b0362; b0362: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\x72", $this->translator->trans("\x41\x6e\40\x65\162\x72\157\162\x20\150\x61\163\40\157\x63\x63\x75\162\162\145\144\54\40\x65\162\x72\x6f\162\40\x6d\145\x73\163\x61\x67\145\x3a\x20\x25\x65\162\162\157\x72\115\x65\163\163\141\147\x65\x25", ["\x25\145\x72\162\x6f\162\115\145\163\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto B5806; B5806: bb4cb: goto be737; c5f1d: C118c: goto C4964; be737: } private function handleVarnishCachePurgeCacheForm(Request $request, Form $form, Site $site) { goto D3143; E0df2: $this->formErrors = $this->getErrorMessages($form); goto A1872; A1872: goto B4893; goto c59b0; d974f: try { goto D804f; e1a65: cdf75: goto Bef11; a810e: $varnishCacheClient = new VarnishCacheClient(); goto ab90d; Ec19a: e3c53: goto f8c52; D4149: if (false === empty($purgeValues) && true === isset($varnishCacheSettings["\163\x65\x72\166\145\162"]) && false === empty($varnishCacheSettings["\163\x65\x72\166\145\162"])) { goto a9625; } goto cf9d3; D217d: goto cdf75; goto c9036; Dae81: $siteEntity = $this->getSiteEntity($domainName); goto B0f41; C9764: $domainName = $site->getDomainName(); goto Dae81; D161d: $user = $this->getUser(); goto d0f7b; f8c52: $eventData = ["\x73\151\x74\x65" => $domainName, "\166\141\154\165\x65\163" => implode("\x2c", $purgeValues)]; goto Dec63; c9036: Fdcdd: goto D161d; B0f41: if (false === is_null($siteEntity)) { goto Fdcdd; } goto f1640; f1640: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\x74\x65\x73")); goto D217d; C5284: a9625: goto a810e; d0f7b: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto d23b9; ab90d: $varnishCacheClient->setServer($varnishCacheSettings["\x73\x65\x72\166\145\x72"]); goto b60f8; cf9d3: throw new \Exception("\126\x61\162\x6e\151\163\150\40\x43\141\143\150\145\40\x53\145\164\x74\x69\156\x67\x73\40\143\141\156\x6e\x6f\164\40\x62\145\x20\x65\x6d\160\x74\171\56"); goto D445c; Dec63: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_PURGE, $user, $eventData, $request); goto cc0ef; D445c: goto e3c53; goto C5284; D804f: $session = $request->getSession(); goto C9764; cc0ef: $session->getFlashBag()->set("\163\165\143\x63\145\163\x73", $this->translator->trans("\126\x61\x72\156\151\x73\150\x20\x43\x61\143\150\145\40\x68\x61\163\40\142\145\x65\156\x20\160\x75\162\x67\x65\x64\56")); goto b48cf; b60f8: foreach ($purgeValues as $purgeValue) { goto D1cc1; a0b70: if (!(false === empty($purgeValue))) { goto A3983; } goto E42b0; D1cc1: $purgeValue = trim($purgeValue); goto a0b70; ae721: $varnishCacheClient->purgeUrl($purgeValue); goto Bbeab; f8846: goto d54d5; goto ff43f; ff43f: C4690: goto ae721; d8e25: $varnishCacheClient->purgeTag($purgeValue); goto f8846; E42b0: if (true === str_starts_with($purgeValue, "\x68\164\x74\x70")) { goto C4690; } goto d8e25; a784e: E3ed9: goto ca96d; D10eb: A3983: goto a784e; Bbeab: d54d5: goto D10eb; ca96d: } goto b42a1; Bef11: return $response; goto ae316; b48cf: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\x74\x65\137\166\141\162\x6e\x69\163\x68\x5f\x63\x61\143\150\x65", ["\x64\x6f\155\141\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto e1a65; d23b9: $purgeValues = array_map("\164\162\151\155", array_filter(explode("\x2c", trim($form->get("\166\141\x6c\x75\x65")->getData())))); goto D4149; b42a1: Daf61: goto Ec19a; ae316: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\145\x72", $this->translator->trans("\101\156\40\x65\162\162\x6f\162\x20\150\141\163\x20\x6f\x63\x63\165\162\x72\145\x64\x2c\40\145\x72\162\157\x72\40\x6d\145\163\163\x61\147\x65\x3a\40\x25\145\162\162\157\x72\115\x65\x73\x73\141\x67\x65\x25", ["\x25\145\162\162\157\162\x4d\x65\x73\163\x61\x67\145\45" => $e->getMessage()])); } goto d30e0; D3143: if (true === $form->isValid()) { goto D6312; } goto E0df2; c59b0: D6312: goto d974f; d30e0: B4893: goto a595a; a595a: } public function purgeVarnishCache(Request $request) : Response { goto ebcd0; e7488: goto a07ad; goto A561a; A561a: Bde7c: goto C91bb; f2848: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\164\145\x73")); goto e7488; D505b: return $response; goto Dfa24; d3436: return $response; goto D6023; D6023: a07ad: goto D505b; ebcd0: $site = $this->getSite($request); goto D9b2c; F4bc7: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\145\x5f\166\x61\162\156\x69\x73\150\x5f\143\141\143\150\145", ["\144\x6f\x6d\x61\x69\x6e\x4e\x61\155\x65" => $site->getDomainName()])); goto d3436; C91bb: try { goto B0509; Aa753: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_PURGE, $user, $eventData, $request); goto Bfbf1; D51a2: $session = $request->getSession(); goto e5f71; e5f71: $domainName = $site->getDomainName(); goto A81a0; ae861: if (!(true === isset($varnishCacheSettings["\163\x65\x72\166\145\162"]) && true === isset($varnishCacheSettings["\143\141\143\x68\x65\x54\141\147\x50\x72\x65\146\151\170"]) && false === empty($varnishCacheSettings["\143\x61\x63\150\x65\124\141\147\120\162\145\x66\x69\170"]))) { goto C57b2; } goto c8e04; A81a0: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto ae861; E84f2: $eventData = ["\163\151\164\145" => $domainName, "\160\165\162\147\x65" => "\146\165\154\x6c"]; goto Aa753; B0509: $user = $this->getUser(); goto D51a2; e07ce: $varnishCacheClient->purgeHost($domainName); goto Aa7bf; e473c: $varnishCacheClient->setServer($varnishCacheSettings["\163\145\162\166\x65\x72"]); goto Aca6c; Aca6c: $varnishCacheClient->purgeTag($cacheTagPrefix); goto e07ce; e32df: $varnishCacheClient = new VarnishCacheClient(); goto e473c; c8e04: $cacheTagPrefix = $varnishCacheSettings["\x63\141\x63\150\x65\x54\x61\x67\x50\162\145\x66\151\x78"]; goto e32df; Bfbf1: $session->getFlashBag()->set("\163\x75\x63\x63\145\163\163", $this->translator->trans("\126\141\x72\156\x69\x73\150\x20\x43\x61\x63\150\x65\40\150\x61\x73\x20\x62\x65\145\x6e\40\160\165\162\x67\145\x64\x2e")); goto b93b8; Aa7bf: C57b2: goto E84f2; b93b8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\101\x6e\x20\145\162\162\157\x72\x20\x68\x61\x73\x20\157\143\143\x75\162\162\x65\144\x2c\40\145\x72\162\x6f\x72\40\155\x65\x73\x73\141\147\x65\72\40\45\x65\x72\162\157\162\115\x65\163\163\x61\147\x65\45", ["\x25\145\162\162\x6f\x72\115\x65\x73\163\x61\147\145\45" => $e->getMessage()])); } goto F4bc7; D9b2c: if (false === is_null($site)) { goto Bde7c; } goto f2848; Dfa24: } public function vhost(Request $request) : Response { goto c82b4; e6879: goto f73e2; goto D6fb5; E095e: return $response; goto Bd76c; aafc1: c50f8: goto Cde80; C066d: if (false === is_null($site)) { goto c4fa6; } goto a2b78; a2b78: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\151\x74\x65\x73")); goto e6879; Cb668: if (!(false === $isCsrfTokenValid)) { goto B4f72; } goto a2620; D6fb5: c4fa6: goto ce70a; Bca63: $oldVhostTemplate = $siteEntity->getVhostTemplate(); goto b4921; ad838: $response = $this->handleVhostUpdate($request, $site, $siteEntity, $oldVhostTemplate); goto a3496; Cde80: F8fd7: goto e562a; ce70a: if (!(true === $request->isMethod("\120\x4f\123\x54"))) { goto F8fd7; } goto d2b0d; c82b4: $site = $this->getSite($request); goto C066d; a2620: throw new InvalidCsrfTokenException("\124\150\145\40\103\x53\122\x46\40\164\157\x6b\x65\x6e\x20\x69\163\40\151\156\166\141\154\x69\x64\56"); goto ae94d; b7d3b: if (!(false === empty($vhostTemplate))) { goto c50f8; } goto ce6f1; ce6f1: $domainName = $site->getDomainName(); goto Ec36c; a3496: if (!(false === is_null($response))) { goto Ac6f0; } goto Dcf1c; Ec36c: $siteEntity = $this->getSiteEntity($domainName); goto Bca63; e562a: $response = $this->render("\106\x72\157\x6e\164\x65\156\144\57\x53\x69\x74\145\x2f\x76\150\157\x73\x74\x2e\x68\x74\x6d\154\56\x74\167\x69\x67", ["\163\151\x74\x65" => $site]); goto ac6d3; ac6d3: f73e2: goto E095e; d2b0d: $isCsrfTokenValid = $this->isCsrfTokenValid("\166\150\157\x73\164\55\x75\160\144\141\x74\145", (string) $request->get("\164\157\x6b\x65\156")); goto Cb668; c7c7c: Ac6f0: goto aafc1; Dcf1c: return $response; goto c7c7c; e9cdc: $vhostTemplate = trim($request->get("\166\x68\157\163\x74\55\x74\145\155\x70\x6c\x61\x74\x65")); goto b7d3b; b4921: $site->setVhostTemplate($vhostTemplate); goto ad838; ae94d: B4f72: goto e9cdc; Bd76c: } private function handleVhostUpdate(Request $request, Site $site, SiteEntity $siteEntity, string $oldVhostTemplate) { try { goto cf878; d48db: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\164\145\x5f\x76\x68\157\x73\164", ["\x64\157\x6d\x61\151\156\x4e\141\155\145" => $domainName])); goto b432f; cbd4c: $siteEntity->setVhostTemplate($vhostTemplate); goto eaf3f; eaf3f: $this->siteEntityManager->updateEntity($siteEntity); goto A8f6d; F6ed8: throw new InvalidVhostException("\144\151\163\x61\142\154\x65\x5f\163\171\155\x6c\151\x6e\153\163\x20\x69\163\x20\x6e\x6f\164\40\x61\154\154\157\x77\x65\x64\x2e"); goto D6ad6; E4d9a: if (!(true === str_contains($site->getVhostTemplate(), "\144\x69\x73\x61\142\154\145\x5f\163\171\155\x6c\x69\x6e\153\163"))) { goto F1f0c; } goto F6ed8; d9b74: $siteUpdater->updateNginxVhostWithRollback(); goto cbd4c; B70f5: $siteUpdater = $this->getSiteUpdater($site); goto d9b74; d82e0: $vhostTemplate = $site->getVhostTemplate(); goto B70f5; a2921: $domainName = $site->getDomainName(); goto d82e0; a3234: $session = $request->getSession(); goto E4d9a; Facdf: $eventData = ["\x73\151\164\145" => $domainName, "\x76\x68\157\163\164" => $vhostTemplate, "\157\x6c\144\126\150\x6f\163\164" => $oldVhostTemplate]; goto b6267; b432f: return $response; goto A92ee; b6267: EventQueue::addEvent(EventQueue::EVENT_SITE_VHOST_UPDATE, $user, $eventData, $request); goto d48db; cf878: $user = $this->getUser(); goto a3234; D6ad6: F1f0c: goto a2921; A8f6d: $session->getFlashBag()->set("\163\x75\x63\x63\145\163\163", $this->translator->trans("\126\150\157\x73\x74\x20\x68\x61\163\40\142\x65\x65\156\40\x73\141\x76\x65\144\x2e")); goto Facdf; A92ee: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\144\x61\156\x67\145\162", $this->translator->trans("\x56\x68\157\x73\x74\40\151\163\x20\x6e\157\x74\40\x76\141\x6c\x69\144\x2c\x20\145\162\162\157\162\40\x6d\145\x73\x73\x61\147\x65\x3a\40\45\x65\x72\x72\x6f\162\x4d\145\163\x73\141\x67\145\45", ["\x25\x65\x72\x72\x6f\162\115\145\x73\x73\141\x67\145\x25" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\x65\162", $this->translator->trans("\x41\x6e\40\x65\x72\x72\x6f\x72\40\x68\141\163\x20\157\143\143\165\x72\x72\145\144\x2c\40\145\x72\162\157\x72\40\x6d\145\x73\x73\x61\147\x65\x3a\40\x25\x65\162\x72\157\x72\115\145\163\163\141\147\145\x25", ["\45\x65\x72\x72\x6f\x72\x4d\145\163\x73\x61\147\x65\x25" => $e->getMessage()])); } } public function settings(Request $request) : Response { goto fe2c7; a2e8e: return $response; goto d9842; b2da2: if (!(true === $pythonSettingsForm->isSubmitted())) { goto E60fe; } goto Ada25; De951: $currentNodeSettings = clone $nodejsSettings; goto cfc85; C201b: $parameters["\x66\x6f\162\x6d\105\x72\162\x6f\x72\163"] = $this->formErrors; goto D7f12; Bff57: $nodejsSettings = $site->getNodejsSettings(); goto A9e4d; Abe76: if (!(SiteEntity::TYPE_PYTHON == $site->getType())) { goto fc56d; } goto D87ed; Ef7cd: $response = null; goto ad93f; e0567: $parameters["\162\145\166\145\162\163\x65\x50\162\x6f\x78\171\x53\x65\x74\164\x69\x6e\x67\x73\x46\x6f\x72\155"] = $reverseProxySettingsForm->createView(); goto fcbb9; A36e7: c5457: goto Ea514; e9a90: if (!(false === is_null($response))) { goto C3a36; } goto Ca011; c647e: $pageSpeedSettingsForm = $this->createPageSpeedSettingsForm($site, $pageSpeedSettingsData); goto d0965; af862: D0c3a: goto a2e8e; d610b: $siteDeleteForm->handleRequest($request); goto Ed4d8; d4733: $parameters["\160\x68\x70\123\x65\164\164\x69\x6e\x67\x73\106\x6f\x72\x6d"] = $phpSettingsForm->createView(); goto Ee470; D87ed: $pythonSettings = $site->getPythonSettings(); goto A6986; D7f12: $response = $this->render("\106\x72\x6f\x6e\x74\145\156\144\x2f\x53\151\164\x65\x2f\x73\x65\x74\164\151\x6e\x67\163\x2e\150\x74\x6d\154\x2e\164\x77\x69\147", $parameters); goto af862; c6472: Df128: goto C201b; fea64: fc56d: goto a36c5; E5dd7: $siteUserSettingsForm = $this->createSiteUserSettingsForm($site, $siteUserSettingsData); goto c647e; bfdc0: b7b48: goto C6c92; ef119: D11b9: goto d1a7a; C382a: $parameters = ["\x73\x69\x74\x65" => $site, "\x64\157\155\x61\151\156\x53\x65\164\164\x69\x6e\x67\x73\106\x6f\162\155" => $domainSettingsForm->createView(), "\x73\x69\x74\145\125\x73\145\162\x53\x65\164\164\151\156\147\163\106\x6f\x72\155" => $siteUserSettingsForm->createView(), "\160\141\x67\x65\x53\160\145\145\144\123\145\164\x74\x69\x6e\x67\x73\106\157\162\155" => $pageSpeedSettingsForm->createView(), "\163\x69\164\145\104\145\154\x65\164\145\106\157\162\x6d" => $siteDeleteForm->createView()]; goto e8165; Adc32: $domainSettingsForm->handleRequest($request); goto c808a; f4cc4: fab37: goto d4733; aa1b9: goto D0c3a; goto de5e9; cf5b9: $parameters["\x70\171\x74\x68\157\156\x53\145\164\x74\151\156\x67\x73\106\157\162\x6d"] = $pythonSettingsForm->createView(); goto fea64; d4919: return $response; goto C41c7; cfc85: $nodejsSettingsForm->handleRequest($request); goto F16ad; E726a: $phpSettings = $site->getPhpSettings(); goto A3998; E9470: d4221: goto b97cb; eff76: $reverseProxySettingsForm->handleRequest($request); goto F03c5; Ea514: if (!(true === $siteDeleteForm->isSubmitted())) { goto d1408; } goto a12d9; Cec47: $pageSpeedSettingsData = ["\x69\163\x45\156\141\142\x6c\145\144" => $site->getPageSpeedEnabled(), "\163\x65\164\x74\151\156\147\x73" => $site->getPageSpeedSettings()]; goto fa36e; A3998: $phpSettingsForm = $this->createPhpSettingsForm($site, $phpSettings); goto d922f; Ee470: c3419: goto Abe76; fa36e: $domainSettingsForm = $this->createDomainSettingsForm($site, $domainSettingsData); goto E5dd7; c8501: $pythonSettingsForm->handleRequest($request); goto b2da2; d8af0: $siteDeleteData = ["\144\x6f\x6d\141\151\x6e\x4e\x61\x6d\145" => $site->getDomainName()]; goto Cec47; ad49b: $response = $this->handleSiteUserSettingsForm($request, $siteUserSettingsForm, $site); goto a6e7e; E6755: return $response; goto E9470; db9b1: if (!(true === $siteUserSettingsForm->isSubmitted())) { goto d35e8; } goto ad49b; c6275: if (!(false === is_null($response))) { goto b7b48; } goto Bc53f; E36e0: Fc02b: goto B2df9; a4349: $parameters["\x6e\x6f\144\x65\152\163\x53\145\x74\x74\151\x6e\x67\163\106\x6f\162\155"] = $nodejsSettingsForm->createView(); goto de0af; d922f: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto fab37; } goto A6e6d; A4c14: $reverseProxySettingsForm = $this->createReverseProxySettingsForm($site); goto f686c; Fc4da: d1408: goto Fd22d; f686c: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto C2991; } goto eff76; ad93f: if (!(true === $domainSettingsForm->isSubmitted())) { goto D9717; } goto e1e49; B2df9: if (!(SiteEntity::TYPE_PHP == $site->getType())) { goto c3419; } goto E726a; cc597: $siteUserSettingsData = ["\163\x69\164\x65\x55\x73\x65\162" => $site->getUser(), "\x73\x73\x68\x4b\x65\171\163" => $site->getSshKeys()]; goto d8af0; Bab6b: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\151\x74\145\163")); goto aa1b9; D9834: D9717: goto db9b1; fcbb9: unset($parameters["\x70\141\147\145\x53\x70\x65\x65\x64\x53\x65\164\x74\151\x6e\x67\x73\x46\x6f\x72\155"]); goto c6472; de5e9: fde7f: goto B47d7; B47d7: $domainSettingsData = ["\x64\157\155\x61\151\x6e\x4e\141\155\x65" => $site->getDomainName(), "\x72\x6f\x6f\164\x44\x69\162\x65\143\x74\x6f\162\x79" => $site->getRootDirectory()]; goto cc597; e1e49: $response = $this->handleDomainSettingsForm($request, $domainSettingsForm, $site); goto D9834; fc0a5: if (false === is_null($site)) { goto fde7f; } goto Bab6b; F5fa5: $phpSettingsForm->handleRequest($request); goto Fc46e; Fc46e: if (!(true === $phpSettingsForm->isSubmitted())) { goto C291c; } goto aa48a; aaa3b: if (!(true === $pageSpeedSettingsForm->isSubmitted())) { goto c5457; } goto F46f8; c808a: $siteUserSettingsForm->handleRequest($request); goto d610b; F03c5: if (!(true === $reverseProxySettingsForm->isSubmitted())) { goto D11b9; } goto f43fc; d1a7a: C2991: goto e0567; f9099: if (!(false === is_null($response))) { goto c02c9; } goto d4919; b70bd: C3a36: goto ae473; f43fc: $response = $this->handleReverseProxySettingsForm($request, $reverseProxySettingsForm, $site); goto f9099; Bc53f: return $response; goto bfdc0; fe2c7: $site = $this->getSite($request); goto fc0a5; Ca011: return $response; goto b70bd; de0af: unset($parameters["\160\x61\147\x65\123\x70\145\x65\x64\x53\145\164\164\151\156\x67\163\x46\157\162\155"]); goto E36e0; Bdcec: Bfa97: goto a4349; F16ad: if (!(true === $nodejsSettingsForm->isSubmitted())) { goto B9141; } goto Dedae; F46f8: $response = $this->handlePageSpeedSettingsForm($request, $pageSpeedSettingsForm, $site); goto A36e7; Ed4d8: $pageSpeedSettingsForm->handleRequest($request); goto Ef7cd; a6e7e: d35e8: goto aaa3b; C41c7: c02c9: goto ef119; Dcbe1: Ecfe9: goto cf5b9; Eedc6: if (!(true === $request->isMethod("\120\117\123\x54"))) { goto efd5a; } goto Adc32; C4422: Efae6: goto f8b94; f8b94: efd5a: goto C382a; C266d: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto Ecfe9; } goto c8501; Dedae: $response = $this->handleNodejsSettingsForm($request, $nodejsSettingsForm, $currentNodeSettings, $site); goto e9a90; C6c92: E60fe: goto Dcbe1; Fd22d: if (!(false === is_null($response))) { goto Efae6; } goto Ace20; fd9f4: if (!(false === is_null($response))) { goto d4221; } goto E6755; Ace20: return $response; goto C4422; a36c5: if (!(SiteEntity::TYPE_REVERSE_PROXY == $site->getType())) { goto Df128; } goto A4c14; A6e6d: $currentPhpSettings = clone $phpSettings; goto F5fa5; A6986: $pythonSettingsForm = $this->createPythonSettingsForm($site, $pythonSettings); goto C266d; A9e4d: $nodejsSettingsForm = $this->createNodejsSettingsForm($site, $nodejsSettings); goto B43c7; a12d9: $response = $this->handleSiteDeleteForm($request, $siteDeleteForm, $site); goto Fc4da; B43c7: if (!(true === $request->isMethod("\120\x4f\x53\x54"))) { goto Bfa97; } goto De951; d0965: $siteDeleteForm = $this->createSiteDeleteForm($site, $siteDeleteData); goto Eedc6; Ada25: $response = $this->handlePythonSettingsForm($request, $pythonSettingsForm, $site); goto c6275; ae473: B9141: goto Bdcec; e8165: if (!(SiteEntity::TYPE_NODEJS == $site->getType())) { goto Fc02b; } goto Bff57; aa48a: $response = $this->handlePhpSettingsForm($request, $phpSettingsForm, $currentPhpSettings, $site); goto fd9f4; b97cb: C291c: goto f4cc4; d9842: } public function purgePageSpeedCache(Request $request) : Response { goto Efd05; Ffd22: try { goto B0d27; C4174: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_CACHE_PURGE, $user, $eventData, $request); goto Fa793; ffc1f: $session = $request->getSession(); goto f4fc6; c4a65: $eventData = ["\x73\151\164\x65" => $site->getDomainName()]; goto C4174; f4fc6: $siteUpdater = $this->getSiteUpdater($site); goto A4805; A4805: $siteUpdater->purgePageSpeedCache(); goto c4a65; B0d27: $user = $this->getUser(); goto ffc1f; Fa793: $session->getFlashBag()->set("\163\165\x63\143\145\163\163", $this->translator->trans("\x50\x61\x67\x65\x20\123\x70\x65\x65\144\x20\103\x61\x63\150\145\x20\x68\x61\163\x20\x62\x65\x65\x6e\x20\x70\165\162\147\x65\x64\x2e")); goto c1e56; c1e56: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\162", $this->translator->trans("\101\x6e\40\145\162\x72\157\162\40\x68\x61\x73\40\157\x63\143\x75\x72\x72\145\x64\x2c\x20\145\x72\162\x6f\162\40\155\145\163\163\x61\147\x65\x3a\40\x25\145\162\162\x6f\x72\115\145\163\x73\141\x67\145\x25", ["\x25\x65\x72\162\x6f\162\x4d\145\x73\163\141\147\145\x25" => $e->getMessage()])); } goto ad30d; bc1d8: return $response; goto f79b5; D26c0: return $response; goto ea8ba; ad30d: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\x69\x74\x65\x5f\x73\145\x74\164\151\156\147\x73", ["\x64\157\155\x61\x69\x6e\116\141\x6d\x65" => $site->getDomainName()])); goto D26c0; ea8ba: A70a7: goto bc1d8; C311e: goto A70a7; goto c3f51; c3f51: f5414: goto Ffd22; Efd05: $site = $this->getSite($request); goto B56b9; b49c2: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\151\164\145\163")); goto C311e; B56b9: if (false === is_null($site)) { goto f5414; } goto b49c2; f79b5: } private function createDomainSettingsForm(Site $site, array $data) : Form { goto e1b56; E59ee: return $form; goto Ea6fe; e1b56: $form = $this->createForm("\101\160\160\x5c\106\x6f\x72\x6d\134\123\151\x74\145\x44\x6f\x6d\x61\x69\x6e\x53\x65\x74\164\151\x6e\x67\x73\124\171\x70\x65", $data, ["\141\143\x74\151\x6f\156" => $this->generateUrl("\x63\154\x70\137\163\151\164\x65\x5f\x73\145\164\x74\x69\156\147\163", ["\144\x6f\x6d\141\151\x6e\116\141\155\x65" => $site->getDomainName()]), "\155\x65\x74\x68\157\x64" => "\120\x4f\123\x54", "\141\164\164\162" => []]); goto d3950; d3950: $form->add("\x73\x75\142\155\151\164", SubmitType::class, ["\141\x74\x74\162" => ["\143\x6c\141\163\x73" => "\142\x74\156\x20\x62\164\x6e\x2d\142\154\x75\x65\x20\142\164\156\x2d\x6c\x67"], "\154\x61\142\145\154" => "\123\141\166\145"]); goto E59ee; Ea6fe: } private function createSiteUserSettingsForm(Site $site, array $data) : Form { goto F1a75; Eeeaf: $form->add("\x73\165\142\x6d\151\164", SubmitType::class, ["\141\x74\164\162" => ["\x63\154\141\x73\163" => "\142\x74\156\x20\142\x74\156\55\142\x6c\165\145\40\142\x74\x6e\55\154\147"], "\154\x61\x62\x65\x6c" => "\x53\141\166\145"]); goto Be5ac; F1a75: $form = $this->createForm("\101\x70\160\134\106\157\162\x6d\134\x53\x69\164\x65\125\163\145\162\x53\145\x74\x74\151\156\x67\163\x54\171\x70\x65", $data, ["\141\x63\x74\x69\x6f\156" => $this->generateUrl("\143\x6c\160\x5f\163\151\164\145\x5f\163\x65\164\x74\151\x6e\x67\x73", ["\x64\157\155\x61\151\x6e\116\141\155\x65" => $site->getDomainName()]), "\x6d\x65\164\150\157\144" => "\x50\117\x53\x54", "\x61\x74\164\x72" => []]); goto Eeeaf; Be5ac: return $form; goto f0e74; f0e74: } private function createPageSpeedSettingsForm(Site $site, array $data) : Form { goto D7581; D7581: $form = $this->createForm("\x41\160\x70\x5c\x46\x6f\x72\x6d\134\x53\151\164\145\120\141\x67\145\x53\x70\145\x65\x64\x53\x65\x74\x74\x69\156\x67\163\124\x79\160\x65", $data, ["\x61\x63\164\151\x6f\x6e" => $this->generateUrl("\x63\154\160\x5f\x73\x69\x74\x65\137\163\x65\164\164\151\156\147\x73", ["\x64\157\x6d\141\151\156\116\141\x6d\145" => $site->getDomainName()]), "\155\x65\164\150\x6f\x64" => "\120\x4f\x53\124", "\141\164\164\162" => []]); goto e61fa; e61fa: $form->add("\163\165\142\x6d\x69\x74", SubmitType::class, ["\x61\164\x74\162" => ["\x63\154\141\163\x73" => "\142\x74\x6e\40\x62\164\x6e\55\x62\x6c\x75\x65\x20\142\x74\x6e\55\x6c\x67"], "\x6c\141\142\x65\x6c" => "\x53\x61\x76\145"]); goto d60ec; d60ec: return $form; goto E981c; E981c: } private function createReverseProxySettingsForm(Site $site) : Form { goto B6e1f; b5f79: return $form; goto Bc7a6; b6924: $form = $this->createForm("\101\x70\x70\x5c\106\x6f\162\x6d\134\123\x69\164\x65\x52\145\166\x65\162\163\x65\x50\162\x6f\x78\x79\123\145\164\164\151\x6e\x67\x73\124\171\x70\145", $data, ["\141\143\x74\x69\157\156" => $this->generateUrl("\x63\154\160\137\163\x69\164\145\137\x73\145\x74\x74\x69\156\147\163", ["\144\157\155\x61\151\156\116\x61\x6d\x65" => $site->getDomainName()]), "\x6d\145\x74\x68\157\144" => "\x50\117\123\x54", "\x61\164\164\162" => ["\151\x64" => "\162\x65\x76\145\162\x73\145\55\160\x72\x6f\x78\171\55\163\145\x74\164\x69\156\147\x73\x2d\146\x6f\162\155"]]); goto B0b78; B0b78: $form->add("\x73\165\x62\x6d\x69\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\x61\163\163" => "\x62\164\156\40\142\164\156\x2d\142\154\x75\x65\40\x62\164\156\55\x6c\147"], "\x6c\141\x62\x65\x6c" => "\123\141\x76\145"]); goto b5f79; B6e1f: $data = ["\162\145\x76\145\162\163\145\x50\162\157\x78\171\125\x72\154" => $site->getReverseProxyUrl()]; goto b6924; Bc7a6: } private function createNodejsSettingsForm(Site $site, NodejsSettings $nodejsSettings) : Form { goto cb1d0; bd702: return $form; goto f4e0b; cb1d0: $form = $this->createForm("\101\x70\x70\134\106\157\162\x6d\x5c\123\x69\164\x65\x4e\157\144\x65\x6a\163\123\145\x74\164\x69\156\147\163\124\x79\160\145", $nodejsSettings, ["\x61\143\x74\151\157\156" => $this->generateUrl("\143\154\x70\137\x73\151\164\145\137\x73\145\x74\x74\151\156\x67\163", ["\144\x6f\x6d\x61\x69\x6e\116\141\155\x65" => $site->getDomainName()]), "\155\145\x74\x68\x6f\x64" => "\120\117\123\x54", "\x61\x74\164\162" => ["\x69\144" => "\x6e\x6f\144\x65\152\163\55\x73\x65\x74\164\x69\156\147\x73\x2d\146\x6f\x72\155"]]); goto e7087; e7087: $form->add("\x73\x75\x62\155\x69\x74", SubmitType::class, ["\x61\164\164\x72" => ["\x63\x6c\141\163\x73" => "\x62\164\156\40\142\x74\156\x2d\142\x6c\x75\145\40\x62\x74\156\x2d\x6c\147"], "\x6c\x61\x62\x65\154" => "\123\141\166\x65"]); goto bd702; f4e0b: } private function createPhpSettingsForm(Site $site, PhpSettings $phpSettings) : Form { goto E83a4; Ed655: return $form; goto a1863; E83a4: $form = $this->createForm("\x41\160\160\134\x46\157\162\x6d\134\x53\151\164\145\x50\x68\160\123\145\164\164\x69\x6e\147\x73\x54\x79\x70\145", $phpSettings, ["\141\143\164\151\x6f\x6e" => $this->generateUrl("\143\x6c\160\x5f\163\x69\x74\145\x5f\163\x65\x74\x74\x69\x6e\x67\163", ["\x64\157\x6d\x61\x69\156\116\x61\x6d\145" => $site->getDomainName()]), "\x6d\145\x74\x68\157\144" => "\120\x4f\123\x54", "\141\164\x74\x72" => []]); goto e1346; e1346: $form->add("\x73\x75\142\x6d\151\164", SubmitType::class, ["\x61\164\x74\162" => ["\x63\154\141\x73\x73" => "\x62\164\156\40\x62\164\156\x2d\142\154\x75\145\40\x62\x74\156\55\x6c\x67"], "\x6c\141\x62\145\x6c" => "\x53\x61\x76\145"]); goto Ed655; a1863: } private function createPythonSettingsForm(Site $site, PythonSettings $pythonSettings) : Form { goto ed8c7; e775f: $form->add("\x73\x75\142\x6d\151\x74", SubmitType::class, ["\141\x74\x74\x72" => ["\x63\154\x61\x73\x73" => "\x62\x74\156\x20\142\x74\156\55\x62\x6c\165\145\x20\142\x74\156\55\154\x67"], "\x6c\x61\142\145\x6c" => "\123\141\166\x65"]); goto C6c65; ed8c7: $form = $this->createForm("\x41\160\x70\134\106\x6f\162\x6d\134\123\x69\164\x65\x50\171\x74\x68\x6f\156\123\x65\x74\x74\151\x6e\147\x73\124\171\x70\145", $pythonSettings, ["\141\143\164\151\x6f\x6e" => $this->generateUrl("\143\x6c\x70\137\x73\151\x74\x65\x5f\x73\x65\164\x74\151\x6e\x67\163", ["\144\x6f\155\x61\x69\156\x4e\141\x6d\145" => $site->getDomainName()]), "\155\x65\x74\150\157\x64" => "\x50\x4f\x53\124", "\141\164\x74\162" => []]); goto e775f; C6c65: return $form; goto C5126; C5126: } private function createSiteDeleteForm(Site $site, array $data) : Form { goto Ab5ed; Bb335: return $form; goto a50c4; f7152: $form->add("\x73\x75\x62\x6d\151\164", SubmitType::class, ["\x61\x74\164\162" => ["\143\x6c\x61\x73\163" => "\142\x74\x6e\x20\142\164\x6e\55\142\154\165\145\40\142\164\156\x2d\154\147", "\x64\151\x73\x61\142\x6c\x65\x64" => "\144\151\163\x61\142\154\x65\144"], "\154\x61\x62\x65\154" => "\x44\145\x6c\145\164\145\40\123\151\x74\145"]); goto Bb335; Ab5ed: $form = $this->createForm("\x41\x70\x70\x5c\x46\x6f\162\155\134\x53\151\164\145\104\145\154\145\164\x65\124\171\160\145", $data, ["\141\x63\164\x69\x6f\x6e" => $this->generateUrl("\143\154\x70\x5f\x73\x69\164\145\137\163\x65\x74\164\x69\x6e\147\x73", ["\144\x6f\x6d\141\151\x6e\116\x61\155\x65" => $site->getDomainName()]), "\155\145\164\150\x6f\x64" => "\x50\x4f\x53\x54", "\141\164\164\x72" => []]); goto f7152; a50c4: } private function handleDomainSettingsForm(Request $request, Form $form, Site $site) { goto Ca3b0; C591b: $this->formErrors = $this->getErrorMessages($form); goto c7353; eee30: try { goto F56a4; d194b: $siteEntity = $this->getSiteEntity($domainName); goto b9ad5; F56a4: $user = $this->getUser(); goto C1cc5; b9ad5: if (!(false === is_null($siteEntity))) { goto Ef95f; } goto facab; efa2b: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\151\164\x65\x5f\163\x65\x74\164\151\156\x67\163", ["\144\x6f\x6d\x61\151\x6e\116\x61\155\145" => $site->getDomainName()])); goto bf1a7; d2f08: $this->siteEntityManager->updateEntity($siteEntity); goto f6a19; ddc8f: EventQueue::addEvent(EventQueue::EVENT_SITE_ROOT_DIRECTORY_UPDATE, $user, $eventData, $request); goto d7d9c; ec1bc: $eventData = ["\x73\151\x74\145" => $domainName, "\x72\x6f\x6f\x74\x44\151\x72\145\x63\x74\x6f\x72\171" => $rootDirectory]; goto ddc8f; A22cb: $siteEntity->setRootDirectory($rootDirectory); goto d2f08; facab: $rootDirectory = rtrim($form->get("\162\x6f\157\164\104\x69\162\x65\x63\164\x6f\x72\x79")->getData(), "\x2f"); goto C6b86; bf1a7: return $response; goto C3aa9; C1cc5: $session = $request->getSession(); goto ace18; f6a19: $siteUpdater = $this->getSiteUpdater($site); goto F7258; F7258: $siteUpdater->domainSettings(); goto ec1bc; C6b86: $site->setRootDirectory($rootDirectory); goto A22cb; Ab176: Ef95f: goto efa2b; d7d9c: $session->getFlashBag()->set("\163\x75\143\x63\145\x73\x73", $this->translator->trans("\x52\157\157\x74\40\x44\x69\x72\145\x63\x74\x6f\162\171\40\150\x61\x73\x20\142\x65\x65\x6e\40\163\x61\x76\x65\144\x2e")); goto Ab176; ace18: $domainName = $site->getDomainName(); goto d194b; C3aa9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\145\x72", $this->translator->trans("\101\156\x20\x65\x72\162\157\x72\x20\150\141\x73\x20\157\x63\143\x75\x72\x72\x65\144\54\x20\145\x72\x72\x6f\x72\40\x6d\x65\163\x73\x61\x67\145\72\x20\45\x65\162\162\x6f\x72\x4d\x65\163\163\141\147\145\x25", ["\x25\145\x72\x72\157\162\115\145\163\163\x61\147\x65\x25" => $e->getMessage()])); } goto a1b43; a1b43: f4af4: goto ca900; c7353: goto f4af4; goto Ea5a2; Ea5a2: ff36b: goto eee30; Ca3b0: if (true === $form->isValid()) { goto ff36b; } goto C591b; ca900: } private function handleSiteUserSettingsForm(Request $request, Form $form, Site $site) { goto C7def; Cc657: Ec391: goto Fc8c5; C7def: if (true === $form->isValid()) { goto Ec391; } goto A1bd2; e9ecf: goto e8754; goto Cc657; A1bd2: $this->formErrors = $this->getErrorMessages($form); goto e9ecf; Fc3a1: e8754: goto ff46c; Fc8c5: try { goto d4f3f; C9912: $siteUser = $site->getUser(); goto E307d; E307d: $sshKeys = trim($form->get("\x73\x73\150\113\x65\171\163")->getData()); goto A589f; Cd3b5: $eventData = ["\x73\x69\x74\x65" => $domainName, "\x73\163\x68\x4b\145\x79\x73" => $sshKeys]; goto E09f8; c4fef: $siteEntity->setSshKeys($sshKeys); goto A3a3d; A91df: $domainName = $site->getDomainName(); goto f89e0; Bbc77: d850c: goto Cd3b5; E09f8: EventQueue::addEvent(EventQueue::EVENT_SITE_USER_SETTINGS_UPDATE, $user, $eventData, $request); goto c9593; D34bd: $siteUpdater->updateUserSShKeys($siteUser, $sshKeys); goto C2059; d4f3f: $user = $this->getUser(); goto Cbf9b; C2059: if (!(false === empty($password))) { goto d850c; } goto cff23; cff23: $siteUpdater->changeUserPassword($siteUser, $password); goto Bbc77; b83b1: $siteUpdater = $this->getSiteUpdater($site); goto D34bd; f89e0: $siteEntity = $this->getSiteEntity($domainName); goto f6caa; e3669: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\x74\x65\137\163\x65\x74\x74\x69\156\147\163", ["\x64\157\155\x61\151\x6e\116\x61\x6d\145" => $site->getDomainName()])); goto f3c66; A3a3d: $this->siteEntityManager->updateEntity($siteEntity); goto b83b1; f6caa: if (!(false === is_null($siteEntity))) { goto Decab; } goto C9912; Cbf9b: $session = $request->getSession(); goto A91df; Dc208: Decab: goto e3669; f3c66: return $response; goto C2a54; c9593: $session->getFlashBag()->set("\163\165\x63\143\x65\x73\x73", $this->translator->trans("\123\151\164\145\40\125\x73\x65\162\x20\123\145\164\x74\151\x6e\147\163\40\150\141\166\x65\x20\142\x65\x65\156\x20\163\x61\166\145\144\56")); goto Dc208; A589f: $password = trim($form->get("\160\141\163\x73\x77\157\x72\x64")->getData()); goto c4fef; C2a54: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\x41\156\x20\145\x72\162\157\162\x20\x68\x61\163\x20\157\x63\143\165\x72\x72\x65\x64\54\x20\x65\x72\x72\x6f\162\40\x6d\x65\x73\163\141\147\145\72\x20\45\x65\x72\x72\157\x72\x4d\145\x73\163\x61\x67\x65\45", ["\x25\x65\x72\x72\157\162\x4d\145\163\x73\141\147\x65\45" => $e->getMessage()])); } goto Fc3a1; ff46c: } private function handlePageSpeedSettingsForm(Request $request, Form $form, Site $site) { goto d9784; Cbe99: goto db206; goto d4c69; Ba738: db206: goto F4bb7; d9784: if (true === $form->isValid()) { goto C9d8d; } goto cae0b; c496b: try { goto F0460; cc5c3: $session->getFlashBag()->set("\x73\165\x63\143\145\163\163", $this->translator->trans("\x50\x61\x67\x65\40\x53\x70\145\145\144\40\123\145\x74\164\x69\x6e\x67\x73\40\150\141\166\145\x20\142\x65\x65\156\x20\x73\x61\x76\x65\144\x2e")); goto F0e6d; F9d87: $domainName = $site->getDomainName(); goto F6fbd; b89c8: $isEnabled = $form->get("\x69\x73\105\156\x61\x62\x6c\x65\144")->getData(); goto b1c09; b1c09: $settings = trim($form->get("\x73\145\x74\164\x69\x6e\x67\163")->getData()); goto cb8cf; F0460: $user = $this->getUser(); goto Db6fd; e1213: $siteUpdater = $this->getSiteUpdater($site); goto feee4; feee4: $siteUpdater->updateNginxVhostWithRollback(); goto a9a4c; Db619: $siteEntity->setPageSpeedSettings($settings); goto e3c70; e3c70: $this->siteEntityManager->updateEntity($siteEntity); goto fceb7; d5fc1: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_SETTINGS_UPDATE, $user, $eventData, $request); goto cc5c3; Db6fd: $session = $request->getSession(); goto F9d87; E2c6c: $siteEntity->setPageSpeedEnabled($isEnabled); goto Db619; d4f86: $site->setPageSpeedSettings($settings); goto e1213; d5f67: return $response; goto Ad452; fceb7: $eventData = ["\163\151\164\145" => $domainName, "\x70\141\x67\x65\x53\160\x65\145\144\x45\x6e\141\x62\154\x65\x64" => $isEnabled, "\160\x61\147\145\x53\x70\x65\145\144\x53\x65\164\164\151\156\x67\x73" => $settings]; goto d5fc1; F0970: if (!(false === is_null($siteEntity))) { goto F88e8; } goto b89c8; F6fbd: $siteEntity = $this->getSiteEntity($domainName); goto F0970; E477a: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\164\145\x5f\x73\x65\164\164\x69\156\147\x73", ["\144\157\155\141\x69\156\116\141\x6d\145" => $site->getDomainName()])); goto d5f67; F0e6d: F88e8: goto E477a; cb8cf: $site->setPageSpeedEnabled($isEnabled); goto d4f86; a9a4c: $siteUpdater->purgePageSpeedCache(); goto E2c6c; Ad452: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\x64\x61\156\x67\145\x72", $this->translator->trans("\120\141\x67\x65\123\160\145\x65\144\40\x53\x65\x74\164\151\x6e\x67\x20\x61\x72\145\x20\156\157\164\40\x76\141\x6c\x69\144\54\x20\x65\x72\162\157\x72\x20\155\x65\163\x73\141\x67\145\72\40\45\145\x72\162\157\x72\x4d\x65\163\163\141\147\x65\x25", ["\45\x65\x72\162\157\x72\x4d\x65\x73\163\x61\x67\145\45" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\x72", $this->translator->trans("\x41\x6e\40\145\x72\162\x6f\162\40\x68\141\163\x20\x6f\x63\x63\x75\162\162\145\144\54\40\x65\x72\162\x6f\162\x20\155\145\163\x73\x61\147\x65\72\40\45\145\162\x72\157\162\115\145\163\163\x61\x67\145\x25", ["\45\145\162\x72\x6f\x72\x4d\x65\163\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto Ba738; d4c69: C9d8d: goto c496b; cae0b: $this->formErrors = $this->getErrorMessages($form); goto Cbe99; F4bb7: } private function handleSiteDeleteForm(Request $request, Form $form, Site $site) { goto Eaad2; F9140: goto E184d; goto Ca972; Efbf5: try { goto E2da5; b33fd: $this->siteEntityManager->deleteEntity($siteEntity); goto ce5d6; Efa36: $siteEntity = $this->getSiteEntity($domainName); goto D1010; dcdd3: $session->getFlashBag()->set("\163\165\x63\x63\x65\163\x73", $this->translator->trans("\x53\x69\x74\x65\40\150\x61\163\x20\x62\145\x65\156\x20\144\145\x6c\145\164\145\x64\56")); goto A8814; ce5d6: $eventData = ["\x73\151\164\x65" => $domainName, "\x74\x79\160\x65" => $site->getType()]; goto B936f; E2da5: $user = $this->getUser(); goto f2b24; A8814: ccfec: goto a14f6; df4fb: $siteDeleter->delete(); goto b33fd; a14f6: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\x73\x69\164\x65\x73")); goto E1ea1; E1ea1: return $response; goto fbfb7; c93c9: $siteDeleter = $this->getSiteDeleter($site); goto df4fb; D1010: if (!(false === is_null($siteEntity))) { goto ccfec; } goto c93c9; Fd165: $domainName = $site->getDomainName(); goto Efa36; B936f: EventQueue::addEvent(EventQueue::EVENT_SITE_DELETE, $user, $eventData, $request); goto dcdd3; f2b24: $session = $request->getSession(); goto Fd165; fbfb7: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\145\162", $this->translator->trans("\x41\156\40\x65\x72\x72\x6f\x72\x20\150\x61\x73\40\x6f\143\143\x75\162\162\x65\144\54\x20\x65\162\x72\x6f\162\40\155\x65\x73\163\x61\147\x65\72\40\x25\145\162\162\x6f\x72\115\x65\x73\x73\x61\x67\145\x25", ["\x25\145\x72\162\x6f\x72\115\x65\163\163\141\147\x65\x25" => $e->getMessage()])); } goto eed79; Ca972: d91a4: goto Efbf5; Eaad2: if (true === $form->isValid()) { goto d91a4; } goto f836d; eed79: E184d: goto e1ef3; f836d: $this->formErrors = $this->getErrorMessages($form); goto F9140; e1ef3: } private function handleNodejsSettingsForm(Request $request, Form $form, NodejsSettings $currentNodejsSettings, Site $site) { goto b7394; a4c38: goto Cd86c; goto fa51e; eeec4: try { goto bd7ec; Bccda: $hasNodejsVersionChanged = $currentNodejsSettings->getNodejsVersion() != $nodejsVersion; goto C66c7; D1733: $siteEntity = $this->getSiteEntity($domainName); goto bc810; A92a8: $nodejsSettings = $form->getData(); goto f144b; a254b: $siteUpdater->installNodejsVersion(); goto C8ed7; B0383: EventQueue::addEvent(EventQueue::EVENT_SITE_NODEJS_SETTINGS_UPDATE, $user, $eventData, $request); goto f3a64; C8ed7: Fa81d: goto f83eb; Ccb09: ccab3: goto a01bf; bd7ec: $user = $this->getUser(); goto D2e61; f144b: $nodejsVersion = $nodejsSettings->getNodejsVersion(); goto Bccda; bc810: if (!(false === is_null($siteEntity))) { goto ccab3; } goto A92a8; a14c1: if (!(true === $hasNodejsVersionChanged)) { goto Fa81d; } goto a254b; f3a64: $session->getFlashBag()->set("\163\x75\x63\143\145\x73\x73", $this->translator->trans("\x4e\x6f\144\x65\56\152\163\40\123\x65\x74\x74\x69\x6e\x67\x73\x20\x68\x61\166\x65\x20\x62\x65\145\x6e\x20\163\x61\x76\x65\144\x2e")); goto Ccb09; A4b6c: $eventData = ["\x73\151\x74\145" => $domainName, "\156\x6f\x64\x65\152\x73\126\145\x72\163\x69\x6f\x6e" => $nodejsVersion, "\160\157\x72\164" => $nodejsSettings->getPort()]; goto B0383; C66c7: $siteUpdater = $this->getSiteUpdater($site); goto a14c1; B4fc5: $domainName = $site->getDomainName(); goto D1733; f83eb: $siteUpdater->nodejsSettings(); goto cf871; C0c5c: return $response; goto f8cf0; cf871: $this->siteEntityManager->updateEntity($siteEntity); goto A4b6c; a01bf: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\x74\145\x5f\163\x65\x74\164\151\156\x67\x73", ["\x64\x6f\x6d\141\x69\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto C0c5c; D2e61: $session = $request->getSession(); goto B4fc5; f8cf0: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\145\x72", $this->translator->trans("\101\x6e\x20\x65\162\x72\x6f\x72\40\150\141\x73\40\x6f\x63\143\165\162\162\x65\144\54\40\145\x72\x72\157\x72\x20\155\145\163\x73\141\x67\x65\72\40\x25\145\x72\x72\x6f\x72\115\145\163\163\x61\x67\145\45", ["\45\145\x72\x72\157\162\x4d\x65\x73\163\x61\x67\x65\x25" => $e->getMessage()])); } goto f0d30; Dee23: $this->formErrors = $this->getErrorMessages($form); goto a4c38; fa51e: A75ad: goto eeec4; b7394: if (true === $form->isValid()) { goto A75ad; } goto Dee23; f0d30: Cd86c: goto b42d7; b42d7: } private function handlePythonSettingsForm(Request $request, Form $form, Site $site) { goto cbd87; cbd87: if (true === $form->isValid()) { goto C9462; } goto A253a; A7440: try { goto F8d57; Ff9c6: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\x69\x74\x65\x5f\x73\145\x74\164\x69\x6e\147\x73", ["\144\157\155\x61\151\x6e\x4e\x61\x6d\x65" => $site->getDomainName()])); goto d3331; d3331: return $response; goto e49a2; d6ed7: $siteUpdater->pythonSettings(); goto Af51a; b2809: $siteEntity = $this->getSiteEntity($domainName); goto Ca0a9; B3140: $eventData = ["\163\151\164\x65" => $domainName, "\160\x79\164\150\157\156\126\145\162\x73\151\x6f\x6e" => $pythonVersion, "\160\157\x72\164" => $pythonSettings->getPort()]; goto Fa715; f9c8d: $siteUpdater = $this->getSiteUpdater($site); goto F0f80; F0f80: $siteUpdater->writePythonVersionFile(); goto d6ed7; Fa715: EventQueue::addEvent(EventQueue::EVENT_SITE_PYTHON_SETTINGS_UPDATE, $user, $eventData, $request); goto e1103; b5469: $pythonSettings = $form->getData(); goto c6b6c; Ca0a9: if (!(false === is_null($siteEntity))) { goto b1c37; } goto b5469; c4639: b1c37: goto Ff9c6; Af51a: $this->siteEntityManager->updateEntity($siteEntity); goto B3140; e1103: $session->getFlashBag()->set("\163\165\143\143\145\163\163", $this->translator->trans("\x50\x79\164\150\x6f\x6e\x20\x53\145\164\164\151\156\147\163\40\x68\141\x76\x65\x20\x62\145\145\x6e\x20\163\141\166\145\144\56")); goto c4639; F8d57: $user = $this->getUser(); goto eb1a4; F10fd: $domainName = $site->getDomainName(); goto b2809; c6b6c: $pythonVersion = $pythonSettings->getPythonVersion(); goto f9c8d; eb1a4: $session = $request->getSession(); goto F10fd; e49a2: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\145\162", $this->translator->trans("\101\x6e\40\x65\x72\x72\157\162\40\150\x61\163\x20\157\x63\x63\x75\162\162\145\144\x2c\40\x65\162\162\157\162\x20\x6d\145\x73\x73\141\x67\x65\72\40\x25\145\x72\162\157\162\x4d\145\x73\163\141\x67\145\45", ["\45\x65\162\162\157\x72\115\145\x73\x73\x61\x67\145\x25" => $e->getMessage()])); } goto Cc8d3; F4220: goto e51f8; goto D415d; Cc8d3: e51f8: goto B79a8; A253a: $this->formErrors = $this->getErrorMessages($form); goto F4220; D415d: C9462: goto A7440; B79a8: } private function handleReverseProxySettingsForm(Request $request, Form $form, Site $site) { goto b5059; Df68f: B84a0: goto fd1be; Ac13e: ad915: goto B7455; fda4d: $this->formErrors = $this->getErrorMessages($form); goto E46bf; E46bf: goto B84a0; goto Ac13e; b5059: if (true === $form->isValid()) { goto ad915; } goto fda4d; B7455: try { goto c3ffb; F89b1: a2993: goto fc0e7; fc0e7: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\x74\x65\137\x73\145\x74\164\x69\x6e\x67\163", ["\x64\157\155\141\151\156\116\x61\155\145" => $site->getDomainName()])); goto d1291; daa0c: EventQueue::addEvent(EventQueue::EVENT_SITE_REVERSE_PROXY_SETTINGS_UPDATE, $user, $eventData, $request); goto D517c; D517c: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\163", $this->translator->trans("\122\x65\166\x65\x72\163\x65\x20\120\x72\x6f\170\171\40\123\x65\x74\x74\x69\x6e\x67\x73\40\x68\x61\x76\x65\x20\x62\145\145\x6e\x20\x73\x61\x76\145\144\x2e")); goto F89b1; b8900: $siteUpdater->updateNginxVhostWithRollback(); goto e84e2; e84e2: $this->siteEntityManager->updateEntity($siteEntity); goto eb721; fdc3d: $siteUpdater = $this->getSiteUpdater($site); goto b8900; cb6e1: $domainName = $site->getDomainName(); goto dc17f; c3ffb: $user = $this->getUser(); goto daf90; b9db6: $reverseProxyUrl = $form->get("\162\x65\166\x65\x72\163\x65\120\162\157\x78\171\125\x72\x6c")->getData(); goto b5bf0; b5bf0: $site->setReverseProxyUrl($reverseProxyUrl); goto C8afb; eb721: $eventData = ["\163\151\164\x65" => $domainName, "\162\145\x76\x65\x72\163\x65\x50\x72\x6f\x78\x79\x55\x72\x6c" => $reverseProxyUrl]; goto daa0c; C8afb: $siteEntity->setReverseProxyUrl($reverseProxyUrl); goto fdc3d; daf90: $session = $request->getSession(); goto cb6e1; dc17f: $siteEntity = $this->getSiteEntity($domainName); goto a233e; a233e: if (!(false === is_null($siteEntity))) { goto a2993; } goto b9db6; d1291: return $response; goto D70c3; D70c3: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\x65\162", $this->translator->trans("\x41\156\40\145\x72\162\x6f\x72\x20\150\141\x73\40\x6f\143\143\165\x72\162\x65\144\x2c\40\145\x72\162\157\162\x20\155\x65\x73\163\x61\147\145\72\40\x25\145\x72\x72\157\x72\115\145\x73\163\x61\147\x65\45", ["\45\145\x72\x72\157\162\115\145\163\163\x61\147\145\x25" => $e->getMessage()])); } goto Df68f; fd1be: } private function handlePhpSettingsForm(Request $request, Form $form, PhpSettings $currentPhpSettings, Site $site) { goto E7d46; c204e: Fc220: goto Bec92; E7d46: if (true === $form->isValid()) { goto e9700; } goto c7196; bae77: try { goto Be798; fc945: $session->getFlashBag()->set("\x73\x75\x63\x63\145\163\x73", $this->translator->trans("\120\x48\120\x20\x53\x65\164\x74\x69\156\147\x73\x20\150\141\166\145\x20\142\x65\145\156\x20\x73\141\x76\145\144\x2e")); goto bc5a0; Be798: $user = $this->getUser(); goto db7ee; d2503: return $response; goto F4f13; c29f0: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\x74\145\x5f\163\x65\x74\164\x69\156\147\163", ["\144\x6f\155\x61\x69\x6e\x4e\141\155\x65" => $site->getDomainName()])); goto d2503; cad48: $siteUpdater = $this->getSiteUpdater($site); goto cab2b; Ac559: $eventData = ["\x73\151\x74\145" => $domainName, "\160\150\x70\126\145\162\x73\x69\x6f\156" => $phpSettings->getPhpVersion(), "\155\x65\x6d\x6f\162\171\x5f\154\x69\x6d\151\x74" => $phpSettings->getMemoryLimit(), "\x6d\141\170\x5f\x65\170\x65\143\x75\164\151\x6f\x6e\x5f\164\x69\x6d\x65" => $phpSettings->getMaxExecutionTime(), "\155\x61\x78\137\x69\x6e\160\x75\164\137\164\151\155\145" => $phpSettings->getMaxInputTime(), "\x6d\141\x78\x5f\x69\x6e\x70\165\164\137\x76\141\x72\x73" => $phpSettings->getMaxInputVars(), "\160\157\x73\x74\x5f\x6d\141\170\137\x73\x69\172\x65" => $phpSettings->getPostMaxSize(), "\x75\x70\x6c\x6f\x61\x64\x5f\155\x61\170\137\x66\x69\154\145\x73\151\172\145" => $phpSettings->getUploadMaxFileSize()]; goto a9fcb; bc5a0: c0e74: goto c29f0; b6244: $phpSettings = $form->getData(); goto B2dd1; e4fb1: Adbfe: goto eac4c; aaacc: $this->siteEntityManager->updateEntity($siteEntity); goto Ac559; B2dd1: $hasPhpVersionChanged = $currentPhpSettings->getPhpVersion() != $phpSettings->getPhpVersion(); goto cad48; e3148: $domainName = $site->getDomainName(); goto A1022; A1022: $siteEntity = $this->getSiteEntity($domainName); goto e8b71; C4154: $siteUpdater->changePhpVersion($currentPhpSettings->getPhpVersion(), $phpSettings->getPhpVersion()); goto e4fb1; cab2b: if (!(true === $hasPhpVersionChanged)) { goto Adbfe; } goto C4154; e8b71: if (!(false === is_null($siteEntity))) { goto c0e74; } goto b6244; db7ee: $session = $request->getSession(); goto e3148; eac4c: $siteUpdater->phpSettings(); goto aaacc; a9fcb: EventQueue::addEvent(EventQueue::EVENT_SITE_PHP_SETTINGS_UPDATE, $user, $eventData, $request); goto fc945; F4f13: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\x65\162", $this->translator->trans("\101\x6e\x20\x65\162\162\x6f\x72\40\x68\141\163\40\x6f\x63\x63\165\x72\x72\145\144\54\40\x65\162\162\x6f\162\x20\x6d\145\x73\163\141\147\x65\72\x20\x25\145\162\x72\x6f\162\x4d\x65\163\163\141\147\x65\45", ["\x25\x65\x72\x72\x6f\162\115\x65\163\x73\x61\147\145\x25" => $e->getMessage()])); } goto c204e; c7196: $this->formErrors = $this->getErrorMessages($form); goto ee36e; Eadb6: e9700: goto bae77; ee36e: goto Fc220; goto Eadb6; Bec92: } private function getSite(Request $request) : ?Site { goto e2f93; Fe17e: $site->setDatabases($siteDatabases); goto E78a2; Feeb6: return $site; goto d451d; B9828: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto C09b7; fd20b: $subdomain = false === empty($subdomain) ? $subdomain : null; goto Adce3; A4cbf: if (!(false === is_null($siteEntity))) { goto a44fe; } goto Cadf4; bcb28: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto B9828; Adce3: $siteDatabases = $this->getSiteDatabases($siteEntity); goto Bb2cf; F8b64: $site->setRootDirectory($siteEntity->getRootDirectory()); goto Ddfcf; A170e: $siteEntity = $this->getSiteEntity($domainName); goto e92b4; E78a2: $site->setCertificate($siteEntity->getCertificate()); goto bf460; Aee04: if (!(false === is_null($site))) { goto a83a4; } goto faa04; C9fdd: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto Adcd0; d9449: goto dcf22; goto F17a5; Adcd0: $site = new NodejsSite(); goto Efb32; Efb32: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto d9449; F17a5: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto dcf22; case SiteEntity::TYPE_PHP: goto e9b1f; C6637: $site->setVarnishCache($siteEntity->getVarnishCache()); goto b5675; e9b1f: $site = new PhpSite(); goto Deb9f; b5675: goto dcf22; goto Ebf87; Deb9f: $site->setPhpSettings($siteEntity->getPhpSettings()); goto C6637; Ebf87: case SiteEntity::TYPE_PYTHON: goto ee078; f3502: $site->setPythonSettings($siteEntity->getPythonSettings()); goto Bdfa3; ee078: $site = new PythonSite(); goto f3502; Bdfa3: goto dcf22; goto C2003; C2003: case SiteEntity::TYPE_REVERSE_PROXY: goto B4b77; Bd289: $site->setReverseProxyUrl($siteEntity->getReverseProxyUrl()); goto bd5fc; bd5fc: goto dcf22; goto b9ed2; B4b77: $site = new ReverseProxySite(); goto Bd289; b9ed2: } goto B9d97; F9898: $site->setSshKeys($siteEntity->getSshKeys()); goto bcb28; D6911: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto e6f66; Bb2cf: $site->setUser($siteEntity->getUser()); goto d85c9; F3149: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto cd383; aefdc: $site->setCronJobs($siteEntity->getCronJobs()); goto D4bdd; Cadf4: if (!(UserEntity::ROLE_USER == $user->getRole() && false === $user->hasSite($siteEntity))) { goto b4fc8; } goto D7cb6; e92b4: $site = null; goto A4cbf; d8917: b4fc8: goto d7cad; e2f93: $user = $this->getUser(); goto Adecd; d7cad: $siteType = $siteEntity->getType(); goto C9fdd; Ddfcf: $site->setBasicAuth($siteEntity->getBasicAuth()); goto b6f47; C9920: $site->setSshUsers($siteEntity->getSshUsers()); goto F9898; b6f47: $site->setBlockedBots($siteEntity->getBlockedBots()); goto f44c2; faa04: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto F3149; B9d97: bbcaf: goto aa2ee; C09b7: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto D6911; bf460: $site->setCertificates($siteEntity->getCertificates()); goto aefdc; cd383: $subdomain = $resolvedDomainName->subDomain()->toString(); goto fd20b; aa697: a44fe: goto Feeb6; d85c9: $site->setDomainName($siteEntity->getDomainName()); goto B589a; Ff65f: $site->setSubdomain($subdomain); goto F8b64; f44c2: $site->setBlockedIps($siteEntity->getBlockedIps()); goto Fe17e; e6f66: a83a4: goto aa697; D7cb6: return null; goto d8917; D4bdd: $site->setFtpUsers($siteEntity->getFtpUsers()); goto C9920; aa2ee: dcf22: goto Aee04; B589a: $site->setRegistrableDomain($registrableDomain); goto Ff65f; Adecd: $domainName = $request->get("\144\157\155\141\151\x6e\x4e\141\x6d\145"); goto A170e; d451d: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto C805a; f53b3: foreach ($databaseEntities as $databaseEntity) { goto a4b7c; a4b7c: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto Db66d; E5116: F98c2: goto B0e49; e50c7: $siteDatabases->add($databaseEntity); goto E5116; B0e49: b5bf7: goto c2d50; Db66d: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto F98c2; } goto e50c7; c2d50: } goto e6c0d; d7148: return $siteDatabases; goto F83a1; b6e75: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Cbfdb; e6c0d: b458b: goto d7148; C805a: $siteDatabases = new ArrayCollection(); goto b6e75; Cbfdb: $databaseEntities = $siteEntity->getDatabases(); goto f53b3; F83a1: } private function getSiteUpdater(Site $site) : ?SiteUpdater { goto C7a24; D1483: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto C3198; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto C3198; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto C3198; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto C3198; case SiteEntity::TYPE_REVERSE_PROXY: $siteUpdater = new ReverseProxySiteUpdater($site); goto C3198; } goto fdd00; c3f26: return $siteUpdater; goto c6bf4; fdd00: C58f9: goto A39cc; C7a24: $siteUpdater = null; goto c7e18; A39cc: C3198: goto c3f26; c7e18: $siteType = $site->getType(); goto D1483; c6bf4: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto f2147; F61be: $siteType = $site->getType(); goto a14b8; Ff1dd: Ffd66: goto db2e8; a14b8: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto C75a7; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto C75a7; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto C75a7; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto C75a7; case SiteEntity::TYPE_REVERSE_PROXY: $siteDeleter = new ReverseProxySiteDeleter($site); goto C75a7; } goto Ff1dd; db2e8: C75a7: goto d6c2d; d6c2d: return $siteDeleter; goto d91e9; f2147: $siteDeleter = null; goto F61be; d91e9: } private function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } }
