<?php
 namespace App\EventListener; use Symfony\Component\HttpKernel\Event\RequestEvent; use Symfony\Component\EventDispatcher\EventSubscriberInterface; use Symfony\Component\Console\Event\ConsoleCommandEvent; use Symfony\Component\HttpKernel\KernelEvents; use Symfony\Component\Console\ConsoleEvents; use Symfony\Contracts\Cache\ItemInterface; use Psr\Cache\CacheItemPoolInterface as CachePool; use GuzzleHttp\Client as HttpClient; use GuzzleHttp\Psr7\Request; use Twig\Environment as TwigEnvironment; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\UserManager; use App\Entity\Manager\DatabaseServerManager; use App\Command\Command; use App\Util\PasswordGenerator; use App\CloudPanel\Environment as CloudPanelEnvironment; use App\CloudPanel\Aws\Instance as AwsInstance; use App\CloudPanel\Do\Instance as DoInstance; use App\CloudPanel\Gce\Instance as GceInstance; use App\CloudPanel\Hetzner\Instance as HetznerInstance; use App\CloudPanel\Vultr\Instance as VultrInstance; use App\CloudPanel\Instance; use App\Do\Client as DoClient; use App\Gce\Client as GceClient; use App\Hetzner\Client as HetznerClient; use App\Vultr\Client as VultrClient; use App\System\CommandExecutor; use App\System\Command\ChangeDatabaseUserPasswordCommand; use App\Entity\DatabaseServer; use App\Service\Crypto; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Database\Connection as DatabaseConnection; use App\Util\Retry; class InitializeListener implements EventSubscriberInterface { private const IP_REQUEST_URL = "\150\x74\164\160\x73\72\x2f\x2f\144\x33\x71\156\x64\x35\x34\x71\70\147\x62\x33\152\x65\x2e\143\154\x6f\x75\x64\x66\162\157\x6e\164\x2e\x6e\x65\x74\x2f"; private ConfigManager $configManager; private DatabaseServerManager $databaseServerManager; private UserManager $userManager; private CachePool $cachePool; private TwigEnvironment $twig; public function __construct(ConfigManager $configManager, DatabaseServerManager $databaseServerManager, UserManager $userManager, CachePool $cachePool, TwigEnvironment $twig) { goto Fdc4a; Fdc4a: $this->configManager = $configManager; goto Ec204; Ec204: $this->databaseServerManager = $databaseServerManager; goto b635d; b635d: $this->userManager = $userManager; goto d813f; d813f: $this->cachePool = $cachePool; goto e0582; e0582: $this->twig = $twig; goto afc91; afc91: } public function onKernelRequest(RequestEvent $event) : void { goto Ba29d; F166d: return; goto A5cb1; Ba29d: if (!(false === $event->isMainRequest())) { goto b3499; } goto F166d; A5cb1: b3499: goto efb7d; efb7d: $this->initialize($event); goto c8aca; c8aca: } public function onConsoleCommand(ConsoleCommandEvent $event) : void { goto fc29f; Dd388: $this->initialize($event); goto Ba31d; fc29f: $command = $event->getCommand(); goto C6736; Ba31d: e5b99: goto F52e5; C6736: if (!$command instanceof Command) { goto e5b99; } goto Dd388; F52e5: } private function initialize(RequestEvent|ConsoleCommandEvent $event) : void { goto afb56; f8657: $this->setCloudPanelReleaseChannel(); goto C6bbb; b6875: $this->setEnvironment($event); goto Ff621; afb56: $this->setTimezone(); goto Fc449; ec8fa: $this->setDatabaseServer($event); goto b6875; Fde09: $this->setCloudPanelVersion(); goto f8657; Fc449: $this->setInstanceUid(); goto Fde09; C6bbb: $this->setLetsEncryptPrivateKey(); goto ec8fa; Ff621: } private function setTimezone() : void { goto F58a1; C6b93: a3992: goto cb959; F58a1: $timezone = $this->configManager->get("\164\151\155\x65\172\x6f\156\x65"); goto E2964; dd55a: $this->configManager->set("\x74\151\x6d\145\x7a\x6f\x6e\145", "\125\124\103"); goto C6b93; E2964: if (!(true === is_null($timezone))) { goto a3992; } goto dd55a; cb959: } private function setInstanceUid() : void { goto c5bd8; C533c: $instanceUid = substr(sha1(uniqid(mt_rand(), true)), 0, 16); goto Cb1b7; Cb1b7: $this->configManager->set("\x69\x6e\163\164\141\x6e\143\145\137\x75\151\x64", $instanceUid); goto Cfe83; c5bd8: $instanceUid = $this->configManager->get("\x69\x6e\x73\164\x61\x6e\x63\x65\137\165\x69\x64"); goto E6a3d; E6a3d: if (!(true === is_null($instanceUid))) { goto e4748; } goto C533c; Cfe83: e4748: goto Fe031; Fe031: } private function setCloudPanelVersion() : void { goto aeb20; aeb20: $appVersion = $_ENV["\x41\x50\x50\x5f\x56\105\122\x53\111\117\x4e"] ?? null; goto E2d5f; A20a6: $this->configManager->set("\x61\x70\x70\137\x76\145\x72\x73\x69\x6f\156", trim($appVersion)); goto cc472; E2d5f: if (!(false === is_null($appVersion))) { goto f128f; } goto A20a6; cc472: f128f: goto ba45e; ba45e: } private function setCloudPanelReleaseChannel() : void { goto cd104; cd104: $releaseChannel = $this->configManager->get("\162\x65\154\x65\141\x73\145\x5f\x63\x68\x61\x6e\156\145\x6c"); goto ebf03; ab083: C7e3c: goto bdcf2; d7614: $this->configManager->set("\x72\145\154\145\x61\x73\145\137\x63\x68\141\x6e\156\145\154", CloudPanelEnvironment::RELEASE_CHANNEL_STABLE); goto ab083; ebf03: if (!(true === is_null($releaseChannel))) { goto C7e3c; } goto d7614; bdcf2: } private function setLetsEncryptPrivateKey() { goto D8adb; fa890: $letsEncryptPrivateKey = $this->configManager->get("\x6c\145\137\160\162\x69\x76\x61\164\x65\x5f\x6b\145\x79"); goto Dfd44; dcb40: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto Fde1d; f44c3: if (!(0 < $numberOfUsers)) { goto Ea630; } goto fa890; Fde1d: $this->configManager->set("\x6c\145\137\160\x72\151\166\141\x74\145\x5f\x6b\x65\171", $privateKey->getPEM()); goto C50cf; Ca27d: Ea630: goto a59ac; d7c6d: $rsaKeyGenerator = new RsaKeyGenerator(); goto dcb40; Dfd44: if (!(true === is_null($letsEncryptPrivateKey))) { goto Bb53a; } goto d7c6d; D8adb: $numberOfUsers = $this->userManager->countAll(); goto f44c3; C50cf: Bb53a: goto Ca27d; a59ac: } private function setDatabaseServer(RequestEvent|ConsoleCommandEvent $event) : void { goto a7e5e; F8265: $tmpDatabaseServer = clone $databaseServer; goto F5937; da60c: $databaseServer->setUserName("\162\157\x6f\164"); goto D044d; aec80: if (!(0 < $numberOfUsers && 0 == count($databaseServers))) { goto ea1d9; } goto Ce828; B6230: $commandExecutor = new CommandExecutor(); goto A4df6; a031e: $databaseServers = $this->databaseServerManager->findAll(); goto aec80; cd8c5: $databaseServer->setVersion($databaseConnection->getVersion()); goto bc566; a7e5e: $numberOfUsers = $this->userManager->countAll(); goto a031e; Bf8fd: goto E4fdc; goto E397c; B5329: E4fdc: goto f9d08; A4df6: $changeDatabaseUserPasswordCommand = new ChangeDatabaseUserPasswordCommand(); goto A7aaa; de6df: $databaseServer = $this->databaseServerManager->createEntity(); goto a4d47; Be60b: $this->databaseServerManager->updateEntity($databaseServer); goto c1086; bc566: $databaseServer->setPassword($encryptedPassword); goto Cbf83; a6862: $passwordGenerator = new PasswordGenerator(); goto B5ac6; E9e96: $commandExecutor->execute($changeDatabaseUserPasswordCommand); goto Ea413; D044d: $databaseServer->setPassword(Crypto::encrypt("\x72\157\x6f\164")); goto Fe753; F5937: $tmpDatabaseServer->setPassword("\x72\x6f\x6f\x74"); goto B6230; C7a87: $databaseServer->setIsDefault(true); goto Cf6c3; A7aaa: $changeDatabaseUserPasswordCommand->setUserName("\162\157\x6f\164"); goto a235d; E397c: D5c0a: goto E54b7; E54b7: $password = "\162\157\x6f\164"; goto B5329; Ea413: Bde89: goto Be60b; a4d47: $databaseServer->setHost("\61\x32\67\x2e\60\56\60\56\61"); goto da60c; Cf6c3: $databaseConnection = new DatabaseConnection($databaseServer); goto addaa; f9d08: $encryptedPassword = Crypto::encrypt($password); goto de6df; Fe753: $databaseServer->setPort(DatabaseServer::DEFAULT_PORT); goto Db3ec; Ce828: if ("\x64\145\x76" == $_ENV["\x41\x50\120\137\x45\x4e\126"]) { goto D5c0a; } goto a6862; B5ac6: $password = $passwordGenerator->generate(); goto Bf8fd; c1086: ea1d9: goto F931d; Cbf83: if (!("\x64\145\166" != $_ENV["\101\x50\x50\x5f\105\116\x56"])) { goto Bde89; } goto F8265; addaa: $databaseServer->setEngine($databaseConnection->getEngine()); goto cd8c5; Db3ec: $databaseServer->setIsActive(true); goto C7a87; d643e: $changeDatabaseUserPasswordCommand->setDatabaseServer($tmpDatabaseServer); goto E9e96; a235d: $changeDatabaseUserPasswordCommand->setNewPassword($password); goto d643e; F931d: } private function setEnvironment(RequestEvent|ConsoleCommandEvent $event) : void { goto Fb161; c3bdb: e382b: goto ebb59; Fb161: $cloud = $this->configManager->get("\143\x6c\157\165\x64"); goto C7609; E1099: $ipv4PublicIp = $instance->getIpv4PublicIp(); goto B5abf; b313f: $isDarkMode = false === is_null($request->cookies->get("\164\x68\x65\x6d\145")) && "\x64\141\x72\153" == $request->cookies->get("\x74\150\x65\155\145") ? true : false; goto E1099; e2255: $hostname = gethostname(); goto E84f7; F1f64: $this->twig->addGlobal("\151\x73\x44\x61\x72\153\x4d\x6f\x64\145", $isDarkMode); goto A7c68; Df558: $instanceUid = $this->configManager->get("\151\156\x73\x74\141\156\x63\145\x5f\x75\x69\144"); goto C755c; B7d88: $this->twig->addGlobal("\151\156\163\x74\141\x6e\143\145", $instance); goto F1f64; C7609: $environment = new CloudPanelEnvironment(); goto C1f02; e45d5: try { $ipv4PublicIp = $this->cachePool->get("\151\160\166\64\137\160\165\x62\x6c\x69\x63\x5f\151\160", function (ItemInterface $item) { goto D839f; F30ff: $ipv4PublicIp = trim((string) $response->getBody()); goto d4669; e3f85: if (!(200 == $responseStatusCode)) { goto e81d9; } goto F30ff; Cf6d7: $ipv4PublicIp = null; goto D69ce; d4669: e81d9: goto b3e98; cd117: $response = $this->retry(function () use($httpClient, $request) { $response = $httpClient->send($request); return $response; }); goto C003d; C003d: $responseStatusCode = $response->getStatusCode(); goto e3f85; D69ce: $config = ["\164\151\x6d\x65\157\165\x74" => 5, "\166\145\x72\x69\146\x79" => false, "\x68\x65\x61\144\145\162\x73" => ["\125\163\145\162\55\x41\147\x65\156\164" => "\103\x6c\157\x75\144\x50\141\x6e\145\154\x20\x76\x32"]]; goto A55e4; F69ea: $request = new Request("\107\x45\x54", self::IP_REQUEST_URL); goto cd117; A55e4: $httpClient = new HttpClient($config); goto F69ea; D839f: $item->expiresAfter(3600); goto Cf6d7; b3e98: return $ipv4PublicIp; goto ad645; ad645: }); } catch (\Exception $e) { } goto fe7ba; a724d: goto fe60f; goto e7f31; e7f31: c69fd: goto f0eda; Db3cb: $command = $event->getCommand(); goto fe9e2; f0eda: $request = $event->getRequest(); goto ad803; fe9e2: $command->setInstance($instance); goto a724d; d5137: Ac1ea: goto d7bda; c83c9: C64e9: goto fd50b; bdd07: $request->attributes->set("\x69\163\104\x61\x72\153\115\157\x64\x65", $isDarkMode); goto B7d88; fd50b: $instance->setEnvironment($environment); goto e2255; bcf65: $ipv4PublicIp = ''; goto e45d5; Ddbaa: if ($event instanceof RequestEvent) { goto c69fd; } goto Db3cb; B5abf: if (!(true === empty($ipv4PublicIp))) { goto Ac1ea; } goto bcf65; A7c68: fe60f: goto b2bc6; fe7ba: $instance->setIpv4PublicIp($ipv4PublicIp); goto d5137; C1f02: switch ($cloud) { case CloudPanelEnvironment::CLOUD_PROVIDER_AWS: goto B172d; B449e: $instance->setInstanceType("\164\63\56\170\154\141\162\147\145"); goto d467e; b86d1: $region = $_ENV["\x44\x45\x56\137\x41\x57\x53\137\122\105\x47\111\117\x4e"] ?? ''; goto c01ee; a57a8: if (!("\144\145\x76" == $_ENV["\101\120\120\137\x45\116\x56"])) { goto Ead77; } goto A0074; C615b: Ead77: goto d37be; B172d: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_AWS); goto Ba4ef; Ba4ef: $instance = new AwsInstance(); goto a57a8; d37be: goto Db7ad; goto Adb51; d467e: $instance->setRegion($region); goto C615b; A0074: $instanceId = $_ENV["\104\105\126\137\101\127\x53\137\111\116\x53\x54\101\116\x43\105\137\111\x44"] ?? ''; goto b86d1; c01ee: $instance->setInstanceId($instanceId); goto B449e; Adb51: case CloudPanelEnvironment::CLOUD_PROVIDER_DO: goto Ae99a; Ed787: $instance->setDropletId($dropletId); goto C9dae; Bc32e: $region = $_ENV["\104\105\126\137\x44\x4f\x5f\x52\105\107\x49\117\116"] ?? ''; goto Ed787; fb613: $doClient->setToken($token); goto c7613; c7613: F8c6b: goto c8ec7; Ae99a: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_DO); goto E9b5c; F149a: if (!("\144\145\166" == $_ENV["\x41\x50\x50\x5f\105\x4e\126"])) { goto C03ab; } goto e576a; d8c74: $instance->setIpv4PublicIp("\61\62\x37\56\60\x2e\x30\56\x31"); goto d12c5; e576a: $dropletId = $_ENV["\104\105\126\137\104\117\x5f\104\x52\x4f\120\x4c\x45\x54\137\111\x44"] ?? ''; goto Bc32e; c95db: $doClient->setInstance($instance); goto F149a; E9b5c: $doClient = new DoClient(); goto cb0fa; c8ec7: $instance = new DoInstance($doClient); goto c95db; d12c5: C03ab: goto F7cec; Df0f1: if (!(false === is_null($token))) { goto F8c6b; } goto fb613; cb0fa: $token = $this->configManager->get("\x64\157\x5f\x61\143\x63\145\x73\163\x5f\x74\x6f\x6b\x65\156"); goto Df0f1; F7cec: goto Db7ad; goto ff0c6; C9dae: $instance->setRegion($region); goto f4fe9; f4fe9: $instance->setFloatingIp("\61\x32\x37\56\x30\56\x30\56\x31"); goto d8c74; ff0c6: case CloudPanelEnvironment::CLOUD_PROVIDER_GCE: goto E7d08; d3439: F9ff9: goto F122b; Df328: $instance->setIpv4PublicIp("\61\62\x37\x2e\60\x2e\60\56\x31"); goto c9f08; c9f08: $instance->setProjectId($projectId); goto ad5a6; Bd861: $gceClient->setGceInstance($instance); goto C7ddb; F122b: $instance = new GceInstance($gceClient); goto Bd861; e0d2d: goto Db7ad; goto E73fe; B0914: $instance->setMachineType($machineType); goto B53f1; fb0fd: Cae81: goto e0d2d; B53f1: $instance->setZone($zone); goto fb0fd; Fb28c: $instance->setInstanceName($instanceName); goto B0914; c06da: $gceClient->setAuthConfig($serviceAccountKeys); goto d3439; B59eb: $projectId = $_ENV["\104\x45\126\x5f\x47\x43\105\x5f\120\122\117\x4a\x45\x43\124\x5f\111\104"] ?? ''; goto B2815; B84c5: if (!(false === is_null($serviceAccountKeys))) { goto F9ff9; } goto Ebd0f; Ebd0f: $serviceAccountKeys = (array) json_decode($serviceAccountKeys, true); goto c06da; D1554: $serviceAccountKeys = $this->configManager->get("\x67\143\145\137\163\145\x72\166\x69\x63\x65\137\141\x63\143\157\x75\x6e\x74\137\x6b\x65\x79\163"); goto B84c5; ad5a6: $instance->setInstanceId($instanceId); goto Fb28c; E7d08: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_GCE); goto f0e65; C0811: $machineType = $_ENV["\104\105\126\x5f\x47\x43\x45\x5f\x4d\x41\103\110\x49\116\x45\x5f\x54\131\x50\x45"] ?? ''; goto a4e05; B2815: $instanceId = $_ENV["\104\105\x56\137\x47\103\105\x5f\x49\x4e\x53\x54\x41\x4e\x43\x45\137\x49\x44"] ?? ''; goto C5dc0; C7ddb: if (!("\144\145\x76" == $_ENV["\101\120\x50\x5f\x45\116\126"])) { goto Cae81; } goto B59eb; f0e65: $gceClient = new GceClient(); goto D1554; C5dc0: $instanceName = $_ENV["\104\105\x56\137\x47\103\105\x5f\111\116\123\124\x41\x4e\x43\105\137\x4e\x41\115\105"] ?? ''; goto C0811; a4e05: $zone = $_ENV["\104\105\126\137\107\103\105\137\132\x4f\116\x45"] ?? ''; goto Df328; E73fe: case CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER: goto a305c; Ee4f1: $hetznerClient->setToken($apiToken); goto c140a; B9d43: goto Db7ad; goto Ddd9b; Cc70e: $instanceId = $_ENV["\104\x45\126\x5f\110\105\124\x5a\x4e\105\x52\137\x49\116\x53\x54\x41\116\103\x45\x5f\111\104"] ?? ''; goto b5be0; c140a: f744c: goto f3e72; b5be0: $instance->setIpv4PublicIp("\61\62\x37\x2e\60\56\60\x2e\x31"); goto d746e; Be29d: $apiToken = $this->configManager->get("\x68\145\x74\x7a\x6e\145\x72\137\141\x70\x69\x5f\x74\x6f\153\145\156"); goto A0fa8; f3e72: $instance = new HetznerInstance($hetznerClient); goto d0842; d746e: $instance->setInstanceId($instanceId); goto e0dc0; e0dc0: c1d19: goto B9d43; d0842: $hetznerClient->setInstance($instance); goto c9ab3; Acbad: $hetznerClient = new HetznerClient(); goto Be29d; A0fa8: if (!(false === is_null($apiToken))) { goto f744c; } goto Ee4f1; a305c: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER); goto Acbad; c9ab3: if (!("\x64\145\x76" == $_ENV["\x41\120\120\x5f\105\x4e\x56"])) { goto c1d19; } goto Cc70e; Ddd9b: case CloudPanelEnvironment::CLOUD_PROVIDER_VULTR: goto Bbdfb; F7738: $instance->setInstanceId($instanceId); goto a17e0; cc3d7: if (!(false === is_null($apiKey))) { goto e7417; } goto f82f8; ac6da: goto Db7ad; goto dce36; f82f8: $vultrClient->setApiKey($apiKey); goto D540f; Bbdfb: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_VULTR); goto A613c; d93c5: $instance->setIpv4PublicIp($ipv4PublicIp); goto F7738; D540f: e7417: goto Fea5d; Fb134: $instanceId = $_ENV["\104\x45\126\137\x56\125\x4c\124\x52\x5f\111\x4e\123\124\x41\x4e\103\105\x5f\111\104"] ?? ''; goto E68cd; A613c: $vultrClient = new VultrClient(); goto Ec8ca; D2e82: if (!("\x64\x65\x76" == $_ENV["\101\x50\x50\137\105\116\126"])) { goto a09fa; } goto Fb134; a17e0: a09fa: goto ac6da; Ec8ca: $apiKey = $this->configManager->get("\x76\165\154\164\162\x5f\x61\160\151\x5f\x6b\145\171"); goto cc3d7; E68cd: $ipv4PublicIp = $_ENV["\104\x45\126\x5f\x56\125\x4c\x54\122\x5f\x49\x50\137\126\x34\137\120\125\102\x4c\x49\103"] ?? "\61\62\x37\56\60\56\x30\56\x31"; goto d93c5; Fea5d: $instance = new VultrInstance($vultrClient); goto c6e7b; c6e7b: $vultrClient->setVultrInstance($instance); goto D2e82; dce36: default: $instance = new Instance(); goto Db7ad; } goto c3bdb; C755c: if (!(false === is_null($instanceUid))) { goto C64e9; } goto Fd9b8; E84f7: $instance->setHostname($hostname); goto Ddbaa; ebb59: Db7ad: goto Df558; ad803: $host = $request->getHost(); goto b313f; d7bda: $request->attributes->set("\x69\x6e\163\164\141\x6e\143\x65", $instance); goto bdd07; Fd9b8: $instance->setUid($instanceUid); goto c83c9; b2bc6: } private function retry(callable $fn, $retries = 1, $delay = 3) { return Retry::retry($fn, $retries, $delay); } public static function getSubscribedEvents() : array { return [KernelEvents::REQUEST => [["\157\156\113\x65\x72\x6e\x65\x6c\122\x65\x71\165\x65\x73\x74", 25]], ConsoleEvents::COMMAND => [["\x6f\x6e\103\x6f\x6e\x73\x6f\x6c\x65\103\x6f\x6d\155\x61\156\144", 25]]]; } }
