<?php
 namespace App\Site\Nginx\Vhost; use App\Site\Site; use App\Site\Nginx\Vhost\Processor\Processor; use App\Site\Nginx\Vhost\Processor\RootDirectory as RootDirectoryProcessor; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; use App\Site\Nginx\Vhost\Processor\NginxAccessLog as NginxAccessLogProcessor; use App\Site\Nginx\Vhost\Processor\NginxErrorLog as NginxErrorLogProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificateKey as NginxCertificateKeyProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificate as NginxCertificateProcessor; use App\Site\Nginx\Vhost\Processor\Settings as SettingsProcessor; class Template { protected Site $site; protected ?string $content = null; protected array $placeholders = []; protected array $processors = []; public function __construct(Site $site) { $this->site = $site; $this->init(); } protected function init() : void { goto B24d6; Dee49: $this->addProcessor($nginxAccessLogProcessor); goto A1f62; b7e4a: $settingsProcessor = new SettingsProcessor(); goto Ff550; Ff550: $this->addProcessor($rootDirectoryProcessor); goto d330e; B24d6: $rootDirectoryProcessor = new RootDirectoryProcessor(); goto e6bad; da4ef: $certificateKeyProcessor = new NginxCertificateKeyProcessor(); goto fdc71; fd2ba: $this->addProcessor($redirectDomainProcessor); goto Dee49; a462e: $nginxAccessLogProcessor = new NginxAccessLogProcessor(); goto d5d28; e6bad: $serverNameProcessor = new ServerNameProcessor(); goto dd28c; d330e: $this->addProcessor($serverNameProcessor); goto b37fd; C5d6d: $this->addProcessor($settingsProcessor); goto Acd73; fdc71: $certificateProcessor = new NginxCertificateProcessor(); goto b7e4a; b37fd: $this->addProcessor($redirectServerNameProcessor); goto fd2ba; d5d28: $nginxErrorLogProcessor = new NginxErrorLogProcessor(); goto da4ef; A1f62: $this->addProcessor($nginxErrorLogProcessor); goto E9719; E9719: $this->addProcessor($certificateKeyProcessor); goto dfb3d; e19eb: $redirectDomainProcessor = new RedirectDomainProcessor(); goto a462e; dd28c: $redirectServerNameProcessor = new RedirectServerNameProcessor(); goto e19eb; dfb3d: $this->addProcessor($certificateProcessor); goto C5d6d; Acd73: } public function getSite() : Site { return $this->site; } public function setContent(string $content) : void { $this->content = $content; } public function getContent() : ?string { return $this->content; } public function build() : void { goto ec629; B355e: $placeholders = $this->getPlaceholders(); goto B20e7; D4176: a4709: goto D02cc; ec629: $processors = $this->getProcessors(); goto B355e; B20e7: foreach ($placeholders as $placeholder) { goto F4a07; F4a07: $hasProcessor = $this->hasProcessor($placeholder); goto b8818; a31b6: f020b: goto a03ce; C16c3: $processor->setSite($this->site); goto C5344; C5344: $this->content = $processor->process($this->content); goto Bc508; a03ce: f9aac: goto f26f2; Bc508: $this->removePlaceholder($placeholder); goto a31b6; b8818: if (!(true === $hasProcessor)) { goto f020b; } goto faf15; faf15: $processor = $processors[$placeholder]; goto C16c3; f26f2: } goto D4176; D02cc: } public function removeEmptyPlaceholders() : void { goto F8b20; F8b20: $placeholders = $this->getPlaceholders(); goto a15f3; a15f3: foreach ($placeholders as $placeholder) { $this->content = str_replace($placeholder, '', $this->content); Ca035: } goto a4d5c; a4d5c: Bbd06: goto e4bf9; e4bf9: } protected function hasProcessor(string $placeholder) : bool { return isset($this->processors[$placeholder]); } protected function getProcessors() : array { return $this->processors; } public function addProcessor(Processor $processor) : void { $this->processors[$processor->getPlaceholder()] = $processor; } public function resetProcessors() : void { $this->processors = []; } public function getPlaceholders() : array { goto b9081; C8733: C3f48: goto C85c7; b9081: if (!(true === empty($this->placeholders))) { goto d6480; } goto F0b1c; b82c3: aaa86: goto C8733; F0b1c: preg_match_all("\57\x5b\x7b\x7b\x5d\x7b\62\x7d\x28\x5b\134\x73\x61\x2d\172\101\55\132\x30\55\x39\x5f\135\53\x29\133\175\x7d\135\173\x32\175\57", $this->content, $placeholders); goto B7cc5; B7cc5: if (!(true === isset($placeholders[0]) && count($placeholders[0]))) { goto C3f48; } goto Caf06; c3b4e: foreach ($placeholders as $placeholder) { goto e04da; E0c79: aacd6: goto Af2dc; e04da: $placeholder = trim($placeholder); goto E6e12; E6e12: if (!(false === empty($placeholder))) { goto C5888; } goto a64e9; a64e9: $this->addPlaceholder($placeholder); goto Ff0ab; Ff0ab: C5888: goto E0c79; Af2dc: } goto b82c3; C85c7: d6480: goto C8d20; C8d20: return $this->placeholders; goto B14a4; Caf06: $placeholders = $placeholders[0]; goto c3b4e; B14a4: } private function addPlaceholder(string $placeholder) : void { $this->placeholders[$placeholder] = $placeholder; } private function removePlaceholder(string $placeholder) : void { goto c7338; Dd3ac: unset($this->placeholders[$placeholder]); goto def3e; c7338: if (!(true === isset($this->placeholders[$placeholder]))) { goto A0a6c; } goto Dd3ac; def3e: A0a6c: goto D30ea; D30ea: } }
