<?php
 namespace App\Site; use App\System\Command\CopyFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\NginxConfigTestCommand; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\ChmodCommand; use App\System\Command\FindChmodCommand; use App\System\Command\WriteFileCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\ChangeUserHomeDirectoryCommand; use App\System\Command\CreateUserCommand; use App\System\Command\DeleteUserCommand; use App\System\Command\ChangeUserPasswordCommand; use App\System\Command\CreateSymlinkCommand; use App\System\Command\ReadLinkCommand; use App\System\Command\ServiceReloadCommand; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Entity\Site as SiteEntity; use App\Site\Ssl\LetsEncrypt\CertificateOrder; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Nginx\Vhost\StaticTemplate; use App\Site\Nginx\Vhost\NodejsTemplate; use App\Site\Nginx\Vhost\PhpTemplate; use App\Site\Nginx\Vhost\PythonTemplate; use App\Site\Nginx\Vhost\ReverseProxyTemplate; abstract class Updater { public const NGINX_BASIC_AUTH_DIRECTORY = "\57\145\164\x63\57\x6e\x67\151\x6e\170\x2f\x62\141\163\151\143\55\141\x75\164\x68\x2f"; public const NGINX_VHOST_DIRECTORY = "\x2f\145\x74\x63\57\156\x67\x69\156\170\x2f\x73\151\164\x65\x73\x2d\145\156\x61\x62\x6c\x65\144\x2f"; public const NGINX_SSL_CERTIFICATES_DIRECTORY = "\57\x65\x74\x63\x2f\156\147\151\x6e\170\x2f\x73\163\x6c\55\143\145\162\x74\151\146\x69\x63\141\x74\x65\x73\x2f"; public const CRON_DIRECTORY = "\x2f\x65\164\143\x2f\x63\162\157\156\56\x64\57"; protected Site $site; protected CommandExecutor $commandExecutor; public function __construct(Site $site) { $this->site = $site; $this->commandExecutor = new CommandExecutor(); } public function domainSettings() : void { $this->updateNginxVhost(); $this->reloadNginxService(); } public function updateNginxVhost() : void { goto f0778; efc9c: $vhostContent = $vhostTemplate->getContent(); goto A610f; b6d19: d208c: goto A6c70; A610f: $writeVhostFileCommand = new WriteFileCommand(); goto A5b17; B42b7: $writeVhostFileCommand->setContent($vhostContent); goto ff935; F742c: $vhostFileContent = $this->site->getVhostTemplate(); goto fe65e; f0778: $domainName = $this->site->getDomainName(); goto F742c; E8122: $vhostFile = sprintf("\x25\x73\x2f\45\x73\56\143\157\156\146", rtrim(self::NGINX_VHOST_DIRECTORY, "\x2f"), $domainName); goto A8169; fe65e: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto d49d3; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto d49d3; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto d49d3; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto d49d3; case SiteEntity::TYPE_REVERSE_PROXY: $vhostTemplate = new ReverseProxyTemplate($this->site); goto d49d3; } goto b6d19; A8169: $vhostTemplate->build(); goto d2864; A5b17: $writeVhostFileCommand->setFile($vhostFile); goto B42b7; A6c70: d49d3: goto D30c3; ff935: $this->commandExecutor->execute($writeVhostFileCommand); goto ed0ea; d2864: $vhostTemplate->removeEmptyPlaceholders(); goto efc9c; D30c3: $vhostTemplate->setContent($vhostFileContent); goto E8122; ed0ea: } public function updateNginxVhostWithRollback() : void { try { goto cabb1; b6f4e: $this->commandExecutor->execute($writeVhostFileCommand); goto Fb143; edba4: $vhostTemplate->build(); goto de910; A022b: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto bc05c; e8f2c: if (!("\144\145\x76" != $_ENV["\101\120\120\x5f\x45\116\x56"])) { goto Abedf; } goto a3154; de910: $vhostTemplate->removeEmptyPlaceholders(); goto e945a; D7a11: $deleteVhostBackupFileCommand = new DeleteFileCommand(); goto Fe888; b0a63: $writeVhostFileCommand = new WriteFileCommand(); goto B48ba; e24f1: ac9c3: goto ca118; Fb143: $this->commandExecutor->execute($nginxConfigTestCommand); goto e8f2c; d43df: $vhostBackupFile = sprintf("\x25\x73\57\45\x73\x2e\x63\157\x6e\146\56\142\141\153", rtrim(self::NGINX_VHOST_DIRECTORY, "\57"), $domainName); goto b7814; F5d27: $reloadNginxServiceCommand->setServiceName("\x6e\147\x69\x6e\170"); goto Fd2fc; b7814: $copyVhostBackupFileCommand = new CopyFileCommand(); goto C9204; Cdf75: $vhostTemplate->setContent($vhostFileContent); goto f0f5c; a3154: $reloadNginxServiceCommand = new ServiceReloadCommand(); goto F5d27; f0f5c: $vhostFile = sprintf("\45\x73\x2f\45\x73\x2e\x63\x6f\x6e\146", rtrim(self::NGINX_VHOST_DIRECTORY, "\57"), $domainName); goto edba4; C9204: $copyVhostBackupFileCommand->setSourceFile($vhostFile); goto b450f; f558b: $writeVhostFileCommand->setContent($vhostContent); goto F7949; D53d5: $this->commandExecutor->execute($copyVhostBackupFileCommand); goto b6f4e; B48ba: $writeVhostFileCommand->setFile($vhostFile); goto f558b; b450f: $copyVhostBackupFileCommand->setDestinationFile($vhostBackupFile); goto b0a63; Fe888: $deleteVhostBackupFileCommand->setFile($vhostBackupFile); goto D53d5; Fd2fc: $this->commandExecutor->execute($reloadNginxServiceCommand); goto D6ef5; e945a: $vhostContent = $vhostTemplate->getContent(); goto d43df; C9786: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto b7f5c; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto b7f5c; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto b7f5c; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto b7f5c; case SiteEntity::TYPE_REVERSE_PROXY: $vhostTemplate = new ReverseProxyTemplate($this->site); goto b7f5c; } goto e24f1; cabb1: $domainName = $this->site->getDomainName(); goto ef5c8; D6ef5: Abedf: goto A022b; F7949: $nginxConfigTestCommand = new NginxConfigTestCommand(); goto D7a11; ef5c8: $vhostFileContent = $this->site->getVhostTemplate(); goto C9786; ca118: b7f5c: goto Cdf75; bc05c: } catch (\Exception $e) { goto c7770; a388b: $this->commandExecutor->execute($reloadNginxServiceCommand); goto c26bb; b03bc: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto fcc60; Fc4b8: $errorMessage = $nginxConfigTestCommand->getOutput(); goto e802b; d6a8b: $restoreBackupFileCommand->setDestinationFile($vhostFile); goto A33cb; e0501: if (!(true === isset($reloadNginxServiceCommand))) { goto Defd3; } goto a388b; fcc60: throw new InvalidVhostException($errorMessage); goto Db155; c26bb: Defd3: goto b03bc; E0f28: $restoreBackupFileCommand->setSourceFile($vhostBackupFile); goto d6a8b; e802b: B46d8: goto b560e; F3f25: if (!(true === isset($nginxConfigTestCommand))) { goto B46d8; } goto Fc4b8; A33cb: $this->commandExecutor->execute($restoreBackupFileCommand); goto e0501; b560e: $restoreBackupFileCommand = new CopyFileCommand(); goto E0f28; c7770: $errorMessage = $e->getMessage(); goto F3f25; Db155: } } public function createSshUser(SshUserEntity $sshUserEntity) : void { goto A64a3; c55fb: $sshDirectoryChmodCommand->setDirectoryChmod(700); goto B0a4a; ec231: $createUserCommand->setShell("\x2f\x62\x69\x6e\x2f\x62\x61\x73\150"); goto Ec451; E3cd5: $changeSiteUserHomeDirectoryPermissionsCommand->setChmod(750); goto E6ab2; b19d6: $skeletonDirectory = realpath(dirname(__FILE__) . "\57\x2e\56\57\x2e\x2e\x2f\162\x65\x73\157\x75\162\143\x65\x73\x2f\145\x74\x63\57\163\x6b\x65\x6c\57\x73\x73\x68\x2d\x75\x73\145\162\57"); goto caea4; f1507: ac634: goto E0024; F6071: $siteUserHomeDirectory = sprintf("\57\150\157\x6d\145\57\x25\x73", $siteUser); goto a716f; B954b: $this->commandExecutor->execute($createUserCommand); goto A820e; B0a4a: $sshDirectoryChmodCommand->setFileChmod(600); goto F6071; f50f9: $createUserCommand->setUserName($sshUserName); goto a15c6; a716f: $changeSiteUserHomeDirectoryPermissionsCommand = new ChmodCommand(); goto f9b0e; F1a1e: $sshUserPassword = $sshUserEntity->getPassword(); goto a4111; E0024: $sshDirectory = sprintf("\x2f\x68\x6f\155\x65\x2f\x25\x73\x2f\x2e\x73\163\150", $sshUserName); goto E1c5d; caea4: $createUserCommand = new CreateUserCommand(); goto f50f9; A4dc0: $sshUserName = $sshUserEntity->getUserName(); goto F1a1e; A64a3: $site = $sshUserEntity->getSite(); goto A91fe; a15c6: $createUserCommand->setPassword($sshUserPassword); goto D01c6; a03cf: $changeSiteUserHomeDirectoryPermissionsCommand->setRecursive(false); goto E3cd5; Df1c6: foreach ($symlinkDirectories as $symlinkDirectory) { goto ea782; bfa32: $symlinkCommand = new CreateSymlinkCommand(); goto D16d1; D16d1: $symlinkCommand->setRunAsUser($sshUserName); goto A1983; A135c: $symlinkCommand->setDestination($destination); goto F4fad; a0ce9: $this->commandExecutor->execute($symlinkCommand); goto fbfd5; fbfd5: a6a97: goto bc5ac; ea782: $source = sprintf("\57\150\x6f\x6d\145\57\x25\x73\x2f\45\x73", $siteUser, $symlinkDirectory); goto E0a3b; bc5ac: ecd45: goto ab260; A1983: $symlinkCommand->setSource($source); goto A135c; E0a3b: $destination = sprintf("\x2f\150\157\155\145\x2f\45\163\57\45\x73", $sshUserName, $symlinkDirectory); goto bfa32; F4fad: if (!("\144\x65\x76" != $_ENV["\x41\120\120\x5f\105\116\126"])) { goto a6a97; } goto a0ce9; ab260: } goto f1507; Ec451: $createUserCommand->setSkeletonDirectory($skeletonDirectory); goto d0d61; a4111: $homeDirectory = sprintf("\x2f\150\x6f\x6d\145\x2f\x25\163", $sshUserName); goto b19d6; E6ab2: $this->commandExecutor->execute($sshDirectoryChmodCommand); goto fd3fc; e6cf7: $sshDirectoryChmodCommand->setFile($sshDirectory); goto c55fb; d0d61: $createUserCommand->setHomeDirectory($homeDirectory); goto C0c0d; fd3fc: $this->commandExecutor->execute($changeSiteUserHomeDirectoryPermissionsCommand); goto b204e; A91fe: $siteUser = $site->getUser(); goto A4dc0; E1c5d: $sshDirectoryChmodCommand = new FindChmodCommand(); goto e6cf7; f9b0e: $changeSiteUserHomeDirectoryPermissionsCommand->setFile($siteUserHomeDirectory); goto a03cf; A820e: $symlinkDirectories = ["\142\141\143\x6b\165\160\x73", "\x68\x74\x64\x6f\143\x73", "\x6c\157\147\x73"]; goto Df1c6; C0c0d: $createUserCommand->createHomeDirectory(true); goto B954b; D01c6: $createUserCommand->setGroup($siteUser); goto ec231; b204e: } public function createFtpUser(FtpUserEntity $ftpUserEntity) : void { goto B65b6; F646c: $changeSiteUserHomeDirectoryPermissionsCommand = new ChmodCommand(); goto F1369; E4201: $homeDirectory = $ftpUserEntity->getHomeDirectory(); goto Bf530; F1369: $changeSiteUserHomeDirectoryPermissionsCommand->setFile($siteUserHomeDirectory); goto De935; B65b6: $site = $ftpUserEntity->getSite(); goto Ed132; Ef200: $createUserCommand->setUserName($ftpUserName); goto e1bc2; Ed132: $siteUser = $site->getUser(); goto A9127; A2a79: $changeSiteUserHomeDirectoryPermissionsCommand->setChmod(750); goto Bdecc; Ec42f: $createUserCommand->setGroups(["\x66\164\x70\55\165\x73\145\162"]); goto c9690; Dc374: $createUserCommand->setGroup($siteUser); goto Ec42f; Bf530: $createUserCommand = new CreateUserCommand(); goto Ef200; Dc77c: $createUserCommand->createHomeDirectory(false); goto Be848; Dcaa4: $createUserCommand->setHomeDirectory($homeDirectory); goto Dc77c; De935: $changeSiteUserHomeDirectoryPermissionsCommand->setRecursive(false); goto A2a79; A9127: $ftpUserName = $ftpUserEntity->getUserName(); goto f2cdd; Ac92a: $this->commandExecutor->execute($changeSiteUserHomeDirectoryPermissionsCommand); goto d81fe; e1bc2: $createUserCommand->setPassword($ftpUserPassword); goto Dc374; Be848: $siteUserHomeDirectory = sprintf("\x2f\150\157\155\145\x2f\x25\163", $siteUser); goto F646c; f2cdd: $ftpUserPassword = $ftpUserEntity->getPassword(); goto E4201; c9690: $createUserCommand->setShell("\x2f\142\151\x6e\57\146\141\154\163\x65"); goto Dcaa4; Bdecc: $this->commandExecutor->execute($createUserCommand); goto Ac92a; d81fe: } public function deleteUser(string $userName, $removeHomeDirectory = true) : void { goto A87c5; F282c: $this->commandExecutor->execute($deleteUserCommand); goto E03f9; Cf9ec: $deleteUserCommand->setUserName($userName); goto b85b1; b85b1: $deleteUserCommand->setRemoveHomeDirectory($removeHomeDirectory); goto F282c; A87c5: $deleteUserCommand = new DeleteUserCommand(); goto Cf9ec; E03f9: } public function installCertificate(CertificateEntity $certificateEntity) : void { goto D12ae; eac52: $certificateFile = sprintf("\x25\163\57\x25\163\56\143\162\164", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\x2f"), $domainName); goto a02a7; a02a7: $certificate = $certificateEntity->getCertificate(); goto Eee2f; Af764: $writeCertificateFileCommand->setFile($certificateFile); goto f0b9a; cdb27: $writePrivateKeyFileCommand->setContent($certificateEntity->getPrivateKey()); goto Af3cb; fcc3b: $this->reloadService("\x6e\147\151\x6e\x78"); goto cbad5; d0cac: $this->commandExecutor->execute($writeCertificateFileCommand); goto fcc3b; cacf4: $certificate .= sprintf("\x25\163\x25\x73", PHP_EOL, trim($certificateEntity->getCertificateChain())); goto d9570; D12ae: $domainName = $this->site->getDomainName(); goto A402b; A402b: $privateKeyFile = sprintf("\x25\x73\x2f\45\x73\56\153\145\171", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\x2f"), $domainName); goto eac52; d9570: b8992: goto a0634; f0b9a: $writeCertificateFileCommand->setContent($certificate); goto B6834; Af3cb: $writeCertificateFileCommand = new WriteFileCommand(); goto Af764; afcaa: $writePrivateKeyFileCommand->setFile($privateKeyFile); goto cdb27; Eee2f: if (!(false === empty($certificateEntity->getCertificateChain()))) { goto b8992; } goto cacf4; B6834: $this->commandExecutor->execute($writePrivateKeyFileCommand); goto d0cac; a0634: $writePrivateKeyFileCommand = new WriteFileCommand(); goto afcaa; cbad5: } public function deleteLetsEncryptChallengeDirectory() : void { goto f3540; e3d7e: $deleteAcmeChallengeDirectoryCommand = new DeleteDirectoryCommand(); goto c3f78; c3f78: $deleteAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto D5099; D5099: $this->commandExecutor->execute($deleteAcmeChallengeDirectoryCommand); goto d7eaf; f3540: $rootDirectory = $this->getRootDirectory(); goto d5531; d5531: $acemeChallengeDirectory = sprintf("\45\x73\57\x2e\167\x65\x6c\x6c\x2d\153\156\x6f\x77\156\57\141\x63\155\x65\55\143\150\141\x6c\x6c\145\x6e\x67\145\57", rtrim($rootDirectory, "\x2f")); goto e3d7e; d7eaf: } public function createBasicAuthFile(BasicAuthEntity $basicAuthEntity) : void { goto Fb1ab; e0a9a: $basicAuthFileContent = sprintf("\45\163\x3a\45\163", $basicAuthEntity->getUserName(), crypt($basicAuthEntity->getPassword(), base64_encode($basicAuthEntity->getPassword()))); goto A794e; B4c80: $this->commandExecutor->execute($writeBasicAuthFileCommand); goto d9dec; C0843: $writeBasicAuthFileCommand->setFile($basicAuthFile); goto d35d8; A794e: $writeBasicAuthFileCommand = new WriteFileCommand(); goto C0843; d35d8: $writeBasicAuthFileCommand->setContent($basicAuthFileContent); goto B4c80; Fb1ab: $basicAuthFile = sprintf("\x25\x73\x2f\x25\163", rtrim(self::NGINX_BASIC_AUTH_DIRECTORY, "\57"), $this->site->getDomainName()); goto e0a9a; d9dec: } public function createLetsEncryptChallengeFiles(CertificateOrder $certificateOrder) : void { goto C28ef; C3774: $wellKnownDirectory = sprintf("\45\163\57\x2e\167\145\154\154\55\153\156\157\167\x6e\x2f", rtrim($rootDirectory, "\57")); goto C1038; A4d6f: $challenges = $certificateOrder->getAuthorizationsChallenges(); goto Fb2c1; Fc47e: $chownWellKnownDirectoryCommandCommand->setRecursive(true); goto E8837; e44de: $chmodWellKnownDirectoryCommand = new FindChmodCommand(); goto E4b73; E8837: $chownWellKnownDirectoryCommandCommand->setUser($siteUser); goto Eb5a2; fb9f9: eeac0: goto E8fd7; E6347: C89cf: goto fb9f9; Bdfb9: $chownWellKnownDirectoryCommandCommand->setFile($wellKnownDirectory); goto Fc47e; C28ef: $siteUser = $this->site->getUser(); goto Cc19a; a3032: $createAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto d8b28; Eb5a2: $chownWellKnownDirectoryCommandCommand->setGroup($siteUser); goto e44de; f2500: $chmodWellKnownDirectoryCommand->setDirectoryChmod(750); goto b7a68; b7a68: $chmodWellKnownDirectoryCommand->setFileChmod(770); goto fe6b8; A3653: if (!count($challenges)) { goto eeac0; } goto B3c7c; d8b28: $this->commandExecutor->execute($createAcmeChallengeDirectoryCommand); goto A3653; Cc19a: $rootDirectory = $this->getRootDirectory(); goto C3774; bd06f: $this->commandExecutor->execute($chmodWellKnownDirectoryCommand); goto F337f; fe6b8: $this->commandExecutor->execute($chownWellKnownDirectoryCommandCommand); goto bd06f; E8fd7: $chownWellKnownDirectoryCommandCommand = new ChownCommand(); goto Bdfb9; B3c7c: foreach ($challenges as $challenge) { goto Da3d6; E0196: $challengeWriteFileCommand = new WriteFileCommand(); goto Ea68b; Da3d6: $token = $challenge["\164\x6f\153\x65\156"] ?? null; goto C7d8d; c87e8: $challengeFile = sprintf("\45\x73\57\45\163", rtrim($acemeChallengeDirectory, "\57"), $token); goto E0196; C7d8d: $verificationContent = $challenge["\x76\145\162\x69\x66\x69\143\x61\x74\151\x6f\156\103\157\156\164\x65\x6e\164"] ?? null; goto A58fc; fd616: fb409: goto F9837; A58fc: if (!(false === is_null($token) && false === is_null($verificationContent))) { goto a753b; } goto c87e8; Ea68b: $challengeWriteFileCommand->setFile($challengeFile); goto D0563; D0563: $challengeWriteFileCommand->setContent($verificationContent); goto d18a0; d18a0: $this->commandExecutor->execute($challengeWriteFileCommand); goto e65eb; e65eb: a753b: goto fd616; F9837: } goto E6347; Fb2c1: $createAcmeChallengeDirectoryCommand = new CreateDirectoryCommand(); goto a3032; C1038: $acemeChallengeDirectory = sprintf("\45\163\x2f\56\x77\145\x6c\154\55\153\156\157\x77\x6e\57\141\143\x6d\145\55\143\150\141\x6c\154\x65\156\147\145\57", rtrim($rootDirectory, "\57")); goto A4d6f; E4b73: $chmodWellKnownDirectoryCommand->setFile($wellKnownDirectory); goto f2500; F337f: } public function updateUserCrontab() : void { goto Ad898; a4c2e: c1916: goto d741d; c96f9: if (!count($cronJobs)) { goto ce00d; } goto b8c61; bc109: $this->commandExecutor->execute($writeCrontabFileCommand); goto d8ee5; ffb74: $writeCrontabFileCommand->setFile($crontabFile); goto B5eb6; f37c7: $cronJobs = $this->site->getCronJobs(); goto c96f9; E4341: $crontabContent = implode(PHP_EOL, $crontabEntries); goto C7808; B5eb6: $writeCrontabFileCommand->setContent($crontabContent); goto bc109; a5ef0: $crontabFile = sprintf("\45\x73\57\x25\163", rtrim(self::CRON_DIRECTORY, "\57"), $siteUser); goto fadff; Ad898: $siteUser = $this->site->getUser(); goto a5ef0; C7808: $writeCrontabFileCommand = new WriteFileCommand(); goto ffb74; d741d: ce00d: goto E4341; fadff: $crontabEntries = ["\x4d\101\x49\114\x54\x4f\x3d\x22\x22"]; goto f37c7; b8c61: foreach ($cronJobs as $cronJob) { $crontabEntries[] = $cronJob->getCrontabExpression(); C60bf: } goto a4c2e; d8ee5: } public function purgePageSpeedCache() : void { goto A6c26; A6c26: $siteUser = $this->site->getUser(); goto C8c37; b92f4: $purgePageSpeedCacheFilesCommand = new DeleteDirectoryCommand(); goto Ba58a; D95af: $this->commandExecutor->execute($purgePageSpeedCacheFilesCommand, 300); goto e7095; C8c37: $cacheDirectory = sprintf("\57\150\x6f\155\x65\57\45\x73\x2f\164\x6d\x70\57\x70\141\147\x65\163\160\145\x65\144\137\x63\x61\143\150\x65", $siteUser); goto b92f4; Ba58a: $purgePageSpeedCacheFilesCommand->setDirectory($cacheDirectory); goto D95af; e7095: } public function updateUserSShKeys(string $userName, $sshKeys) : void { goto b7f46; cbe50: $readLinkCommand = new ReadLinkCommand(); goto A6340; b7f46: $authorizedKeysFile = sprintf("\x2f\x68\157\155\145\x2f\45\x73\x2f\x2e\x73\163\x68\57\141\165\x74\x68\x6f\x72\151\172\145\x64\137\x6b\145\x79\163", $userName); goto cbe50; A358b: $writeAuthorizedKeysFileCommand->setContent($sshKeys); goto B5734; Eb46e: $this->commandExecutor->execute($readLinkCommand); goto d5428; d5428: $readLinkPath = $readLinkCommand->getOutput(); goto F73e7; F73e7: if (!(false === empty($readLinkPath) && $readLinkPath == $authorizedKeysFile)) { goto E3bb2; } goto d8ed0; B5734: $this->commandExecutor->execute($writeAuthorizedKeysFileCommand); goto cd695; cd695: E3bb2: goto F94c6; A6340: $readLinkCommand->setFile($authorizedKeysFile); goto Eb46e; d8ed0: $writeAuthorizedKeysFileCommand = new WriteFileCommand(); goto Bc7d4; Bc7d4: $writeAuthorizedKeysFileCommand->setFile($authorizedKeysFile); goto A358b; F94c6: } public function changeUserHomeDirectory(string $userName, string $homeDirectory) : void { goto C0e82; E99b1: $this->commandExecutor->execute($changeUserHomeDirectoryCommand); goto Bc676; c7e8e: $changeUserHomeDirectoryCommand->setHomeDirectory($homeDirectory); goto E99b1; C7b0c: $changeUserHomeDirectoryCommand->setUserName($userName); goto c7e8e; C0e82: $changeUserHomeDirectoryCommand = new ChangeUserHomeDirectoryCommand(); goto C7b0c; Bc676: } public function changeUserPassword(string $userName, string $password) : void { goto D3d4f; f9360: $changeUserPasswordCommand->setPassword($password); goto C73cf; cc6fe: $changeUserPasswordCommand->setUserName($userName); goto f9360; C73cf: $this->commandExecutor->execute($changeUserPasswordCommand); goto eaec6; D3d4f: $changeUserPasswordCommand = new ChangeUserPasswordCommand(); goto cc6fe; eaec6: } protected function getRootDirectory() : string { goto Bcd74; Bcd74: $siteUser = $this->site->getUser(); goto E4071; E4071: $rootDirectory = $this->site->getRootDirectory(); goto fb87b; ac3ee: return $rootDirectory; goto E595d; fb87b: $rootDirectory = sprintf("\57\150\157\x6d\x65\57\45\163\x2f\x68\x74\x64\157\x63\x73\57\x25\163", $siteUser, $rootDirectory); goto ac3ee; E595d: } public function reloadNginxService() : void { $this->reloadService("\x6e\x67\x69\156\170"); } public function reloadService($serviceName) { goto B4a36; A2369: $this->commandExecutor->execute($reloadServiceCommand); goto cd75d; cd75d: F12c0: goto Dcdc1; Bdfa6: $reloadServiceCommand = new ServiceReloadCommand(); goto D2987; B4a36: if (!("\x64\x65\x76" != $_ENV["\x41\x50\120\137\x45\x4e\126"])) { goto F12c0; } goto Bdfa6; D2987: $reloadServiceCommand->setServiceName($serviceName); goto A2369; Dcdc1: } }
